

///////////////////////////////////////////////////////////////////////////////////////////
////																				   ////
///								GESTION TOPOLOGIQUE										///
////																				   ////
///////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listALLtopos
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d] [H3d r1]
int ZM3listALLtopos(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ZM3listALLtopos ");
#endif
    int s3d = MMget(m,0);

    if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int	n=0;
	int tx, tmp_res;

	for(int k=0; k<scene->MshList.Size(); k++)
    {
		int s3d = MMget(m,0);
		int hash = MTOP(MMfetch(m,MTOP(s3d),1));

		tx = NodeTOHandle(m, hash, (int)scene->MshList[k]);
		if(tx!=NIL)
		{
			tx = PTOM(tx);
			if(MMpush(m,tx))			return MERRMEM;
			INVERT(m,0,1);
			n++;
		}
    }

	if(n==0)		{	MMset(m,0,NIL);		return n;	}
	MMpull(m);
	if(MMpush(m,NIL))		return MERRMEM;

	for(int j=0;j<n;j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getTopo
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S] H3d
int ZM3getTopo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ZM3getTopo ");
#endif
	int name = MMpull(m);
    int s3d  = MMget(m,0);

    if((name==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*)MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	string	matName = string(MMstartstr(m,MTOP(name)));

	ZMesh	*topo = NULL;

	for(int k=0; k<scene->MshList.Size(); k++)
	{
		if( scene->MshList[k]->name==matName && (topo==NULL || scene->MshList[k]->version>topo->version) )		topo = scene->MshList[k];
	}

	if(topo==NULL)		{	MMset(m,0,NIL);		return 0;	}

	int	top = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)topo);
	if(top!=NIL)		top = PTOM(top);
	MMset(m,0,top);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createTopo														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d] H3d
int ZM3createTopo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createTopo ");
#endif
    int s3d;

    s3d = MMget(m,0);
    if(s3d==NIL)		{	MMset(m,0,NIL);		return 0;	}

	ZScene	*scene = (ZScene*) MMfetch(m, MTOP(s3d), 0);
	if(scene==NULL)		{	MMset(m,0,NIL);		return 0;	}

	// Cre la topologie
	ZMesh	*topo = new ZMesh((int)scene, 0, 0);
	if(topo==NULL)	{	MMset(m,0,NIL);		return 0;	}
	scene->MshList.Add(topo);

	topo->SetName("");

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)topo, hash_tab);

	scene->meshModified		= true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3cleanTopo
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3cleanTopo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3cleanTopo ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    
	// Nettoie la topologie..

	ZMesh	*topo = (ZMesh*) node;
	for(int i=0; i<topo->NbFaces; i++)		topo->Faces[i].DeleteFace();
	
	topo->FacesFlat.gour.resize(0);
	topo->FacesFlat.flat.resize(0);
	topo->FacesFlat.no.resize(0);



	for(i=0; i<topo->FacesTex1.size(); i++)	
	{
		topo->FacesTex1[i].ClampUV.flat.resize(0);	topo->FacesTex1[i].ClampUV.gour.resize(0);	topo->FacesTex1[i].ClampUV.no.resize(0);
		topo->FacesTex1[i].ClampU. flat.resize(0);	topo->FacesTex1[i].ClampU. gour.resize(0);	topo->FacesTex1[i].ClampU .no.resize(0);
		topo->FacesTex1[i].ClampV. flat.resize(0);	topo->FacesTex1[i].ClampV. gour.resize(0);	topo->FacesTex1[i].ClampV .no.resize(0);
		topo->FacesTex1[i].NoClamp.flat.resize(0);	topo->FacesTex1[i].NoClamp.gour.resize(0);	topo->FacesTex1[i].NoClamp.no.resize(0);
	}
	topo->FacesTex1.resize(0);

	for(i=0; i<topo->FacesEnv.size(); i++)	
	{
		topo->FacesEnv[i].NoClamp.flat.resize(0);
		topo->FacesEnv[i].NoClamp.gour.resize(0);
		topo->FacesEnv[i].NoClamp.no.resize(0);
	}
	topo->FacesEnv.resize(0);

	for(i=0; i<topo->FacesColTransp.size(); i++)	
	{
		topo->FacesColTransp[i].ClampUV.flat.resize(0);	topo->FacesColTransp[i].ClampUV.gour.resize(0);	topo->FacesColTransp[i].ClampUV.no.resize(0);
		topo->FacesColTransp[i].ClampU. flat.resize(0);	topo->FacesColTransp[i].ClampU. gour.resize(0);	topo->FacesColTransp[i].ClampU .no.resize(0);
		topo->FacesColTransp[i].ClampV. flat.resize(0);	topo->FacesColTransp[i].ClampV. gour.resize(0);	topo->FacesColTransp[i].ClampV .no.resize(0);
		topo->FacesColTransp[i].NoClamp.flat.resize(0);	topo->FacesColTransp[i].NoClamp.gour.resize(0);	topo->FacesColTransp[i].NoClamp.no.resize(0);
	}
	topo->FacesColTransp.resize(0);

	for(i=0; i<topo->FacesTex2.size(); i++)
	{
		topo->FacesTex2[i].ClampUV.flat.resize(0);	topo->FacesTex2[i].ClampUV.gour.resize(0);	topo->FacesTex2[i].ClampUV.no.resize(0);
		topo->FacesTex2[i].ClampU. flat.resize(0);	topo->FacesTex2[i].ClampU. gour.resize(0);	topo->FacesTex2[i].ClampU .no.resize(0);
		topo->FacesTex2[i].ClampV. flat.resize(0);	topo->FacesTex2[i].ClampV. gour.resize(0);	topo->FacesTex2[i].ClampV .no.resize(0);
		topo->FacesTex2[i].NoClamp.flat.resize(0);	topo->FacesTex2[i].NoClamp.gour.resize(0);	topo->FacesTex2[i].NoClamp.no.resize(0);
	}
	topo->FacesTex2.resize(0);



	for(i=0; i<topo->FacesMatGour.size(); i++)
	{
		topo->FacesMatGour[i].faces.resize(0);
	}
	topo->FacesMatGour.resize(0);

	for(i=0; i<topo->FacesMatFlat.size(); i++)
	{
		topo->FacesMatFlat[i].faces.resize(0);
	}
	topo->FacesMatFlat.resize(0);

	for(i=0; i<topo->FacesMatNo.size(); i++)
	{
		topo->FacesMatNo[i].faces.resize(0);
	}
	topo->FacesMatNo.resize(0);

	topo->FacesTransp.resize(0);
	
	topo->Verts.resize(0);
	topo->Faces.resize(0);

	topo->NbFaces = topo->NbVerts = 0;

	topo->dependency		= false;
	topo->displayListCreate = true;
	topo->multiTex			= false;

	topo->DeleteRapidModel();

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	
	topo->DeleteDisplayList();

	
	scene->meshModified	 = true;


    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoCount
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3topoCount(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoCount ");
#endif
	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZData	*topo = (ZData*) MMfetch(m,MTOP(h3d),0);
	if(topo==NULL || topo->type!=MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0,ITOM(topo->nbRef));
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoAddFace
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [I I I] [[I I][I I][I I]] [[I I][I I][I I]] HMat3d] I
//
//	Attention !! Le sens direct n'est ici pas respect pour le passage des params en SCOL !!
//
int ZM3topoAddFace(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoAddFace ");
#endif

	int mat	 = MMpull(m);
	int tex2 = MMpull(m);
	int tex1 = MMpull(m);
	int Vref = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(Vref==NIL)||(tex1==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;


	// Recupre le materiau
    node = (ZNode*) MMfetch(m,MTOP(mat),0);
	if((node==NULL)||(node->type!=MAT_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMaterial	*materio = (ZMaterial*) node;

	// Recupre les vert-refz
	int	vert0 = MTOI(MMfetch(m,MTOP(Vref),0));
	int	vert1 = MTOI(MMfetch(m,MTOP(Vref),1));
	int	vert2 = MTOI(MMfetch(m,MTOP(Vref),2));

	// Recupre les textures coordinates n1
	int	coord0 = MTOP(MMfetch(m,MTOP(tex1),0));
	int	coord1 = MTOP(MMfetch(m,MTOP(tex1),1));
	int	coord2 = MTOP(MMfetch(m,MTOP(tex1),2));
	ZVector3	U1, V1;
	U1.SetCoord( MTOI(MMfetch(m,coord0,0)), MTOI(MMfetch(m,coord1,0)), MTOI(MMfetch(m,coord2,0)) );
	V1.SetCoord( MTOI(MMfetch(m,coord0,1)), MTOI(MMfetch(m,coord1,1)), MTOI(MMfetch(m,coord2,1)) );
	
	// Recupre les textures coordinates n2
	ZVector3	U2, V2;
	if(tex2!=NIL)
	{
		coord0 = MTOP(MMfetch(m,MTOP(tex2),0));
		coord1 = MTOP(MMfetch(m,MTOP(tex2),1));
		coord2 = MTOP(MMfetch(m,MTOP(tex2),2));
		U2.SetCoord( MTOI(MMfetch(m,coord0,0)), MTOI(MMfetch(m,coord1,0)), MTOI(MMfetch(m,coord2,0)) );
		V2.SetCoord( MTOI(MMfetch(m,coord0,1)), MTOI(MMfetch(m,coord1,1)), MTOI(MMfetch(m,coord2,1)) );
	}


	// Cre la face correspondante
	ZFace	face;
	face.initFace();

	face.SetVertsRef( vert0, vert1, vert2 );
	face.SetMaterial(materio);

	U1 *= 1.0f/CONST_TEX_COORD;
	U2 *= 1.0f/CONST_TEX_COORD;
	V1 *= 1.0f/CONST_TEX_COORD;
	V2 *= 1.0f/CONST_TEX_COORD;

	face.UV1[0].SetCoord( U1.x, V1.x );
	face.UV1[1].SetCoord( U1.y, V1.y );
	face.UV1[2].SetCoord( U1.z, V1.z );

	if( face.UV1[0].u<0.0f || face.UV1[1].u<0.0f || face.UV1[2].u<0.0f ||
		face.UV1[0].u>1.0f || face.UV1[1].u>1.0f || face.UV1[2].u>1.0f )	face.clampU1 = false;
	else																	face.clampU1 = true;

	if( face.UV1[0].v<0.0f || face.UV1[1].v<0.0f || face.UV1[2].v<0.0f || 
		face.UV1[0].v>1.0f || face.UV1[1].v>1.0f || face.UV1[2].v>1.0f )	face.clampV1 = false;
	else																	face.clampV1 = true;


	if(tex2!=NIL)
	{
		face.UV2[0].SetCoord( U2.x, V2.x );
		face.UV2[1].SetCoord( U2.y, V2.y );
		face.UV2[2].SetCoord( U2.z, V2.z );

		if( face.UV2[0].u<0.0f || face.UV2[1].u<0.0f || face.UV2[2].u<0.0f ||
			face.UV2[0].u>1.0f || face.UV2[1].u>1.0f || face.UV2[2].u>1.0f )	face.clampU2 = false;
		else																	face.clampU2 = true;

		if( face.UV2[0].v<0.0f || face.UV2[1].v<0.0f || face.UV2[2].v<0.0f || 
			face.UV2[0].v>1.0f || face.UV2[1].v>1.0f || face.UV2[2].v>1.0f )	face.clampV2 = false;
		else																	face.clampV2 = true;
	}
	else
	{
		face.UV2[0].SetCoord(0.0f, 0.0f);	
		face.UV2[1].SetCoord(1.0f, 0.0f);	
		face.UV2[2].SetCoord(0.0f, 1.0f);
		face.clampU2 = face.clampV2 = true;
	}
	
	topo->addFace(face);
	face.SetMaterial(NULL);

	scene->meshModified	= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoAddFaceF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [I I I] [[F F][F F][F F]] [[F F][F F][F F]] HMat3d] I
//
//	Attention !! Le sens direct n'est ici pas respect pour le passage des params en SCOL !!
//
int ZM3topoAddFaceF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoAddFaceF ");
#endif
	int mat	 = MMpull(m);
	int tex2 = MMpull(m);
	int tex1 = MMpull(m);
	int Vref = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(Vref==NIL)||(tex1==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;


	// Recupre le materiau
    node = (ZNode*) MMfetch(m,MTOP(mat),0);
	if((node==NULL)||(node->type!=MAT_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMaterial	*materio = (ZMaterial*) node;

	// Recupre les vert-refz
	int	vert0 = MTOI(MMfetch(m,MTOP(Vref),0));
	int	vert1 = MTOI(MMfetch(m,MTOP(Vref),1));
	int	vert2 = MTOI(MMfetch(m,MTOP(Vref),2));

	// Recupre les textures coordinates n1
	int	coord0 = MTOP(MMfetch(m,MTOP(tex1),0));
	int	coord1 = MTOP(MMfetch(m,MTOP(tex1),1));
	int	coord2 = MTOP(MMfetch(m,MTOP(tex1),2));
	ZVector3	U1, V1;
	U1.SetCoord( MTOF(MMfetch(m,coord0,0)), MTOF(MMfetch(m,coord1,0)), MTOF(MMfetch(m,coord2,0)) );
	V1.SetCoord( MTOF(MMfetch(m,coord0,1)), MTOF(MMfetch(m,coord1,1)), MTOF(MMfetch(m,coord2,1)) );
	
	// Recupre les textures coordinates n2
	ZVector3	U2, V2;
	if(tex2!=NIL)
	{
		coord0 = MTOP(MMfetch(m,MTOP(tex2),0));
		coord1 = MTOP(MMfetch(m,MTOP(tex2),1));
		coord2 = MTOP(MMfetch(m,MTOP(tex2),2));
		U2.SetCoord( MTOF(MMfetch(m,coord0,0)), MTOF(MMfetch(m,coord1,0)), MTOF(MMfetch(m,coord2,0)) );
		V2.SetCoord( MTOF(MMfetch(m,coord0,1)), MTOF(MMfetch(m,coord1,1)), MTOF(MMfetch(m,coord2,1)) );
	}


	// Cre la face correspondante
	ZFace	face;
	face.initFace();

	face.SetVertsRef( vert0, vert1, vert2 );
	face.SetMaterial(materio);

	face.UV1[0].SetCoord( U1.x, V1.x );
	face.UV1[1].SetCoord( U1.y, V1.y );
	face.UV1[2].SetCoord( U1.z, V1.z );

	if( face.UV1[0].u<0.0f || face.UV1[1].u<0.0f || face.UV1[2].u<0.0f ||
		face.UV1[0].u>1.0f || face.UV1[1].u>1.0f || face.UV1[2].u>1.0f )	face.clampU1 = false;
	else																	face.clampU1 = true;

	if( face.UV1[0].v<0.0f || face.UV1[1].v<0.0f || face.UV1[2].v<0.0f || 
		face.UV1[0].v>1.0f || face.UV1[1].v>1.0f || face.UV1[2].v>1.0f )	face.clampV1 = false;
	else																	face.clampV1 = true;
	
	if(tex2!=NIL)
	{
		face.UV2[0].SetCoord( U2.x, V2.x );
		face.UV2[1].SetCoord( U2.y, V2.y );
		face.UV2[2].SetCoord( U2.z, V2.z );
		
		if( face.UV2[0].u<0.0f || face.UV2[1].u<0.0f || face.UV2[2].u<0.0f ||
			face.UV2[0].u>1.0f || face.UV2[1].u>1.0f || face.UV2[2].u>1.0f )	face.clampU2 = false;
		else																	face.clampU2 = true;

		if( face.UV2[0].v<0.0f || face.UV2[1].v<0.0f || face.UV2[2].v<0.0f || 
			face.UV2[0].v>1.0f || face.UV2[1].v>1.0f || face.UV2[2].v>1.0f )	face.clampV2 = false;
		else																	face.clampV2 = true;
	}
	else
	{
		face.UV2[0].SetCoord(0.0f, 0.0f);	
		face.UV2[1].SetCoord(1.0f, 0.0f);	
		face.UV2[2].SetCoord(0.0f, 1.0f);
		face.clampU2 = face.clampV2 = true;
	}
	
	topo->addFace(face);
	face.SetMaterial(NULL);

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setFaceVertRef
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [I I I]] I
int ZM3setFaceVertRef(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setFaceVertRef ");
#endif
	int Vref = MMpull(m);
	int num	 = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(Vref==NIL)||(num==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;


	int index = MTOI(num);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}

	int	vert0 = MTOI(MMfetch(m,MTOP(Vref),0));
	int	vert1 = MTOI(MMfetch(m,MTOP(Vref),1));
	int	vert2 = MTOI(MMfetch(m,MTOP(Vref),2));

	topo->Faces[index].SetVertsRef(vert0, vert1, vert2);

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified	 = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getFaceVertRef
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I] [I I I]
int ZM3getFaceVertRef(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getFaceVertRef ");
#endif
	int num	 = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(num==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(num);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}

	// cration du tuple de rsultat
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, ITOM(topo->Faces[index].VertRef[0]));
	MMstore(m, tuple, 1, ITOM(topo->Faces[index].VertRef[1]));
	MMstore(m, tuple, 2, ITOM(topo->Faces[index].VertRef[2]));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setFaceMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I HMat3d] I
int ZM3setFaceMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setFaceMaterial ");
#endif
	int mat	 = MMpull(m);
	int num	 = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(num==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(num);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}
	
    node = (ZNode*) MMfetch(m,MTOP(mat),0);
	if((node==NULL)||(node->type!=MAT_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZMaterial	*materio = (ZMaterial*) node;

	topo->Faces[index].SetMaterial(materio);

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getFaceMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I] HMat3d
int ZM3getFaceMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getFaceMaterial ");
#endif
	int num	 = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(num==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(num);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}
	
	ZMaterial	*mat = topo->Faces[index].GetMaterial();
	if(mat==NULL)						{	MMset(m,0,NIL);		return 0;	}
	
	int	mat3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
	if(mat3d!=NIL)	mat3d = PTOM(mat3d);
	MMset(m,0,mat3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setFaceTexCoord
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I I [[I I][I I][I I]] ] I
int ZM3setFaceTexCoord(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setFaceTexCoord ");
#endif
	int texC = MMpull(m);
	int numT = MMpull(m);
	int face = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(face==NIL)||(texC==NIL)||(numT==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int numTex = MTOI(numT);
	if((numTex>3)||(numTex<1))			{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(face);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}

	// Recupre les textures coordinates
	int	coord0 = MTOP(MMfetch(m,MTOP(texC),0));
	int	coord1 = MTOP(MMfetch(m,MTOP(texC),1));
	int	coord2 = MTOP(MMfetch(m,MTOP(texC),2));
	ZVector3	U, V;
	U.SetCoord( MTOI(MMfetch(m,coord0,0)), MTOI(MMfetch(m,coord1,0)), MTOI(MMfetch(m,coord2,0)) );
	V.SetCoord( MTOI(MMfetch(m,coord0,1)), MTOI(MMfetch(m,coord1,1)), MTOI(MMfetch(m,coord2,1)) );
	U *= 1.0f/CONST_TEX_COORD;
	V *= 1.0f/CONST_TEX_COORD;


	if(numTex==1)
	{
		topo->Faces[index].UV1[0].SetCoord( U.x, V.x);
		topo->Faces[index].UV1[1].SetCoord( U.y, V.y);
		topo->Faces[index].UV1[2].SetCoord( U.z, V.z);

		if( topo->Faces[index].UV1[0].u<0.0f || topo->Faces[index].UV1[1].u<0.0f || topo->Faces[index].UV1[2].u<0.0f ||
			topo->Faces[index].UV1[0].u>1.0f || topo->Faces[index].UV1[1].u>1.0f || topo->Faces[index].UV1[2].u>1.0f )	topo->Faces[index].clampU1 = false;
		else																											topo->Faces[index].clampU1 = true;

		if( topo->Faces[index].UV1[0].v<0.0f || topo->Faces[index].UV1[1].v<0.0f || topo->Faces[index].UV1[2].v<0.0f || 
			topo->Faces[index].UV1[0].v>1.0f || topo->Faces[index].UV1[1].v>1.0f || topo->Faces[index].UV1[2].v>1.0f )	topo->Faces[index].clampV1 = false;
		else																											topo->Faces[index].clampV1 = true;
	}
	else
	{
		topo->Faces[index].UV2[0].SetCoord( U.x, V.x);
		topo->Faces[index].UV2[1].SetCoord( U.y, V.y);
		topo->Faces[index].UV2[2].SetCoord( U.z, V.z);

		if( topo->Faces[index].UV2[0].u<0.0f || topo->Faces[index].UV2[1].u<0.0f || topo->Faces[index].UV2[2].u<0.0f ||
			topo->Faces[index].UV2[0].u>1.0f || topo->Faces[index].UV2[1].u>1.0f || topo->Faces[index].UV2[2].u>1.0f )	topo->Faces[index].clampU2 = false;
		else																											topo->Faces[index].clampU2 = true;

		if( topo->Faces[index].UV2[0].v<0.0f || topo->Faces[index].UV2[1].v<0.0f || topo->Faces[index].UV2[2].v<0.0f || 
			topo->Faces[index].UV2[0].v>1.0f || topo->Faces[index].UV2[1].v>1.0f || topo->Faces[index].UV2[2].v>1.0f )	topo->Faces[index].clampV2 = false;
		else																											topo->Faces[index].clampV2 = true;
	}

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setFaceTexCoordF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I I [[F F][F F][F F]] ] I
int ZM3setFaceTexCoordF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setFaceTexCoordF ");
#endif
	int texC = MMpull(m);
	int numT = MMpull(m);
	int face = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(face==NIL)||(texC==NIL)||(numT==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int numTex = MTOI(numT);
	if((numTex>3)||(numTex<1))			{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(face);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}

	// Recupre les textures coordinates
	int	coord0 = MTOP(MMfetch(m,MTOP(texC),0));
	int	coord1 = MTOP(MMfetch(m,MTOP(texC),1));
	int	coord2 = MTOP(MMfetch(m,MTOP(texC),2));
	ZVector3	U, V;
	U.SetCoord( MTOF(MMfetch(m,coord0,0)), MTOF(MMfetch(m,coord1,0)), MTOF(MMfetch(m,coord2,0)) );
	V.SetCoord( MTOF(MMfetch(m,coord0,1)), MTOF(MMfetch(m,coord1,1)), MTOF(MMfetch(m,coord2,1)) );

	if(numTex==1)
	{
		topo->Faces[index].UV1[0].SetCoord( U.x, V.x);
		topo->Faces[index].UV1[1].SetCoord( U.y, V.y);
		topo->Faces[index].UV1[2].SetCoord( U.z, V.z);

		if( topo->Faces[index].UV1[0].u<0.0f || topo->Faces[index].UV1[1].u<0.0f || topo->Faces[index].UV1[2].u<0.0f ||
			topo->Faces[index].UV1[0].u>1.0f || topo->Faces[index].UV1[1].u>1.0f || topo->Faces[index].UV1[2].u>1.0f )	topo->Faces[index].clampU1 = false;
		else																											topo->Faces[index].clampU1 = true;

		if( topo->Faces[index].UV1[0].v<0.0f || topo->Faces[index].UV1[1].v<0.0f || topo->Faces[index].UV1[2].v<0.0f || 
			topo->Faces[index].UV1[0].v>1.0f || topo->Faces[index].UV1[1].v>1.0f || topo->Faces[index].UV1[2].v>1.0f )	topo->Faces[index].clampV1 = false;
		else																											topo->Faces[index].clampV1 = true;
	}
	else
	{
		topo->Faces[index].UV2[0].SetCoord( U.x, V.x);
		topo->Faces[index].UV2[1].SetCoord( U.y, V.y);
		topo->Faces[index].UV2[2].SetCoord( U.z, V.z);

		if( topo->Faces[index].UV2[0].u<0.0f || topo->Faces[index].UV2[1].u<0.0f || topo->Faces[index].UV2[2].u<0.0f ||
			topo->Faces[index].UV2[0].u>1.0f || topo->Faces[index].UV2[1].u>1.0f || topo->Faces[index].UV2[2].u>1.0f )	topo->Faces[index].clampU2 = false;
		else																											topo->Faces[index].clampU2 = true;

		if( topo->Faces[index].UV2[0].v<0.0f || topo->Faces[index].UV2[1].v<0.0f || topo->Faces[index].UV2[2].v<0.0f || 
			topo->Faces[index].UV2[0].v>1.0f || topo->Faces[index].UV2[1].v>1.0f || topo->Faces[index].UV2[2].v>1.0f )	topo->Faces[index].clampV2 = false;
		else																											topo->Faces[index].clampV2 = true;
	}

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getFaceTexCoord
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I I] [[I I][I I][I I]]
int ZM3getFaceTexCoord(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getFaceTexCoord ");
#endif
	int numT = MMpull(m);
	int face = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(face==NIL)||(numT==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int numTex = MTOI(numT);
	if((numTex>3)||(numTex<1))			{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(face);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}


	// cration du tuple de rsultat
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	for(int iii=0; iii<3; iii++)	MMstore(m, tuple, iii, NIL);

	MMpush(m, PTOM(tuple));

	int coord0 = MMmalloc(m, 3, TYPETAB);
	if(coord0==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	for(iii=0; iii<3; iii++)	MMstore(m, coord0, iii, NIL);
	MMpush(m, PTOM(coord0));
	
	int coord1 = MMmalloc(m, 3, TYPETAB);
	if(coord1==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	for(iii=0; iii<3; iii++)	MMstore(m, coord1, iii, NIL);
	MMpush(m, PTOM(coord1));
	
	int coord2 = MMmalloc(m, 3, TYPETAB);
	for(iii=0; iii<3; iii++)	MMstore(m, coord2, iii, NIL);
	if(coord2==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	
	coord1 = MTOP( MMpull(m) );
	coord0 = MTOP( MMpull(m) );
	tuple  = MTOP( MMpull(m) );

	if(numTex==1)
	{
		MMstore(m, coord0, 0, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV1[0].u)));
		MMstore(m, coord0, 1, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV1[0].v)));

		MMstore(m, coord1, 0, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV1[1].u)));
		MMstore(m, coord1, 1, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV1[1].v)));
		
		MMstore(m, coord2, 0, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV1[2].u)));
		MMstore(m, coord2, 1, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV1[2].v)));
	}
	else
	{
		MMstore(m, coord0, 0, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV2[0].u)));
		MMstore(m, coord0, 1, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV2[0].v)));

		MMstore(m, coord1, 0, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV2[1].u)));
		MMstore(m, coord1, 1, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV2[1].v)));
		
		MMstore(m, coord2, 0, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV2[2].u)));
		MMstore(m, coord2, 1, ITOM(AROUNDINT(CONST_TEX_COORD*topo->Faces[index].UV2[2].v)));
	}

	MMstore(m, tuple, 0, PTOM(coord0));
	MMstore(m, tuple, 1, PTOM(coord1));
	MMstore(m, tuple, 2, PTOM(coord2));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getFaceTexCoordF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I I] [[F F][F F][F F]]
int ZM3getFaceTexCoordF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getFaceTexCoordF ");
#endif
	int numT = MMpull(m);
	int face = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(face==NIL)||(numT==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int numTex = MTOI(numT);
	if((numTex>3)||(numTex<1))			{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(face);
	if(index >= topo->Faces.size())		{	MMset(m,0,NIL);		return 0;	}


	// cration du tuple de rsultat
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	for(int iii=0; iii<3; iii++)	MMstore(m, tuple, iii, NIL);

	MMpush(m, PTOM(tuple));

	int coord0 = MMmalloc(m, 3, TYPETAB);
	if(coord0==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	for(iii=0; iii<3; iii++)	MMstore(m, coord0, iii, NIL);
	MMpush(m, PTOM(coord0));
	
	int coord1 = MMmalloc(m, 3, TYPETAB);
	if(coord1==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	for(iii=0; iii<3; iii++)	MMstore(m, coord1, iii, NIL);
	MMpush(m, PTOM(coord1));
	
	int coord2 = MMmalloc(m, 3, TYPETAB);
	if(coord2==NIL)						{	MMset(m,0,NIL);		return MERRMEM;	}
	for(iii=0; iii<3; iii++)	MMstore(m, coord2, iii, NIL);
	
	coord1 = MTOP( MMpull(m) );
	coord0 = MTOP( MMpull(m) );
	tuple  = MTOP( MMpull(m) );

	if(numTex==1)
	{
		MMstore(m, coord0, 0, FTOM(topo->Faces[index].UV1[0].u));
		MMstore(m, coord0, 1, FTOM(topo->Faces[index].UV1[0].v));

		MMstore(m, coord1, 0, FTOM(topo->Faces[index].UV1[1].u));
		MMstore(m, coord1, 1, FTOM(topo->Faces[index].UV1[1].v));

		MMstore(m, coord2, 0, FTOM(topo->Faces[index].UV1[2].u));
		MMstore(m, coord2, 1, FTOM(topo->Faces[index].UV1[2].v));
	}
	else
	{
		MMstore(m, coord0, 0, FTOM(topo->Faces[index].UV2[0].u));
		MMstore(m, coord0, 1, FTOM(topo->Faces[index].UV2[0].v));

		MMstore(m, coord1, 0, FTOM(topo->Faces[index].UV2[1].u));
		MMstore(m, coord1, 1, FTOM(topo->Faces[index].UV2[1].v));

		MMstore(m, coord2, 0, FTOM(topo->Faces[index].UV2[2].u));
		MMstore(m, coord2, 1, FTOM(topo->Faces[index].UV2[2].v));
	}

	MMstore(m, tuple, 0, PTOM(coord0));
	MMstore(m, tuple, 1, PTOM(coord1));
	MMstore(m, tuple, 2, PTOM(coord2));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listOfPolygons
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d] [[HMat3d [[I I I] r1]] r1]
int ZM3listOfPolygons(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listOfPolygons ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL))		{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
    
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);


	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	// Cration de la liste des faces
	if(faces->size()==0)			{	return MMpush(m,NIL);	}

	MMpush(m, s3d);

	int			n=0, mat3d, i, k, tmp_res;
	ZMaterial	*mater;
    for(int j=0; j<faces->size(); j++)
    {
		F = &((*faces)[j]);

		// recupre le materiau
		mater = F->GetMaterial();
		if (mater==NULL)	
		{
			if(MMpush(m,NIL))		return MERRMEM;
		}
		else
		{
			s3d = MMget(m,0);
			mat3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mater);
			if(mat3d!=NIL)	mat3d = PTOM(mat3d);
			if(MMpush(m, mat3d))		return MERRMEM;
		}

		// cration des tuples pour les vertices [I I I]
		for(i=0; i<3; i++)
		{
			if(MMpush(m, ITOM(F->VertRef[i])))										return MERRMEM;
			if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*F->UV1[i].u))))				return MERRMEM;
			if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*F->UV1[i].v))))				return MERRMEM;
	    	if(MMpush(m, 3*2))														return MERRMEM;
			if(k=MBdeftab(m))		return k;
		}
		if(MMpush(m,NIL)) return MERRMEM;

		// cration de la liste des vertices [[I I I] r1]
		for(i=0; i<3; i++)
		{
			if(MMpush(m,2*2))		return MERRMEM;
			if(k=MBdeftab(m))		return k;
		}

		// cration d'un element final [HMat3d [[I I I] r1]]
		if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;

		INVERT(m,0,1);	// replace le S3d en tte de pile..		
		
		n++;
    }

	MMpull(m);

	if(MMpush(m,NIL))		return MERRMEM;
	for(j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listOfPolygonsF
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d] [[HMat3d [[I F F] r1]] r1]
int ZM3listOfPolygonsF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listOfPolygonsF ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL))		{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);


	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	// Cration de la liste des faces
	if(faces->size()==0)			{	return MMpush(m,NIL);	}

	MMpush(m, s3d);

	int			n=0, mat3d, i, k, tmp_res;
	ZMaterial	*mater;
    for(int j=0; j<faces->size(); j++)
    {
		F = &((*faces)[j]);

		// recupre le materiau
		mater = F->GetMaterial();
		if (mater==NULL)	
		{
			if(MMpush(m,NIL))		return MERRMEM;
		}
		else
		{
			s3d = MMget(m,0);
			mat3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mater);
			if(mat3d!=NIL)	mat3d = PTOM(mat3d);
			if(MMpush(m, mat3d))		return MERRMEM;
		}

		// cration des tuples pour les vertices [I I I]
		for(i=0; i<3; i++)
		{
			if(MMpush(m, ITOM(F->VertRef[i])))				return MERRMEM;
			if(MMpush(m, FTOM(F->UV1[i].u)))				return MERRMEM;
			if(MMpush(m, FTOM(F->UV1[i].v)))				return MERRMEM;
	    	if(MMpush(m, 3*2))								return MERRMEM;
			if(k=MBdeftab(m))		return k;
		}
		if(MMpush(m,NIL)) return MERRMEM;

		// cration de la liste des vertices [[I I I] r1]
		for(i=0; i<3; i++)
		{
			if(MMpush(m,2*2))		return MERRMEM;
			if(k=MBdeftab(m))		return k;
		}

		// cration d'un element final [HMat3d [[I I I] r1]]
		if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;

		INVERT(m,0,1);	// replace le S3d en tte de pile..		
		
		n++;
    }

	MMpull(m);

	if(MMpush(m,NIL))		return MERRMEM;
	for(j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setPolygons
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d [[HMat3d [[I I I] r1]] r1]] I
int ZM3setPolygons(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setPolygons ");
#endif
	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	int		p, q, r, i, j;
	float	u[4], v[4];
	bool	rectangle;									// flag dsignant si le polygone est un rectangle ou un triangle

	MMset(m,0,0);

	rectangle = false;

	for(j=0; j<faces->size(); j++)
	{
		F = &((*faces)[j]);

		// CAS o la face prcdente tait un triangle
		if(!rectangle)
		{
			if(liste==NIL)
			{
				topo->hasTopoChanged = true;
				topo->hasViewChanged = true;
				topo->displayListCreate = false;

				scene->meshModified		= true;

				return 0;
			}

			// rcupre le tuple de donnes de la face
			if((p=MMfetch(m,liste,0)>>1)!=NIL)
			{
				// recupre les donnes des vertices
				q = MTOP(MMfetch(m,p,1));
				
				for(i=0; i<4; i++)
				{
					u[i] = -100.0f;

					if(q!=NIL)
					{
						r = MTOP(MMfetch(m,q,0));
						if(r!=NIL)
						{
							if(i==3)	rectangle = true;

							u[i] = ((float)MTOI(MMfetch(m,r,1))) / CONST_TEX_COORD;
							v[i] = ((float)MTOI(MMfetch(m,r,2))) / CONST_TEX_COORD;
						}
						q = MTOP(MMfetch(m,q,1));
					}
				}

				// attribue les donnes  la face courante
				if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
				if(u[1] != -100.0f)		{	F->UV1[1].u = u[1];		F->UV1[1].v = v[1];	}
				if(u[2] != -100.0f)		{	F->UV1[2].u = u[2];		F->UV1[2].v = v[2];	}

				if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
					F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
				else															F->clampU1 = true;

				if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
					F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
				else															F->clampV1 = true;
			}
			liste = MTOP(MMfetch(m,liste,1));
		}
		// CAS o la face prcdente tait un rectangle
		else
		{
			// attribue les donnes  la face courante
			if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
			if(u[2] != -100.0f)		{	F->UV1[1].u = u[2];		F->UV1[1].v = v[2];	}
			if(u[3] != -100.0f)		{	F->UV1[2].u = u[3];		F->UV1[2].v = v[3];	}

			if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
				F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
			else															F->clampU1 = true;

			if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
				F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
			else															F->clampV1 = true;

			rectangle = false;
		}
    }

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setPolygonsF
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d [[HMat3d [[I F F] r1]] r1]] I
int ZM3setPolygonsF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setPolygonsF ");
#endif
	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	int		p, q, r, i, j;
	float	u[4], v[4];
	bool	rectangle;									// flag dsignant si le polygone est un rectangle ou un triangle

	MMset(m,0,0);

	rectangle = false;

	for(j=0; j<faces->size(); j++)
	{
		F = &((*faces)[j]);

		// CAS o la face prcdente tait un triangle
		if(!rectangle)
		{
			if(liste==NIL)
			{
				topo->hasTopoChanged = true;
				topo->hasViewChanged = true;
				topo->displayListCreate = false;

				scene->meshModified		= true;

				return 0;
			}

			// rcupre le tuple de donnes de la face
			if((p=MMfetch(m,liste,0)>>1)!=NIL)
			{
				// recupre les donnes des vertices
				q = MTOP(MMfetch(m,p,1));

				for(i=0; i<4; i++)
				{
					u[i] = -100.0f;

					if(q!=NIL)
					{
						r = MTOP(MMfetch(m,q,0));
						if(r!=NIL)
						{
							if(i==3)	rectangle = true;

							u[i] = MTOF(MMfetch(m,r,1));
							v[i] = MTOF(MMfetch(m,r,2));
						}
						q = MTOP(MMfetch(m,q,1));
					}
				}

				// attribue les donnes  la face courante
				if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
				if(u[1] != -100.0f)		{	F->UV1[1].u = u[1];		F->UV1[1].v = v[1];	}
				if(u[2] != -100.0f)		{	F->UV1[2].u = u[2];		F->UV1[2].v = v[2];	}

				if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
					F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
				else															F->clampU1 = true;

				if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
					F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
				else															F->clampV1 = true;
			}
			liste = MTOP(MMfetch(m,liste,1));
		}
		// CAS o la face prcdente tait un rectangle
		else
		{
			// attribue les donnes  la face courante
			if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
			if(u[2] != -100.0f)		{	F->UV1[1].u = u[2];		F->UV1[1].v = v[2];	}
			if(u[3] != -100.0f)		{	F->UV1[2].u = u[3];		F->UV1[2].v = v[3];	}

			if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
				F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
			else															F->clampU1 = true;

			if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
				F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
			else															F->clampV1 = true;

			rectangle = false;
		}
    }

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3deltaPolygons
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d [[HMat3d [[I I I] r1]] r1]] I
int ZM3deltaPolygons(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3deltaPolygons ");
#endif
	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	int		p, q, r, i, j;
	float	u[4], v[4];
	bool	rectangle;												// flag dsignant si le polygone est un rectangle ou un triangle

	MMset(m,0,0);

	rectangle = false;

    for(j=0; j<faces->size(); j++)
    {
		F = &((*faces)[j]);

		// CAS o la face prcdente tait un triangle
		if(!rectangle)
		{
			if(liste==NIL)
			{
				topo->hasTopoChanged = true;
				topo->hasViewChanged = true;
				topo->displayListCreate = false;

				scene->meshModified	 = true;

				return 0;
			}

			// rcupre le tuple de donnes de la face
			if((p=MMfetch(m,liste,0)>>1)!=NIL)
			{
				// recupre les donnes des vertices
				q = MTOP(MMfetch(m,p,1));
				for(i=0; i<4; i++)
				{
					u[i] = -100.0f;
					
					if(q!=NIL)
					{
						r = MTOP(MMfetch(m,q,0));
						if(r!=NIL)
						{
							if(i==3)	rectangle = true;

							u[i] = ((float)MTOI(MMfetch(m,r,1))) / CONST_TEX_COORD;
							v[i] = ((float)MTOI(MMfetch(m,r,2))) / CONST_TEX_COORD;
						}
						q = MTOP(MMfetch(m,q,1));
					}
				}

				// attribue les donnes  la face courante
				if(u[0] != -100.0f)		{	F->UV1[0].u += u[0];		F->UV1[0].v += v[0];	}
				if(u[1] != -100.0f)		{	F->UV1[1].u += u[1];		F->UV1[1].v += v[1];	}
				if(u[2] != -100.0f)		{	F->UV1[2].u += u[2];		F->UV1[2].v += v[2];	}

				if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
					F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
				else															F->clampU1 = true;

				if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
					F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
				else															F->clampV1 = true;
			}
			liste = MTOP(MMfetch(m,liste,1));
		}
		// CAS o la face prcdente tait un rectangle
		else
		{
			// attribue les donnes  la face courante
			if(u[0] != -100.0f)		{	F->UV1[0].u += u[0];		F->UV1[0].v += v[0];	}
			if(u[2] != -100.0f)		{	F->UV1[1].u += u[2];		F->UV1[1].v += v[2];	}
			if(u[3] != -100.0f)		{	F->UV1[2].u += u[3];		F->UV1[2].v += v[3];	}

			if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
				F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
			else															F->clampU1 = true;

			if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
				F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
			else															F->clampV1 = true;

			rectangle = false;
		}
    }

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;



	scene->meshModified		= true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3deltaPolygonsF
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d [[HMat3d [[I F F] r1]] r1]] I
int ZM3deltaPolygonsF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3deltaPolygonsF ");
#endif
	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	int		p, q, r, i, j;
	float	u[4], v[4];
	bool	rectangle;												// flag dsignant si le polygone est un rectangle ou un triangle

	MMset(m,0,0);

	rectangle = false;

    for(j=0; j<faces->size(); j++)
    {
		F = &((*faces)[j]);

		// CAS o la face prcdente tait un triangle
		if(!rectangle)
		{
			if(liste==NIL)
			{
				topo->hasTopoChanged = true;
				topo->hasViewChanged = true;
				topo->displayListCreate = false;

				scene->meshModified	 = true;

				return 0;
			}

			// rcupre le tuple de donnes de la face
			if((p=MMfetch(m,liste,0)>>1)!=NIL)
			{
				// recupre les donnes des vertices
				q = MTOP(MMfetch(m,p,1));
				for(i=0; i<4; i++)
				{
					u[i] = -100.0f;
					
					if(q!=NIL)
					{
						r = MTOP(MMfetch(m,q,0));
						if(r!=NIL)
						{
							if(i==3)	rectangle = true;

							u[i] = MTOF(MMfetch(m,r,1));
							v[i] = MTOF(MMfetch(m,r,2));
						}
						q = MTOP(MMfetch(m,q,1));
					}
				}

				// attribue les donnes  la face courante
				if(u[0] != -100.0f)		{	F->UV1[0].u += u[0];		F->UV1[0].v += v[0];	}
				if(u[1] != -100.0f)		{	F->UV1[1].u += u[1];		F->UV1[1].v += v[1];	}
				if(u[2] != -100.0f)		{	F->UV1[2].u += u[2];		F->UV1[2].v += v[2];	}

				if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
					F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
				else															F->clampU1 = true;

				if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
					F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
				else															F->clampV1 = true;
			}
			liste = MTOP(MMfetch(m,liste,1));
		}
		// CAS o la face prcdente tait un rectangle
		else
		{
			// attribue les donnes  la face courante
			if(u[0] != -100.0f)		{	F->UV1[0].u += u[0];		F->UV1[0].v += v[0];	}
			if(u[2] != -100.0f)		{	F->UV1[1].u += u[2];		F->UV1[1].v += v[2];	}
			if(u[3] != -100.0f)		{	F->UV1[2].u += u[3];		F->UV1[2].v += v[3];	}

			if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
				F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
			else															F->clampU1 = true;

			if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
				F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
			else															F->clampV1 = true;

			rectangle = false;
		}
    }

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;



	scene->meshModified		= true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3morphPolygons
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d [[HMat3d [[I I I] r1]] r1] [[HMat3d [[I I I] r1]] r1] I] I
int ZM3morphPolygons(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3morphPolgons ");
#endif
	int rate  = MTOI(MMpull(m));
	int list1 = MTOP(MMpull(m));
	int list2 = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(list1==NIL)||(list2==NIL)||(rate==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	int		p, pp, q, qq, r, rr, i, j;
	float	u[4], v[4];
	bool	rectangle;												// flag dsignant si le polygone est un rectangle ou un triangle

	float	t = (float)rate;
	t /= CONST_ANGLE;
	float	ut = 1-t;

	float	val1, val2;

	MMset(m,0,0);

	rectangle = false;

    for(j=0; j<faces->size(); j++)
    {
		F = &((*faces)[j]);

		// CAS o la face prcdente tait un triangle
		if(!rectangle)
		{
			if((list1==NIL)||(list2==NIL))
			{
				topo->hasTopoChanged = true;
				topo->hasViewChanged = true;
				topo->displayListCreate = false;

				scene->meshModified	 = true;

				return 0;
			}

			// rcupre le tuple de donnes de la face
			if(((p=MMfetch(m,list1,0)>>1)!=NIL)&&((pp=MMfetch(m,list2,0)>>1)!=NIL))		// rcupre le tuple de donnes de la face
			{
				// recupre les donnes des vertices
				q  = MTOP(MMfetch(m,p,1));													// recupre les donnes des vertices 1
				qq = MTOP(MMfetch(m,pp,1));													// recupre les donnes des vertices 2

				for(i=0; i<4; i++)
				{
					u[i] = -100.0f;
					
					if((q!=NIL)&&(qq!=NIL))
					{
						r  = MTOP(MMfetch(m,q,0));
						rr = MTOP(MMfetch(m,qq,0));
	
						if((r!=NIL)&&(rr!=NIL))
						{
							if(i==3)	rectangle = true;

							val1 = ((float)MTOI(MMfetch(m,r,1)))  / CONST_TEX_COORD;
							val2 = ((float)MTOI(MMfetch(m,rr,1))) / CONST_TEX_COORD;
							u[i] = ut*val1 + t*val2;

							val1 = ((float)MTOI(MMfetch(m,r,2)))  / CONST_TEX_COORD;
							val2 = ((float)MTOI(MMfetch(m,rr,2))) / CONST_TEX_COORD;
							v[i] = ut*val1 + t*val2;
						}
						q  = MTOP(MMfetch(m,q,1));
						qq = MTOP(MMfetch(m,qq,1));
					}
				}

				// attribue les donnes  la face courante
				if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
				if(u[1] != -100.0f)		{	F->UV1[1].u = u[1];		F->UV1[1].v = v[1];	}
				if(u[2] != -100.0f)		{	F->UV1[2].u = u[2];		F->UV1[2].v = v[2];	}

				if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
					F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
				else															F->clampU1 = true;

				if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
					F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
				else															F->clampV1 = true;
			}
			list1 = MTOP(MMfetch(m,list1,1));
			list2 = MTOP(MMfetch(m,list2,1));
		}
		// CAS o la face prcdente tait un rectangle
		else
		{
			// attribue les donnes  la face courante
			if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
			if(u[2] != -100.0f)		{	F->UV1[1].u = u[2];		F->UV1[1].v = v[2];	}
			if(u[3] != -100.0f)		{	F->UV1[2].u = u[3];		F->UV1[2].v = v[3];	}

			if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
				F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
			else															F->clampU1 = true;

			if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
				F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
			else															F->clampV1 = true;

			rectangle = false;
		}
    }

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3morphPolygonsF
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d [[HMat3d [[I F F] r1]] r1] [[HMat3d [[I F F] r1]] r1] F] I
int ZM3morphPolygonsF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3morphPolygonsF ");
#endif
	int rate  = MMpull(m);
	int list1 = MTOP(MMpull(m));
	int list2 = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(list1==NIL)||(list2==NIL)||(rate==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	vector<ZFace>		*faces;
	ZFace				*F;
	faces = &(topo->Faces);

	int		p, pp, q, qq, r, rr, i, j;
	float	u[4], v[4];
	bool	rectangle;												// flag dsignant si le polygone est un rectangle ou un triangle

	float	t = MTOF(rate);
	float	ut = 1-t;

	float	val1, val2;

	MMset(m,0,0);

	rectangle = false;

    for(j=0; j<faces->size(); j++)
    {
		F = &((*faces)[j]);

		// CAS o la face prcdente tait un triangle
		if(!rectangle)
		{
			if((list1==NIL)||(list2==NIL))
			{
				topo->hasTopoChanged = true;
				topo->hasViewChanged = true;
				topo->displayListCreate = false;

				scene->meshModified	 = true;

				return 0;
			}

			// rcupre le tuple de donnes de la face
			if(((p=MMfetch(m,list1,0)>>1)!=NIL)&&((pp=MMfetch(m,list2,0)>>1)!=NIL))		// rcupre le tuple de donnes de la face
			{
				// recupre les donnes des vertices
				q  = MTOP(MMfetch(m,p,1));													// recupre les donnes des vertices 1
				qq = MTOP(MMfetch(m,pp,1));													// recupre les donnes des vertices 2

				for(i=0; i<4; i++)
				{
					u[i] = -100.0f;
					
					if((q!=NIL)&&(qq!=NIL))
					{
						r  = MTOP(MMfetch(m,q,0));
						rr = MTOP(MMfetch(m,qq,0));

						if((r!=NIL)&&(rr!=NIL))
						{
							if(i==3)	rectangle = true;

							val1 = MTOF(MMfetch(m,r,1));
							val2 = MTOF(MMfetch(m,rr,1));
							u[i] = ut*val1 + t*val2;

							val1 = MTOF(MMfetch(m,r,2));
							val2 = MTOF(MMfetch(m,rr,2));
							v[i] = ut*val1 + t*val2;
						}
						q  = MTOP(MMfetch(m,q,1));
						qq = MTOP(MMfetch(m,qq,1));
					}
				}

				// attribue les donnes  la face courante
				if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
				if(u[1] != -100.0f)		{	F->UV1[1].u = u[1];		F->UV1[1].v = v[1];	}
				if(u[2] != -100.0f)		{	F->UV1[2].u = u[2];		F->UV1[2].v = v[2];	}

				if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
					F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
				else															F->clampU1 = true;

				if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
					F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
				else															F->clampV1 = true;
			}
			list1 = MTOP(MMfetch(m,list1,1));
			list2 = MTOP(MMfetch(m,list2,1));
		}
		// CAS o la face prcdente tait un rectangle
		else
		{
			// attribue les donnes  la face courante
			if(u[0] != -100.0f)		{	F->UV1[0].u = u[0];		F->UV1[0].v = v[0];	}
			if(u[2] != -100.0f)		{	F->UV1[1].u = u[2];		F->UV1[1].v = v[2];	}
			if(u[3] != -100.0f)		{	F->UV1[2].u = u[3];		F->UV1[2].v = v[3];	}

			if( F->UV1[0].u<0.0f || F->UV1[1].u<0.0f || F->UV1[2].u<0.0f ||
				F->UV1[0].u>1.0f || F->UV1[1].u>1.0f || F->UV1[2].u>1.0f )	F->clampU1 = false;
			else															F->clampU1 = true;

			if( F->UV1[0].v<0.0f || F->UV1[1].v<0.0f || F->UV1[2].v<0.0f || 
				F->UV1[0].v>1.0f || F->UV1[1].v>1.0f || F->UV1[2].v>1.0f )	F->clampV1 = false;
			else															F->clampV1 = true;

			rectangle = false;
		}
    }

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}


 
//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoAddVertex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [I I I]] I
int ZM3topoAddVertex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoAddVertex ");
#endif
	int vtx  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL))						{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	// Recupre les coords du vertex
	float	vertX =  ((float)MTOI(MMfetch(m,MTOP(vtx),0))) / 100.0f;
	float	vertY =  ((float)MTOI(MMfetch(m,MTOP(vtx),1))) / 100.0f;
	float	vertZ = -((float)MTOI(MMfetch(m,MTOP(vtx),2))) / 100.0f;

	ZVert	vert;
	vert.color1.SetCoord(1.0f, 1.0f, 1.0f);
	vert.color2.SetCoord(1.0f, 1.0f, 1.0f);
	
	vert.SetCoord( vertX, vertY, vertZ );
	int numVert = topo->addVert(vert);

	MMset(m,0,ITOM(numVert));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoAddVertexF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [F F F]] I
int ZM3topoAddVertexF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoAddVertexF ");
#endif
	int vtx  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL))						{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	// Recupre les coords du vertex
	float	vertX =  MTOF(MMfetch(m,MTOP(vtx),0)) / 100.0f;
	float	vertY =  MTOF(MMfetch(m,MTOP(vtx),1)) / 100.0f;
	float	vertZ = -MTOF(MMfetch(m,MTOP(vtx),2)) / 100.0f;

	ZVert	vert;
	vert.color1.SetCoord(1.0f, 1.0f, 1.0f);
	vert.color2.SetCoord(1.0f, 1.0f, 1.0f);

	vert.SetCoord( vertX, vertY, vertZ );
	int numVert = topo->addVert(vert);

	MMset(m,0,ITOM(numVert));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoAddVertices
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[I I I] r1]] I
int ZM3topoAddVertices(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoAddVertices ");
#endif
	int vtx  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL))						{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	// Recupre les coords du vertex
	ZVert	vert;
	vert.color1.SetCoord(1.0f, 1.0f, 1.0f);
	vert.color2.SetCoord(1.0f, 1.0f, 1.0f);

	int coord, numVert=0;
	
	while(vtx!=NIL)
	{
		if((coord=MTOP(MMfetch(m,vtx,0))) != NIL)
		{
			float	vertX =  ((float)MTOI(MMfetch(m,coord,0))) / 100.0f;
			float	vertY =  ((float)MTOI(MMfetch(m,coord,1))) / 100.0f;
			float	vertZ = -((float)MTOI(MMfetch(m,coord,2))) / 100.0f;

			vert.SetCoord( vertX, vertY, vertZ );
			numVert = topo->addVert(vert);
		}
		vtx = MTOP(MMfetch(m,vtx,1));
	}

	MMset(m,0,ITOM(numVert));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoAddVerticesF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[F F F] r1]] I
int ZM3topoAddVerticesF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoAddVerticesF ");
#endif
	int vtx  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL))						{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	// Recupre les coords du vertex
	ZVert	vert;
	vert.color1.SetCoord(1.0f, 1.0f, 1.0f);
	vert.color2.SetCoord(1.0f, 1.0f, 1.0f);

	int coord, numVert=0;
	
	while(vtx!=NIL)
	{
		if((coord=MTOP(MMfetch(m,vtx,0))) != NIL)
		{
			float	vertX =  MTOF(MMfetch(m,coord,0)) / 100.0f;
			float	vertY =  MTOF(MMfetch(m,coord,1)) / 100.0f;
			float	vertZ = -MTOF(MMfetch(m,coord,2)) / 100.0f;

			vert.SetCoord( vertX, vertY, vertZ );
			numVert = topo->addVert(vert);
		}
		vtx = MTOP(MMfetch(m,vtx,1));
	}

	MMset(m,0,ITOM(numVert));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listOfVertices
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d] [[I I I] r1]
int ZM3listOfVertices(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listOfVertices ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL))		{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	
	ZVert	*vert;
	int		n=0, k;
	
	for(int j=0; j<topo->NbVerts; j++)
	{
		vert = &(topo->Verts[j]);
		if(MMpush(m,ITOM(AROUNDINT(100.0f*vert->x))))			return MERRMEM;
		if(MMpush(m,ITOM(AROUNDINT(100.0f*vert->y))))			return MERRMEM;
		if(MMpush(m,ITOM(AROUNDINT(-100.0f*vert->z))))			return MERRMEM;
    	if (MMpush(m,3*2))		return MERRMEM;
		if (k=MBdeftab(m))		return k;
		n++;
	}

	if(MMpush(m,NIL))		return MERRMEM;
	for(j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listOfVerticesF
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d] [[F F F] r1]
int ZM3listOfVerticesF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listOfVerticesF ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL))		{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	
	ZVert	*vert;
	int		n=0, k;
	
	for(int j=0; j<topo->NbVerts; j++)
	{
		vert = &(topo->Verts[j]);
		if(MMpush(m,FTOM(100.0f*vert->x)))			return MERRMEM;
		if(MMpush(m,FTOM(100.0f*vert->y)))			return MERRMEM;
		if(MMpush(m,FTOM(-100.0f*vert->z)))			return MERRMEM;
    	if (MMpush(m,3*2))		return MERRMEM;
		if (k=MBdeftab(m))		return k;
		n++;
	}

	if(MMpush(m,NIL))		return MERRMEM;
	for(j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoSetVertex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [I I I]] I
int ZM3topoSetVertex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoSetVertex ");
#endif
	int vtx  = MMpull(m);
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL)||(num==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(num);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	// Recupre les coords du vertex
	float	vertX =  ((float)MTOI(MMfetch(m,MTOP(vtx),0))) / 100.0f;
	float	vertY =  ((float)MTOI(MMfetch(m,MTOP(vtx),1))) / 100.0f;
	float	vertZ = -((float)MTOI(MMfetch(m,MTOP(vtx),2))) / 100.0f;

	topo->Verts[index].SetCoord( vertX, vertY, vertZ );

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;
	
	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoSetVertexF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [F F F]] I
int ZM3topoSetVertexF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoSetVertexF ");
#endif
	int vtx  = MMpull(m);
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL)||(num==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(num);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	// Recupre les coords du vertex
	float	vertX =  MTOF(MMfetch(m,MTOP(vtx),0)) / 100.0f;
	float	vertY =  MTOF(MMfetch(m,MTOP(vtx),1)) / 100.0f;
	float	vertZ = -MTOF(MMfetch(m,MTOP(vtx),2)) / 100.0f;

	topo->Verts[index].SetCoord( vertX, vertY, vertZ );

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;
	
	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoGetVertex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I] [I I I]
int ZM3topoGetVertex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoGetVertex ");
#endif
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(num==NIL))						{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(num);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	// cre le tuple final
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, ITOM(AROUNDINT(100.0f*topo->Verts[index].x)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(100.0f*topo->Verts[index].y)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(-100.0f*topo->Verts[index].z)));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoGetVertexF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I] [F F F]
int ZM3topoGetVertexF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoGetVertexF ");
#endif
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(num==NIL))						{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(num);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	// cre le tuple final
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, FTOM(100.0f*topo->Verts[index].x)  );
	MMstore(m, tuple, 1, FTOM(100.0f*topo->Verts[index].y)  );
	MMstore(m, tuple, 2, FTOM(-100.0f*topo->Verts[index].z) );

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setVertices
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[I I I] r1]] I
int ZM3setVertices(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setVertices ");
#endif
	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	ZVert	*vert;
	int		p;


	for(int j=0; j<topo->NbVerts; j++)
	{
		vert = &(topo->Verts[j]);

		if(liste==NIL)
		{
			topo->hasTopoChanged = true;
			topo->hasViewChanged = true;

			scene->meshModified	= true;

			MMpush(m,0);
			return 0;
		}

		if((p=MMfetch(m,liste,0)>>1)!=NIL)
		{
			vert->SetCoord( ((float)MTOI(MMfetch(m,p,0)))/100.0f, ((float)MTOI(MMfetch(m,p,1)))/100.0f, -((float)MTOI(MMfetch(m,p,2)))/100.0f );
		}
		
		liste = MTOP(MMfetch(m,liste,1));
    }

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;


	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

	MMpush(m,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setVerticesF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[F F F] r1]] I
int ZM3setVerticesF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setVerticesF ");
#endif
	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	ZVert	*vert;
	int		p;


	for(int j=0; j<topo->NbVerts; j++)
	{
		vert = &(topo->Verts[j]);

		if(liste==NIL)
		{
			topo->hasTopoChanged = true;
			topo->hasViewChanged = true;

			scene->meshModified	= true;

			MMpush(m,0);
			return 0;
		}

		if((p=MMfetch(m,liste,0)>>1)!=NIL)
		{
			vert->SetCoord( MTOF(MMfetch(m,p,0))/100.0f, MTOF(MMfetch(m,p,1))/100.0f, -MTOF(MMfetch(m,p,2))/100.0f );
		}
		
		liste = MTOP(MMfetch(m,liste,1));
    }

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;


	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

	MMpush(m,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3deltaVertex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [I I I]] I
int ZM3deltaVertex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3deltaVertex ");
#endif
	int vtx  = MMpull(m);
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL)||(num==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(num);
	if(index > topo->NbVerts)									{	MMset(m,0,NIL);		return 0;	}

	// Recupre les coords du vertex
	float	vertX = ((float)MTOI(MMfetch(m,MTOP(vtx),0))) / 100.0f;
	float	vertY = ((float)MTOI(MMfetch(m,MTOP(vtx),1))) / 100.0f;
	float	vertZ = -((float)MTOI(MMfetch(m,MTOP(vtx),2))) / 100.0f;

	topo->Verts[index].x += vertX;
	topo->Verts[index].y += vertY;
	topo->Verts[index].z += vertZ;

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;
	
	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3deltaVertexF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [I I I]] I
int ZM3deltaVertexF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3deltaVertexF ");
#endif
	int vtx  = MMpull(m);
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vtx==NIL)||(num==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(num);
	if(index > topo->NbVerts)									{	MMset(m,0,NIL);		return 0;	}

	// Recupre les coords du vertex
	float	vertX = MTOF(MMfetch(m,MTOP(vtx),0)) / 100.0f;
	float	vertY = MTOF(MMfetch(m,MTOP(vtx),1)) / 100.0f;
	float	vertZ = -MTOF(MMfetch(m,MTOP(vtx),2)) / 100.0f;

	topo->Verts[index].x += vertX;
	topo->Verts[index].y += vertY;
	topo->Verts[index].z += vertZ;

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;
	
	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3deltaVertices
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[I I I] r1]] I
int ZM3deltaVertices(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3deltaVertices ");
#endif

	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	
	ZVert	*vert;
	int		p;
	
    for(int j=0; j<topo->NbVerts; j++)
    {
		vert = &(topo->Verts[j]);

		if(liste==NIL)
		{
			topo->hasTopoChanged = true;
			topo->hasViewChanged = true;

			scene->meshModified		= true;

			MMpush(m,0);
			return 0;
		}

		if((p=MMfetch(m,liste,0)>>1)!=NIL)
		{
			vert->x += ((float)MTOI(MMfetch(m,p,0)))/100.0f;
			vert->y += ((float)MTOI(MMfetch(m,p,1)))/100.0f;
			vert->z += -((float)MTOI(MMfetch(m,p,2)))/100.0f;
		}
		
		liste = MTOP(MMfetch(m,liste,1));
    }
	
	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

	MMpush(m,0);
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3deltaVerticesF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[F F F] r1]] I
int ZM3deltaVerticesF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3deltaVerticesF ");
#endif

	int liste = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(liste==NIL))					{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	
	ZVert	*vert;
	int		p;
	
    for(int j=0; j<topo->NbVerts; j++)
    {
		vert = &(topo->Verts[j]);

		if(liste==NIL)
		{
			topo->hasTopoChanged = true;
			topo->hasViewChanged = true;

			scene->meshModified		= true;

			MMpush(m,0);
			return 0;
		}

		if((p=MMfetch(m,liste,0)>>1)!=NIL)
		{
			vert->x += MTOF(MMfetch(m,p,0))  / 100.0f;
			vert->y += MTOF(MMfetch(m,p,1))  / 100.0f;
			vert->z += -MTOF(MMfetch(m,p,2)) / 100.0f;
		}
		
		liste = MTOP(MMfetch(m,liste,1));
    }
	
	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified		= true;

	MMpush(m,0);
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3morphVertex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [I I I] [I I I] I] I
int ZM3morphVertex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3morphVertex ");
#endif
	int rate = MTOI(MMpull(m));
	int pos2 = MTOP(MMpull(m));
	int pos1 = MTOP(MMpull(m));
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(num==NIL)||(pos1==NIL)||(pos2==NIL)||(rate==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)																			{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(num);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	float	t = (float)rate;
	t /= CONST_ANGLE;
	float	ut = 1-t;

	// Recupre les coords 1 du vertex
	float	vertX1 = ((float)MTOI(MMfetch(m,pos1,0))) / 100.0f;
	float	vertY1 = ((float)MTOI(MMfetch(m,pos1,1))) / 100.0f;
	float	vertZ1 = -((float)MTOI(MMfetch(m,pos1,2))) / 100.0f;

	// Recupre les coords 2 du vertex
	float	vertX2 = ((float)MTOI(MMfetch(m,pos2,0))) / 100.0f;
	float	vertY2 = ((float)MTOI(MMfetch(m,pos2,1))) / 100.0f;
	float	vertZ2 = -((float)MTOI(MMfetch(m,pos2,2))) / 100.0f;

	topo->Verts[index].x = vertX1*ut + vertX2*t;
	topo->Verts[index].y = vertY1*ut + vertY2*t;
	topo->Verts[index].z = vertZ1*ut + vertZ2*t;

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3morphVertexF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [F F F] [F F F] F] I
int ZM3morphVertexF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3morphVertexF ");
#endif
	int rate = MMpull(m);
	int pos2 = MTOP(MMpull(m));
	int pos1 = MTOP(MMpull(m));
	int num  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(num==NIL)||(pos1==NIL)||(pos2==NIL)||(rate==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)																			{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
	{	MMset(m,0,NIL);		return 0;	}

	int index = MTOI(num);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	float	t = MTOF(rate);
	float	ut = 1-t;

	// Recupre les coords 1 du vertex
	float	vertX1 = MTOF(MMfetch(m,pos1,0)) / 100.0f;
	float	vertY1 = MTOF(MMfetch(m,pos1,1)) / 100.0f;
	float	vertZ1 = -MTOF(MMfetch(m,pos1,2)) / 100.0f;

	// Recupre les coords 2 du vertex
	float	vertX2 = MTOF(MMfetch(m,pos2,0)) / 100.0f;
	float	vertY2 = MTOF(MMfetch(m,pos2,1)) / 100.0f;
	float	vertZ2 = -MTOF(MMfetch(m,pos2,2)) / 100.0f;

	topo->Verts[index].x = vertX1*ut + vertX2*t;
	topo->Verts[index].y = vertY1*ut + vertY2*t;
	topo->Verts[index].z = vertZ1*ut + vertZ2*t;

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3morphVertices
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[I I I] r1] [[I I I] r1] I] I
int ZM3morphVertices(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3morphVertices ");
#endif

	int rate  = MTOI(MMpull(m));
	int list2 = MTOP(MMpull(m));
	int list1 = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(list1==NIL)||(list2==NIL)||(rate==NIL))					{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)																		{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	
	float	t = (float)rate;
	t /= CONST_ANGLE;
	float	ut = 1-t;


	ZVert	*vert;
	int		p, pp;
	
    for(int j=0; j<topo->NbVerts; j++)
    {
		vert = &(topo->Verts[j]);

		if((list1==NIL)||(list2==NIL))
		{
			topo->hasTopoChanged = true;
			topo->hasViewChanged = true;

			scene->meshModified		= true;

			MMpush(m,0);
			return 0;
		}

		if( ((p=MMfetch(m,list1,0)>>1)!=NIL) && ((pp=MMfetch(m,list2,0)>>1)!=NIL) )
		{
			vert->x = ut*((float)MTOI(MMfetch(m,p,0)))/100.0f + t*((float)MTOI(MMfetch(m,pp,0)))/100.0f;
			vert->y = ut*((float)MTOI(MMfetch(m,p,1)))/100.0f + t*((float)MTOI(MMfetch(m,pp,1)))/100.0f;
			vert->z = -(ut*((float)MTOI(MMfetch(m,p,2)))/100.0f + t*((float)MTOI(MMfetch(m,pp,2)))/100.0f);
		}
		
		list1 = MTOP(MMfetch(m,list1,1));
		list2 = MTOP(MMfetch(m,list2,1));
    }

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified	 = true;

	MMpush(m,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3morphVerticesF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[F F F] r1] [[F F F] r1] F] I
int ZM3morphVerticesF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3morphVerticesF ");
#endif
	int rate  = MMpull(m);
	int list2 = MTOP(MMpull(m));
	int list1 = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(list1==NIL)||(list2==NIL)||(rate==NIL))					{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)																		{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	
	float	t = MTOF(rate);
	float	ut = 1-t;

	ZVert	*vert;
	int		p, pp;
	
    for(int j=0; j<topo->NbVerts; j++)
    {
		vert = &(topo->Verts[j]);

		if((list1==NIL)||(list2==NIL))
		{
			topo->hasTopoChanged = true;
			topo->hasViewChanged = true;

			scene->meshModified		= true;

			MMpush(m,0);
			return 0;
		}

		if( ((p=MMfetch(m,list1,0)>>1)!=NIL) && ((pp=MMfetch(m,list2,0)>>1)!=NIL) )
		{
			vert->x =   ut*(MTOF(MMfetch(m,p,0)))/100.0f + t*(MTOF(MMfetch(m,pp,0)))/100.0f;
			vert->y =   ut*(MTOF(MMfetch(m,p,1)))/100.0f + t*(MTOF(MMfetch(m,pp,1)))/100.0f;
			vert->z = -(ut*(MTOF(MMfetch(m,p,2)))/100.0f + t*(MTOF(MMfetch(m,pp,2)))/100.0f);
		}

		list1 = MTOP(MMfetch(m,list1,1));
		list2 = MTOP(MMfetch(m,list2,1));
    }

	topo->hasTopoChanged = true;
	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;


	scene->meshModified	 = true;

	MMpush(m,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listOfColorVertices
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d H3d I] [I r1]
int ZM3listOfColorVertices(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listOfColorVertices ");
#endif
	int numP = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL))		{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	numP = MTOI(numP);
	if((numP>3)||(numP<1))			{	return MMpush(m,NIL);	}

	int			n=0, k;
	ZVector3	*color;
	int			coul;

	for(int j=0; j<topo->NbVerts; j++)
	{
		if(numP==1)		color = &(topo->Verts[j].color1);
		else			color = &(topo->Verts[j].color2);

		coul = AROUNDINT(color->z*CONST_COLOR) + (AROUNDINT(color->y*CONST_COLOR)<<8) + (AROUNDINT(color->x*CONST_COLOR)<<16);
		if(MMpush(m,ITOM(coul)))		return MERRMEM;

		n++;
	}

	if(MMpush(m,NIL))		return MERRMEM;
	for(j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoSetColorVertex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I I I] I
int ZM3topoSetColorVertex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoSetColorVertex ");
#endif
	int col  = MMpull(m);
	int numP = MMpull(m);
	int ind  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(ind==NIL)||(col==NIL)||(numP==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(ind);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	numP = MTOI(numP);
	if((numP>3)||(numP<1))			{	MMset(m,0,NIL);		return 0;	}

	// Recupre la couleur du vertex
	col = MTOI(col);
	
	ZVector3	*color;
	if(numP==1)		color = &(topo->Verts[index].color1);
	else			color = &(topo->Verts[index].color2);
	
	color->SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
		 			 ((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
					 ((float) (col&0x000000ff)	  )  / CONST_COLOR  );

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified	 = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3topoGetColorVertex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I I] I
int ZM3topoGetColorVertex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3topoGetColorVertex ");
#endif
	int numP = MMpull(m);
	int ind  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(numP==NIL)||(ind==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	int index = MTOI(ind);
	if(index > topo->NbVerts)		{	MMset(m,0,NIL);		return 0;	}

	numP = MTOI(numP);
	if((numP>3)||(numP<1))			{	MMset(m,0,NIL);		return 0;	}

	// cre le tuple final
	ZVector3	*color;
	if(numP==1)		color = &(topo->Verts[index].color1);
	else			color = &(topo->Verts[index].color2);

	int coul = AROUNDINT(color->z*CONST_COLOR) + (AROUNDINT(color->y*CONST_COLOR)<<8) + (AROUNDINT(color->x*CONST_COLOR)<<16);

	MMset(m,0,ITOM(coul));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setColorVertices
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I [I r1]] I
int ZM3setColorVertices(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setColorVertices ");
#endif
	int liste = MTOP(MMpull(m));
	int numP  = MMpull(m);
	int h3d   = MMpull(m);
    int s3d   = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(numP==NIL)||(liste==NIL))		{	return MMpush(m,NIL);	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	return MMpush(m,NIL);	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	return MMpush(m,NIL);	}
	
	ZMesh	*topo;

	if(node->type==OBJ_TYPE_ID)
	{
		topo = ((ZObject*)node)->GetMesh();
		if(topo==NULL)					{	return MMpush(m,NIL);	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		topo = (ZMesh*)node;
	}
	else
		return MMpush(m,NIL);

	numP = MTOI(numP);
	if((numP>3)||(numP<1))			{	MMset(m,0,NIL);		return 0;	}
	
	ZVector3	*color;
	int			p;

	for(int j=0; j<topo->NbVerts; j++)
	{
		if(numP==1)		color = &(topo->Verts[j].color1);
		else			color = &(topo->Verts[j].color2);

		if(liste==NIL)
		{
			topo->hasViewChanged = true;

			scene->meshModified	= true;

			MMpush(m,0);
			return 0;
		}

		if((p=MMfetch(m,liste,0)>>1)!=NIL)
		{
			color->SetCoord( ((float)((p&0x00ff0000)>>16)) / CONST_COLOR,
		 					 ((float)((p&0x0000ff00)>>8) ) / CONST_COLOR,
							 ((float) (p&0x000000ff)	 ) / CONST_COLOR );
		}

		liste = MTOP(MMfetch(m,liste,1));
    }

	topo->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	topo->displayListCreate = false;

	scene->meshModified		= true;

	MMpush(m,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3convVrt
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d H3d [I I I]] [I I I]
int ZM3convVrt(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3convVrt ");
#endif
	int vect = MTOP(MMpull(m));
	int dst  = MMpull(m);
	int src  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(src==NIL)||(dst==NIL)||(vect==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(src),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vector;
	vector.SetCoord(MTOI(MMfetch(m,vect,0)), MTOI(MMfetch(m,vect,1)), -MTOI(MMfetch(m,vect,2)));

	vector *= 0.01f;

	// on remonte au World space
	vector *= ComputeWorldMatrix(node);

	// on redescend  la destination
    node = (ZNode*)MMfetch(m,MTOP(dst),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	ZMatrix		mat = ComputeWorldMatrix(node);
	mat.Inverse();
	vector *= mat;

	// cre le tuple de rsultat	
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	vector *= 100.0f;

	MMstore(m, tuple, 0, ITOM(AROUNDINT(vector.x)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(vector.y)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(-vector.z)));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3convVrtF
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d H3d [F F F]] [F F F]
int ZM3convVrtF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3convVrtF ");
#endif
	int vect = MTOP(MMpull(m));
	int dst  = MMpull(m);
	int src  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(src==NIL)||(dst==NIL)||(vect==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(src),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vector;
	vector.SetCoord( MTOF(MMfetch(m,vect,0)), MTOF(MMfetch(m,vect,1)), -MTOF(MMfetch(m,vect,2)));

	vector *= 0.01f;

	// on remonte au World space
	vector *= ComputeWorldMatrix(node);

	// on redescend  la destination
    node = (ZNode*)MMfetch(m,MTOP(dst),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	ZMatrix		mat = ComputeWorldMatrix(node);
	mat.Inverse();
	vector *= mat;

	// cre le tuple de rsultat	
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	vector *= 100.0f;

	MMstore(m, tuple, 0, FTOM(vector.x));
	MMstore(m, tuple, 1, FTOM(vector.y));
	MMstore(m, tuple, 2, FTOM(-vector.z));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3convVec
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d H3d [I I I]] [I I I]
int ZM3convVec(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3convVec ");
#endif
	int vect = MTOP(MMpull(m));
	int dst  = MMpull(m);
	int src  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(src==NIL)||(dst==NIL)||(vect==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(src),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZVector4	vector;
	vector.SetCoord(MTOI(MMfetch(m,vect,0)), MTOI(MMfetch(m,vect,1)), -MTOI(MMfetch(m,vect,2)), 0);

	// on remonte au World space
	vector *= ComputeWorldMatrix(node);

	// on redescend  la destination
    node = (ZNode*)MMfetch(m,MTOP(dst),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	ZMatrix		mat = ComputeWorldMatrix(node);
	mat.Inverse();
	vector *= mat;

	// cre le tuple de rsultat	
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, ITOM(AROUNDINT(vector.x)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(vector.y)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(-vector.z)));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3convVecF
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d H3d [F F F]] [F F F]
int ZM3convVecF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3convVecF ");
#endif
	int vect = MTOP(MMpull(m));
	int dst  = MMpull(m);
	int src  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(src==NIL)||(dst==NIL)||(vect==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(src),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZVector4	vector;
	vector.SetCoord(MTOF(MMfetch(m,vect,0)), MTOF(MMfetch(m,vect,1)), -MTOF(MMfetch(m,vect,2)), 0);

	// on remonte au World space
	vector *= ComputeWorldMatrix(node);

	// on redescend  la destination
    node = (ZNode*)MMfetch(m,MTOP(dst),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}
	ZMatrix		mat = ComputeWorldMatrix(node);
	mat.Inverse();
	vector *= mat;

	// cre le tuple de rsultat	
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, FTOM(vector.x));
	MMstore(m, tuple, 1, FTOM(vector.y));
	MMstore(m, tuple, 2, FTOM(-vector.z));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}

