/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////*****************************************************************************************************////////////////
///////////////** 												    **///////////////
//////////////**								~ Zoo Engine (Moteur 3D pour SCOL) ~ **//////////////
/////////////**											  ~ version 1.0 ~     **/////////////
/////////////**													      **/////////////
//////////////**										par Pacme DANHIEZ   **//////////////
///////////////** 												    **///////////////
////////////////*****************************************************************************************************////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///																  ///
///		FICHIER :	Surface.cpp											  ///
///																  ///
///		NATURE	:	Dfinition des fonctions SCOL et gestion des tables de hachage					  ///
///																  ///
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//
// Modification History
//
//$LB (12/01/2006) : cut the file into several cpp files (./zooscol) to improve the compilation process
//


#include	"scol/zooscol.h"
#include "x11/common_x11.h"
#include "window/window_cb.h"
#include "bitmap/bitmap.h"
#include <linux/stddef.h>
#include <sys/time.h>

#ifdef	__OPTI_P4__
#include	<emmintrin.h>
#endif


#ifdef LIB3D_X11_DEBUG
#define	_SCOL_DEBUG_
#endif





#define		HASH_SIZE			256

#define		MYWND_WINDOWED			0
#define		MYWND_FULLSCREEN		2


#define		TYP_MESH_STATIC			1
#define		TYP_MESH_MULTI_TOPO		2
#define		TYP_MESH_NOT_CLICKABLE	        4

#define		RANGE_INFINITY			(-10)
#define		RANGE_INFINITY_F		(-20)

#define		TEX_MIPMAP			 2



//$LB cbmachine	ww;
mmachine	mm;


int			typeSurface;								// id Type pour les ObjSurfaces
int			typeSession;								// id Type pour les sessions


DWORD		dwSurfaceCount;

GdkWindow*	HScol;										// fentre SCOL principale

int			num3d = 0;




int			tmp_i;
int			tmp_f;





///////////////////////////////////
///		FENETRE OpenGL MERE		///
///////////////////////////////////

HGLRC		CreateMainContext();

//$LB HINSTANCE	hInstance;



bool		infoP3;
bool		infoP4;


bool		monClavier[256];















///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////


#ifdef _INFO_SCREEN_

extern bool	focusTreeGraph;
extern bool blockRendering;
extern bool refreshInfos;

HWND		mainInfoWND = NULL;
HGLRC		mainInfoRC	= NULL;
HDC			mainInfoDC	= NULL;

int			mainInfoWW = 0;
int			mainInfoWH = 0;

int			mainMouseX, mainMouseY;

HINSTANCE	hInstINFO;

bool		keysPressed[256];



bool	g_fDragging = false;


void Main_OnBeginSelect(HWND hwndTV, LPNMTREEVIEW lpnmtv) 
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("Main_OnBeginSelect"); 
      #endif

	selectedITEM = lpnmtv->itemNew.hItem;
}


void Main_OnBeginDrag(HWND hwndTV, LPNMTREEVIEW lpnmtv) 
{
    HIMAGELIST	himl;			// handle to image list 
    RECT		rcItem;			// bounding rectangle of item 
    DWORD		dwLevel;		// heading level of item 
    DWORD		dwIndent;		// amount that child items are indented 


      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("Main_OnBeginDrag"); 
      #endif

    // Tell the tree view control to create an image to use for dragging. 
    himl = TreeView_CreateDragImage(hwndTV, lpnmtv->itemNew.hItem); 
 
    // Get the bounding rectangle of the item being dragged. 
    TreeView_GetItemRect(hwndTV, lpnmtv->itemNew.hItem, &rcItem, TRUE); 
 
    // Get the heading level and the amount that the child items are indented. 
    dwLevel		= lpnmtv->itemNew.lParam; 
    dwIndent	= (DWORD) SendMessage(hwndTV, TVM_GETINDENT, 0, 0);

	// Start the drag operation. 
	ImageList_BeginDrag(himl, 0, 0, 0); 
 
    // Hide the mouse pointer, and direct mouse input to the 
    // parent window. 
    ShowCursor(FALSE); 
    SetCapture(GetParent(hwndTV)); 
    g_fDragging = true;
    return; 
} 


void Main_OnMouseMove(HWND hwndParent, HWND hwndTV, int xCur, int yCur) 
{ 
    HTREEITEM		htiTarget;  // handle to target item 
    TVHITTESTINFO	tvht;  // hit test information 


      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("Main_OnMouseMove"); 
      #endif

	if(g_fDragging) 
	{ 
		// Drag the item to the current position of the mouse pointer. 
        ImageList_DragMove(xCur, yCur);
 
        // Find out if the pointer is on the item. If it is, highlight the item as a drop target. 
        tvht.pt.x = xCur;
        tvht.pt.y = yCur;

		if((htiTarget = TreeView_HitTest(hwndTV, &tvht)) != NULL)		TreeView_SelectDropTarget(hwndTV, htiTarget);
    } 
    return;
}


void Main_OnLButtonUp(void) 
{ 

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("Main_OnLButtonUp"); 
      #endif

    if(g_fDragging) 
	{
        ImageList_EndDrag(); 
        ReleaseCapture(); 
        ShowCursor(TRUE); 
        g_fDragging = false; 
    } 
    return; 
} 

void Main_OnLButtonDown(int x, int y)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("Main_OnLButtonDown"); 
      #endif

	if(y<mainInfoWH-InfoScreenHH)
	{
		if(x<mainInfoWW/2)		focusTreeGraph = true;
		else					focusTreeGraph = false;
		focusInfo = 0;
	}
	else if(y<mainInfoWH-InfoMouseHH)
	{
		SetFocus(mainInfoWND);
		focusInfo = 1;
	}
	else if(y<mainInfoWH)
	{
		SetFocus(mainInfoWND);
		focusInfo = 2;
	}


	if( x<mainInfoWW-10 && x>mainInfoWW-20 && y<mainInfoWH-InfoScreenHH+20 && y>mainInfoWH-InfoScreenHH+10)
	{
		blockRendering = !blockRendering;
	}

	if( x<mainInfoWW-30 && x>mainInfoWW-40 && y<mainInfoWH-InfoScreenHH+20 && y>mainInfoWH-InfoScreenHH+10)
	{
		refreshInfos = true;
	}
}


#define LOWORD(l)					((WORD)(l))
#define HIWORD(l)					((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define GET_X_LPARAM(lp)			((int)(short)LOWORD(lp))
#define GET_Y_LPARAM(lp)			((int)(short)HIWORD(lp))



LRESULT CALLBACK InfoWndProc(HWND thisWindow, UINT msgType, WPARAM wParam, LPARAM lParam)
{
	int		xPos, yPos;


      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("InfoWndProc"); 
      #endif

	switch ( msgType )
	{
		case WM_LBUTTONDOWN:
			xPos = GET_X_LPARAM(lParam);
			yPos = GET_Y_LPARAM(lParam);
			Main_OnLButtonDown(xPos, yPos);
			break;

		case WM_NOTIFY: 
			switch (((LPNMHDR) lParam)->code) 
			{
				case TVN_BEGINDRAG:
					Main_OnBeginDrag(TreeGraph, (LPNMTREEVIEW) lParam);
					break; 

				case TVN_SELCHANGED:
					Main_OnBeginSelect(TreeGraph, (LPNMTREEVIEW) lParam);
					break;
			}
			break; 

		case WM_MOUSEMOVE:
			xPos = GET_X_LPARAM(lParam);
			yPos = GET_Y_LPARAM(lParam);
			Main_OnMouseMove(thisWindow, TreeGraph, xPos, yPos);
			break;

		case WM_CREATE:
			return 0;
			break;

		case WM_DESTROY:
			return 0;

		case WM_KEYUP:
			keysPressed[wParam] = false;
			break;

		case WM_KEYDOWN:
			keysPressed[wParam] = true;
			break;

		case WM_CHAR:

		case WM_LBUTTONUP:
			Main_OnLButtonUp();
			break;

		case WM_MBUTTONDOWN:
			break;

		case WM_RBUTTONDOWN:
			break;

		case WM_CLOSE:
			mainInfoWND = NULL;
			mainInfoDC	= NULL;
			mainInfoRC	= NULL;
	//		PostQuitMessage(0);
//			return 0;

		case WM_RBUTTONUP:
		case WM_MBUTTONUP:
		case WM_LBUTTONDBLCLK:
		case WM_RBUTTONDBLCLK:
		case WM_MBUTTONDBLCLK:
		case WM_CAPTURECHANGED:
//		case WM_MOUSEWHEEL:

		
		case WM_SETFOCUS:
		case WM_KILLFOCUS:
		case WM_PAINT:
			break;
	}

	return DefWindowProc(thisWindow,msgType,wParam,lParam);
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		CreateWinInfoSCREEN
//////////////////////////////////////////////////////////////////////////////////////////////
void CreateWinInfoSCREEN(int w, int h)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("CreateWinInfoSCREEN"); 
      #endif

	for(int ii=0; ii<255; ii++)		keysPressed[ii] = false;

	// Register the window-class
	WNDCLASS	infownd;

	infownd.style			= 0;
	infownd.cbClsExtra		= 0;
	infownd.cbWndExtra		= 0;
	infownd.hbrBackground	= 0;
	infownd.hCursor			= LoadCursor(NULL,IDC_ARROW);
	infownd.hIcon			= NULL;
	infownd.hInstance		= hInstance;
	infownd.lpfnWndProc		= InfoWndProc;
	infownd.lpszClassName	= "InfoGL";
	infownd.lpszMenuName	= NULL;

	RegisterClass(&infownd);



	HWND	hwnd;

	RECT	WindowRect;						// Grabs Rectangle Upper Left / Lower Right Values
	
	WindowRect.left		= (long) 0;			// Set Left Value To 0
	WindowRect.right	= (long) w;			// Set Right Value To Requested Width
	WindowRect.top		= (long) 0;			// Set Top Value To 0
	WindowRect.bottom	= (long) h;			// Set Bottom Value To Requested Height

	AdjustWindowRectEx(&WindowRect, WS_OVERLAPPEDWINDOW, FALSE, WS_EX_APPWINDOW | WS_EX_WINDOWEDGE);

	// Create The Window
	hwnd = CreateWindowEx(	WS_EX_APPWINDOW | WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW,				// Extended Style For The Window
							"InfoGL",										// Class Name
							"InfoGL",										// Window Title
							WS_SYSMENU | WS_CAPTION | WS_OVERLAPPED | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,	// Required Window Style
							0, 0,											// Window Position
							WindowRect.right-WindowRect.left,				// Calculate Window Width
							WindowRect.bottom-WindowRect.top,				// Calculate Window Height
							NULL,											// No Parent Window
							NULL,											// No Menu
							NULL,											// Instance
							NULL );											// Dont Pass Anything To WM_CREATE

	ShowWindow(hwnd, SW_SHOW);
	SetForegroundWindow(hwnd);
	SetFocus(hwnd);
	UpdateWindow(hwnd);

	HDC hdc = GetDC(hwnd);

	PIXELFORMATDESCRIPTOR pfd; 

	ZeroMemory(&pfd, sizeof(pfd)); 
	pfd.nSize	 = sizeof(pfd); 
	pfd.nVersion = 1;

	SetPixelFormat(hdc, mainPIXELFORMAT, &pfd);

	HGLRC hglrc	= wglCreateContext(hdc);

	if(wglGetCurrentContext()!=hglrc)
	{
		wglMakeCurrent(hdc,hglrc);
	}

	wglShareLists(mainglrc, hglrc);

	glViewport(0,0,w,h);												// Reset The Current Viewport

	mainInfoWW	= w;
	mainInfoWH	= h;
	mainInfoWND = hwnd;
	mainInfoDC	= hdc;
	mainInfoRC	= hglrc;
}

#endif


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////




unsigned long * colortable=NULL;

void Alloc15to32()
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("Alloc15to32"); 
      #endif

	colortable = (unsigned long*) malloc(sizeof(unsigned long)*32768);
	if(!colortable)		return;

	for(int i=0; i<32768; i++)
	{
		unsigned char	r = ((i>>10)&31)<<3;
		unsigned char	g = ((i>>5)&31)<<3;
		unsigned char	b = (i&31)<<3;
		colortable[i]=(b<<16) + (g<<8) + (r) + 0xFF000000;
	}
}




///////////////////////////////////////////////////////////////////////////////////
///		createH3D																///
///////////////////////////////////////////////////////////////////////////////////
///	Cre un nouveau H3D et renvoit le pointeur SCOL correspondant (pas le mot)
int	createH3D(mmachine m, int adress, int hash_tab)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("createH3D"); 
      #endif

	MMpush(m, PTOM(hash_tab) );

	// Cre le H3D dans SCOL
	int h3d = MMmalloc(m, 3, TYPETAB);
	if(h3d==NIL)		return MERRMEM;
	MMstore(m, h3d, 0, adress);					// pointeur C sur le node
	MMstore(m, h3d, 1, NIL);						// call-back 1
	MMstore(m, h3d, 2, NIL);						// call-back 2

	MMpush(m, PTOM(h3d) );

	// Cre la case dans la hash_table
	int boxHash = MMmalloc(m, 3, TYPETAB);
	if(boxHash==NIL)		return MERRMEM;
	MMstore(m, boxHash, 1, adress);				// pointeur C sur le node
	h3d = MTOP( MMpull(m) );
	MMstore(m, boxHash, 2, PTOM(h3d) );				// MOT-pointeur SCOL sur le H3D

	hash_tab = MTOP( MMpull(m) );
	int place = (adress>>4) % HASH_SIZE;
	int	nextCase = MMfetch(m, hash_tab, place);
	MMstore(m, boxHash, 0, nextCase);				// MOT-pointeur sur la case suivante

	// Place la case dans la hash_table
	MMstore(m, hash_tab, place, PTOM(boxHash));

	return	h3d;
}



///////////////////////////////////////////////////////////////////////////////////
///		createHmatHtx															///
///////////////////////////////////////////////////////////////////////////////////
///	Cre un nouveau MAT ou TEX et renvoit le pointeur SCOL correspondant (pas le mot)
int	createHmatHtx(mmachine m, int adress, int hash_tab)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("createHmatHtx"); 
      #endif

	MMpush(m, PTOM(hash_tab) );

	// Cre le MAT ou le TEX dans SCOL
	int mat = MMmalloc(m, 1, TYPETAB);
	if(mat==NIL)		return MERRMEM;
	MMstore(m, mat, 0, adress);						// pointeur C sur le node

	MMpush(m, PTOM(mat) );

	// Cre la case dans la hash_table
	int boxHash = MMmalloc(m, 3, TYPETAB);
	if(boxHash==NIL)		return MERRMEM;
	MMstore(m, boxHash, 1, adress);					// pointeur C sur le node
	MMstore(m, boxHash, 2, MMpull(m));				// MOT-pointeur SCOL sur le H3D

	hash_tab = MTOP( MMpull(m) );
	int place = (adress>>4) % HASH_SIZE;
	int	nextCase = MMfetch(m, hash_tab, place);
	MMstore(m, boxHash, 0, nextCase);				// MOT-pointeur sur la case suivante

	// Place la case dans la hash_table
	MMstore(m, hash_tab, place, PTOM(boxHash));

	return	mat;
}



///////////////////////////////////////////////////////////////////////////////////
///		NodeTOHandle															///
///////////////////////////////////////////////////////////////////////////////////
///	Retourne le handle correspondant  un Node -- Valable pour les ZNodes de TOUT type
int	NodeTOHandle(mmachine m, int hash_tab, int adress)
{

      #ifdef LIB3D_X11_DEBUG 
      //SCOL_X11_DEBUG("NodeTOHandle"); 
      #endif

	int place	= (adress>>4) % HASH_SIZE;
	int	curBox	= MMfetch(m, hash_tab, place);

	while( (curBox!=NIL) && (adress!=MMfetch(m,MTOP(curBox),1)) )		curBox = MMfetch(m,MTOP(curBox),0);

	if(curBox==NIL)		return NIL;

	return	MTOP( MMfetch(m,MTOP(curBox),2) );
}



///////////////////////////////////////////////////////////////////////////////////
///		DelObj																	///
///////////////////////////////////////////////////////////////////////////////////
///	Efface un handle de TOUT type - Donnes passes en pointeurs SCOL (pas en mots..)
int	DelObj(mmachine m, int hash_tab, int handle)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("DelObj"); 
      #endif

	// supprime le pointeur C dans le H3D
	int adress = MMfetch(m, handle, 0);
	MMstore(m, handle, 0, (int)NULL);

	// supprime la case de la hash_table
	int place = (adress>>4) % HASH_SIZE;
	int	curBox = MMfetch(m, hash_tab, place);

	if( adress == MMfetch(m,MTOP(curBox),1) )		// CAS DU PREMIER ELEMENT
	{
		MMstore(m, MTOP(curBox), 2, NIL);
		MMstore(m, MTOP(curBox), 1, (int)NULL);

		int next = MMfetch(m,MTOP(curBox),0);
		MMstore(m, MTOP(curBox), 0, NIL);
		MMstore(m, hash_tab, place, next);
	}
	else											// CAS DES ELEMENTS SUIVANTS
	{
		int next = MMfetch(m,MTOP(curBox),0);
		
		while( (next!=NIL) && (adress!=MMfetch(m,MTOP(next),1)) )
		{
			curBox	= next;
			next	= MMfetch(m,MTOP(curBox),0);
		}

		if(next!=NIL)
		{
			MMstore(m, MTOP(next), 2, NIL);
			MMstore(m, MTOP(next), 1, (int)NULL);
			MMstore(m, MTOP(curBox), 0, MMfetch(m,MTOP(next),0) );
			MMstore(m, MTOP(next), 0, NIL);
		}
		else
			return 1;	// retour d'erreur : aucune case ne correspond
	}

	return 0;
}



///////////////////////////////////////////////////////////////////////////////////////////
///								FUNCTION WHICH	DELETE A NODE							///
///////////////////////////////////////////////////////////////////////////////////////////
void DeleteRecursiveNode(mmachine m, int hash_tab, ZNode *firstNode)
{
	ZNode	*curNode, *nodeSon, *nodeNext;
	int		h3d;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("DeleteRecursiveNode"); 
      #endif


	curNode = firstNode;

	while(curNode != NULL)
	{
		nodeSon  = curNode->son;
		nodeNext = curNode->next;

		delete curNode;
		
		h3d = NodeTOHandle(m, hash_tab, (int)curNode);
		DelObj(m, hash_tab, h3d);

		// Test of recursion
		if(nodeSon!=NULL)			DeleteRecursiveNode(m, hash_tab, nodeSon);
		curNode = nodeNext;
	}
}


 
void DeleteNode(mmachine m, int hash_tab, ZNode *baseNode)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("DeleteNode"); 
      #endif

	if(baseNode->father)
	{
		// SEPARE THE NODE FROM THE HIERARCHY
		// if the son of the father link is equal to the current node (first node of the list)
		if (baseNode->father->son == baseNode)
		{
			baseNode->father->son = baseNode->next;
			if (baseNode->next)		baseNode->next->prev = baseNode->prev;
		}
		else
		{
			if (!baseNode->next)	baseNode->father->son->prev = baseNode->prev;						// If the node is the last, fix the prevlink of the first child
			baseNode->prev->next = baseNode->next;
			if (baseNode->next)		baseNode->next->prev = baseNode->prev;
		}

		baseNode->prev = baseNode->next = NULL;													// Brother links are free, but the attached tree is available
	}	

	// DELETE the attached hierarchy
	DeleteRecursiveNode(m, hash_tab, baseNode->son);

	// finally DELETE the baseNode
	delete baseNode;
}



///////////////////////////////////////////////////////////////////////////////////
///		CleanHash																///
///////////////////////////////////////////////////////////////////////////////////
///	Efface tous les lments d'une hash table
void CleanHash(mmachine m, int hash_tab)
{
	int		i, curBox, nextBox, h3d;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("CleanHash"); 
      #endif


	for(i=0; i<HASH_SIZE; i++)
	{
		curBox = MMfetch(m, hash_tab, i);

		while(curBox!=NIL)
		{
			MMstore(m, MTOP(curBox), 1, (int)NULL);		// efface le pointeur C dans la case de la hash_tab
			
			h3d = MMfetch(m, MTOP(curBox), 2);			// efface le pointeur C dans le H3d correspondant  la case
			MMstore(m, MTOP(h3d), 0, (int)NULL);

			MMstore(m, MTOP(curBox), 2, NIL);			// efface le pointeur C dans la case de la hash_tab

			nextBox = MMfetch(m, MTOP(curBox), 0);		// passage  l'lment suivant
			MMstore(m, MTOP(curBox), 0, NIL);			// efface le pointeur C dans la case de la hash_tab

			curBox = nextBox;
		}

		MMstore(m, hash_tab, i, NIL);
	}
}




///////////////////////////////////////////////////////////////////////////////////
///		getBigFather															///
///////////////////////////////////////////////////////////////////////////////////
ZNode*	getBigFather(ZNode* node)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("	getBigFather"); 
      #endif

	ZNode	*curNode = node;
	while(curNode->father->type <= MAX_NODE_SCENE)		curNode = curNode->father;
	return curNode;
}








////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                //
//   include sources files                                                                        //
//                                                                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////


//$LB (12/01/2006)
/*
#include "zooscol/sess_surf.inl"

#include "zooscol/obj.inl"

#include "zooscol/geo.inl"

#include "zooscol/topo.inl"

#include "zooscol/mesh.inl"

#include "zooscol/mat.inl"

#include "zooscol/tex.inl"

#include "zooscol/render.inl"

#include "zooscol/coll.inl"

#include "zooscol/anim.inl"

#include "zooscol/light.inl"

#include "zooscol/sprite.inl"

#include "zooscol/interp.inl"

#include "zooscol/oldies.inl"

#include "zooscol/scolfun.inl"
*/




//$LB
/*
#define GET_X_LPARAM(lp)			((int)(short)LOWORD(lp))
#define GET_Y_LPARAM(lp)			((int)(short)HIWORD(lp))
*/

 

//$LB
/*
LRESULT CALLBACK GLWndProc (HWND thisWindow, UINT msgType, WPARAM wParam, LPARAM lParam)     
{
	LPARAM	newparam;
	POINT	point;
	HWND	parent;


	if( (parent=GetParent(thisWindow)) == NULL)		return DefWindowProc(thisWindow,msgType,wParam,lParam);

	// Traitement pour chaque type d'vnement
	switch ( msgType )
	{
		//case WM_MOUSEWHEEL:
		case WM_LBUTTONDOWN:
		case WM_RBUTTONDOWN: 
		case WM_MBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_RBUTTONUP:
		case WM_MBUTTONUP:
		case WM_LBUTTONDBLCLK:
		case WM_RBUTTONDBLCLK:
		case WM_MBUTTONDBLCLK:
		case WM_MOUSEMOVE:
#ifdef _INFO_SCREEN_
			mainMouseX = GET_X_LPARAM(lParam);
			mainMouseY = GET_Y_LPARAM(lParam);
#endif 
			point.x = GET_X_LPARAM(lParam);
			point.y = GET_Y_LPARAM(lParam);
			ClientToScreen(thisWindow, &point);
			ScreenToClient(parent, &point);
			newparam = MAKELONG(point.x, point.y);
			PostMessage(GetParent(thisWindow), msgType, wParam, newparam);
			break;

		case WM_KEYUP:
//			monClavier[wParam] = false;

		case WM_KEYDOWN:
//			monClavier[wParam] = true;

		case WM_CHAR:
		case WM_CAPTURECHANGED:
		case WM_SETFOCUS:
		case WM_KILLFOCUS:
		case WM_PAINT:
			PostMessage(GetParent(thisWindow),msgType,wParam,lParam);
			break;

		case WM_CREATE:
			SetWindowLong(thisWindow,GWL_USERDATA,lParam);
			return 0;
			break;

		case WM_DESTROY:
			{
				OBJdelTH(mm, typeSurface, (int)thisWindow);
			}
			return 0;
			break;

	}

	return DefWindowProc(thisWindow,msgType,wParam,lParam);
}
*/











///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///							      FONCTIONS D'APPEL DE LA DLL                           ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



int LoadEngine(mmachine m)
{
	int			k;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG(" LoadEngine"); 
      #endif


	MMechostr(0,"\n" );
	MMechostr(0,"*************************    Zoo Engine   *************************\n" );

	k = PKhardpak(m, "ZooEngine", NbZooPKG, ZooName, ZooFunc, ZooNArg, ZooType);

	// Declaration des types de donne
	typeSurface = OBJregister(0, 0, ZooDestroySurface, "OBJTYPESURFACE");			// type 'ObjSurface'
        typeSession	= OBJregister(0, 0, ZooDestroySession, "OBJTYPE3D");				// type 'S3d'



	//==== Init des classes de fentre OGL ====
	//$LB HScol = NULL;
	//$LB HScol = (HWND)SCgetExtra("hscol");
	HScol = GDK_ROOT_PARENT ();

	//$LB
	/*
	WNDCLASS	glwnd;
	hInstance   = GetModuleHandle(NULL);    // Grab An Instance For Our Window
	glwnd.style			= CS_DBLCLKS;
	glwnd.cbClsExtra	= 0;
	glwnd.cbWndExtra	= 0;
	glwnd.hbrBackground	= 0;
	glwnd.hCursor		= LoadCursor(NULL,IDC_ARROW);
	glwnd.hIcon			= NULL;
	glwnd.hInstance		= hInstance;
	glwnd.lpfnWndProc	= GLWndProc;
	glwnd.lpszClassName	= "scolGL";
	glwnd.lpszMenuName	= NULL;

	RegisterClass(&glwnd);
	*/

	Alloc15to32();

	//==== Software inits ====
	Zbuffer = (CELL*) malloc( 1600 * sizeof(CELL));


	InitPaletteSOFT();



#ifdef	__OPTI_P3__

	if(testP3())		{	infoP3 = true;		MMechostr(0,"*****  SSE1 supported !                                       *****\n" );		}
	else				{	infoP3 = false;		MMechostr(0,"*****  SSE1 not supported                                     *****\n" );		}

	if(testP4())		{	infoP4 = true;		MMechostr(0,"*****  SSE2 supported !                                       *****\n" );		}
	else				{	infoP4 = false;		MMechostr(0,"*****  SSE2 not supported                                     *****\n" );		}

#else

	infoP4 = infoP3 = false;

#endif

	MMechostr(0,"**********************  Successfully Loaded  **********************\n" );
	MMechostr(0,"\n" );

	return k;
}



///////////////////////////////////////////////
///		FUNCTIONS for Engine declaring		///
///////////////////////////////////////////////
//int		(*MX3registerDevice)(char *clearname,char *id);


///////////////////////////////////////////////
///		FUNCTIONS for Sound Loading			///
///////////////////////////////////////////////
int		SCOLloadSound(mmachine m);				// Declaration in Sound.cpp
int		SCOLfreeSound();					// Declaration in Sound.cpp


///////////////////////////////////////////////
///		FUNCTION for Particle Loading		///
///////////////////////////////////////////////
int		SCOLloadParticle(mmachine m);			// Declaration in Particle4.cpp


///////////////////////////////////////////////
///		FUNCTION for Callback3D Loading		///
///////////////////////////////////////////////
int		SCOLloadCB3D(mmachine m);				// Declaration in Particle4.cpp


///////////////////////////////////////////////
///		FUNCTION for BOX loading			///
///////////////////////////////////////////////
int		SCOLloadBOX(mmachine m);							// Declaration in Particle4.cpp








