/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////*****************************************************************************************************////////////////
///////////////** 												    **///////////////
//////////////**				~ Zoo Engine (Moteur 3D pour SCOL) ~				     **//////////////
/////////////**							     ~ version 1.0 ~				      **/////////////
/////////////**													      **/////////////
//////////////**						  par Pacme DANHIEZ		  		     **//////////////
///////////////** 											            **///////////////
////////////////*****************************************************************************************************////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///																																  ///
///		FICHIER :	Surface.h																									  ///
///																																  ///
///		NATURE	:	Dfinition des fonctions SCOL et gestion des tables de hachage												  ///
///																																  ///
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




#ifndef __SURFACE_H__
#define __SURFACE_H__




#include "x11/common_x11.h"
#include	"scol/winuser.h"
#include	"basic/zoostd.h"

#include	"basic/zoodetect.h"

#include "GLX/scolglx.h"




#define MAX_Z 1.0f

// Maximum length of the chosen device name and description of the 
// chosen Direct3D device. 

#define MAX_DEVICE_NAME			256
#define MAX_DEVICE_DESC			256
#define MAX_DEVICES_NUM			6

// Standard return values

#define COLORTRANSP 0x1

#define WIRE_MODE	1
#define SOLID_MODE	2
#define SPLINE_MODE	4


#define MX3D_RET_OK		2
#define MX3D_RET_FAIL	NIL


extern HGLRC	CreateMainContext();
extern HGLRC	mainglrc;


int		SCOLloadMX3d(mmachine m); // Loads all 3D API verbs.

int		createH3D(mmachine m, int adress, int hash_tab);
int		createHmatHtx(mmachine m, int adress, int hash_tab);

int		NodeTOHandle(mmachine m, int hash_tab, int adress);
int		DelObj(mmachine m, int hash_tab, int handle);





#include	"basic/zooscene.h"
#include	"collision/zoooldcoll.h"
#include	"loaders/m3d/zoom3d.h"


#include	"scol/ext.h"
#include	"scol/objstr.h"


#include	"scol/winuser.h"
#include	"scol/macro.h"


















#endif //#if !defined __SURFACE_H__


