//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///				   GESTION DES ANIMATIONS							    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
///		FONCTIONS POUR ZM3setAnimKey
//////////////////////////////////////////////////////////////////////////////////////////////
int M3DrecAnimKey(ZNode *node, ZNode *pere, float key, int flag, int first)
{
	if(node==NULL)		return -1;

	if((node->type==ANI_TYPE_ID)&&(pere!=NULL))
	{
		ZAnim	*anim = (ZAnim*) node;
		ZPRS	*prs = NULL;

		prs = ((ZNodeGraph*)pere)->GetPRS();
		
		anim->putAnimKey(prs, key, flag);
	}

	if((!first)&&(node->next!=NULL))
    {
		if(M3DrecAnimKey(node->next, pere, key, flag, 0))			return -1;
    }

	if(node->son!=NULL)
    {
		if(M3DrecAnimKey(node->son, node, key, flag, 0))			return -1;
    }

	return 0;
}

// M3DsetAnimKey
int M3DsetAnimKey(ZNode *node, float key, int flag)
{
	return M3DrecAnimKey(node, NULL, key, flag, 1);
}

//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setAnimKey
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I] I
int ZM3setAnimKey(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setAnimKey ");
#endif


	int key  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(key==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)								{	MMset(m,0,NIL);		return 0;	}

	int p = M3DsetAnimKey(node, MTOI(key), -1);

	MMset(m,0,ITOM(p));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setAnimKeyF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d F] I
int ZM3setAnimKeyF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setAnimKeyF ");
#endif
	int key  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(key==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)								{	MMset(m,0,NIL);		return 0;	}

	int p = M3DsetAnimKey(node, MTOF(key), -1);

	MMset(m,0,ITOM(p));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		FONCTIONS POUR ZM3setAnimKey2
//////////////////////////////////////////////////////////////////////////////////////////////
int M3DrecAnimKey2(ZNode *node, ZNode *pere, float key1, float key2, float rate, int flag, int first)
{
	if(node==NULL)		return -1;

	if((node->type==ANI_TYPE_ID)&&(pere!=NULL))
	{
		ZAnim	*anim = (ZAnim*) node;
		ZPRS	*prs = NULL;

		prs = ((ZNodeGraph*)pere)->GetPRS();

		anim->putAnimKeyInterp(prs, key1, key2, rate, flag);
	}
	
	if((!first)&&(node->next!=NULL))
    {
		if(M3DrecAnimKey2(node->next, pere, key1, key2, rate, flag, 0))		return -1;
    }

	if(node->son!=NULL)
    {
		if(M3DrecAnimKey2(node->son, node, key1, key2, rate, flag, 0))		return -1;
    }
  
	return 0;
}


int M3DsetAnimKey2(ZNode *node, float key1, float key2, float rate, int flag)
{
	return M3DrecAnimKey2(node, NULL, key1, key2, rate, flag, 1);
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setAnimKey2
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I I I] I
int ZM3setAnimKey2(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setAnimKey2 ");
#endif
	int rate = MMpull(m);
	int key2 = MMpull(m);
	int key1 = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(key1==NIL)||(key2==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)												{	MMset(m,0,NIL);		return 0;	}

	rate = MTOI(rate) & 255;

	int p = M3DsetAnimKey2(node, MTOI(key1), MTOI(key2), ((float)rate)/CONST_VAL8, -1);

	MMset(m,0,ITOM(p));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
   return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setAnimKey2F
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d F F F] I
int ZM3setAnimKey2F(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setAnimKey2F ");
#endif

	int rate = MMpull(m);
	int key2 = MMpull(m);
	int key1 = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(key1==NIL)||(key2==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)												{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)												{	MMset(m,0,NIL);		return 0;	}

	int p = M3DsetAnimKey2(node, MTOF(key1), MTOF(key2), MTOF(rate), -1);

	MMset(m,0,ITOM(p));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		FONCTIONS POUR ZM3applyAnimKey
//////////////////////////////////////////////////////////////////////////////////////////////
ZNode*	findObj3d(ZNode *node, string name)
{
	while(node!=NULL)
	{
		if(node->name==name)		return node;
		node = node->next;
	}
	return NULL;
}


int M3DrecApplyAnimKey(ZNode *nodeA, ZNode *nodeT, float key, int flag)
{
	if(nodeA==NULL)		return -1;

	ZNode *node;
	if( (node=findObj3d(nodeT,nodeA->name)) != NULL )
	{
		if(nodeA->type==ANI_TYPE_ID)
		{
			ZAnim	*anim = (ZAnim*) nodeA;
			ZPRS	*prs = NULL;

			prs = ((ZNodeGraph*)node)->GetPRS();

			anim->putAnimKey(prs, key, flag);
		}

		if(nodeA->son!=NULL)
		{
			if(M3DrecApplyAnimKey(nodeA->son, node->son, key, flag))	return -1;
		}
	}

	if(nodeA->next!=NULL)
    {
		if(M3DrecApplyAnimKey(nodeA->next, nodeT, key, flag))		return -1;
    }
	return 0;
}


int M3DapplyAnimKey(ZNode *nodeA, ZNode *nodeT, float key, int flag)
{
	if((flag & ANIM_TOP) && (nodeA->type==ANI_TYPE_ID))
	{
		ZAnim	*anim = (ZAnim*) nodeA;
		ZPRS	*prs = NULL;

		prs = ((ZNodeGraph*)nodeT)->GetPRS();
		
		anim->putAnimKey(prs, key, flag);
	}

	return M3DrecApplyAnimKey(nodeA->son, nodeT->son, key, flag);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3applyAnimKey
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d I I] I
int ZM3applyAnimKey(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3applyAnimKey ");
#endif

	int flag = MMpull(m);
	int key  = MMpull(m);
	int top  = MMpull(m);
	int ani  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(ani==NIL)||(top==NIL)||(key==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeA = (ZNode*) MMfetch(m,MTOP(ani),0);
	if(nodeA==NULL)														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeT = (ZNode*) MMfetch(m,MTOP(top),0);
	if(nodeT==NULL)														{	MMset(m,0,NIL);		return 0;	}

	int p = M3DapplyAnimKey(nodeA, nodeT, MTOI(key), MTOI(flag));
    
	MMset(m,0,ITOM(p));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

   return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3applyAnimKeyF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d F I] I
int ZM3applyAnimKeyF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3applyAnimKeyF ");
#endif

	int flag = MMpull(m);
	int key  = MMpull(m);
	int top  = MMpull(m);
	int ani  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(ani==NIL)||(top==NIL)||(key==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeA = (ZNode*) MMfetch(m,MTOP(ani),0);
	if(nodeA==NULL)														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeT = (ZNode*) MMfetch(m,MTOP(top),0);
	if(nodeT==NULL)														{	MMset(m,0,NIL);		return 0;	}

	int p = M3DapplyAnimKey(nodeA, nodeT, MTOF(key), MTOI(flag));
    
	MMset(m,0,ITOM(p));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		FONCTIONS POUR ZM3applyAnimKey2
//////////////////////////////////////////////////////////////////////////////////////////////
bool M3DanimKey2(ZAnim *ani0, ZAnim *ani1, ZPRS *prs, float frame0, float frame1, float rate, int flag)
{
	if(prs==NULL)		return false;


	int length0 = ani0->getLength();
	int length1 = ani1->getLength();
	
	if( (frame0<0) || (frame0>length0) || (frame1<0) || (frame1>length1) )		return false;


	///////////////////////////
	// ----> POSITION <----- //
	///////////////////////////

	if(flag & ANIM_POS)
	{
		ZVector3	pos0, pos1;

		//--- Position 0 ---//

		if(ani0->listPos.size())
		{
				 if(frame0 >= ani0->maxKeyPos)			pos0 = ani0->listPos[ani0->listPos.size()-1].pos;
			else if(frame0 <= ani0->minKeyPos)			pos0 = ani0->listPos[0].pos;
			else
			{
			  int i;
				for(i=0; i<ani0->listPos.size() && frame0>ani0->listPos[i].key; i++);

				if(ani0->listPos[i].key == frame0)		pos0 = ani0->listPos[i].pos;
				else
				{
					float t = ((float)(frame0-ani0->listPos[i-1].key)) / ((float)(ani0->listPos[i].key-ani0->listPos[i-1].key));
					pos0 = t*ani0->listPos[i].pos + (1-t)*ani0->listPos[i-1].pos;
				}
			}
		}
		// dans l'ultime cas o il n'y a pas d'animation..
		else
			pos0 = prs->GetPos();


		//--- Position 1 ---//
		
		if(ani1->listPos.size())
		{
				 if(frame1 >= ani1->maxKeyPos)			pos1 = ani1->listPos[ani1->listPos.size()-1].pos;
			else if(frame1 <= ani1->minKeyPos)			pos1 = ani1->listPos[0].pos;
			else							
			{
			  int i;
				for(i=0; i<ani1->listPos.size() && frame1>ani1->listPos[i].key; i++);

				if(ani1->listPos[i].key == frame1)		pos1 = ani1->listPos[i].pos;
				else
				{
					float t = ((float)(frame1-ani1->listPos[i-1].key)) / ((float)(ani1->listPos[i].key-ani1->listPos[i-1].key));
					pos1 = t*ani1->listPos[i].pos + (1-t)*ani1->listPos[i-1].pos;
				}
			}
		}
		// dans l'ultime cas o il n'y a pas d'animation..
		else
			pos1 = prs->GetPos();


		// On interpole entre les deux positions au taux de 'rate'
		prs->SetPos( rate*pos1 + (1-rate)*pos0 );	
	}


	///////////////////////////
	// ----> ROTATION <----- //
	///////////////////////////

	if(flag & ANIM_ANG)
	{
		ZQuat	rot0, rot1;
		
		//--- Rotation 0 ---//

		if(ani0->listRot.size())
		{
				 if(frame0 >= ani0->maxKeyRot)			rot0 = ani0->listRot[ani0->listRot.size()-1].rot;
			else if(frame0 <= ani0->minKeyRot)			rot0 = ani0->listRot[0].rot;
			else
			{
			  int i;
				for(i=0; i<ani0->listRot.size() && frame0>ani0->listRot[i].key; i++);

				if(ani0->listRot[i].key == frame0)		rot0 = ani0->listRot[i].rot;
				else
				{
					float t = ((float)(frame0-ani0->listRot[i-1].key)) / ((float)(ani0->listRot[i].key-ani0->listRot[i-1].key));
					rot0 = quatSlerp(ani0->listRot[i-1].rot, ani0->listRot[i].rot, t);
				}
			}
		}
		// dans l'ultime cas o il n'y a pas d'animation..
		else
		{
			// calcul du quaternion de position de PRS
			ZMatrix	matx;

			matx  = prs->mat;
			matx.SetTrans(0.0f, 0.0f, 0.0f);
			matx *= ScaleMatrix(1.0f / prs->GetScale());
			
			rot0 = matx.GetQuat();
		}

		
		//--- Rotation 1 ---//

		if(ani1->listRot.size())
		{
				 if(frame1 >= ani1->maxKeyRot)			rot1 = ani1->listRot[ani1->listRot.size()-1].rot;
			else if(frame1 <= ani1->minKeyRot)			rot1 = ani1->listRot[0].rot;
			else
			{
			  int i;
				for(i=0; i<ani1->listRot.size() && frame1>ani1->listRot[i].key; i++);

				if(ani1->listRot[i].key == frame1)		rot1 = ani1->listRot[i].rot;
				else
				{
					float t = ((float)(frame1-ani1->listRot[i-1].key)) / ((float)(ani1->listRot[i].key-ani1->listRot[i-1].key));
					rot1 = quatSlerp(ani1->listRot[i-1].rot, ani1->listRot[i].rot, t);
				}
			}
		}
		// dans l'ultime cas o il n'y a pas d'animation..
		else
		{
			// calcul du quaternion de position de PRS
			ZMatrix	matx;

			matx  = prs->mat;
			matx.SetTrans(0.0f, 0.0f, 0.0f);
			matx *= ScaleMatrix(1.0f / prs->GetScale());
			
			rot1 = matx.GetQuat();
		}

		
		// Interpolation finale entre les deux quaternions
		prs->SetAng( (quatSlerp(rot0, rot1, rate)).GetAnglesYXZ() );
	}
	

	return true;
}


int M3DrecApplyAnimKey2(ZNode *nodeA0, ZNode *nodeA1, ZNode *nodeT, float key0, float key1, float rate, int flag)
{
	if(nodeA0==NULL)		return -1;
	
	ZNode	*nodeC1, *nodeC2;

	if( ((nodeC1=findObj3d(nodeA1,nodeA0->name))!=NULL) && ((nodeC2=findObj3d(nodeT,nodeA0->name))!=NULL) )
	{
		if((nodeA0->type==ANI_TYPE_ID)&&(nodeC1->type==ANI_TYPE_ID))
		{
			ZAnim	*anim0 = (ZAnim*) nodeA0;
			ZAnim	*anim1 = (ZAnim*) nodeC1;
			ZPRS	*prs = NULL;

			prs = ((ZNodeGraph*)nodeC2)->GetPRS();
			
			M3DanimKey2(anim0, anim1, prs, key0, key1, rate, flag);
		}

		if((nodeA0->son!=NULL)&&(nodeC1->son!=NULL))
		{
			if(M3DrecApplyAnimKey2(nodeA0->son, nodeC1->son, nodeC2->son, key0,key1, rate, flag))		return -1;
		}
	}
	
	if(nodeA0->next!=NULL)
    {
		if(M3DrecApplyAnimKey2(nodeA0->next, nodeA1, nodeT, key0, key1, rate, flag))		return -1;
    }

	return 0;
}


int M3DapplyAnimKey2(ZNode *nodeA0, ZNode *nodeA1, ZNode *nodeT, float key0, float key1, float rate, int flag)
{
	if( (flag&ANIM_TOP) && (nodeA0->type==ANI_TYPE_ID)&&(nodeA1->type==ANI_TYPE_ID) )
	{
		ZAnim	*anim0 = (ZAnim*) nodeA0;
		ZAnim	*anim1 = (ZAnim*) nodeA1;
		ZPRS	*prs = NULL;

		prs = ((ZNodeGraph*)nodeT)->GetPRS();

		M3DanimKey2(anim0, anim1, prs, key0, key1, rate, flag);
	}

	return M3DrecApplyAnimKey2(nodeA0->son, nodeA1->son, nodeT->son, key0, key1, rate, flag);
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3applyAnimKey2
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d H3d I I I I] I
int ZM3applyAnimKey2(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3applyAnimKey2 ");
#endif

	int flag = MMpull(m);
	int rate = MMpull(m);
	int key1 = MMpull(m);
	int key0 = MMpull(m);
	int top  = MMpull(m);
	int ani1 = MMpull(m);
	int ani0 = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(ani0==NIL)||(ani1==NIL)||(top==NIL)||(key0==NIL)||(key1==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeA0 = (ZNode*) MMfetch(m,MTOP(ani0),0);
	if(nodeA0==NULL)													{	MMset(m,0,NIL);		return 0;	}

	ZNode	*nodeA1 = (ZNode*) MMfetch(m,MTOP(ani1),0);
	if(nodeA1==NULL)													{	MMset(m,0,NIL);		return 0;	}    

	ZNode	*nodeT = (ZNode*) MMfetch(m,MTOP(top),0);
	if(nodeT==NULL)														{	MMset(m,0,NIL);		return 0;	}


	rate = MTOI(rate) & 255;

	int p = M3DapplyAnimKey2(nodeA0, nodeA1, nodeT, MTOI(key0), MTOI(key1), ((float)rate)/CONST_VAL8, MTOI(flag));

	MMset(m,0,ITOM(p));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3applyAnimKey2F
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d H3d F F F I] I
int ZM3applyAnimKey2F(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3applyAnimKey2F ");
#endif

	int flag = MMpull(m);
	int rate = MMpull(m);
	int key1 = MMpull(m);
	int key0 = MMpull(m);
	int top  = MMpull(m);
	int ani1 = MMpull(m);
	int ani0 = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(ani0==NIL)||(ani1==NIL)||(top==NIL)||(key0==NIL)||(key1==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeA0 = (ZNode*) MMfetch(m,MTOP(ani0),0);
	if(nodeA0==NULL)													{	MMset(m,0,NIL);		return 0;	}

	ZNode	*nodeA1 = (ZNode*) MMfetch(m,MTOP(ani1),0);
	if(nodeA1==NULL)													{	MMset(m,0,NIL);		return 0;	}    

	ZNode	*nodeT = (ZNode*) MMfetch(m,MTOP(top),0);
	if(nodeT==NULL)														{	MMset(m,0,NIL);		return 0;	}

	int p = M3DapplyAnimKey2(nodeA0, nodeA1, nodeT, MTOF(key0), MTOF(key1), MTOF(rate), MTOI(flag));

	MMset(m,0,ITOM(p));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		FONCTIONS POUR ZM3getAnimLength
//////////////////////////////////////////////////////////////////////////////////////////////
int M3DrecAnimLength(ZNode *node, int max, int first)
{
	if(node==NULL)		return -1;

	if(node->type==ANI_TYPE_ID)
	{
		ZAnim	*anim= (ZAnim*)node;
		if(max < anim->getLength())		max = anim->getLength();
	}

	if((!first)&&(node->next!=NULL))	max = M3DrecAnimLength(node->next, max, 0);

	if(node->son!=NULL)			max = M3DrecAnimLength(node->son, max, 0);

	return max;
}

int M3DgetAnimLength(ZNode *node)
{
	return M3DrecAnimLength(node, 0, 1);
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getAnimLength
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3getAnimLength(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getAnimLength ");
#endif

	int ani  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(ani==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(ani),0);
	if(node==NULL)								{	MMset(m,0,NIL);		return 0;	}

    int p = M3DgetAnimLength(node);
    
	MMset(m,0,ITOM(p));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}


