//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///				 GESTION DES COLLISIONS								    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createSphere
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d I] H3d
int ZM3createSphere(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createSphere ");
#endif

	int ray = MMpull(m);
	int s3d = MMget(m,0);

	if((s3d==NIL)||(ray==NIL))			{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)						{   MMset(m,0,NIL);		return 0;	}

    ray = MTOI(ray);

	ZColl	*sph;
	sph = new ZColl((int)scene, 0);
	if(sph==NULL)						{   MMset(m,0,NIL);		return 0;	}
	sph->InsertAsChildOf(scene->World);
	sph->pos.SetNull();		// zro, car c'est le sommet de l'arbre de collision

	sph->rayon = ((float)ray) / 100.0f;

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)sph, hash_tab);

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createSphereF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d F] H3d
int ZM3createSphereF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createSphereF ");
#endif

	int ray = MMpull(m);
	int s3d = MMget(m,0);

	if((s3d==NIL)||(ray==NIL))			{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)						{   MMset(m,0,NIL);		return 0;	}

	ZColl	*sph;
	sph = new ZColl((int)scene, 0);
	if(sph==NULL)						{   MMset(m,0,NIL);		return 0;	}
	sph->InsertAsChildOf(scene->World);
	sph->pos.SetNull();		// zro, car c'est le sommet de l'arbre de collision

	sph->rayon = MTOF(ray) / 100.0f;

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)sph, hash_tab);

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createObb
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d [I I I]] H3d
int ZM3createObb(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createObb ");
#endif

	int tupl = MMpull(m);
	int s3d  = MMget(m,0);

	if((s3d==NIL)||(tupl==NIL))			{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)						{   MMset(m,0,NIL);		return 0;	}


	float x = (float)(MMfetch(m,MTOP(tupl),0)>>1) / 100.0f;
	float y = (float)(MMfetch(m,MTOP(tupl),1)>>1) / 100.0f;
	float z = (float)(MMfetch(m,MTOP(tupl),2)>>1) / 100.0f;


	// cre la sphre MERE de l'Obb
	ZColl	*sph;
	sph = new ZColl((int)scene, 0);
	if(sph==NULL)						{   MMset(m,0,NIL);		return 0;	}
	sph->InsertAsChildOf(scene->World);
	sph->pos.SetNull();		// zro, car c'est le sommet de l'arbre de collision

	sph->rayon = sqrt(x*x + y*y + z*z);

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)sph, hash_tab);


	// cre l'Obb (dans l'arbre de collision)
	ZColl	*obb;
	obb = new ZColl((int)scene, 1);
	if(obb==NULL)						{   MMset(m,0,NIL);		return 0;	}
	obb->pos.SetNull();	
	obb->u.x = x;
	obb->v.y = y;
	obb->w.z = z;


	// insertion comme premier fils
	sph->colA = obb;

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createObbF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d [F F F]] H3d
int ZM3createObbF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createObbF ");
#endif

	int tupl = MMpull(m);
	int s3d  = MMget(m,0);

	if((s3d==NIL)||(tupl==NIL))			{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)						{   MMset(m,0,NIL);		return 0;	}


	float x = MTOF(MMfetch(m,MTOP(tupl),0)) / 100.0f;
	float y = MTOF(MMfetch(m,MTOP(tupl),1)) / 100.0f;
	float z = MTOF(MMfetch(m,MTOP(tupl),2)) / 100.0f;


	// cre la sphre MERE de l'Obb
	ZColl	*sph;
	sph = new ZColl((int)scene, 0);
	if(sph==NULL)						{   MMset(m,0,NIL);		return 0;	}
	sph->InsertAsChildOf(scene->World);
	sph->pos.SetNull();		// zro, car c'est le sommet de l'arbre de collision

	sph->rayon = sqrt(x*x + y*y + z*z);

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)sph, hash_tab);


	// cre l'Obb (dans l'arbre de collision)
	ZColl	*obb;
	obb = new ZColl((int)scene, 1);
	if(obb==NULL)						{   MMset(m,0,NIL);		return 0;	}
	obb->pos.SetNull();	
	obb->u.x = x;
	obb->v.y = y;
	obb->w.z = z;


	// insertion comme premier fils
	sph->colA = obb;

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3calcObb
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[I I I] [I I I]]
int ZM3calcObb(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3calcObb ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	if( (node->type!=OBJ_TYPE_ID) || ( ((ZObject*)node)->GetMesh()==NULL ) )
	{
		MMpull(m);
		int k;

		if (MMpush(m,ITOM(0)))		return MERRMEM;
		if (MMpush(m,ITOM(0)))		return MERRMEM;
		if (MMpush(m,ITOM(0)))		return MERRMEM;
		if (MMpush(m,3*2))			return MERRMEM;
		if (k=MBdeftab(m))			return k;

		if (MMpush(m,ITOM(0)))		return MERRMEM;
		if (MMpush(m,ITOM(0)))		return MERRMEM;
		if (MMpush(m,ITOM(0)))		return MERRMEM;
		if (MMpush(m,3*2))			return MERRMEM;
		if (k=MBdeftab(m))			return k;

		if (MMpush(m,2*2))			return MERRMEM;
		return MBdeftab(m);
	}


	vector<ZVert>	*vertInit;
	vertInit	= &(((ZObject*)node)->GetMesh()->Verts);
	int	nbVerts = ((ZObject*)node)->GetMesh()->NbVerts;

	if(nbVerts==0)					{	MMset(m,0,NIL);		return 0;	}

	float	xmin, xmax, ymin, ymax, zmin, zmax;
	xmin = xmax = (*vertInit)[0].x;
	ymin = ymax = (*vertInit)[0].y;
	zmin = zmax = (*vertInit)[0].z;

	for(int i=1; i<nbVerts; i++)
	{
		if(xmin > (*vertInit)[i].x)		xmin = (*vertInit)[i].x;
		else
		if(xmax < (*vertInit)[i].x)		xmax = (*vertInit)[i].x;

		if(ymin > (*vertInit)[i].y)		ymin = (*vertInit)[i].y;
		else
		if(ymax < (*vertInit)[i].y)		ymax = (*vertInit)[i].y;

		if(zmin > (*vertInit)[i].z)		zmin = (*vertInit)[i].z;
		else
		if(zmax < (*vertInit)[i].z)		zmax = (*vertInit)[i].z;
	}

	ZPRS	*prs = ((ZObject*)node)->GetPRS();
	float	posX = (xmin+xmax) / 2.0f;
	float	posY = (ymin+ymax) / 2.0f;
	float	posZ = (zmin+zmax) / 2.0f;

	float	rx = (xmax-xmin) / 2.0f;
	float	ry = (ymax-ymin) / 2.0f;
	float	rz = (zmax-zmin) / 2.0f;

	MMpull(m);
	int k;
	
	if (MMpush(m,ITOM(AROUNDINT(posX*100.0f))))		return MERRMEM;
    if (MMpush(m,ITOM(AROUNDINT(posY*100.0f))))		return MERRMEM;
    if (MMpush(m,ITOM(AROUNDINT(-posZ*100.0f))))	return MERRMEM;
	if (MMpush(m,3*2))								return MERRMEM;
	if (k=MBdeftab(m))								return k;

	if (MMpush(m,ITOM(AROUNDINT(rx*100.0f))))		return MERRMEM;
    if (MMpush(m,ITOM(AROUNDINT(ry*100.0f))))		return MERRMEM;
    if (MMpush(m,ITOM(AROUNDINT(rz*100.0f))))		return MERRMEM;
	if (MMpush(m,3*2))								return MERRMEM;
	if (k=MBdeftab(m))								return k;

	if (MMpush(m,2*2)) return MERRMEM;
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3calcObbF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[F F F] [F F F]]
int ZM3calcObbF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3CalcObbF ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	if( (node->type!=OBJ_TYPE_ID) || ( ((ZObject*)node)->GetMesh()==NULL ) )
	{
		MMpull(m);
		int k;

		if (MMpush(m,FTOM(0)))		return MERRMEM;
		if (MMpush(m,FTOM(0)))		return MERRMEM;
		if (MMpush(m,FTOM(0)))		return MERRMEM;
		if (MMpush(m,3*2))			return MERRMEM;
		if (k=MBdeftab(m))			return k;

		if (MMpush(m,FTOM(0)))		return MERRMEM;
		if (MMpush(m,FTOM(0)))		return MERRMEM;
		if (MMpush(m,FTOM(0)))		return MERRMEM;
		if (MMpush(m,3*2))			return MERRMEM;
		if (k=MBdeftab(m))			return k;

		if (MMpush(m,2*2))			return MERRMEM;
		return MBdeftab(m);
	}


	vector<ZVert>	*vertInit;
	vertInit	= &(((ZObject*)node)->GetMesh()->Verts);
	int	nbVerts = ((ZObject*)node)->GetMesh()->NbVerts;

	if(nbVerts==0)					{	MMset(m,0,NIL);		return 0;	}

	float	xmin, xmax, ymin, ymax, zmin, zmax;
	xmin = xmax = (*vertInit)[0].x;
	ymin = ymax = (*vertInit)[0].y;
	zmin = zmax = (*vertInit)[0].z;

	for(int i=1; i<nbVerts; i++)
	{
		if(xmin > (*vertInit)[i].x)		xmin = (*vertInit)[i].x;
		else
		if(xmax < (*vertInit)[i].x)		xmax = (*vertInit)[i].x;

		if(ymin > (*vertInit)[i].y)		ymin = (*vertInit)[i].y;
		else
		if(ymax < (*vertInit)[i].y)		ymax = (*vertInit)[i].y;

		if(zmin > (*vertInit)[i].z)		zmin = (*vertInit)[i].z;
		else
		if(zmax < (*vertInit)[i].z)		zmax = (*vertInit)[i].z;
	}

	ZPRS	*prs = ((ZObject*)node)->GetPRS();
	float	posX = (xmin+xmax) / 2.0f;
	float	posY = (ymin+ymax) / 2.0f;
	float	posZ = (zmin+zmax) / 2.0f;

	float	rx = (xmax-xmin) / 2.0f;
	float	ry = (ymax-ymin) / 2.0f;
	float	rz = (zmax-zmin) / 2.0f;

	MMpull(m);
	int k;
	
	if (MMpush(m,FTOM(posX*100.0f)))		return MERRMEM;
    if (MMpush(m,FTOM(posY*100.0f)))		return MERRMEM;
    if (MMpush(m,FTOM(-posZ*100.0f)))		return MERRMEM;
	if (MMpush(m,3*2))						return MERRMEM;
	if (k=MBdeftab(m))						return k;

	if (MMpush(m,FTOM(rx*100.0f)))			return MERRMEM;
    if (MMpush(m,FTOM(ry*100.0f)))			return MERRMEM;
    if (MMpush(m,FTOM(rz*100.0f)))			return MERRMEM;
	if (MMpush(m,3*2))						return MERRMEM;
	if (k=MBdeftab(m))						return k;

	if (MMpush(m,2*2)) return MERRMEM;
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3firstRadius
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3firstRadius(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3firstRadius ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=COL_TYPE_ID))			{	MMset(m,0,NIL);		return 0;	}

    ZColl	*col = (ZColl*)node;
	if(col->typeColl!=0)								{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0,ITOM(AROUNDINT(col->rayon*100.0f)));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3firstRadiusF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] F
int ZM3firstRadiusF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3firstRadiusF ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=COL_TYPE_ID))			{	MMset(m,0,NIL);		return 0;	}

    ZColl	*col = (ZColl*)node;
	if(col->typeColl!=0)								{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0,FTOM(col->rayon*100.0f));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3testInter
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d] [H3d H3d]
int ZM3testInter(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3testInter ");
#endif

	int noB  = MMpull(m);
	int noA  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(noA==NIL)||(noB==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeA = (ZNode*) MMfetch(m,MTOP(noA),0);
	if(nodeA==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeB = (ZNode*) MMfetch(m,MTOP(noB),0);
	if(nodeB==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*collA, *collB;
    int p = M3DtestInter(scene, nodeA, nodeB, &collA, &collB);

	if(!p)		{	MMset(m,0,NIL);		return 0;	}

	// Traitement des resultats
	noA = noB = NIL;

	if(collA!=NULL)
	{
		noA = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)collA);
		if(noA!=NIL)	noA = PTOM(noA);
	}
	if(MMpush(m,noA))			return MERRMEM;

	int tmp_res=0;
	INVERT(m,0,1);

	if(collB!=NULL)
	{
		noB = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(MMget(m,0)),1)), (int)collB);
		if(noB!=NIL)	noB = PTOM(noB);
	}
	if(MMpush(m,noB))			return MERRMEM;

	INVERT(m,0,1);
	MMpull(m);			// dpile le S3d avant la cration du tableau
	
    if(MMpush(m,2*2))			return MERRMEM;
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3testColl
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d [I I I] I] [H3d H3d [I I I] [I I I]]
int ZM3testColl(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3testColl ");
#endif

	int gar	 = MMpull(m);
	int vec	 = MMpull(m);
	int noB  = MMpull(m);
	int noA  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(noA==NIL)||(noB==NIL)||(gar==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeA = (ZNode*) MMfetch(m,MTOP(noA),0);
	if(nodeA==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeB = (ZNode*) MMfetch(m,MTOP(noB),0);
	if(nodeB==NULL)								{	MMset(m,0,NIL);		return 0;	}

	float garde = (float)( MTOI(gar) ) / 100.0f;
	if(garde<0)		garde = 0.0f;

	ZVector3	transl;
	transl.x = ((float) (MMfetch(m,MTOP(vec),0)>>1)) / 100.0f;
	transl.y = ((float) (MMfetch(m,MTOP(vec),1)>>1)) / 100.0f;
	transl.z = -((float) (MMfetch(m,MTOP(vec),2)>>1)) / 100.0f;

    ZNode		*collA, *collB;
    float		res;
	ZVector3	vcol;
	int k = M3DtestColl(scene, nodeA, nodeB, transl, &res, &vcol, garde, &collA, &collB);

	// Traitement des resultats
	if(!k)		{	MMset(m,0,NIL);		return 0;	}
	
	noA = noB = NIL;
	
	if(collA!=NULL)
	{
		noA = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)collA);
		if(noA!=NIL)	noA = PTOM(noA);
	}
    if(MMpush(m,noA))		return MERRMEM;

	int tmp_res=0;
	INVERT(m,0,1);

	if(collB!=NULL)
	{
		noB = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(MMget(m,0)),1)), (int)collB);
		if(noB!=NIL)	noB = PTOM(noB);
	}
    if(MMpush(m,noB))		return MERRMEM;
    
	INVERT(m,0,1);
	MMpull(m);			// dpile le S3d avant la cration du tableau

	if(k<0)		res = 0;
	transl *= (res*100.0f);

    if(MMpush(m,ITOM(AROUNDINT(transl.x))))			return MERRMEM;
    if(MMpush(m,ITOM(AROUNDINT(transl.y))))			return MERRMEM;
    if(MMpush(m,ITOM(AROUNDINT(-transl.z))))		return MERRMEM;
    if(MMpush(m,3*2))		return MERRMEM;

    int r;
	if(r=MBdeftab(m))		return r;
	
	if(k<0)
	{
		if(MMpush(m,NIL))	return MERRMEM;
	}
	else
	{
		vcol *= 100.0f;
		if(MMpush(m,ITOM(AROUNDINT(vcol.x))))			return MERRMEM;
		if(MMpush(m,ITOM(AROUNDINT(vcol.y))))			return MERRMEM;
		if(MMpush(m,ITOM(AROUNDINT(-vcol.z))))			return MERRMEM;
		if(MMpush(m,3*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}
    
	if(MMpush(m,4*2))		return MERRMEM;
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3testCollF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d [F F F] F] [H3d H3d [F F F] [F F F]]
int ZM3testCollF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3testCollF ");
#endif

	int gar	 = MMpull(m);
	int vec	 = MMpull(m);
	int noB  = MMpull(m);
	int noA  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(noA==NIL)||(noB==NIL)||(gar==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeA = (ZNode*) MMfetch(m,MTOP(noA),0);
	if(nodeA==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeB = (ZNode*) MMfetch(m,MTOP(noB),0);
	if(nodeB==NULL)								{	MMset(m,0,NIL);		return 0;	}

	float garde = MTOF(gar) / 100.0f;
	if(garde<0)		garde = 0.0f;

	ZVector3	transl;
	transl.x =  MTOF(MMfetch(m,MTOP(vec),0)) / 100.0f;
	transl.y =  MTOF(MMfetch(m,MTOP(vec),1)) / 100.0f;
	transl.z = -MTOF(MMfetch(m,MTOP(vec),2)) / 100.0f;

    ZNode		*collA, *collB;
    float		res;
	ZVector3	vcol;
	int k = M3DtestColl(scene, nodeA, nodeB, transl, &res, &vcol, garde, &collA, &collB);

	// Traitement des resultats
	if(!k)		{	MMset(m,0,NIL);		return 0;	}
	
	noA = noB = NIL;
	
	if(collA!=NULL)
	{
		noA = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)collA);
		if(noA!=NIL)	noA = PTOM(noA);
	}
    if(MMpush(m,noA))		return MERRMEM;

	int tmp_res=0;
	INVERT(m,0,1);

	if(collB!=NULL)
	{
		noB = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(MMget(m,0)),1)), (int)collB);
		if(noB!=NIL)	noB = PTOM(noB);
	}
    if(MMpush(m,noB))		return MERRMEM;
    
	INVERT(m,0,1);
	MMpull(m);			// dpile le S3d avant la cration du tableau

	if(k<0)		res = 0;
	transl *= (res*100.0f);

    if(MMpush(m,FTOM(transl.x)))		return MERRMEM;
    if(MMpush(m,FTOM(transl.y)))		return MERRMEM;
    if(MMpush(m,FTOM(-transl.z)))		return MERRMEM;
    if(MMpush(m,3*2))					return MERRMEM;

    int r;
	if(r=MBdeftab(m))					return r;
	
	if(k<0)
	{
		if(MMpush(m,NIL))	return MERRMEM;
	}
	else
	{
		vcol *= 100.0f;
		if(MMpush(m,FTOM(vcol.x)))			return MERRMEM;
		if(MMpush(m,FTOM(vcol.y)))			return MERRMEM;
		if(MMpush(m,FTOM(-vcol.z)))			return MERRMEM;
		if(MMpush(m,3*2))					return MERRMEM;
		if(k=MBdeftab(m))					return k;
	}
    
	if(MMpush(m,4*2))		return MERRMEM;
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createExactModel
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3createExactModel(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createExactModel ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL || node->type!=OBJ_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}

	ZObject	*obj = (ZObject*) node;
	if(obj->IsMultiMeshes())					{	MMset(m,0,NIL);		return 0;	}

	ZMesh	*mesh = obj->GetMesh();
	if(mesh==NULL || mesh->dependency || mesh->displayListCreate==false)		{	MMset(m,0,NIL);		return 0;	}


	if(mesh->CreateRapidModel())		MMset(m,0,0);
	else								MMset(m,0,NIL);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3destroyExactModel 
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3destroyExactModel(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3destroyExactModel ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL || node->type!=OBJ_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}

	ZObject	*obj = (ZObject*) node;
	if(obj->IsMultiMeshes())					{	MMset(m,0,NIL);		return 0;	}

	ZMesh	*mesh = obj->GetMesh();
	if(mesh==NULL || mesh->dependency || mesh->displayListCreate==false)		{	MMset(m,0,NIL);		return 0;	}

	mesh->DeleteRapidModel();

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




bool	DetectInter(ZObject *obj1, ZObject *obj2)
{
	float		R1[3][3], R2[3][3], T1[3], T2[3], scale1, scale2;

	scale1 = obj1->worldScale;
	scale2 = obj2->worldScale;

	for(int k=0; k<3; k++)
	{
		for(int l=0; l<3; l++)
		{
			R1[l][k] = obj1->worldMat(l,k)/scale1;
			R2[l][k] = obj2->worldMat(l,k)/scale2;
		}
	}

	T1[0] = obj1->worldPos.x;		T1[1] = obj1->worldPos.y;		T1[2] = obj1->worldPos.z;
	T2[0] = obj2->worldPos.x;		T2[1] = obj2->worldPos.y;		T2[2] = obj2->worldPos.z;

	RAPID_Collide(R1, T1, scale1, obj1->GetMesh()->rapid, R2, T2, scale2, obj2->GetMesh()->rapid, RAPID_FIRST_CONTACT);

	if(RAPID_num_contacts)	return true;
	else					return false;
						
}



bool	DetectCollide(ZObject *obj1, ZObject *obj2, ZVector3 &depl)
{
	float		R1[3][3], R2[3][3], T1[3], T2[3], scale1, scale2;
	
	ZVector3	nul, deplCOL;
	deplCOL = depl;
	nul.SetNull();

	scale1 = obj1->worldScale;
	scale2 = obj2->worldScale;

	for(int k=0; k<3; k++)
	{
		for(int l=0; l<3; l++)
		{
			R1[l][k] = obj1->worldMat(l,k)/scale1;
			R2[l][k] = obj2->worldMat(l,k)/scale2;
		}
	}

	T1[0] = obj1->worldPos.x;		T1[1] = obj1->worldPos.y;		T1[2] = obj1->worldPos.z;
	T2[0] = obj2->worldPos.x;		T2[1] = obj2->worldPos.y;		T2[2] = obj2->worldPos.z;

	RAPID_Collide_trans(R1, T1, scale1, depl.vals, obj1->GetMesh()->rapid, R2, T2, scale2, nul.vals, obj2->GetMesh()->rapid, RAPID_ALL_CONTACTS);

	deplCOL *= RAPID_coeff;
	depl = deplCOL;

	if(RAPID_num_contacts)	return true;
	else					return false;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3testExactInter
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d] I
int ZM3testExactInter(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3testExactInter ");
#endif

	int h3d2 = MMpull(m);
 	int h3d1 = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d1==NIL)||(h3d2==NIL))	{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    // Rcupre l'obj1
	ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d1),0);
	if(node==NULL || node->type!=OBJ_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}

	ZObject	*obj1 = (ZObject*) node;
	if(obj1->IsMultiMeshes())					{	MMset(m,0,NIL);		return 0;	}

    // Rcupre l'obj2
	node = (ZNode*) MMfetch(m,MTOP(h3d2),0);
	if(node==NULL || node->type!=OBJ_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}

	ZObject	*obj2 = (ZObject*) node;
	if(obj2->IsMultiMeshes())					{	MMset(m,0,NIL);		return 0;	}

	ZMesh	*mesh1, *mesh2;
	mesh1 = obj1->GetMesh();
	mesh2 = obj2->GetMesh();

	if(		mesh1==NULL || mesh1->rapidCreated==false 
		||	mesh2==NULL || mesh2->rapidCreated==false )		{	MMset(m,0,NIL);		return 0;	}

	if(DetectInter(obj1, obj2))		MMset(m,0,0);
	else							MMset(m,0,NIL);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3testExactColl
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d [F F F]] [F F F]
int ZM3testExactColl(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3testExactColl ");
#endif

	int vec  = MMpull(m);
	int h3d2 = MMpull(m);
 	int h3d1 = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d1==NIL)||(h3d2==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    // Rcupre l'obj1
	ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d1),0);
	if(node==NULL || node->type!=OBJ_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}
	ZObject	*obj1 = (ZObject*) node;
	if(obj1->IsMultiMeshes())					{	MMset(m,0,NIL);		return 0;	}

    // Rcupre l'obj2
	node = (ZNode*) MMfetch(m,MTOP(h3d2),0);
	if(node==NULL || node->type!=OBJ_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}
	ZObject	*obj2 = (ZObject*) node;
	if(obj2->IsMultiMeshes())					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	transl;
	transl.x =  MTOF(MMfetch(m,MTOP(vec),0)) / 100.0f;
	transl.y =  MTOF(MMfetch(m,MTOP(vec),1)) / 100.0f;
	transl.z = -MTOF(MMfetch(m,MTOP(vec),2)) / 100.0f;

	ZMatrix		matx;

	if(scene->activeCam)
	{
		matx = scene->activeCam->cameraMatx;
		matx._14 = matx._24 = matx._34 = 0.0f;
		matx._41 = matx._42 = matx._42 = 0.0f;
		transl *= matx;
	}
	else
	{
		MMset(m,0,NIL);
		return 0;
	}


	ZMesh	*mesh1, *mesh2;
	mesh1 = obj1->GetMesh();
	mesh2 = obj2->GetMesh();

	if(		mesh1==NULL || mesh1->rapidCreated==false 
		||	mesh2==NULL || mesh2->rapidCreated==false )		{	MMset(m,0,NIL);		return 0;	}

	if(DetectCollide(obj1, obj2, transl))
	{
		MMpull(m);

		// Collision en translation
		if(RAPID_is_contact_trans==1)
		{
			transl *= 100.0f;
			matx.Inverse();
			transl *= matx;

			if(MMpush(m,FTOM(transl.x)))		return MERRMEM;
			if(MMpush(m,FTOM(transl.y)))		return MERRMEM;
			if(MMpush(m,FTOM(-transl.z)))		return MERRMEM;
			if(MMpush(m,3*2))					return MERRMEM;

			int r;
			if(r=MBdeftab(m))					return r;
		}
		else
		// Prime intersection
		{
			if(MMpush(m,FTOM(0)))				return MERRMEM;
			if(MMpush(m,FTOM(0)))				return MERRMEM;
			if(MMpush(m,FTOM(0)))				return MERRMEM;
			if(MMpush(m,3*2))					return MERRMEM;

			int r;
			if(r=MBdeftab(m))					return r;
		}
	}
	else
		MMset(m,0,NIL);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}
