//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////
////										       ////
///			      GESTION GEOMETRIQUE					///
////										       ////
///////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjRange
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I]] I
int ZM3setObjRange(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjRange ");
#endif
    int	rang = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(rang==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)								{	MMset(m,0,NIL);		return 0;	}

	int		rangeMIN = MTOI(MMfetch(m,rang,0));
	int		rangeMAX = MTOI(MMfetch(m,rang,1));

	if( (rangeMIN < 0) || ((rangeMAX < 0)&&(rangeMAX!=RANGE_INFINITY)) )		{	MMset(m,0,NIL);		return 0;	}

	// vecteur  utiliser
	node->rangeMIN = (((float)rangeMIN)/100.0f) * (((float)rangeMIN)/100.0f);

	if(rangeMAX==RANGE_INFINITY)		node->rangeMAX = RANGE_INFINITY;
	else								node->rangeMAX = (((float)rangeMAX)/100.0f) * (((float)rangeMAX)/100.0f);

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjRangeF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [F F]] I
int ZM3setObjRangeF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjRangeF ");
#endif
	int	rang = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(rang==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)								{	MMset(m,0,NIL);		return 0;	}

	int		rangeMIN = (int)MTOF(MMfetch(m,rang,0));
	int		rangeMAX = (int)MTOF(MMfetch(m,rang,1));

	if( (rangeMIN < 0) || ((rangeMAX < 0)&&(rangeMAX!=RANGE_INFINITY_F)) )		{	MMset(m,0,NIL);		return 0;	}

	// vecteur  utiliser
	node->rangeMIN = (rangeMIN/100.0f) * (rangeMIN/100.0f);
	
	if(rangeMAX==RANGE_INFINITY_F)		node->rangeMAX = RANGE_INFINITY;	// ok !! ligne valide !!
	else								node->rangeMAX = (rangeMAX/100.0f) * (rangeMAX/100.0f);

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjRange
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I]
int ZM3getObjRange(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjRange ");
#endif

    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	int		rangeMIN = ITOM( AROUNDINT( sqrt(node->rangeMIN) * 100.0f ) );

	int		rangeMAX;
	if(node->rangeMAX < 0)		rangeMAX = ITOM(RANGE_INFINITY);
	else						rangeMAX = ITOM( AROUNDINT( sqrt(node->rangeMAX) * 100.0f ) );


	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;		}

	MMstore(m, tuple, 0, rangeMIN);
	MMstore(m, tuple, 1, rangeMAX);

    MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjRangeF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [F F]
int ZM3getObjRangeF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjRangeF ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	int		rangeMIN = FTOM( sqrt(node->rangeMIN) * 100.0f );

	int		rangeMAX;
	if(node->rangeMAX < 0)		rangeMAX = FTOM(RANGE_INFINITY_F);
	else						rangeMAX = FTOM( sqrt(node->rangeMAX) * 100.0f );


	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, rangeMIN);
	MMstore(m, tuple, 1, rangeMAX);

    MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjVec
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I I]] I
int ZM3setObjVec(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjVec ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	// vecteur  utiliser
	ZVector3	vect;
	vect.SetCoord(MTOI(MMfetch(m,vec,0)), MTOI(MMfetch(m,vec,1)), - MTOI(MMfetch(m,vec,2)));

	// utilisation..
	ZPRS	*prs = node->GetPRS();
	prs->SetPos( vect*(1.0f/100.0f) );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjVecF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [F F F]] I
int ZM3setObjVecF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjVecF ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	// vecteur  utiliser
	ZVector3	vect;
	vect.SetCoord( MTOF(MMfetch(m,vec,0)), MTOF(MMfetch(m,vec,1)), - MTOF(MMfetch(m,vec,2)));

	// utilisation..
	ZPRS	*prs = node->GetPRS();
	prs->SetPos( vect*(1.0f/100.0f) );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjVec
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I I]
int ZM3getObjVec(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjVec ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;

	ZPRS	*prs = node->GetPRS();
	vect = prs->GetPos() * 100.0f;

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, ITOM(AROUNDINT(vect.x)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(vect.y)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(-vect.z)));

    MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjVecF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [F F F]
int ZM3getObjVecF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjVecF ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;

	ZPRS	*prs = node->GetPRS();
	vect = prs->GetPos() * 100.0f;

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, tuple, 0, FTOM(vect.x));
	MMstore(m, tuple, 1, FTOM(vect.y));
	MMstore(m, tuple, 2, FTOM(-vect.z));

    MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjAng
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I I]] I
int ZM3setObjAng(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjAng ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}


//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	angl;
	angl.SetCoord(MTOI(MMfetch(m,vec,1)), MTOI(MMfetch(m,vec,0)), MTOI(MMfetch(m,vec,2)));
	angl *= 360.0f/CONST_ANGLE;


	ZPRS	*prs = node->GetPRS();
	prs->SetAng( angl );


    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjAngF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [F F F]] I
int ZM3setObjAngF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjAngF ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)								{	MMset(m,0,NIL);		return 0;	}


//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	angl;
	angl.SetCoord( MTOF(MMfetch(m,vec,1)), MTOF(MMfetch(m,vec,0)), MTOF(MMfetch(m,vec,2)));
	angl *= 180.0f/ MY_PI;


	ZPRS	*prs = node->GetPRS();
	prs->SetAng( angl );


    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjAng
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I I]
int ZM3getObjAng(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjAng ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	angl;

	ZPRS	*prs = node->GetPRS();
	angl = prs->GetAng() * (CONST_ANGLE/360.0f);


	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, ITOM(AROUNDINT(angl.y)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(angl.x)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(angl.z)));

    MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjAngF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [F F F]
int ZM3getObjAngF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjAngF ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	angl;

	ZPRS	*prs = node->GetPRS();
	angl = prs->GetAng() * (MY_PI/180.0f);


	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, FTOM(angl.y));
	MMstore(m, tuple, 1, FTOM(angl.x));
	MMstore(m, tuple, 2, FTOM(angl.z));

    MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjScale
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I] I
int ZM3setObjScale(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjScale ");
#endif
    int	scal = MTOI(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(scal==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZPRS	*prs = node->GetPRS();
	prs->SetScale( ((float)(scal))/100.0f );


    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setObjScaleF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d F] I
int ZM3setObjScaleF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setObjScaleF ");
#endif
    int	scal = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(scal==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZPRS	*prs = node->GetPRS();
	prs->SetScale( (MTOF(scal))/100.0f );


    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjScale
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3getObjScale(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjScale ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}


	ZPRS	*prs = node->GetPRS();
	float scal = (prs->GetScale() * 100.0f);


    MMset(m,0,ITOM(AROUNDINT(scal)));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjScaleF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] F
int ZM3getObjScaleF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjScaleF ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}


	ZPRS	*prs = node->GetPRS();
	float scal = prs->GetScale() * 100.0f;


    MMset(m,0, FTOM(scal));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3movObj
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I I]] I
int ZM3movObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3movObj ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;
	vect.SetCoord(MTOI(MMfetch(m,vec,0)), MTOI(MMfetch(m,vec,1)), - MTOI(MMfetch(m,vec,2)));



	ZPRS	*prs = node->GetPRS();

	ZMatrix	mat;
	mat  = prs->mat;
	mat.SetTrans(0.0f, 0.0f, 0.0f);
	mat *= ScaleMatrix(1.0f / prs->GetScale());

	prs->AddPos( mat * (vect *(1.0f/100.0f)) );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3movObjF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [F F F]] I
int ZM3movObjF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3movObjF ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;
	vect.SetCoord( MTOF(MMfetch(m,vec,0)), MTOF(MMfetch(m,vec,1)), - MTOF(MMfetch(m,vec,2)) );


	ZPRS	*prs = node->GetPRS();

	ZMatrix	mat;
	mat  = prs->mat;
	mat.SetTrans(0.0f, 0.0f, 0.0f);
	mat *= ScaleMatrix(1.0f / prs->GetScale());

	prs->AddPos( mat * (vect *(1.0f/100.0f)) );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3rotateObj
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I I]] I
int ZM3rotateObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3rotateObj ");
#endif
    int	ang  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(ang==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,ang,0)==NIL) || (MMfetch(m,ang,1)==NIL) || (MMfetch(m,ang,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	angl;
	angl.SetCoord( MTOI(MMfetch(m,ang,1)), MTOI(MMfetch(m,ang,0)), MTOI(MMfetch(m,ang,2)));
	angl *= 360.0f/CONST_ANGLE;

	ZMatrix		mat;


	ZPRS	*prs = node->GetPRS();

	mat  = prs->mat;
	mat.SetTrans(0.0f, 0.0f, 0.0f);
	mat *= ScaleMatrix(1.0f / prs->GetScale());
	mat *= RotateYXZMatrix(0.0174532925f * angl);	

	prs->SetAng( mat.GetAnglesYXZ() );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3rotateObjF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [F F F]] I
int ZM3rotateObjF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3rotateObjF ");
#endif

    int	ang  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(ang==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,ang,0)==NIL) || (MMfetch(m,ang,1)==NIL) || (MMfetch(m,ang,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	angl;
	angl.SetCoord( MTOF(MMfetch(m,ang,1)), MTOF(MMfetch(m,ang,0)), MTOF(MMfetch(m,ang,2)));

	ZMatrix		mat;

	ZPRS	*prs = node->GetPRS();

	mat  = prs->mat;
	mat.SetTrans(0.0f, 0.0f, 0.0f);
	mat *= ScaleMatrix(1.0f / prs->GetScale());
	mat *= RotateYXZMatrix(angl);	

	prs->SetAng( mat.GetAnglesYXZ() );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3movObjExt
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I I]] I
int ZM3movObjExt(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3movObjExt ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;
	vect.SetCoord(MTOI(MMfetch(m,vec,0)), MTOI(MMfetch(m,vec,1)), - MTOI(MMfetch(m,vec,2)));

	ZPRS	*prs = node->GetPRS();
	prs->AddPos( vect *(1.0f/100.0f) );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3movObjExtF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [F F F]] I
int ZM3movObjExtF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3movObjExtF ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;
	vect.SetCoord( MTOF(MMfetch(m,vec,0)), MTOF(MMfetch(m,vec,1)), - MTOF(MMfetch(m,vec,2)));

	ZPRS	*prs = node->GetPRS();
	prs->AddPos( vect *(1.0f/100.0f) );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3rotateObjExt
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I I]] I
int ZM3rotateObjExt(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3rotateObjExt ");
#endif

    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;
	vect.SetCoord( MTOI(MMfetch(m,vec,1)), MTOI(MMfetch(m,vec,0)), MTOI(MMfetch(m,vec,2)));
	vect *= 360.0f/CONST_ANGLE;

	ZPRS	*prs = node->GetPRS();
	prs->AddAng( vect );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3rotateObjExtF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [F F F]] I
int ZM3rotateObjExtF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3rotateObjExtF ");
#endif
    int	vec  = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(vec==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

//	if( (MMfetch(m,vec,0)==NIL) || (MMfetch(m,vec,1)==NIL) || (MMfetch(m,vec,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}

	ZVector3	vect;
	vect.SetCoord( MTOF(MMfetch(m,vec,1)), MTOF(MMfetch(m,vec,0)), MTOF(MMfetch(m,vec,2)));
	vect *= 180.0f/MY_PI;

	ZPRS	*prs = node->GetPRS();
	prs->AddAng( vect );

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}






//////////////////////////////////////////////////////////////////////////////////////////////
///		ComputeWorldMatrix : calcule la matrice d'un objet dans le World Space
//////////////////////////////////////////////////////////////////////////////////////////////
ZMatrix	ComputeWorldMatrix(ZNode *node)
{
	ZPRS		*prs;
	ZMatrix		mat;
	
	mat.IdentityMatrix();
	
	ZNode		*curNode = node;

	while( curNode->type <= MAX_NODE_SCENE )
	{
		prs = ((ZNodeGraph*)curNode)->GetPRS();		
		mat = prs->mat * mat;
		
		curNode = curNode->father;
	}

	return mat;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3calcMat
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3calcMat(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3calcMat ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}


	// Prpare la matrice de l'objet de rfrence
	ZMatrix		mat = ComputeWorldMatrix(node);
	node->worldMat = mat;
	node->worldPos.SetCoord(mat(0,3), mat(1,3), mat(2,3));



	// ----> Create the lists <---- //
	ZNodeGraph	*father = (ZNodeGraph*) getBigFather(node);

	if( scene->updateGraphList || (scene->lastBaseNodeList != (ZNode*)father) )
	{
		scene->World->createNodeLists(father);								// Create the linear lists of OBJECT & LIGHT & CAMS
		scene->updateGraphList  = false;
		scene->lastBaseNodeList = (ZNode*)father;
	}

	
	// ----> Prepare the NODE matrix inversed <----
	ZMatrix		matx;
	matx = node->worldMat;// * (1.0f/node->worldScale);
	matx._14 = matx._24 = matx._34 = 0.0f;

	ZVector3	angles;
	angles = matx.GetAnglesYXZ();		// YXZ car provient de la matrice de rotation calcule par :  Ry.Rx.Rz

	matx.RotateYXZMatrix(0.0174532925f * angles );
	matx.Transpose();
	matx *= TranslateMatrix(-node->worldPos.x, -node->worldPos.y, -node->worldPos.z);


	// ----> Compute the matrices <----
	scene->World->ComputeMatrices(node, father, matx, 1.0f, true);


#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	

	MMset(m,0,0);
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjVecRender
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I I]
int ZM3getObjVecRender(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjVecRender ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	pos;

	pos  = node->worldPos;	
	pos *= 100.0f;

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, tuple, 0, ITOM(AROUNDINT(pos.x)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(pos.y)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(-pos.z)));

    MMset(m,0,PTOM(tuple));	
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjVecRenderF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [F F F]
int ZM3getObjVecRenderF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjVecRenderF ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZVector3	pos;

	pos  = node->worldPos;	
	pos *= 100.0f;

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, tuple, 0, FTOM(pos.x));
	MMstore(m, tuple, 1, FTOM(pos.y));
	MMstore(m, tuple, 2, FTOM(-pos.z));

    MMset(m,0,PTOM(tuple));	
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjMatrixRender
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[I I I] [I I I] [I I I]]
int ZM3getObjMatrixRender(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjMatrixRender ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZMatrix		matx;

	matx = node->worldMat;
	matx *= CONST_ANGLE;

	int ligne1 = MMmalloc(m, 3, TYPETAB);
	if(ligne1==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne1, 0, ITOM(AROUNDINT(matx._11)));
	MMstore(m, ligne1, 1, ITOM(AROUNDINT(matx._12)));
	MMstore(m, ligne1, 2, ITOM(AROUNDINT(matx._13)));

	MMpush(m, PTOM(ligne1));
	int ligne2 = MMmalloc(m, 3, TYPETAB);
	if(ligne2==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne2, 0, ITOM(AROUNDINT(matx._21)));
	MMstore(m, ligne2, 1, ITOM(AROUNDINT(matx._22)));
	MMstore(m, ligne2, 2, ITOM(AROUNDINT(matx._23)));

	MMpush(m, PTOM(ligne2));
	int ligne3 = MMmalloc(m, 3, TYPETAB);
	if(ligne3==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne3, 0, ITOM(AROUNDINT(matx._31)));
	MMstore(m, ligne3, 1, ITOM(AROUNDINT(matx._32)));
	MMstore(m, ligne3, 2, ITOM(AROUNDINT(matx._33)));

	// TUPLE FINAL
	MMpush(m, PTOM(ligne3));
	int matrice = MMmalloc(m, 3, TYPETAB);
	if(matrice==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, matrice, 2, MMpull(m) );
	MMstore(m, matrice, 1, MMpull(m) );
	MMstore(m, matrice, 0, MMpull(m) );


    MMset(m,0,PTOM(matrice));	
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjMatrixRenderF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[F F F] [F F F] [F F F]]
int ZM3getObjMatrixRenderF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjMatrixRenderF ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	ZMatrix		matx;

	matx = node->worldMat;

	int ligne1 = MMmalloc(m, 3, TYPETAB);
	if(ligne1==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne1, 0, FTOM(matx._11));
	MMstore(m, ligne1, 1, FTOM(matx._12));
	MMstore(m, ligne1, 2, FTOM(matx._13));

	MMpush(m, PTOM(ligne1));
	int ligne2 = MMmalloc(m, 3, TYPETAB);
	if(ligne2==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne2, 0, FTOM(matx._21));
	MMstore(m, ligne2, 1, FTOM(matx._22));
	MMstore(m, ligne2, 2, FTOM(matx._23));

	MMpush(m, PTOM(ligne2));
	int ligne3 = MMmalloc(m, 3, TYPETAB);
	if(ligne3==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne3, 0, FTOM(matx._31));
	MMstore(m, ligne3, 1, FTOM(matx._32));
	MMstore(m, ligne3, 2, FTOM(matx._33));

	// TUPLE FINAL
	MMpush(m, PTOM(ligne3));
	int matrice = MMmalloc(m, 3, TYPETAB);
	if(matrice==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, matrice, 2, MMpull(m) );
	MMstore(m, matrice, 1, MMpull(m) );
	MMstore(m, matrice, 0, MMpull(m) );


    MMset(m,0,PTOM(matrice));	
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getCamera
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[I I] [I I] [I I I]]
int ZM3getCamera(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getCamera ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=CAM_TYPE_ID))			{	MMset(m,0,NIL);		return 0;	}

	ZCamera	 *cam  = (ZCamera*)node;
	float	 coeff = 100.0f;

	int dist = MMmalloc(m, 2, TYPETAB);
	if(dist==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, dist, 0, ITOM(cam->dx));
	MMstore(m, dist, 1, ITOM(cam->dy));

	MMpush(m, PTOM(dist));
	int taille = MMmalloc(m, 2, TYPETAB);
	if(taille==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, taille, 0, ITOM(cam->width/2));
	MMstore(m, taille, 1, ITOM(cam->height/2));

	MMpush(m, PTOM(taille));
	int Zprop = MMmalloc(m, 3, TYPETAB);
	if(Zprop==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, Zprop, 0, ITOM(AROUNDINT(cam->Znear*coeff)));
	MMstore(m, Zprop, 1, ITOM(AROUNDINT(cam->Zfog*coeff)));
	MMstore(m, Zprop, 2, ITOM(AROUNDINT(cam->Zfar*coeff)));

	// TUPLE FINAL
	MMpush(m, PTOM(Zprop));
	int result = MMmalloc(m, 3, TYPETAB);
	if(result==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, result, 2, MMpull(m) );
	MMstore(m, result, 1, MMpull(m) );
	MMstore(m, result, 0, MMpull(m) );


    MMset(m,0,PTOM(result));	

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setCamera
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [[I I] [I I] [I I I]] ] I
int ZM3setCamera(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setCamera ");
#endif

	int info = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(info==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=CAM_TYPE_ID))			{	MMset(m,0,NIL);		return 0;	}
	ZCamera	 *cam  = (ZCamera*)node;

	int data, res;

	data = MTOP(MMfetch(m,MTOP(info),0));
	if(data!=NIL)
	{
		res = MTOI(MMfetch(m,data,0));		if(res>0)	cam->dx = res;
		res = MTOI(MMfetch(m,data,1));		if(res>0)	cam->dy = res;
	}

	data = MTOP(MMfetch(m,MTOP(info),1));
	if(data!=NIL)
	{
		res = MTOI(MMfetch(m,data,0));		if(res>0)	cam->width  = res*2;
		res = MTOI(MMfetch(m,data,1));		if(res>0)	cam->height = res*2;
	}

	float	coeff = 100.0f;
	data = MTOP(MMfetch(m,MTOP(info),2));
	if(data!=NIL)
	{
		res = MTOI(MMfetch(m,data,0));		if(res>0)	cam->Znear = ((float)res) / coeff;
		res = MTOI(MMfetch(m,data,1));		if(res>0)	cam->Zfog  = ((float)res) / coeff;
		res = MTOI(MMfetch(m,data,2));		if(res>0)	cam->Zfar  = ((float)res) / coeff;
	}

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3calcPosRef
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d] [[I I I] [[I I I][I I I][I I I]]]
int ZM3calcPosRef(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3calcPosRef ");
#endif

	int ref  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(ref==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*refer = (ZNode*) MMfetch(m,MTOP(ref),0);
	if(refer==NULL||refer->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}


	ZMatrix		refMat = ComputeWorldMatrix(refer);
	refMat.Inverse();
	ZMatrix		result = refMat * ComputeWorldMatrix(node);


	// CALCUL DE LA POSITION
	// attention le coeffM3D de la PRS est pris  100.0f ICI !!!!!
	int posi = MMmalloc(m, 3, TYPETAB);
	if(posi==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, posi, 0, ITOM(AROUNDINT(100.0f*result(0,3))) );
	MMstore(m, posi, 1, ITOM(AROUNDINT(100.0f*result(1,3))) );
	MMstore(m, posi, 2, ITOM(AROUNDINT(-100.0f*result(2,3))) );


	// CALCUL DE LA MATRICE
	result *= CONST_ANGLE;

	MMpush(m, PTOM(posi));

	int ligne1 = MMmalloc(m, 3, TYPETAB);
	if(ligne1==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne1, 0, ITOM(AROUNDINT(result._11)));
	MMstore(m, ligne1, 1, ITOM(AROUNDINT(result._12)));
	MMstore(m, ligne1, 2, ITOM(AROUNDINT(result._13)));

	MMpush(m, PTOM(ligne1));
	int ligne2 = MMmalloc(m, 3, TYPETAB);
	if(ligne2==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne2, 0, ITOM(AROUNDINT(result._21)));
	MMstore(m, ligne2, 1, ITOM(AROUNDINT(result._22)));
	MMstore(m, ligne2, 2, ITOM(AROUNDINT(result._23)));

	MMpush(m, PTOM(ligne2));
	int ligne3 = MMmalloc(m, 3, TYPETAB);
	if(ligne3==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne3, 0, ITOM(AROUNDINT(result._31)));
	MMstore(m, ligne3, 1, ITOM(AROUNDINT(result._32)));
	MMstore(m, ligne3, 2, ITOM(AROUNDINT(result._33)));

	MMpush(m, PTOM(ligne3));
	int matrice = MMmalloc(m, 3, TYPETAB);
	if(matrice==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, matrice, 2, MMpull(m) );
	MMstore(m, matrice, 1, MMpull(m) );
	MMstore(m, matrice, 0, MMpull(m) );


	// CREATION DU TUPLE FINAL
	MMpush(m, PTOM(matrice));
	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, tuple, 1, MMpull(m) );
	MMstore(m, tuple, 0, MMpull(m) );


	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3calcPosRefF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d H3d] [[F F F] [[F F F][F F F][F F F]]]
int ZM3calcPosRefF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3calcPosRefF ");
#endif

	int ref  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(ref==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*refer = (ZNode*) MMfetch(m,MTOP(ref),0);
	if(refer==NULL||refer->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}


	ZMatrix		refMat = ComputeWorldMatrix(refer);
	refMat.Inverse();
	ZMatrix		result = refMat * ComputeWorldMatrix(node);


	// CALCUL DE LA POSITION
	int posi = MMmalloc(m, 3, TYPETAB);
	if(posi==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, posi, 0, FTOM(100.0f*result(0,3))  );
	MMstore(m, posi, 1, FTOM(100.0f*result(1,3))  );
	MMstore(m, posi, 2, FTOM(-100.0f*result(2,3)) );


	// CALCUL DE LA MATRICE
	MMpush(m, PTOM(posi));

	int ligne1 = MMmalloc(m, 3, TYPETAB);
	if(ligne1==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne1, 0, FTOM(result._11));
	MMstore(m, ligne1, 1, FTOM(result._12));
	MMstore(m, ligne1, 2, FTOM(result._13));

	MMpush(m, PTOM(ligne1));
	int ligne2 = MMmalloc(m, 3, TYPETAB);
	if(ligne2==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne2, 0, FTOM(result._21));
	MMstore(m, ligne2, 1, FTOM(result._22));
	MMstore(m, ligne2, 2, FTOM(result._23));

	MMpush(m, PTOM(ligne2));
	int ligne3 = MMmalloc(m, 3, TYPETAB);
	if(ligne3==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, ligne3, 0, FTOM(result._31));
	MMstore(m, ligne3, 1, FTOM(result._32));
	MMstore(m, ligne3, 2, FTOM(result._33));

	MMpush(m, PTOM(ligne3));
	int matrice = MMmalloc(m, 3, TYPETAB);
	if(matrice==NIL)				{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, matrice, 2, MMpull(m) );
	MMstore(m, matrice, 1, MMpull(m) );
	MMstore(m, matrice, 0, MMpull(m) );


	// CREATION DU TUPLE FINAL
	MMpush(m, PTOM(matrice));
	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, tuple, 1, MMpull(m) );
	MMstore(m, tuple, 0, MMpull(m) );


	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3angularFromMatrix
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [ [[I I I][I I I][I I I]] ]	[I I I]
int ZM3angularFromMatrix(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3angularFromMatrix ");
#endif

	ZMatrix		mat;
	ZVector3	angl;
	
	mat.IdentityMatrix();

	int	matrix = MTOP(MMget(m,0));
	if((matrix==NIL)||(MMfetch(m,matrix,0)==NIL)||(MMfetch(m,matrix,1)==NIL)||(MMfetch(m,matrix,2)==NIL))		{	MMset(m,0,NIL);		return 0;	}


	int	ligne = MTOP(MMfetch(m,matrix,0));
	if( (MMfetch(m,ligne,0)==NIL) || (MMfetch(m,ligne,1)==NIL) || (MMfetch(m,ligne,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	mat._11 = ((float)(MTOI(MMfetch(m,ligne,0)))) / CONST_ANGLE;
	mat._12 = ((float)(MTOI(MMfetch(m,ligne,1)))) / CONST_ANGLE;
	mat._13 = ((float)(MTOI(MMfetch(m,ligne,2)))) / CONST_ANGLE;

	ligne = MTOP(MMfetch(m,matrix,1));
	if( (MMfetch(m,ligne,0)==NIL) || (MMfetch(m,ligne,1)==NIL) || (MMfetch(m,ligne,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	mat._21 = ((float)(MTOI(MMfetch(m,ligne,0)))) / CONST_ANGLE;
	mat._22 = ((float)(MTOI(MMfetch(m,ligne,1)))) / CONST_ANGLE;
	mat._23 = ((float)(MTOI(MMfetch(m,ligne,2)))) / CONST_ANGLE;

	ligne = MTOP(MMfetch(m,matrix,2));
	if( (MMfetch(m,ligne,0)==NIL) || (MMfetch(m,ligne,1)==NIL) || (MMfetch(m,ligne,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	mat._31 = ((float)(MTOI(MMfetch(m,ligne,0)))) / CONST_ANGLE;
	mat._32 = ((float)(MTOI(MMfetch(m,ligne,1)))) / CONST_ANGLE;
	mat._33 = ((float)(MTOI(MMfetch(m,ligne,2)))) / CONST_ANGLE;

	//angl  = mat.GetAnglesZXY();
	angl  = mat.GetAnglesYXZ();
	angl *= CONST_ANGLE / 360.0f;

	// CREATION DU TUPLE FINAL
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, tuple, 0, ITOM(AROUNDINT(angl.y)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(angl.x)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(angl.z)));

	MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3angularFromMatrixF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [ [[F F F][F F F][F F F]] ]	[F F F]
int ZM3angularFromMatrixF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3angularFromMatrixF ");
#endif

	ZMatrix		mat;
	ZVector3	angl;
	
	mat.IdentityMatrix();

	int	matrix = MTOP(MMget(m,0));
	if((matrix==NIL)||(MMfetch(m,matrix,0)==NIL)||(MMfetch(m,matrix,1)==NIL)||(MMfetch(m,matrix,2)==NIL))		{	MMset(m,0,NIL);		return 0;	}


	int	ligne = MTOP(MMfetch(m,matrix,0));
	if( (MMfetch(m,ligne,0)==NIL) || (MMfetch(m,ligne,1)==NIL) || (MMfetch(m,ligne,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	mat._11 = FTOM(MMfetch(m,ligne,0));
	mat._12 = FTOM(MMfetch(m,ligne,1));
	mat._13 = FTOM(MMfetch(m,ligne,2));

	ligne = MTOP(MMfetch(m,matrix,1));
	if( (MMfetch(m,ligne,0)==NIL) || (MMfetch(m,ligne,1)==NIL) || (MMfetch(m,ligne,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	mat._21 = FTOM(MMfetch(m,ligne,0));
	mat._22 = FTOM(MMfetch(m,ligne,1));
	mat._23 = FTOM(MMfetch(m,ligne,2));

	ligne = MTOP(MMfetch(m,matrix,2));
	if( (MMfetch(m,ligne,0)==NIL) || (MMfetch(m,ligne,1)==NIL) || (MMfetch(m,ligne,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	mat._31 = FTOM(MMfetch(m,ligne,0));
	mat._32 = FTOM(MMfetch(m,ligne,1));
	mat._33 = FTOM(MMfetch(m,ligne,2));

	//angl  = mat.GetAnglesZXY();
	angl  = mat.GetAnglesYXZ();
	angl *= (MY_PI/180.0f);

	// CREATION DU TUPLE FINAL
	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}
	MMstore(m, tuple, 0, FTOM(angl.y));
	MMstore(m, tuple, 1, FTOM(angl.x));
	MMstore(m, tuple, 2, FTOM(angl.z));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getRadius
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3getRadius(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getRadius ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||((node->type!=OBJ_TYPE_ID)&&(node->type!=MSH_TYPE_ID)))	{	MMset(m,0,NIL);		return 0;	}
	if( ((ZObject*)node)->GetMesh() == NULL)										{	MMset(m,0,NIL);		return 0;	}

	vector<ZVert>		*verts;
	if(node->type == OBJ_TYPE_ID)		verts = &(((ZObject*)node)->GetMesh()->Verts);
	else								verts = &(((ZMesh*)node)->Verts);

	float	dist = 0;
	for(int i=0; i<verts->size(); i++)			if(dist < (*verts)[i].Length())		dist = (*verts)[i].Length();

	MMset(m,0,ITOM(AROUNDINT(dist*100.0f)));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getRadiusF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] F
int ZM3getRadiusF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getRadiusF ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||((node->type!=OBJ_TYPE_ID)&&(node->type!=MSH_TYPE_ID)))	{	MMset(m,0,NIL);		return 0;	}
	if( ((ZObject*)node)->GetMesh() == NULL)										{	MMset(m,0,NIL);		return 0;	}

	vector<ZVert>		*verts;
	if(node->type == OBJ_TYPE_ID)		verts = &(((ZObject*)node)->GetMesh()->Verts);
	else								verts = &(((ZMesh*)node)->Verts);

	float	dist = 0;
	for(int i=0; i<verts->size(); i++)			if(dist < (*verts)[i].Length())		dist = (*verts)[i].Length();

	MMset(m,0, FTOM(dist*100.0f));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3calcProj
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d H3d] [I I I I]
//	calcule la projection d'un objet sur une camera (x,y) ecran et z
//	le rayon apparent, et pose NIL sur la pile si objet invisible ou erreur
int ZM3calcProj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3calcProj ");
#endif
	int h3d  = MMpull(m);
	int cam  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(cam==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)										{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if( (node==NULL) ||
		((node->type!=OBJ_TYPE_ID)&&(node->type!=CAM_TYPE_ID)&&(node->type!=LGH_TYPE_ID)&&
		 (node->type!=SHL_TYPE_ID)&&(node->type!=COL_TYPE_ID)&&(node->type!=SPR_TYPE_ID)&&
		 (node->type!=PCL_TYPE_ID)&&(node->type!=SND_TYPE_ID)))
														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*camer = (ZNode*) MMfetch(m,MTOP(cam),0);
	if((camer==NULL)||(camer->type!=CAM_TYPE_ID))		{	MMset(m,0,NIL);		return 0;	}

	int tuple = MMmalloc(m, 4, TYPETAB);
	if(tuple==NIL)										{	MMset(m,0,NIL);		return MERRMEM;	}
	for(int iii=0; iii<4; iii++)	MMstore(m, tuple, iii, NIL);


	// Calcul de la position projete
	ZMatrix		objMat = ComputeWorldMatrix(node);

	ZVector3	worldPos;
	worldPos.SetCoord(objMat(0,3), objMat(1,3), objMat(2,3));

	ZCamera		*curCam = (ZCamera*)camer;
	curCam->worldMat = ComputeWorldMatrix(camer);
	curCam->worldPos.SetCoord(curCam->worldMat(0,3), curCam->worldMat(1,3), curCam->worldMat(2,3));
	curCam->ComputeMatrix();

	worldPos *= curCam->cameraMatx;


	// utilisation des clipping BACK et FRONT
	if((-worldPos.z<curCam->Znear)||(-worldPos.z>curCam->Zfar))				{	MMset(m,0,NIL);		return 0;	}
	MMstore(m, tuple, 2, ITOM(AROUNDINT(-worldPos.z*100.0f)));


	// On projette la position 3D sur le plan Znear (Thals)
	float	coeff = -curCam->Znear / worldPos.z;
	worldPos *= coeff;

	// On calcule les valeurs des bords cran en 3D (plan Znear)
	float	top		= curCam->Znear * ((double)(curCam->height/2)) / ((double)curCam->dy);
	float	right	= top * ((float)curCam->width / (float)curCam->height);

	// On dtermine les positions cran finales
	float	posX =  (curCam->width *worldPos.x) / (2.0f*right);
	float	posY =  (curCam->height*worldPos.y) / (2.0f*top);
	MMstore(m, tuple, 0, ITOM(AROUNDINT(posX)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(posY)));

	// Rayon apparent
	if(node->type!=OBJ_TYPE_ID)			MMstore(m, tuple, 3, 0);
	else
	{
		ZMesh*	msh = ((ZObject*)node)->GetMesh();

		if(msh)
		{
			float	rayon = (msh->xmax - msh->xmin)*(msh->xmax - msh->xmin) + (msh->ymax - msh->ymin)*(msh->ymax - msh->ymin) + (msh->zmax - msh->zmin)*(msh->zmax - msh->zmin);
			rayon = coeff * sqrt(rayon) / 2.0f;

			float	rayonX = (curCam->width *rayon) / (2.0f*right);
			float	rayonY = (curCam->height*rayon) / (2.0f*top);

			if(rayonX > rayonY)			MMstore(m, tuple, 3, ITOM(AROUNDINT(rayonX)));
			else						MMstore(m, tuple, 3, ITOM(AROUNDINT(rayonY)));
		}
		else
			MMstore(m, tuple, 3, NIL);
	}


	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3calcProjF
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d H3d] [I I F F]
//	calcule la projection d'un objet sur une camera (x,y) ecran et z
//	le rayon apparent, et pose NIL sur la pile si objet invisible ou erreur
int ZM3calcProjF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3calcProjF ");
#endif
	int h3d  = MMpull(m);
	int cam  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(cam==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)										{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if( (node==NULL) ||
		((node->type!=OBJ_TYPE_ID)&&(node->type!=CAM_TYPE_ID)&&(node->type!=LGH_TYPE_ID)&&
		 (node->type!=SHL_TYPE_ID)&&(node->type!=COL_TYPE_ID)&&(node->type!=SPR_TYPE_ID)&&
		 (node->type!=PCL_TYPE_ID)&&(node->type!=SND_TYPE_ID)))
														{	MMset(m,0,NIL);		return 0;	}

    ZNode	*camer = (ZNode*) MMfetch(m,MTOP(cam),0);
	if((camer==NULL)||(camer->type!=CAM_TYPE_ID))		{	MMset(m,0,NIL);		return 0;	}

	int tuple = MMmalloc(m, 4, TYPETAB);
	if(tuple==NIL)										{	MMset(m,0,NIL);		return MERRMEM;	}
	for(int iii=0; iii<4; iii++)	MMstore(m, tuple, iii, NIL);


	// Calcul de la position projete
	ZMatrix		objMat = ComputeWorldMatrix(node);

	ZVector3	worldPos;
	worldPos.SetCoord(objMat(0,3), objMat(1,3), objMat(2,3));

	ZCamera		*curCam = (ZCamera*)camer;
	curCam->worldMat = ComputeWorldMatrix(camer);
	curCam->worldPos.SetCoord(curCam->worldMat(0,3), curCam->worldMat(1,3), curCam->worldMat(2,3));
	curCam->ComputeMatrix();

	worldPos *= curCam->cameraMatx;


	// utilisation des clipping BACK et FRONT
	if((-worldPos.z<curCam->Znear)||(-worldPos.z>curCam->Zfar))				{	MMset(m,0,NIL);		return 0;	}
	MMstore(m, tuple, 2, FTOM(-worldPos.z*100.0f) );


	// On projette la position 3D sur le plan Znear (Thals)
	float	coeff = -curCam->Znear / worldPos.z;
	worldPos *= coeff;

	// On calcule les valeurs des bords cran en 3D (plan Znear)
	float	top		= curCam->Znear * ((double)(curCam->height/2)) / ((double)curCam->dy);
	float	right	= top * ((float)curCam->width / (float)curCam->height);

	// On dtermine les positions cran finales
	float	posX =  (curCam->width *worldPos.x) / (2.0f*right);
	float	posY =  (curCam->height*worldPos.y) / (2.0f*top);
	MMstore(m, tuple, 0, ITOM(AROUNDINT(posX)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(posY)));

	// Rayon apparent
	if(node->type!=OBJ_TYPE_ID)			MMstore(m, tuple, 3, 0);
	else
	{
		ZMesh*	msh = ((ZObject*)node)->GetMesh();

		if(msh)
		{
			float	rayon = (msh->xmax - msh->xmin)*(msh->xmax - msh->xmin) + (msh->ymax - msh->ymin)*(msh->ymax - msh->ymin) + (msh->zmax - msh->zmin)*(msh->zmax - msh->zmin);
			rayon = coeff * sqrt(rayon) / 2.0f;

			float	rayonX = (curCam->width *rayon) / (2.0f*right);
			float	rayonY = (curCam->height*rayon) / (2.0f*top);

			if(rayonX > rayonY)			MMstore(m, tuple, 3, FTOM(rayonX));
			else						MMstore(m, tuple, 3, FTOM(rayonY));
		}
		else
			MMstore(m, tuple, 3, NIL);
	}


	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3areMeshesCulled
//////////////////////////////////////////////////////////////////////////////////////////////
//	Cette fonction n'est utilisable qu'aprs un rendu  l'cran : elle utilise la camera qui a permis le rendu
//
//	fun [S3d H3d [H3d r1]] [I r1]
//
int ZM3areMeshesCulled(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3areMeshesCulled ");
#endif
	int list = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(list==NIL))					{	MMpush(m,NIL);	return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMpush(m,NIL);	return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if( (node==NULL) ||(node->type!=OBJ_TYPE_ID) )			{	MMpush(m,NIL);	return 0;	}
	ZObject	*obj = (ZObject*) node;

	if(scene->activeCam == NULL)							{	MMpush(m,NIL);	return 0;	}

	ZVector3	origine, rayon;
	float		distanceTmp;
	int			curH3D, tmp_res;
	int			n=0;

	while(list!=NIL)
	{
		curH3D = MTOP(MMfetch(m,list,0));
		node = (ZNode*) MMfetch(m, curH3D, 0);

		if( node && (node->type==OBJ_TYPE_ID) && (((ZObject*)node)->GetMesh()) )
		{
			origine = scene->activeCam->worldPos;
			rayon	= ((ZObject*)node)->worldPos;
			distanceTmp = rayon.Length();

			if( TestObject(scene->activeCam->worldMat, obj, origine, rayon, &distanceTmp, scene->activeCam->Znear, NULL, NULL, NULL, NULL) )
			{
				// "obj" cache le curH3D
				if(MMpush(m, PTOM(list)))		return MERRMEM;
				if(MMpush(m, ITOM(1)))			return MERRMEM;
				INVERT(m,0,1);
				list = MTOP(MMpull(m));
			}
			else
			{
				// "obj" ne cache pas le curH3D
				if(MMpush(m, PTOM(list)))		return MERRMEM;
				if(MMpush(m, 0))				return MERRMEM;
				INVERT(m,0,1);
				list = MTOP(MMpull(m));
			}
		}
		else
		{
			if(MMpush(m, PTOM(list)))		return MERRMEM;
			if(MMpush(m,NIL))				return MERRMEM;
			INVERT(m,0,1);
			list = MTOP(MMpull(m));
		}

		list = MTOP(MMfetch(m,list,1));
		n++;
	}

	int k;

	if(MMpush(m,NIL))		return MERRMEM;
	for(int j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3isMeshCulledByOthers
//////////////////////////////////////////////////////////////////////////////////////////////
//	Cette fonction n'est utilisable qu'aprs un rendu  l'cran : elle utilise la camera qui a permis le rendu
//
//	fun [S3d H3d [H3d r1]] [I r1]
//
int ZM3isMeshCulledByOthers(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3isMeshCulledByOthers ");
#endif

//	_asm{int 3};

	int list = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL)||(list==NIL))					{	MMpush(m,NIL);	return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMpush(m,NIL);	return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if( (node==NULL) ||(node->type!=OBJ_TYPE_ID) )			{	MMpush(m,NIL);	return 0;	}
	ZObject	*obj = (ZObject*) node;

	if(scene->activeCam == NULL)							{	MMpush(m,NIL);	return 0;	}

	ZVector3	origine, rayon;
	float		distanceTmp;
	int			curH3D, tmp_res;
	int			n=0;


	while(list!=NIL)
	{
		curH3D = MTOP(MMfetch(m,list,0));
		node = (ZNode*) MMfetch(m, curH3D, 0);

		if( node && (node->type==OBJ_TYPE_ID) && (((ZObject*)node)->GetMesh()) )
		{
			//origine = scene->activeCam->worldPos;
			origine.SetNull();
			rayon	= obj->worldPos;
			distanceTmp = rayon.Length();
			rayon.Normalize();

			if( TestObject(scene->activeCam->worldMat, (ZObject*)node, origine, rayon, &distanceTmp, scene->activeCam->Znear, NULL, NULL, NULL, NULL) )
			{
				// "obj" est cach par le curH3D
				if(MMpush(m, PTOM(list)))		return MERRMEM;
				if(MMpush(m, ITOM(1)))			return MERRMEM;
				INVERT(m,0,1);
				list = MTOP(MMpull(m));
			}
			else
			{
				// "obj" n'est pas cach par le curH3D
				if(MMpush(m, PTOM(list)))		return MERRMEM;
				if(MMpush(m, 0))				return MERRMEM;
				INVERT(m,0,1);
				list = MTOP(MMpull(m));
			}
		}
		else
		{
			if(MMpush(m, PTOM(list)))		return MERRMEM;
			if(MMpush(m,NIL))				return MERRMEM;
			INVERT(m,0,1);
			list = MTOP(MMpull(m));
		}

		list = MTOP(MMfetch(m,list,1));
		n++;
	}


	int k;

	if(MMpush(m,NIL))		return MERRMEM;
	for(int j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		AngularTarget
//////////////////////////////////////////////////////////////////////////////////////////////
//	positionnement d'un objet vers une cible determinee
ZVector3 AngularTarget(ZVector3 src, ZVector3 dest)
{
	ZVector3	angl;
	float		dx, dy, dh, d;

	dx =  dest.z - src.z;
	dy = -dest.x + src.x;
	dh =  dest.y - src.y;

	d = sqrt(dx*dx+dy*dy);

	if(d>0.001f)
	{
		angl.y = atan2(dy,dx) * 32768.0f / 3.14159f;
		d = sqrt(dx*dx+dy*dy);
		angl.x = atan(dh/d) * 32768.0f / 3.14159f;
	}
	else
	{
		angl.x = 0;
		angl.y = 0;
	}
	angl.z = 0;

	return angl;
}
//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3angularTarget
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [[I I I] [I I I]] [I I I]
int ZM3angularTarget(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3angularTarget ");
#endif
	int dst  = MTOP(MMpull(m));
	int src  = MTOP(MMget(m,0));

	if((src==NIL)||(dst==NIL))		{	MMset(m,0,NIL);		return 0;	}

	ZVector3	srce, dest, result;

	if( (MMfetch(m,src,0)==NIL) || (MMfetch(m,src,1)==NIL) || (MMfetch(m,src,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	srce.SetCoord(MTOI(MMfetch(m,src,0)), MTOI(MMfetch(m,src,1)), MTOI(MMfetch(m,src,2)));

	if( (MMfetch(m,dst,0)==NIL) || (MMfetch(m,dst,1)==NIL) || (MMfetch(m,dst,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	dest.SetCoord(MTOI(MMfetch(m,dst,0)), MTOI(MMfetch(m,dst,1)), MTOI(MMfetch(m,dst,2)));

	result = AngularTarget(srce, dest);

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, ITOM(AROUNDINT(result.y)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(result.x)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(result.z)));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3angularTargetF
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [[F F F] [F F F]] [F F F]
int ZM3angularTargetF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3angularTargetF ");
#endif
	int dst  = MTOP(MMpull(m));
	int src  = MTOP(MMget(m,0));

	if((src==NIL)||(dst==NIL))		{	MMset(m,0,NIL);		return 0;	}

	ZVector3	srce, dest, result;

	if( (MMfetch(m,src,0)==NIL) || (MMfetch(m,src,1)==NIL) || (MMfetch(m,src,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	srce.SetCoord(MTOF(MMfetch(m,src,0)), MTOF(MMfetch(m,src,1)), MTOF(MMfetch(m,src,2)));

	if( (MMfetch(m,dst,0)==NIL) || (MMfetch(m,dst,1)==NIL) || (MMfetch(m,dst,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	dest.SetCoord(MTOF(MMfetch(m,dst,0)), MTOF(MMfetch(m,dst,1)), MTOF(MMfetch(m,dst,2)));

	result = AngularTarget(srce, dest) * (MY_PI / 32768.0f);

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, FTOM(result.y));
	MMstore(m, tuple, 1, FTOM(result.x));
	MMstore(m, tuple, 2, FTOM(result.z));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getGlobalVec
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d [I I I]] [I I I]
int ZM3getGlobalVec(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getGlobalVec ");
#endif
	int vect = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vect==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	if( (MMfetch(m,vect,0)==NIL) || (MMfetch(m,vect,1)==NIL) || (MMfetch(m,vect,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	ZVector4	vector;
	vector.SetCoord(MTOI(MMfetch(m,vect,0)), MTOI(MMfetch(m,vect,1)), -MTOI(MMfetch(m,vect,2)), 0.0f);

	vector *= ComputeWorldMatrix(node);

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	MMstore(m, tuple, 0, ITOM(AROUNDINT(vector.x)));
	MMstore(m, tuple, 1, ITOM(AROUNDINT(vector.y)));
	MMstore(m, tuple, 2, ITOM(AROUNDINT(-vector.z)));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getGlobalVecF
//////////////////////////////////////////////////////////////////////////////////////////////
//	fun [S3d H3d [F F F]] [F F F]
int ZM3getGlobalVecF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getGlobalVecF ");
#endif
	int vect = MTOP(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(vect==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	if( (MMfetch(m,vect,0)==NIL) || (MMfetch(m,vect,1)==NIL) || (MMfetch(m,vect,2)==NIL) )			{	MMset(m,0,NIL);		return 0;	}
	ZVector4	vector;
	vector.SetCoord( MTOF(MMfetch(m,vect,0)), MTOF(MMfetch(m,vect,1)), - MTOF(MMfetch(m,vect,2)), 0.0f);

	vector *= ComputeWorldMatrix(node);

	int tuple = MMmalloc(m, 3, TYPETAB);
	if(tuple==NIL)					{	MMset(m,0,NIL);		return MERRMEM;	}

	// pas de multiplication par 100.0f, c'est NORMAL !!
	MMstore(m, tuple, 0, FTOM(vector.x));
	MMstore(m, tuple, 1, FTOM(vector.y));
	MMstore(m, tuple, 2, FTOM(-vector.z));

	MMset(m,0,PTOM(tuple));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}

