//$LB OK
//////////////////////////////////////////////////////////////////////////////////////////////
///		M3interpVec														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[[I I I] [I I I] I] [I I I]
int M3interpVec(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3interpVec ");
#endif

    int			p,q,tx;
    ZVector3	v, w, r;

	tx = MMpull(m)>>1;
    q  = MMpull(m)>>1;
    p  = MMpull(m)>>1;
    if((p==NIL)||(q==NIL))		return MMpush(m,NIL);

	tx &= 255;

    v.x	= MMfetch(m,p,0)>>1;
    v.y	= MMfetch(m,p,1)>>1;
    v.z	= MMfetch(m,p,2)>>1;
    w.x	= MMfetch(m,q,0)>>1;
    w.y	= MMfetch(m,q,1)>>1;
    w.z	= MMfetch(m,q,2)>>1;

	r = v*(1-((float)tx)/CONST_VAL8) + w*(((float)tx)/CONST_VAL8);
	
	if (MMpush(m,ITOM(AROUNDINT(r.x))))		return MERRMEM;
	if (MMpush(m,ITOM(AROUNDINT(r.y))))		return MERRMEM;
	if (MMpush(m,ITOM(AROUNDINT(r.z))))		return MERRMEM;
	if (MMpush(m,3*2))						return MERRMEM;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		M3interpVecF														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[[F F F] [F F F] F] [F F F]
int M3interpVecF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3interpVecF ");
#endif

    int			p,q,tx;
    ZVector3	v, w, r;

	tx = MMpull(m);
    q  = MTOP(MMpull(m));
    p  = MTOP(MMpull(m));
    
	if((p==NIL)||(q==NIL))			return MMpush(m,NIL);

	float	rate = MTOF(tx);

    v.x	= MTOF(MMfetch(m,p,0));
    v.y	= MTOF(MMfetch(m,p,1));
    v.z	= MTOF(MMfetch(m,p,2));
    
	w.x	= MTOF(MMfetch(m,q,0));
    w.y	= MTOF(MMfetch(m,q,1));
    w.z	= MTOF(MMfetch(m,q,2));

	r = v*(1-rate) + w*rate;
	
	if (MMpush(m,FTOM(r.x)))		return MERRMEM;
	if (MMpush(m,FTOM(r.y)))		return MERRMEM;
	if (MMpush(m,FTOM(r.z)))		return MERRMEM;
	if (MMpush(m,3*2))				return MERRMEM;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		M3interpAng													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[[I I I] [I I I] I] [I I I]
int M3interpAng(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3interpAng ");
#endif

    int			p,q,tx;
    ZVector3	v, w, r;

	tx = MMpull(m)>>1;
    q  = MMpull(m)>>1;
    p  = MMpull(m)>>1;
    if((p==NIL)||(q==NIL))		return MMpush(m,NIL);

	tx &= 255;

	v.x = MMfetch(m,p,0)>>1;
    v.y = MMfetch(m,p,1)>>1;
    v.z = MMfetch(m,p,2)>>1;

    w.x = MMfetch(m,q,0)>>1;
    w.y = MMfetch(m,q,1)>>1;
    w.z = MMfetch(m,q,2)>>1;

	r  = interpAng(v*(360.0f/CONST_ANGLE), w*(360.0f/CONST_ANGLE), ((float)tx)/CONST_VAL8);
	r *= CONST_ANGLE / 360.0f;

	if (MMpush(m,ITOM(AROUNDINT(r.x))))		return MERRMEM;
	if (MMpush(m,ITOM(AROUNDINT(r.y))))		return MERRMEM;
	if (MMpush(m,ITOM(AROUNDINT(r.z))))		return MERRMEM;
	if (MMpush(m,3*2))						return MERRMEM;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		M3interpAngF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[[F F F] [F F F] F] [F F F]
int M3interpAngF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3interpAngF ");
#endif

    int			p,q,tx;
    ZVector3	v, w, r;

	tx = MMpull(m);
    q  = MTOP(MMpull(m));
    p  = MTOP(MMpull(m));

    if((p==NIL)||(q==NIL))		return MMpush(m,NIL);

	float	rate = MTOF(tx);

    v.x	= MTOF(MMfetch(m,p,0));
    v.y	= MTOF(MMfetch(m,p,1));
    v.z	= MTOF(MMfetch(m,p,2));
    
	w.x	= MTOF(MMfetch(m,q,0));
    w.y	= MTOF(MMfetch(m,q,1));
    w.z	= MTOF(MMfetch(m,q,2));

	r  = interpAng(v*(180.0f/MY_PI), w*(180.0f/MY_PI), rate);
	r *= MY_PI / 180.0f;

	if (MMpush(m,FTOM(r.x)))		return MERRMEM;
	if (MMpush(m,FTOM(r.y)))		return MERRMEM;
	if (MMpush(m,FTOM(r.z)))		return MERRMEM;
	if (MMpush(m,3*2))				return MERRMEM;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return MBdeftab(m);
}
