//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///					  GESTION DES LUMIERES							    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setLightModel
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d I] I
int ZM3setLightModel(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setLightModel ");
#endif

	int type = MTOI( MMpull(m) );
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(type==NIL))										{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

	if(type==0)		scene->generalRealLighting = true;
	else			scene->generalRealLighting = false;

    MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getLightModel
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] I
int ZM3getLightModel(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getLightModel ");
#endif

    int s3d  = MMget(m,0);

    if(s3d==NIL)													{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

	int type;
	if(scene->generalRealLighting)		type = 0;
	else								type = 1;

    MMset(m,0,ITOM(type));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createLight
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d I I I I I I] H3d
int ZM3createLight(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createLight ");
#endif

	int p3	 = MMpull(m);
	int p2	 = MMpull(m);
	int p1	 = MMpull(m);
	int beta = MMpull(m);
	int alph = MMpull(m);
	int type = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(type==NIL)||(alph==NIL))						{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

	if( (MTOI(type)==LIGHT_PARA) && (beta==NIL) )					{	MMset(m,0,NIL);		return 0;	}
	if( (MTOI(type)==LIGHT_OMNI) && ((beta==NIL)||(p1==NIL)) )		{	MMset(m,0,NIL);		return 0;	}
	if( (MTOI(type)==LIGHT_SPOT) && ((beta==NIL)||(p1==NIL)) )		{	MMset(m,0,NIL);		return 0;	}


	ZLight	*curLgh;
	curLgh = new ZLight((int)scene);
	if(curLgh == NULL)							{	MMset(m,0,NIL);		return 0;	}
	curLgh->InsertAsChildOf(scene->World);
	curLgh->SetName("");
	curLgh->oldStyle = true;


	// Attribution des composantes de la lumire
	curLgh->LightType = MTOI(type);


	float	ambient = ((float)MTOI(alph)) / 64.0f;
	curLgh->SetAmbient(ambient, ambient, ambient, 1.0f);
	curLgh->alpha = MTOI(alph);

	if(beta!=NIL)
	{
		float	diffuse = ((float)MTOI(beta)) / 64.0f;
		curLgh->SetDiffuse(diffuse, diffuse, diffuse, 1.0f);
		curLgh->beta = MTOI(beta);
	}

	if(p1!=NIL)
	{
		float	distance = ((float)MTOI(p1)) / 100.0f;
		curLgh->distance = distance;
		curLgh->dist = MTOI(p1);
	}


	// Declaration en SCOL
	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)curLgh, hash_tab);

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getLight
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I I I I I]
int ZM3getLight(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getLight ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

    if((s3d==NIL)||(h3d==NIL))						{	MMpush(m,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{	MMpush(m,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=LGH_TYPE_ID))		{	MMpush(m,NIL);		return 0;	}
	ZLight	*lgh = (ZLight*)node;

	if(lgh->oldStyle == false)						{	MMpush(m,NIL);		return 0;	}

	if(MMpush(m,ITOM(lgh->LightType)))							return MERRMEM;
	if(MMpush(m,ITOM(AROUNDINT(lgh->ambient[0]*64.0f))))		return MERRMEM;
	if(MMpush(m,ITOM(AROUNDINT(lgh->diffuse[0]*64.0f))))		return MERRMEM;
	if(MMpush(m,ITOM(AROUNDINT(lgh->distance*100.0f))))			return MERRMEM;
	if(MMpush(m,NIL))											return MERRMEM;
	if(MMpush(m,NIL))											return MERRMEM;
	if(MMpush(m,6*2))											return MERRMEM;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setLight
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I I I I I]] I
int ZM3setLight(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setLight ");
#endif

	int data = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(data==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=LGH_TYPE_ID))		{	MMset(m,0,NIL);		return 0;	}
	ZLight	*lgh = (ZLight*) node;

	if(lgh->oldStyle == false)						{	MMset(m,0,NIL);		return 0;	}


	// Attribution des composantes de la lumire
	lgh->LightType = MTOI(MMfetch(m,MTOP(data),0));

	float	ambient = ((float)MTOI(MMfetch(m,MTOP(data),1))) / 64.0f;
	lgh->SetAmbient(ambient, ambient, ambient, 1.0f);
	lgh->alpha = MTOI(MMfetch(m,MTOP(data),1));

	float	diffuse = ((float)MTOI(MMfetch(m,MTOP(data),2))) / 64.0f;
	lgh->SetDiffuse(diffuse, diffuse, diffuse, 1.0f);
	lgh->beta = MTOI(MMfetch(m,MTOP(data),2));

	float	distance = ((float)MTOI(MMfetch(m,MTOP(data),3))) / 100.0f;
	lgh->distance = distance;
	lgh->dist = MTOI(MMfetch(m,MTOP(data),3));

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createColorLight
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d I I I I I I I] H3d
int ZM3createColorLight(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createColorLight ");
#endif

	int att_q = MMpull(m);
	int att_c = MMpull(m);
	int angl  = MMpull(m);
	int spec  = MMpull(m);
	int diff  = MMpull(m);
	int amb   = MMpull(m);
	int type  = MMpull(m);
	
    int s3d   = MMget(m,0);

    if((s3d==NIL)||(type==NIL)||(amb==NIL)||(diff==NIL)||(spec==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

	ZLight	*curLgh;
	curLgh = new ZLight((int)scene);
	if(curLgh == NULL)							{	MMset(m,0,NIL);		return 0;	}
	curLgh->InsertAsChildOf(scene->World);
	curLgh->SetName("");
	curLgh->oldStyle = false;


	// Attribution des composantes de la lumire
	curLgh->LightType = MTOI( type );

	amb = MTOI(amb);
	curLgh->SetAmbient( ((float)((amb&0x00ff0000)>>16)) / CONST_COLOR,
						((float)((amb&0x0000ff00)>>8) ) / CONST_COLOR,
						((float) (amb&0x000000ff)	  ) / CONST_COLOR, 
						1.0f);
	curLgh->alpha = (int) ((curLgh->ambient[0]+curLgh->ambient[1]+curLgh->ambient[2]) * 64.0f / 3.0f);

	diff = MTOI(diff);
	curLgh->SetDiffuse( ((float)((diff&0x00ff0000)>>16)) / CONST_COLOR,
						((float)((diff&0x0000ff00)>>8) ) / CONST_COLOR,
						((float) (diff&0x000000ff)	   ) / CONST_COLOR, 
						1.0f);
	curLgh->beta = (int) ((curLgh->diffuse[0]+curLgh->diffuse[1]+curLgh->diffuse[2]) * 64.0f / 3.0f);

	spec = MTOI(spec);
	curLgh->SetSpecular( ((float)((spec&0x00ff0000)>>16)) / CONST_COLOR,
						 ((float)((spec&0x0000ff00)>>8) ) / CONST_COLOR,
						 ((float) (spec&0x000000ff)		) / CONST_COLOR, 
						 1.0f);


	// Cut-off et attenuation (const et quadratique)
	if(angl == NIL)		curLgh->spot_cut_off	= (int)180.0f;
	else				curLgh->spot_cut_off	= MTOI( angl );

	if(att_c == NIL)	curLgh->attenuate_const = 1.0f;
	else				curLgh->attenuate_const = ((float)MTOI(att_c))/100.0f;

	if(att_q == NIL)	curLgh->attenuate_quadr = 0.0f;
	else				curLgh->attenuate_quadr = ((float)MTOI(att_q))/100.0f;


	// Declaration en SCOL
	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)curLgh, hash_tab);

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getColorLight
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I I I I I I]
int ZM3getColorLight(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getColorLight ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL))						{	MMpush(m,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{	MMpush(m,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=LGH_TYPE_ID))		{	MMpush(m,NIL);		return 0;	}
	ZLight	*lgh = (ZLight*)node;

	if(lgh->oldStyle == true)						{	MMpush(m,NIL);		return 0;	}

	
	
	int coul = 0;
	
	if(MMpush(m,ITOM(lgh->LightType)))							return MERRMEM;

	coul = AROUNDINT(lgh->ambient[2]*CONST_COLOR) + (AROUNDINT(lgh->ambient[1]*CONST_COLOR)<<8) + (AROUNDINT(lgh->ambient[0]*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;
	
	coul = AROUNDINT(lgh->diffuse[2]*CONST_COLOR) + (AROUNDINT(lgh->diffuse[1]*CONST_COLOR)<<8) + (AROUNDINT(lgh->diffuse[0]*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;

	coul = AROUNDINT(lgh->specular[2]*CONST_COLOR) + (AROUNDINT(lgh->specular[1]*CONST_COLOR)<<8) + (AROUNDINT(lgh->specular[0]*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;

	if(MMpush(m,ITOM(lgh->spot_cut_off)))						return MERRMEM;
	if(MMpush(m,ITOM(AROUNDINT(lgh->attenuate_const*100.0f))))	return MERRMEM;
	if(MMpush(m,ITOM(AROUNDINT(lgh->attenuate_quadr*100.0f))))	return MERRMEM;

	if(MMpush(m,7*2))											return MERRMEM;
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return MBdeftab(m);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setColorLight
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I I I I I I I] I
int ZM3setColorLight(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setColorLight ");
#endif

	int att_q = MMpull(m);
	int att_c = MMpull(m);
	int angl  = MMpull(m);
	int spec  = MMpull(m);
	int diff  = MMpull(m);
	int amb   = MMpull(m);
	int type  = MMpull(m);
	int h3d   = MMpull(m);

    int s3d   = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(type==NIL)||(amb==NIL)||(diff==NIL)||(spec==NIL))				{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=LGH_TYPE_ID))		{	MMset(m,0,NIL);		return 0;	}
	ZLight	*lgh = (ZLight*) node;

	if(lgh->oldStyle == true)						{	MMset(m,0,NIL);		return 0;	}


	// Attribution des composantes de la lumire
	lgh->LightType = MTOI( type );

	amb = MTOI(amb);
	lgh->SetAmbient( ((float)((amb&0x00ff0000)>>16)) / CONST_COLOR,
					 ((float)((amb&0x0000ff00)>>8) ) / CONST_COLOR,
					 ((float) (amb&0x000000ff)	   ) / CONST_COLOR, 
					 1.0f);
	lgh->alpha = (int) ((lgh->ambient[0]+lgh->ambient[1]+lgh->ambient[2]) * 64.0f / 3.0f);

	diff = MTOI(diff);
	lgh->SetDiffuse( ((float)((diff&0x00ff0000)>>16)) / CONST_COLOR,
					 ((float)((diff&0x0000ff00)>>8) ) / CONST_COLOR,
					 ((float) (diff&0x000000ff)	    ) / CONST_COLOR, 
					 1.0f);
	lgh->beta = (int) ((lgh->diffuse[0]+lgh->diffuse[1]+lgh->diffuse[2]) * 64.0f / 3.0f);

	spec = MTOI(spec);
	lgh->SetSpecular( ((float)((spec&0x00ff0000)>>16)) / CONST_COLOR,
					  ((float)((spec&0x0000ff00)>>8) ) / CONST_COLOR,
					  ((float) (spec&0x000000ff)	 ) / CONST_COLOR, 
					  1.0f);


	// Cut-off et attenuation (const et quadratique)
	if(angl == NIL)		lgh->spot_cut_off	= (int)180.0f;
	else				lgh->spot_cut_off	= MTOI( angl );

	if(att_c == NIL)	lgh->attenuate_const = 1.0f;
	else				lgh->attenuate_const = ((float)MTOI(att_c))/100.0f;

	if(att_q == NIL)	lgh->attenuate_quadr = 0.0f;
	else				lgh->attenuate_quadr = ((float)MTOI(att_q))/100.0f;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}
