//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///				   GESTION DES MATERIAUX							    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialTransparencyOrder
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [HMat3d I] I
int ZM3setMaterialTransparencyOrder(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialTransparencyOrder");
#endif
	int order = MTOI(MMpull(m));
	int mat = MMget(m,0);

    if((mat==NIL)||(order==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)						{	MMset(m,0,NIL);		return 0;	}

	if(order<0)		order = 0;
	mater->transparencyOrder = order;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialTransparencyOrder
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [HMat3d] I
int ZM3getMaterialTransparencyOrder(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialTransparencyOrder");
#endif
	int mat = MMget(m,0);

    if((mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)		{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0, ITOM(mater->transparencyOrder));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listALLMaterials
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d] [HMat3d r1]
int ZM3listALLMaterials(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listALLMaterials ");
#endif
    int s3d = MMget(m,0);

    if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int	n=0;
	int tx, tmp_res;
    

	int k;
	for(k=0; k<scene->MatList.Size(); k++)
    {
		int s3d = MMget(m,0);
		int hash = MTOP(MMfetch(m,MTOP(s3d),2));

		tx = NodeTOHandle(m, hash, (int)scene->MatList[k]);
		if(tx!=NIL)
		{
			tx = PTOM(tx);
			if(MMpush(m,tx))			return MERRMEM;
			INVERT(m,0,1);
			n++;
		}
    }

	if(n==0)		{	MMset(m,0,NIL);		return n;	}
	MMpull(m);
	if(MMpush(m,NIL))		return MERRMEM;

	int j;
	for(j=0;j<n;j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S] HMat3d
int ZM3createMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createMaterial ");
#endif
	int name = MMpull(m);
	int s3d  = MMget(m,0);
    
    if((s3d==NIL)||(name==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}


	// Creation du nouveau materiau
	string	nom = string(MMstartstr(m,MTOP(name)));

	ZMaterial*	curMat = new ZMaterial(scene->accelerated);
	if(!curMat)						{	MMset(m,0,NIL);		return 0;	}
	scene->MatList.Add(curMat);

	curMat->SetName(nom);

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),2) );
	int mat = createHmatHtx(m, (int)curMat, hash_tab);

	scene->materialModified		= true;

	MMset(m, 0, PTOM(mat));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMat
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S] HMat3d
int ZM3getMat(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMat ");
#endif
	int name = MMpull(m);
    int s3d  = MMget(m,0);
    
    if((name==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*)MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	string	matName = string(MMstartstr(m,MTOP(name)));

	ZMaterial	*curMat = NULL;

	int k;
	for(k=0; k<scene->MatList.Size(); k++)
	{
		if( scene->MatList[k]->name==matName && (curMat==NULL || scene->MatList[k]->version>curMat->version) )		curMat = scene->MatList[k];
	}


	if(curMat==NULL)		{	MMset(m,0,NIL);		return 0;	}

	int	mat3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)curMat);
	if(mat3d!=NIL)		mat3d = PTOM(mat3d);
	MMset(m,0,mat3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3materialName
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] S
int ZM3materialName(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3materialName ");
#endif
   int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMpull(m);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return Mpushstrbloc(m, (char*)mater->name.c_str());
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3renameMat
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d S] I
int ZM3renameMat(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3renameMat ");
#endif
    int name = MMpull(m);
    int mat  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(name==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->SetName((char*)MMstartstr(m,MTOP(name)));

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		fillMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// Fill a material with the good texture
///
void fillMaterial(ZMaterial	*mater)
{
	// Texture 1
	ZTexture	*tex = mater->GetTexture1();

	if( (tex!=NULL) && ((tex->activated==false)||(tex->renamed==true)) )
	{
		free(tex->Image);			tex->Image		= NULL;
		free(tex->ImageModif);		tex->ImageModif = NULL;		

		tex->A = tex->C = tex->X = tex->Y = tex->R = tex->S = false;

		int		debName = 0;
		char	*namefile = (char*)tex->name.c_str();
		if(namefile[0]=='%')			debName = M3DloadFilter(namefile, tex);

		bool	test = true;
		char	name[SIZESIGN];

		//$LB if(SPfindfile((packdir)SCgetExtra("FirstPack"), &(namefile[debName]), NULL, name)==-1)		test=false;
		if(SPfindfile((packdir)Firstpack, &(namefile[debName]), NULL, name)==-1)		test=false;

		if(test)	{ if(tex->LoadTexture(name)==false)		test=false;		}

		if(test)
		{
			if(tex->ImageModif!=NULL)		{	free(tex->ImageModif);		tex->ImageModif = NULL;		}
			tex->CreateModifiedImg();
			tex->SetupTexture();
			mater->EnableMode(RENDER_TEXTURED);
			mater->modified = true;
			tex->modified	= true;
		}
	}
	else if(tex!=NULL && tex->modified /*&& tex->activated==true*/)
	{
		mater->modified = true;
	}

	// Texture 2
	tex = mater->GetTexture2();

	if( (tex!=NULL) && ((tex->activated==false)||(tex->renamed==true)) )
	{
		free(tex->Image);			tex->Image		= NULL;
		free(tex->ImageModif);		tex->ImageModif = NULL;

		tex->A = tex->C = tex->X = tex->Y = tex->R = tex->S = false;

		int		debName = 0;
		char	*namefile = (char*)tex->name.c_str();
		if(namefile[0]=='%')			debName = M3DloadFilter(namefile, tex);

		bool	test = true;
		char	name[SIZESIGN];

		//$LB if(SPfindfile((packdir)SCgetExtra("FirstPack"), &(namefile[debName]), NULL, name)==-1)		test=false;
		if(SPfindfile((packdir)Firstpack, &(namefile[debName]), NULL, name)==-1)		test=false;

		if(test)	{ if(tex->LoadTexture(name)==false)		test=false;		}

		if(test)
		{
			if(tex->ImageModif!=NULL)		{	free(tex->ImageModif);		tex->ImageModif = NULL;		}
			tex->CreateModifiedImg();
			tex->SetupTexture();
			mater->EnableMode(RENDER_TEXTURED);
			mater->modified = true;
			tex->modified	= true;
		}
	}
	else if(tex!=NULL && tex->modified /*&& tex->activated==true*/)
	{
		mater->modified = true;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3fillMat
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] I
int ZM3fillMat(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3fillMat ");
#endif

    int mat  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene		*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	fillMaterial(mater);

	scene->materialModified = true;
	scene->textureModified  = true;

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3fillMatObj
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3fillMatObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3fillMatObj ");
#endif
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))			{	MMset(m,0,NIL);		return 0;	}

	ZObject	*obj = (ZObject*)node;
	
	if( (obj->IsMultiMeshes()==false) && (obj->GetMesh()) )
	{
		ZMesh	*mesh = obj->GetMesh();

		int i;
		for(i=0; i<mesh->FacesMatGour.size(); i++)
		{
			fillMaterial(mesh->FacesMatGour[i].mat);
		}
		for(i=0; i<mesh->FacesMatFlat.size(); i++)
		{
			fillMaterial(mesh->FacesMatFlat[i].mat);
		}
		for(i=0; i<mesh->FacesMatNo.size(); i++)
		{
			fillMaterial(mesh->FacesMatNo[i].mat);
		}
	}
	else if(obj->IsMultiMeshes()==true)
	{
		ZArray<ZMesh*>		*mshList;
		mshList = obj->GetMeshList();

		int k;
		for(k=0; k<mshList->Size(); k++)
		{		
			ZMesh	*mesh = (*mshList)[k];

			int i;
			for(i=0; i<mesh->FacesMatGour.size(); i++)
			{
				fillMaterial(mesh->FacesMatGour[i].mat);
			}
			for(i=0; i<mesh->FacesMatFlat.size(); i++)
			{
				fillMaterial(mesh->FacesMatFlat[i].mat);
			}
			for(i=0; i<mesh->FacesMatNo.size(); i++)
			{
				fillMaterial(mesh->FacesMatNo[i].mat);
			}
		}
	}
	else
	{	
		MMset(m,0,NIL);		
		return 0;	
	}

	scene->materialModified = true;
	scene->textureModified  = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}





void fillObjectRecurs(ZNode	*node)
{
	ZNode		*curNode = node->son;
	ZObject		*obj;

	while(curNode!=NULL)
	{
		if(curNode->type == OBJ_TYPE_ID)
		{
			obj = (ZObject*) curNode;
			
			if( (obj->IsMultiMeshes()==false) && (obj->GetMesh()) )
			{
				ZMesh	*mesh = obj->GetMesh();

				int i;
				for(i=0; i<mesh->FacesMatGour.size(); i++)
				{
					fillMaterial(mesh->FacesMatGour[i].mat);
				}
				for(i=0; i<mesh->FacesMatFlat.size(); i++)
				{
					fillMaterial(mesh->FacesMatFlat[i].mat);
				}
				for(i=0; i<mesh->FacesMatNo.size(); i++)
				{
					fillMaterial(mesh->FacesMatNo[i].mat);
				}
			}
			else if(obj->IsMultiMeshes()==true)
			{
				ZArray<ZMesh*>		*mshList;
				mshList = obj->GetMeshList();

				int k;
				for(k=0; k<mshList->Size(); k++)
				{		
					ZMesh	*mesh = (*mshList)[k];

					int i;
					for(i=0; i<mesh->FacesMatGour.size(); i++)
					{
						fillMaterial(mesh->FacesMatGour[i].mat);
					}
					for(i=0; i<mesh->FacesMatFlat.size(); i++)
					{
						fillMaterial(mesh->FacesMatFlat[i].mat);
					}
					for(i=0; i<mesh->FacesMatNo.size(); i++)
					{
						fillMaterial(mesh->FacesMatNo[i].mat);
					}
				}
			}
		}

		if(curNode->son != NULL)	fillObjectRecurs(curNode);
		curNode = curNode->next;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3recursFillMatObj
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3recursFillMatObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3recursFillMatObj ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);


	if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}



	if(node->type==OBJ_TYPE_ID)
	{
		ZObject	*obj = (ZObject*)node;
		
		if( (obj->IsMultiMeshes()==false) && (obj->GetMesh()) )
		{
			ZMesh	*mesh = obj->GetMesh();

			int i;
			for(i=0; i<mesh->FacesMatGour.size(); i++)
			{
				fillMaterial(mesh->FacesMatGour[i].mat);
			}
			for(i=0; i<mesh->FacesMatFlat.size(); i++)
			{
				fillMaterial(mesh->FacesMatFlat[i].mat);
			}
			for(i=0; i<mesh->FacesMatNo.size(); i++)
			{
				fillMaterial(mesh->FacesMatNo[i].mat);
			}
		}
		else if(obj->IsMultiMeshes()==true)
		{
			ZArray<ZMesh*>		*mshList;
			mshList = obj->GetMeshList();

			int k;
			for(k=0; k<mshList->Size(); k++)
			{		
				ZMesh	*mesh = (*mshList)[k];

				int i;
				for(i=0; i<mesh->FacesMatGour.size(); i++)
				{
					fillMaterial(mesh->FacesMatGour[i].mat);
				}
				for(i=0; i<mesh->FacesMatFlat.size(); i++)
				{
					fillMaterial(mesh->FacesMatFlat[i].mat);
				}
				for(i=0; i<mesh->FacesMatNo.size(); i++)
				{
					fillMaterial(mesh->FacesMatNo[i].mat);
				}
			}
		}
	}

	fillObjectRecurs(node);

	scene->materialModified = true;
	scene->textureModified  = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] I
int ZM3getType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getType ");
#endif
    int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMset(m, 0, ITOM(mater->RenderMode));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getRealType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] I
int ZM3getRealType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getRealType ");
#endif
    int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int render = mater->RenderMode;

	if(mater->IsOnMode(RENDER_TEXTURED) && ((mater->GetTexture1()==NULL)||(mater->GetTexture1()->activated==false)))		{	render &= (0xffffffff - RENDER_TEXTURED);	render &= (0xffffffff - RENDER_TEXTURED_BIS);	}
	else
	if(mater->IsOnMode(RENDER_TEXTURED_BIS) && ((mater->GetTexture2()==NULL)||(mater->GetTexture1()->activated==false)))		render &= (0xffffffff - RENDER_TEXTURED_BIS);

	MMset(m, 0, ITOM(render));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3setType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setType ");
#endif
    int mod = MMpull(m);
    int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(mod==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)								{	MMset(m,0,NIL);		return 0;	}

	int mode = MTOI(mod);
	if(mode > MAXIMUM_MODE)			return false;
	mater->RenderMode = mode;
	mater->modified   = true;

	scene->materialModified = true;

	MMset(m, 0, 0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialFlat
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] I
int ZM3getMaterialFlat(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialFlat ");
#endif
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int col = mater->GetDefaultColor();
	int color;
	
	color = ((col&0xff)<<16) + (col&0xff00) + ((col&0xff0000)>>16);
	
	MMset(m, 0, ITOM(color));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialFlat
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3setMaterialFlat(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialFlat ");
#endif
	int col = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(col==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->SetDefaultColor(((col&0xff)<<16)+(col&0xff00)+((col&0xff0000)>>16));
	mater->color.x  = (float) (col&0x000000ff)		/ CONST_COLOR;
	mater->color.y  = (float)((col&0x0000ff00)>>8)	/ CONST_COLOR;
	mater->color.z  = (float)((col&0x00ff0000)>>16)	/ CONST_COLOR;
	mater->modified = true;	

	scene->materialModified = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialTransparency
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] I
int ZM3getMaterialTransparency(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialTransparency ");
#endif
    int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMset(m, 0, ITOM(mater->GetCoeffTransp()));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialTransparency
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3setMaterialTransparency(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialTransparency ");
#endif

	int col = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(col==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	if((col<0)||(col>255))			{	MMset(m,0,NIL);		return 0;	}

	mater->SetCoeffTransp(col);
	mater->coeffTransp   = 1.0f-((float)mater->GetCoeffTransp())/CONST_COLOR;

	mater->modified = true;
	scene->materialModified = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialColor
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3getMaterialColor (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialColor ");
#endif
    int num = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(num==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	if(num == 1)	MMset(m, 0, ITOM(mater->color1_16));
	else 
	if(num == 2)	MMset(m, 0, ITOM(mater->color2_16));
	else	
		MMset(m,0,NIL);	
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialColor
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I I] I
int ZM3setMaterialColor(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialColor ");
#endif
    int col = MTOI(MMpull(m));
    int num = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(col==NIL)||(num==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	if(num == 1)
	{
		mater->color1_16 = col;
		mater->color1.x = (float) (col&0x000000ff)		/ CONST_COLOR;
		mater->color1.y = (float)((col&0x0000ff00)>>8)	/ CONST_COLOR;
		mater->color1.z = (float)((col&0x00ff0000)>>16)	/ CONST_COLOR;
		mater->modified = true;

		scene->materialModified = true;

		MMset(m,0,0);
	}
	else 
	if(num == 2)
	{
		mater->color2_16 = col;
		mater->color2.x = (float) (col&0x000000ff)		/ CONST_COLOR;
		mater->color2.y = (float)((col&0x0000ff00)>>8)	/ CONST_COLOR;
		mater->color2.z = (float)((col&0x00ff0000)>>16)	/ CONST_COLOR;
		mater->modified = true;

		scene->materialModified = true;

		MMset(m,0,0);
	}
	else	
		MMset(m,0,NIL);	

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureFromMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] HTx3d
int ZM3textureFromMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureFromMaterial ");
#endif
	int mat  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(mat==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}


	if(mater->GetTexture1()==NULL)		{	MMset(m,0,NIL);		return 0;	}
	
	int	tex = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),3)), (int)mater->GetTexture1());
	if(tex!=NIL)		tex = PTOM(tex);
	MMset(m,0,tex);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureBISFromMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] HTx3d
int ZM3textureBISFromMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureBISFromMaterial ");
#endif
	int mat  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(mat==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}


	if(mater->GetTexture2()==NULL)		{	MMset(m,0,NIL);		return 0;	}
	
	int	tex = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),3)), (int)mater->GetTexture2());
	if(tex!=NIL)		tex = PTOM(tex);
	MMset(m,0,tex);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3chgMaterialTexture
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d HTx3d] I
int ZM3chgMaterialTexture(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3chgMaterialTexture ");
#endif
	int tex  = MMpull(m);
	int mat  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

    if(tex==NIL)
	{
		mater->SetTexture1(NULL);
		mater->modified = true;

		scene->materialModified = true;

		MMset(m,0,0);
		return 0;
	}	
	
	ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->SetTexture1(textu);
	mater->modified = true;

	scene->materialModified = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3chgMaterialTextureBIS
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d HTx3d] I
int ZM3chgMaterialTextureBIS(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3chgMaterialTextureBIS ");
#endif
	int tex  = MMpull(m);
	int mat  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(mat==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

    if(tex==NIL)
	{
		mater->SetTexture2(NULL);
		mater->modified = true;

		scene->materialModified = true;

		MMset(m,0,0);
		return 0;
	}	

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->SetTexture2(textu);
	mater->modified = true;

	scene->materialModified = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialMultitex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] I
int ZM3getMaterialMultitex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialMultitex ");
#endif
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0,ITOM(AROUNDINT(mater->alpha*CONST_ANGLE)));
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialMultitex
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3setMaterialMultitex(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialMultitex ");
#endif
    int col = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(col==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->alpha = ((float)col) / CONST_ANGLE;
	mater->modified = true;
	
	scene->materialModified = true;

	MMset(m,0,0);	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialAmbient
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3setMaterialAmbient(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialAmbient ");
#endif
    int col = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(col==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->ambient[0] = (float)((col&0x00ff0000)>>16)	/ CONST_COLOR;
	mater->ambient[1] = (float)((col&0x0000ff00)>>8)	/ CONST_COLOR;
	mater->ambient[2] = (float) (col&0x000000ff)		/ CONST_COLOR;
	mater->modified = true;
	
	scene->materialModified = true;

	MMset(m,0,0);	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialAmbient
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] [I I I]
int ZM3getMaterialAmbient(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialAmbient ");
#endif
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int color = 0;
	color += AROUNDINT(mater->ambient[0]*CONST_COLOR) << 16;
	color += AROUNDINT(mater->ambient[1]*CONST_COLOR) << 8;
	color += AROUNDINT(mater->ambient[2]*CONST_COLOR);
	
	MMset(m,0,ITOM(color));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialDiffuse
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3setMaterialDiffuse(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialDiffuse ");
#endif
    int col = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(col==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->diffuse[0] = (float)((col&0x00ff0000)>>16)	/ CONST_COLOR;
	mater->diffuse[1] = (float)((col&0x0000ff00)>>8)	/ CONST_COLOR;
	mater->diffuse[2] = (float) (col&0x000000ff)		/ CONST_COLOR;
	mater->modified = true;
	
	scene->materialModified = true;

	MMset(m,0,0);	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialDiffuse
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] [I I I]
int ZM3getMaterialDiffuse(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialDiffuse ");
#endif
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int color = 0;
	color += AROUNDINT(mater->diffuse[0]*CONST_COLOR) << 16;
	color += AROUNDINT(mater->diffuse[1]*CONST_COLOR) << 8;
	color += AROUNDINT(mater->diffuse[2]*CONST_COLOR);
	
	MMset(m,0,ITOM(color));
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setMaterialSpecular
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d I] I
int ZM3setMaterialSpecular(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setMaterialSpecular ");
#endif
    int col = MTOI(MMpull(m));
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL)||(col==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	mater->specular[0] = (float)((col&0x00ff0000)>>16)	/ CONST_COLOR;
	mater->specular[1] = (float)((col&0x0000ff00)>>8)	/ CONST_COLOR;
	mater->specular[2] = (float) (col&0x000000ff)		/ CONST_COLOR;
	mater->modified = true;
	
	scene->materialModified = true;

	MMset(m,0,0);	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getMaterialSpecular
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] [I I I]
int ZM3getMaterialSpecular(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getMaterialSpecular ");
#endif
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int color = 0;
	color += AROUNDINT(mater->specular[0]*CONST_COLOR) << 16;
	color += AROUNDINT(mater->specular[1]*CONST_COLOR) << 8;
	color += AROUNDINT(mater->specular[2]*CONST_COLOR);

	MMset(m,0,ITOM(color));
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3materialCount
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] I
int ZM3materialCount(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3materialCount ");
#endif
	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0,ITOM(mater->nbRef));
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listOfMaterials
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] [HMat3d r1]
int ZM3listOfMaterials(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listOfMaterials ");
#endif

	int obj = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(obj==NIL))	{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)				{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(obj),0);
	if(node==NULL)				{	MMset(m,0,NIL);		return 0;	}
	
	if(node->type==OBJ_TYPE_ID)
	{
		ZObject	*curObj = (ZObject*)node;

		int	n=-1;
		// attention, le S3d est empil pour l'usage dans la fonction qui suit..
		if(curObj->GetMesh())		n = ZM3listOfMatOne(m, curObj->GetMesh(), 0);

		if(n<0)		{	MMset(m,0,NIL);		return 0;	}

		MMpull(m);

#ifdef	_SCOL_DEBUG_
		MMechostr(0,"ok\n");
#endif
		return ZM3listOfMatEnd(m,n);
	}
	else if(node->type==MSH_TYPE_ID)
	{
		ZMesh	*msh = (ZMesh*)node;

		int	n=-1;										// attention, le S3d est empil pour l'usage dans la fonction qui suit..
		n = ZM3listOfMatOne(m, msh, 0);

		if(n<0)		{	MMset(m,0,NIL);		return 0;	}

		MMpull(m);

#ifdef	_SCOL_DEBUG_
		MMechostr(0,"ok\n");
#endif
		return ZM3listOfMatEnd(m,n);
	}
	else
	{	
#ifdef	_SCOL_DEBUG_
		MMechostr(0,"ERROR !!\n");
#endif
		MMset(m,0,NIL);		
		return 0;	
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3copyObjMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d HMat3d] HMat3d
int ZM3copyObjMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3copyObjMaterial ");
#endif

	int mat = MMpull(m);
	int obj = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(obj==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(obj),0);
	if(node==NULL)								{	MMset(m,0,NIL);		return 0;	}
	
    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)								{	MMset(m,0,NIL);		return 0;	}

	int newMat = NIL;

	ZMesh	*msh;

	// Selection du mesh
	if(node->type == OBJ_TYPE_ID)
	{
		ZObject	*curObj = (ZObject*)node;
		msh	= curObj->GetMesh();
		if(msh==NULL)								{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type == MSH_TYPE_ID)
	{
		msh = (ZMesh*)node;
	}
	else
	{	
		MMset(m,0,NIL);
		return 0;	
	}

	// Vrification de prsence du matriau dans l'objet 3D
	vector<ZFace>	*faces	= &(msh->Faces);
	bool			presence = false;
	
	int i;
	for(i=0; (i<msh->NbFaces)&&(!presence); i++)
	{
		if( (*faces)[i].GetMaterial() == mater )		presence = true;
	}

	if(presence == false)				{	MMset(m,0,NIL);		return 0;	}


	// Si le matriau est prsent, on procde  l'isolation
	if(mater->nbRef != 1)
	{
		ZMaterial*	curMat = new ZMaterial(scene->accelerated);
		if(!curMat)						{	MMset(m,0,NIL);		return 0;	}
		scene->MatList.Add(curMat);

		curMat->SetName(mater->name);

		// Dclaration dans la hashtable
		int hash_tab = MTOP( MMfetch(m,MTOP(s3d),2) );
		newMat = createHmatHtx(m, (int)curMat, hash_tab);

		// Copie des ppts
		for(i=0; i<4; i++)
		{
			curMat->ambient[i]  = mater->ambient[i];
			curMat->diffuse[i]  = mater->diffuse[i];
			curMat->specular[i] = mater->specular[i];
			curMat->emission[i] = mater->emission[i];
		}

		curMat->shininess = mater->shininess;
		
		curMat->SetTexture1(mater->GetTexture1());
		curMat->SetTexture2(mater->GetTexture2());

		curMat->RenderMode = mater->RenderMode;

		curMat->transparencyOrder = mater->transparencyOrder;

		curMat->color  = mater->color;
		curMat->color1 = mater->color1;
		curMat->color2 = mater->color2;
		curMat->SetDefaultColor(mater->GetDefaultColor());
		curMat->color1_16 = mater->color1_16;
		curMat->color2_16 = mater->color2_16;

		curMat->alpha = mater->alpha;
		curMat->coeffTransp = mater->coeffTransp;
		curMat->SetCoeffTransp(mater->GetCoeffTransp());

		curMat->modified = true;

		scene->materialModified = true;

		// Attribution  l'objet 3D
		for(i=0; i<msh->NbFaces; i++)
		{
			if( (*faces)[i].GetMaterial() == mater )			(*faces)[i].SetMaterial(curMat);
		}
		msh->hasViewChanged = true;

		scene->meshModified		= true;
	}
	else
	{
		newMat = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mater);
	}

	if(newMat!=NIL)		newMat = PTOM(newMat);

	MMset(m,0,newMat);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3copyMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d S] HMat3d
int ZM3copyMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3copyMaterial ");
#endif
	int name = MMpull(m);
	int mat  = MMpull(m);
	int s3d  = MMget(m,0);
    
    if((name==NIL)||(s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	
	// Creation du nouveau materiau
	string	nom = string(MMstartstr(m,MTOP(name)));

	ZMaterial*	curMat = new ZMaterial(scene->accelerated);
	if(!curMat)						{	MMset(m,0,NIL);		return 0;	}
	scene->MatList.Add(curMat);

	curMat->SetName(nom);

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),2) );
	mat = createHmatHtx(m, (int)curMat, hash_tab);

	// Copie des ppts
	int i;
	for(i=0; i<4; i++)
	{
		curMat->ambient[i]  = mater->ambient[i];
		curMat->diffuse[i]  = mater->diffuse[i];
		curMat->specular[i] = mater->specular[i];
		curMat->emission[i] = mater->emission[i];
	}

	curMat->shininess = mater->shininess;
	
	curMat->SetTexture1(mater->GetTexture1());
	curMat->SetTexture2(mater->GetTexture2());

	curMat->RenderMode = mater->RenderMode;

	curMat->transparencyOrder = mater->transparencyOrder;

	curMat->color  = mater->color;
	curMat->color1 = mater->color1;
	curMat->color2 = mater->color2;
	curMat->SetDefaultColor(mater->GetDefaultColor());
	curMat->color1_16 = mater->color1_16;
	curMat->color2_16 = mater->color2_16;
	
	curMat->alpha = mater->alpha;
	curMat->coeffTransp = mater->coeffTransp;
	curMat->SetCoeffTransp(mater->GetCoeffTransp());

	curMat->modified = true;	

	scene->materialModified = true;


	MMset(m, 0, PTOM(mat));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3chgObjMaterial
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d HMat3d HMat3d] I
int ZM3chgObjMaterial(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3chgObjMaterial ");
#endif
	int matNew = MMpull(m);
	int matCur = MMpull(m);
	int obj = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(obj==NIL)||(matNew==NIL)||(matCur==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(obj),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZMaterial	*matN = (ZMaterial*) MMfetch(m,MTOP(matNew),0);
	if(matN==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZMaterial	*matC = (ZMaterial*) MMfetch(m,MTOP(matCur),0);
	if(matC==NULL)					{	MMset(m,0,NIL);		return 0;	}


	if(node->type==OBJ_TYPE_ID)
	{
		ZObject	*curObj = (ZObject*)node;

		// Change le materiau
		if(curObj->IsMultiMeshes()==false)
		{
			ZMesh	*msh = curObj->GetMesh();
			if(msh==NULL)					{	MMset(m,0,NIL);		return 0;	}

			vector<ZFace>	*faces = &(msh->Faces);
			
			int i;
			for(i=0; i<msh->NbFaces; i++)
			{
				if( (*faces)[i].GetMaterial() == matC )			(*faces)[i].SetMaterial(matN);
			}
			
			msh->hasViewChanged = true;
		}
		else
		{
			ZArray<ZMesh*>	*mshList = curObj->GetMeshList();
			ZMesh	*msh;

			int ii;
			for(ii=0; ii<mshList->Size(); ii++)
			{
				msh = (*mshList)[ii];

				if(msh!=NULL)
				{
					vector<ZFace>	*faces = &(msh->Faces);
					
					int i;
					for(i=0; i<msh->NbFaces; i++)
					{
						if( (*faces)[i].GetMaterial() == matC )			(*faces)[i].SetMaterial(matN);
					}

					msh->hasViewChanged = true;
				}
			}
		}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		ZMesh*	msh = (ZMesh*)node;

		vector<ZFace>	*faces = &(msh->Faces);
		
		int i;
		for(i=0; i<msh->NbFaces; i++)
		{
			if( (*faces)[i].GetMaterial() == matC )			(*faces)[i].SetMaterial(matN);
		}
		
		msh->hasViewChanged = true;
	}
	else
	{	
		MMset(m,0,NIL);
		return 0;
	}


	scene->meshModified	= true;

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3shiftTextureXY
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d HMat3d I I] I
int ZM3shiftTextureXY(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3shiftTextureXY ");
#endif

	int	Y	= MTOI(MMpull(m));
	int	X	= MTOI(MMpull(m));
	int mat = MMpull(m);
	int obj = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(obj==NIL)||(mat==NIL)||(X==NIL)||(Y==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(obj),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZMesh	*msh;

	if(node->type==OBJ_TYPE_ID)	
	{
		msh = ((ZObject*)node)->GetMesh();
		if(msh==NULL)				{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		msh = (ZMesh*)node;
	}
	else
	{	
		MMset(m,0,NIL);
		return 0;
	}

	// Change le materiau
	ZFace	*fac;
	float	dX = ((float)X) / CONST_TEX_COORD_SHIFT;
	float	dY = ((float)Y) / CONST_TEX_COORD_SHIFT;

	int i;
	for(i=0; i<msh->NbFaces; i++)
	{
		fac = &(msh->Faces[i]);
		
		if(fac->GetMaterial() == mater)
		{
			fac->UV1[0].u += dX;			fac->UV1[0].v += dY;
			fac->UV1[1].u += dX;			fac->UV1[1].v += dY;
			fac->UV1[2].u += dX;			fac->UV1[2].v += dY;

			if( fac->UV1[0].u<0.0f || fac->UV1[1].u<0.0f || fac->UV1[2].u<0.0f ||
				fac->UV1[0].u>1.0f || fac->UV1[1].u>1.0f || fac->UV1[2].u>1.0f )	fac->clampU1 = false;
			else																	fac->clampU1 = true;

			if( fac->UV1[0].v<0.0f || fac->UV1[1].v<0.0f || fac->UV1[2].v<0.0f || 
				fac->UV1[0].v>1.0f || fac->UV1[1].v>1.0f || fac->UV1[2].v>1.0f )	fac->clampV1 = false;
			else																	fac->clampV1 = true;
		}
	}

	msh->hasViewChanged = true;

	// Dsactive la compilation des displays lists
	msh->displayListCreate = false;


	scene->meshModified	= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3shiftTextureXYF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d HMat3d F F] I
int ZM3shiftTextureXYF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3shiftTextureXYF ");
#endif
	int	Y	= MMpull(m);
	int	X	= MMpull(m);
	int mat = MMpull(m);
	int obj = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(obj==NIL)||(mat==NIL)||(X==NIL)||(Y==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(obj),0);
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZMesh	*msh;

	if(node->type==OBJ_TYPE_ID)	
	{
		msh = ((ZObject*)node)->GetMesh();
		if(msh==NULL)				{	MMset(m,0,NIL);		return 0;	}
	}
	else if(node->type==MSH_TYPE_ID)
	{
		msh = (ZMesh*)node;
	}
	else
	{	
		MMset(m,0,NIL);
		return 0;
	}


	// Change le materiau
	ZFace	*fac;
	float	dX = MTOF(X);
	float	dY = MTOF(Y);

	int i;
	for(i=0; i<msh->NbFaces; i++)
	{
		fac = &(msh->Faces[i]);
		
		if(fac->GetMaterial() == mater)
		{
			fac->UV1[0].u += dX;			fac->UV1[0].v += dY;
			fac->UV1[1].u += dX;			fac->UV1[1].v += dY;
			fac->UV1[2].u += dX;			fac->UV1[2].v += dY;

			if( fac->UV1[0].u<0.0f || fac->UV1[1].u<0.0f || fac->UV1[2].u<0.0f ||
				fac->UV1[0].u>1.0f || fac->UV1[1].u>1.0f || fac->UV1[2].u>1.0f )	fac->clampU1 = false;
			else																	fac->clampU1 = true;

			if( fac->UV1[0].v<0.0f || fac->UV1[1].v<0.0f || fac->UV1[2].v<0.0f || 
				fac->UV1[0].v>1.0f || fac->UV1[1].v>1.0f || fac->UV1[2].v>1.0f )	fac->clampV1 = false;
			else																	fac->clampV1 = true;
		}
	}

	msh->hasViewChanged = true;
	
	// Dsactive la compilation des displays lists
	msh->displayListCreate = false;


	scene->meshModified	= true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3saveMat
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] S
int ZM3saveMat(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3saveMat ");
#endif
	int mat  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(mat==NIL))					{	MMpush(m,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMpush(m,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMpush(m,NIL);		return 0;	}


    struct Save3d	sv;
	struct Sv3d		sm;

	sm.m	= m;						// mmachine
	sm.n	= 0;						// counter of words

	sv.cb	= ZM3saveconc;				// CallBack de sauvegarde
	sv.user	= (int*)&sm;				// structure de sauvegarde

	int		k;
	if((k=ZM3DsaveMat(scene, &sv, mater)))		return k;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return ZM3saveconc(NULL, sv.user);
}
