//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////
////										       ////
///			   GESTION DE MESH						///
////										       ////
///////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createMesh
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3createMesh(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createMesh ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

	// Creation du Mesh
	ZObject	*newObj;
	newObj = new ZObject((int)scene);
	if(newObj==NULL)				{	MMset(m,0,NIL);		return 0;	}
	newObj->InsertAsChildOf(scene->World);
	newObj->SetName("");

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	msh = createH3D(m, (int)newObj, hash_tab);

	ZPRS	*newPRS;
	newPRS = newObj->GetPRS();
	newPRS->coeffM3D = 100.0f;


	newObj->SetMesh(topo);


	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(msh!=NIL)	msh = PTOM(msh);
    MMset(m,0,msh);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshSetMultiTopo
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[H3d I] r1]] I
int ZM3meshSetMultiTopo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshSetMultiTopo ");
#endif
	int list = MTOP(MMpull(m));
	int objt = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(objt==NIL)||(list==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{	MMset(m,0,NIL);		return 0;	}

	ZNode* node = (ZNode*) MMfetch(m,MTOP(objt),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	if(obj->IsMultiMeshes()==false)							{	MMset(m,0,NIL);		return 0;	}

	obj->CleanMeshList();

	int tuple, curH3D, range;

	while(list!=NIL)
	{
		tuple = MTOP(MMfetch(m,list,0));

		curH3D  = MTOP(MMfetch(m,tuple,0));
		range	= MTOI(MMfetch(m,tuple,1));
		
		node = (ZNode*) MMfetch(m, curH3D, 0);

		if( (curH3D!=NIL) && (node!=NULL) && (node->type==MSH_TYPE_ID))
		{
			if(range >=0 )		obj->AddMeshInList( (ZMesh*)node, (((float)range)/100.0f)*(((float)range)/100.0f) );
			else				obj->AddMeshInList( (ZMesh*)node, FLT_MAX );
		}

		list = MTOP(MMfetch(m,list,1));
	}

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshSetMultiTopoF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d [[H3d F] r1]] I
int ZM3meshSetMultiTopoF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshSetMultiTopoF ");
#endif
	int list = MTOP(MMpull(m));
	int objt = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(objt==NIL)||(list==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{	MMset(m,0,NIL);		return 0;	}

	ZNode* node = (ZNode*) MMfetch(m,MTOP(objt),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	if(obj->IsMultiMeshes()==false)							{	MMset(m,0,NIL);		return 0;	}

	obj->CleanMeshList();

	int		tuple, curH3D;
	float	range;

	while(list!=NIL)
	{
		tuple = MTOP(MMfetch(m,list,0));

		curH3D  = MTOP(MMfetch(m,tuple,0));
		range	= MTOF(MMfetch(m,tuple,1));
		
		node = (ZNode*) MMfetch(m, curH3D, 0);

		if( (curH3D!=NIL) && (node!=NULL) && (node->type==MSH_TYPE_ID))
		{
			if(range >=0 )		obj->AddMeshInList( (ZMesh*)node, (((float)range)/100.0f)*(((float)range)/100.0f) );
			else				obj->AddMeshInList( (ZMesh*)node, FLT_MAX );
		}

		list = MTOP(MMfetch(m,list,1));
	}

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshGetMultiTopo
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] [[H3d I] r1]
int ZM3meshGetMultiTopo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshGetMultiTopo ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	if(obj->IsMultiMeshes()==false)							{	MMset(m,0,NIL);		return 0;	}

	ZArray<ZMesh*>		*mshList;
	ZArray<float>		*rangeList;
	
	mshList		= obj->GetMeshList();
	rangeList	= obj->GetRangeSQRList();

	int range, k, n=0, tmp_res;

	for(int i=0; i<mshList->Size(); i++)
	{
		h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)(*mshList)[i]);
		if(h3d!=NIL)	h3d = PTOM(h3d);

		if((*rangeList)[i] != FLT_MAX)		range = ITOM( AROUNDINT(sqrt((float)(*rangeList)[i]) * 100.0f) );
		else								range = ITOM( RANGE_INFINITY );

		if(MMpush(m, h3d))		return MERRMEM;
		if(MMpush(m, range))	return MERRMEM;
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;

		INVERT(m,0,1);
		s3d = MMget(m,0);

		n++;
	}

	MMpull(m);

	if(MMpush(m,NIL))		return MERRMEM;
	for(int j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshGetMultiTopoF
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] [[H3d F] r1]
int ZM3meshGetMultiTopoF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshGetMultiTopoF ");
#endif

	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	if(obj->IsMultiMeshes()==false)							{	MMset(m,0,NIL);		return 0;	}

	ZArray<ZMesh*>		*mshList;
	ZArray<float>		*rangeList;
	
	mshList		= obj->GetMeshList();
	rangeList	= obj->GetRangeSQRList();

	int range, k, n=0, tmp_res;

	for(int i=0; i<mshList->Size(); i++)
	{
		h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)(*mshList)[i]);
		if(h3d!=NIL)	h3d = PTOM(h3d);

		if((*rangeList)[i] != FLT_MAX)		range = FTOM( sqrt((float)(*rangeList)[i]) * 100.0f );
		else								range = FTOM( RANGE_INFINITY_F );

		if(MMpush(m, h3d))		return MERRMEM;
		if(MMpush(m, range))	return MERRMEM;
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;

		INVERT(m,0,1);
		s3d = MMget(m,0);

		n++;
	}

	MMpull(m);

	if(MMpush(m,NIL))		return MERRMEM;
	for(int j=0; j<n; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshGetActiveTopo
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3meshGetActiveTopo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshGetActiveTopo ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	if(obj->IsMultiMeshes()==false)							{	MMset(m,0,NIL);		return 0;	}


	h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj->GetMesh());
	if(h3d!=NIL)	h3d = PTOM(h3d);

	MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshSetTopology
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d H3d] I
int ZM3meshSetTopology(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshSetTopology ");
#endif
	int top  = MMpull(m);
	int msh  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(msh==NIL)||(top==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(top),0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZMesh	*topo = (ZMesh*) node;

    node = (ZNode*) MMfetch(m,MTOP(msh),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	if(obj->IsMultiMeshes()==true)								{	MMset(m,0,NIL);		return 0;	}

	obj->SetMesh(topo);

    MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshGetTopology
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3meshGetTopology(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshGetTopology ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	if(obj->IsMultiMeshes()==true)								{	MMset(m,0,NIL);		return 0;	}

	ZMesh	*msh = obj->GetMesh();
	if(msh==NULL)								{	MMset(m,0,NIL);		return 0;	}
	
	h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)msh);

	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshSetType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I] I
int ZM3meshSetType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshSetType ");
#endif

	int typ  = MMpull(m);
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(typ==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode*	node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	typ = MTOI(typ);

	if(typ & TYP_MESH_MULTI_TOPO)			obj->setFlagMulti(true);
	else									obj->setFlagMulti(false);

	if(typ & TYP_MESH_NOT_CLICKABLE)		obj->clickable = false;
	else									obj->clickable = true;

	if(obj->IsMultiMeshes())
	{
		ZArray<ZMesh*>		*mshList = obj->GetMeshList();
		
		if(typ & TYP_MESH_STATIC)		{	for(int k=0; k<mshList->Size(); k++)	(*mshList)[k]->displayListCreate = true;	}
		else							{	for(int k=0; k<mshList->Size(); k++)	(*mshList)[k]->displayListCreate = false;	}
	}
	else
	if(obj->GetMesh())
	{
		if(typ & TYP_MESH_STATIC)				obj->GetMesh()->displayListCreate = true;
		else									obj->GetMesh()->displayListCreate = false;
	}

    MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3meshGetType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3meshGetType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3meshGetType ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=OBJ_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
    ZObject	*obj = (ZObject*) node;

	ZMesh	*msh = obj->GetMesh();
	if(msh==NULL)								{	MMset(m,0,NIL);		return 0;	}

	int mask = 0;

	if(msh->displayListCreate==true)			mask += TYP_MESH_STATIC;
	if(obj->IsMultiMeshes()==true)				mask += TYP_MESH_MULTI_TOPO;
	if(obj->clickable==false)					mask += TYP_MESH_NOT_CLICKABLE;

	MMset(m,0,ITOM(mask));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3distance
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d H3d] I
int ZM3distance(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3distance ");
#endif
	int nod2 = MMpull(m);
	int nod1 = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(nod2==NIL)||(nod1==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{	MMset(m,0,NIL);		return 0;	}


    ZNode	*node = (ZNode*) MMfetch(m,MTOP(nod1),0);
	if((node==NULL)||(node->type<0)||(node->type>MAX_NODE_SCENE))
	{	
		MMset(m,0,NIL);
		return 0;
	}
	ZMatrix		mat = ComputeWorldMatrix(node);
	ZVector3	vect1;
	vect1.SetCoord(mat(0,3), mat(1,3), mat(2,3));


    node = (ZNode*) MMfetch(m,MTOP(nod2),0);
	if((node==NULL)||(node->type<0)||(node->type>MAX_NODE_SCENE))
	{	
		MMset(m,0,NIL);
		return 0;
	}
	mat = ComputeWorldMatrix(node);
	ZVector3	vect2;
	vect2.SetCoord(mat(0,3), mat(1,3), mat(2,3));

	vect2 -= vect1;
	float	length = vect2.Length();

    MMset(m,0, ITOM(AROUNDINT(100.0f*length)));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}





// Concatne les donnes..
int ZM3saveconc(char *buf, int *user)
{
	sv3d	s = (sv3d) user;
	int		k, i;

	if(buf)
	{
		if((k = Mpushstrbloc(s->m,buf)))		return k;
		s->n++;
	}

	if((buf==NULL)||(s->n>256))
	{
		if(MMpush(s->m,NIL))	return MERRMEM;

		for(i=0; i<s->n; i++)
		{
			if(MMpush(s->m,2*2))		return MERRMEM;
			if(k=MBdeftab(s->m))		return k;
		}

		if((k=MBstrcatn(s->m)))		return k;

		s->n = 1;
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3save
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d I] S
int ZM3save(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3save ");
#endif
	int flg  = MTOI(MMpull(m));
	int h3d  = MMpull(m);
    int s3d  = MMpull(m);

	if((s3d==NIL)||(h3d==NIL))					{	MMpush(m,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMpush(m,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type>MAX_NODE_SCENE))				{	MMpush(m,NIL);		return 0;	}

    struct Save3d	sv;
	struct Sv3d		sm;

	sm.m	= m;						// mmachine
	sm.n	= 0;						// counter of words

	sv.cb	= ZM3saveconc;				// CallBack de sauvegarde
	sv.user	= (int*)&sm;				// structure de sauvegarde

	int		k;
	if((k=ZM3Dsave(scene, &sv, node, true, flg)))		return k;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return ZM3saveconc(NULL, sv.user);
}





// Cloture de la liste d'lments
int ZM3listOfMatEnd(mmachine m,int n)
{
	int j, k;
	if(MMpush(m,NIL))		return MERRMEM;
	
	for(j=0;j<n;j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}
	
	return 0;
}

// Test de prsence dans la pile d'un materiau donn
int ZM3alreadyChecked(mmachine m, int n, int mat3d)
{
	int i;
	for(i=0;i<n;i++)		if(MMget(m,i)==mat3d)	return 1;
	return 0;
}

// Pose les materiaux d'un mesh dans la pile
int ZM3listOfMatOne(mmachine m, ZMesh* mesh, int n)
{
	int	mat3d, tmp_res;
	
	for(int j=0; j<mesh->NbFaces; j++)
    {
		int s3d = MMget(m,0);
		int hash = MTOP(MMfetch(m,MTOP(s3d),2));

		mat3d = NodeTOHandle(m, hash, (int)mesh->Faces[j].GetMaterial());
		if(mat3d!=NIL)		mat3d = PTOM(mat3d);
		
		if(!ZM3alreadyChecked(m, n, mat3d))
		{
			if(MMpush(m,mat3d))			return MERRMEM;
			INVERT(m,0,1);
			n++;
		}
    }
	return n;
}

// Recursion pour la cration de la liste des matriaux
int ZM3recListOfMat(mmachine m, ZNode* node, int n, bool first)
{
	if( (node->type==OBJ_TYPE_ID) && (((ZObject*)node)->GetMesh()) )
														n = ZM3listOfMatOne(m, ((ZObject*)node)->GetMesh(), n);

	if(node->son != NULL)
    {
		n = ZM3recListOfMat(m, node->son, n, false);
    }

	if ((!first)&&(node->next!=NULL))
    {
		n = ZM3recListOfMat(m, node->next, n, false);
    }
	
	return n;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3recListOfMaterials
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] [HMat3d r1]
int ZM3recListOfMaterials(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3recListOfMaterials ");
#endif
	int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type>MAX_NODE_SCENE))				{	MMset(m,0,NIL);		return 0;	}

    // attention, le S3d est empil pour l'usage dans la fonction qui suit..
	int n = ZM3recListOfMat(m, node, 0, true);
	if(n<0)			{	MMset(m,0,NIL);		return 0;	}

	MMpull(m);	// supprime le S3d qui est en tte de pile, avant la cration de la liste finale

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return ZM3listOfMatEnd(m, n);
}
