//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///			       GESTION DES OBJETS								    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3isValidObj
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3isValidObj(mmachine m)
{
    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if(s3d==NIL)					{	MMset(m,0,ITOM(4));		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,ITOM(3));		return 0;	}

	if(h3d==NIL)					{	MMset(m,0,ITOM(2));		return 0;	}
    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					{	MMset(m,0,ITOM(1));		return 0;	}

	MMset(m,0,ITOM(0));

	return 0;
}



///////////////////////////////////////////////////////////////////////////////////////////
////										       ////
///		     GESTION HIERARCHIQUE					        ///
////										       ////
///////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3load														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S H3d] I
int ZM3load(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3load ");
#endif

    FILE *f;
    char name[SIZESIGN];

    int	pere = MMpull(m);
    int nam	 = MMpull(m);
    int s3d	 = MMget(m,0);
    
    if((nam==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*) MMfetch(m, MTOP(s3d), 0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMechostr(1,"--- Begin loading 3d file : %s\n",MMstartstr(m,MTOP(nam)));
	//$LB if( SPfindfile((packdir)SCgetExtra("FirstPack"),MMstartstr(m,MTOP(nam)),NULL,name) == -1 )		{	MMset(m,0,NIL);		return 0;	}
	if( SPfindfile((packdir)Firstpack,MMstartstr(m,MTOP(nam)),NULL,name) == -1 )		{	MMset(m,0,NIL);		return 0;	}

	MMechostr(1,"-> %s\n",name);
    f = fopen(name,"rb");

	int res;

	if(f)
    {
		if(pere==NIL)
		{
			res = ZM3DloadFILE(m, MTOP(s3d), f, scene->World, 100.0f);
		}
		else
		{
			
			ZNode	*node = (ZNode*) MMfetch(m, MTOP(pere), 0);
			if(node!=NULL)		res = ZM3DloadFILE(m, MTOP(s3d), f, node, 100.0f);
		}
		fclose(f);
    }
    else
	{
		MMset(m,0,NIL);
		return 0;
	}

	MMechostr(1,"--- End loading 3d file \n");

	scene->updateGraphList		= true;

	scene->textureModified		= true;
	scene->materialModified		= true;
	scene->meshModified			= true;

	MMset(m,0,res*2);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3loadString														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S H3d] I
int ZM3loadString(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3loadString ");
#endif
    int	pere = MMpull(m);
    int fich = MMpull(m);
    int s3d	 = MMget(m,0);

    if((fich==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*) MMfetch(m, MTOP(s3d), 0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    int	res;
	if(pere==NIL)
	{
		res = ZM3Dloadbuf(m, MTOP(s3d), (char*)MMstartstr(m,fich>>1), scene->World, 100.0f);
	}
	else
	{
		ZNode	*node = (ZNode*) MMfetch(m, MTOP(pere), 0);
		if(node!=NULL)		res = ZM3Dloadbuf(m, MTOP(s3d), (char*)MMstartstr(m,fich>>1), node, 100.0f);
	}

	scene->updateGraphList		= true;

	scene->textureModified		= true;
	scene->materialModified		= true;
	scene->meshModified			= true;


	MMset(m,0,res*2);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createShell
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d] H3d
int ZM3createShell(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createShell ");
#endif
    int s3d;

    s3d = MMget(m,0);

    if(s3d==NIL)		{	MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m, MTOP(s3d), 0);
	if(scene==NULL)		{	MMset(m,0,NIL);		return 0;	}

	// Cre le ZShell
	ZShell	*shell;
	shell = new ZShell((int)scene);
	shell->SetName("");
	shell->InsertAsChildOf(scene->World);

	ZPRS	*shlPRS;
	shlPRS = shell->GetPRS();

	shlPRS->coeffM3D = 100.0f;

	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)shell, hash_tab);
	
	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);
    
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3delObj														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3delObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3delObj ");
#endif

    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZNode	*curNode = (ZNode*) MMfetch(m, MTOP(h3d), 0);

	if(curNode)
	{
		if(curNode->type==MSH_TYPE_ID)		{	MMset(m,0,NIL);		return 0;	}

		DeleteNode(m, MTOP(MMfetch(m,MTOP(s3d),1)), curNode);	// supprime rellement le pointeur C et sa descendance
		DelObj(m, MTOP(MMfetch(m,MTOP(s3d),1)), MTOP(h3d));		// supprime le pointeur C dans le H3d et dans la hash_tab

		scene->updateGraphList = true;
	    MMset(m,0,0);
	}
	else
		MMset(m,0,NIL);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}


void copyCollision(ZColl *newcol, ZColl *col)
{
	newcol->rayon	 = col->rayon;
	newcol->typeColl = col->typeColl;
	newcol->u		 = col->u;
	newcol->v		 = col->v;
	newcol->w		 = col->w;

	if(col->colA)
	{
		newcol->colA = new ZColl(col->scene3D, col->colA->typeColl);
		copyCollision(newcol->colA, col->colA);
	}

	if(col->colB)
	{
		newcol->colB = new ZColl(col->scene3D, col->colB->typeColl);
		copyCollision(newcol->colB, col->colB);
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3copyObj														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3copyObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3copyObj ");
#endif

    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZNode	*curNode = (ZNode*) MMfetch(m, MTOP(h3d), 0);
	if(curNode==NULL)				{	MMset(m,0,NIL);		return 0;	}

	h3d = NIL;


	//*********** OBJ ***********//
	if (curNode->type == OBJ_TYPE_ID)
	{
		ZObject		*curObj = (ZObject*) curNode;
		ZObject		*newObj = new ZObject((int)scene);
		if (newObj==NULL)		{	MMset(m,0,NIL);		return 0;	}
		newObj->InsertAsChildOf(scene->World);
		newObj->SetName(curObj->name);

		h3d = createH3D(m, (int)newObj, MTOP(MMfetch(m,MTOP(s3d),1)));

		ZPRS	*newPRS;
		ZPRS	*prs = curObj->GetPRS();
		newPRS = newObj->GetPRS();
		newPRS->coeffM3D = prs->coeffM3D;
		newPRS->SetPos(prs->GetPos());
		newPRS->SetAng(prs->GetAng());
		newPRS->SetScale(prs->GetScale());

		newObj->name	 = curObj->name;
		newObj->rangeMAX = curObj->rangeMAX;
		newObj->rangeMIN = curObj->rangeMIN;


		// Copie du mesh galement...
		if(curObj->IsMultiMeshes()==false)
		{
			ZMesh	*msh = curObj->GetMesh();
			ZMesh	*curMsh = NULL;

			if(msh)
			{
				curMsh = new ZMesh((int)scene, msh->NbVerts, msh->NbFaces);
				if(curMsh==NULL)		{	MMset(m,0,NIL);		return 0;	}
				scene->MshList.Add(curMsh);

				curMsh->name			  = msh->name;
				curMsh->dependency		  = msh->dependency;
				curMsh->displayListCreate = msh->displayListCreate;

				createH3D(m, (int)curMsh, MTOP(MMfetch(m,MTOP(s3d),1)));

				ZFace	*curFace, *face;
				int i;
				for(i=0; i<msh->Faces.size(); i++)
				{
					curFace = &(curMsh->Faces[i]);
					face	= &(msh->Faces[i]);

					curFace->initFace();
					curFace->SetMaterial(face->GetMaterial());

					curFace->SetVertsRef(face->VertRef[0], face->VertRef[1], face->VertRef[2]);
					curFace->dependency = face->dependency;

					curFace->UV1[0] = face->UV1[0];
					curFace->UV1[1] = face->UV1[1];
					curFace->UV1[2] = face->UV1[2];
					curFace->UV2[0] = face->UV2[0];
					curFace->UV2[1] = face->UV2[1];
					curFace->UV2[2] = face->UV2[2];

					curFace->clampU1 = face->clampU1;
					curFace->clampV1 = face->clampV1;
					curFace->clampU2 = face->clampU2;
					curFace->clampV2 = face->clampV2;

					curFace->index	= face->index;
				}

				ZVert	*curVert, *vert;
				for(i=0; i<msh->Verts.size(); i++)
				{
					curVert = &(curMsh->Verts[i]);
					vert	= &(msh->Verts[i]);

					curVert->color1 = vert->color1;
					curVert->color2 = vert->color2;
					curVert->Normal = vert->Normal;
					curVert->SetCoord(vert->x, vert->y, vert->z);
				}

				curMsh->hasTopoChanged = true;
				curMsh->hasViewChanged = true;

				newObj->SetMesh(curMsh);

				scene->meshModified	= true;
			}
		}
		else
		{
			ZArray<ZMesh*>		*mshList  = curObj->GetMeshList();
			ZArray<float>		*rangeSQR = curObj->GetRangeSQRList();

			newObj->setFlagMulti(true);

			int i;
			for(i=0; i<rangeSQR->Size(); i++)		newObj->AddMeshInList((*mshList)[i], (*rangeSQR)[i]);
		}
	}
	//*********** CAM ***********//
	else if (curNode->type == CAM_TYPE_ID)
	{
		ZCamera		*cam = (ZCamera*) curNode;
		ZCamera		*curCam = new ZCamera((int)scene);
		if(curCam==NULL)		{	MMset(m,0,NIL);		return 0;	}
		curCam->InsertAsChildOf(scene->World);
		curCam->SetName(cam->name);
		curCam->dx  = cam->dx;			curCam->dy = cam->dy;
		curCam->fov = cam->fov;			
		curCam->width = cam->width;		curCam->height = cam->height;

		h3d = createH3D(m, (int)curCam, MTOP(MMfetch(m,MTOP(s3d),1)));

		ZPRS	*curPRS;
		ZPRS	*prs = cam->GetPRS();
		curPRS = curCam->GetPRS();
		curPRS->coeffM3D = prs->coeffM3D;
		curPRS->SetPos(prs->GetPos());
		curPRS->SetAng(prs->GetAng());
		curPRS->SetScale(prs->GetScale());

		curCam->name	 = cam->name;
		curCam->rangeMAX = cam->rangeMAX;
		curCam->rangeMIN = cam->rangeMIN;
	}
	//*********** LGH ***********//
	else if (curNode->type == LGH_TYPE_ID)
	{
		ZLight	*lgh = (ZLight*) curNode;
		ZLight	*curLgh = new ZLight((int)scene);
		if(curLgh==NULL)		{	MMset(m,0,NIL);		return 0;	}
		curLgh->InsertAsChildOf(scene->World);
		
		curLgh->SetName(lgh->name);
		
		curLgh->SetAmbient(lgh->ambient);
		curLgh->SetDiffuse(lgh->diffuse);
		curLgh->SetSpecular(lgh->specular);
		
		curLgh->alpha = lgh->alpha;
		curLgh->beta  = lgh->beta;
		curLgh->dist  = lgh->dist;
		curLgh->target	  = lgh->target;
		curLgh->distance  = lgh->distance;
		curLgh->exponent  = lgh->exponent;
		curLgh->LightType = lgh->LightType;
		curLgh->oldStyle  = lgh->oldStyle;
		curLgh->attenuate_const = lgh->attenuate_const;
		curLgh->attenuate_quadr = lgh->attenuate_quadr;
		curLgh->spot_cut_off	= lgh->spot_cut_off;
		
		h3d = createH3D(m, (int)curLgh, MTOP(MMfetch(m,MTOP(s3d),1)));

		ZPRS	*curPRS;
		ZPRS	*prs = lgh->GetPRS();
		curPRS = curLgh->GetPRS();
		curPRS->coeffM3D = prs->coeffM3D;
		curPRS->SetPos( prs->GetPos() );
		curPRS->SetAng( prs->GetAng() );
		curPRS->SetScale(prs->GetScale());

		curLgh->rangeMAX = lgh->rangeMAX;
		curLgh->rangeMIN = lgh->rangeMIN;
	}
	//*********** SHL ***********//
	else if (curNode->type == SHL_TYPE_ID)
	{
		ZShell	*shl = (ZShell*) curNode;
		ZShell	*curShell = new ZShell((int)scene);
		if(curShell == NULL)	{	MMset(m,0,NIL);		return 0;	}
		curShell->InsertAsChildOf(scene->World);
		curShell->SetName(shl->name);

		h3d = createH3D(m, (int)curShell, MTOP(MMfetch(m,MTOP(s3d),1)));

		ZPRS	*shlPRS;
		ZPRS	*prs = shl->GetPRS();
		shlPRS = curShell->GetPRS();
		shlPRS->coeffM3D = prs->coeffM3D;
		shlPRS->SetPos( prs->GetPos() );
		shlPRS->SetAng( prs->GetAng() );
		shlPRS->SetScale(prs->GetScale());

		curShell->rangeMAX = shl->rangeMAX;
		curShell->rangeMIN = shl->rangeMIN;
	}
	//*********** ANI ***********//
	else if (curNode->type == ANI_TYPE_ID)
	{
		ZAnim	*an = (ZAnim*) curNode;
		ZAnim	*anim = new ZAnim((int)scene);
		if(!anim)				{	MMset(m,0,NIL);		return 0;	}
		anim->InsertAsChildOf(scene->World);
		anim->SetName(an->name);

		h3d = createH3D(m, (int)anim, MTOP(MMfetch(m,MTOP(s3d),1)));
		
		ZPRS	*animPRS;
		ZPRS	*prs = an->GetPRS();
		animPRS = anim->GetPRS();
		animPRS->coeffM3D = prs->coeffM3D;
		animPRS->SetPos( prs->GetPos() );
		animPRS->SetAng( prs->GetAng() );
		animPRS->SetScale(prs->GetScale());

		anim->setLength(an->getLength());
		anim->minKeyPos = an->minKeyPos;
		anim->maxKeyPos = an->maxKeyPos;
		anim->minKeyRot = an->minKeyRot;
		anim->maxKeyRot = an->maxKeyRot;
		
		anim->listPos.resize(an->listPos.size());
		anim->listRot.resize(an->listRot.size());
		int i;
		for(i=0; i<an->listPos.size(); i++)		{	anim->listPos[i].key = an->listPos[i].key;		anim->listPos[i].pos = an->listPos[i].pos;	}
		for(i=0; i<an->listRot.size(); i++)		{	anim->listRot[i].key = an->listRot[i].key;		anim->listRot[i].rot = an->listRot[i].rot;	}
	}
	//*********** COL ***********//
	else if (curNode->type == COL_TYPE_ID)
	{
		ZColl	*col = (ZColl*) curNode;
		ZColl	*newcol = new ZColl((int)scene, col->typeColl);
		if(!newcol)				{	MMset(m,0,NIL);		return 0;	}
		newcol->InsertAsChildOf(scene->World);
		newcol->name = col->name;

		h3d = createH3D(m, (int)newcol, MTOP(MMfetch(m,MTOP(s3d),1)));

		ZPRS	*colPRS;
		ZPRS	*prs = col->GetPRS();
		colPRS = newcol->GetPRS();
		colPRS->coeffM3D = prs->coeffM3D;
		colPRS->SetPos( prs->GetPos() );
		colPRS->SetAng( prs->GetAng() );
		colPRS->SetScale(prs->GetScale());

		copyCollision(newcol, col);
	}
	//*********** SPR ***********//
	else if (curNode->type == SPR_TYPE_ID)
	{
		ZSprite	*spr = (ZSprite*) curNode;
		ZSprite	*newspr = new ZSprite((int)scene);
		if(!newspr)				{	MMset(m,0,NIL);		return 0;	}
		newspr->InsertAsChildOf(scene->World);

		h3d = createH3D(m, (int)newspr, MTOP(MMfetch(m,MTOP(s3d),1)));

		ZPRS	*newPRS;
		ZPRS	*prs = spr->GetPRS();
		newPRS = newspr->GetPRS();
		newPRS->coeffM3D = prs->coeffM3D;
		newPRS->SetPos( prs->GetPos() );
		newPRS->SetAng( prs->GetAng() );
		newPRS->SetScale(prs->GetScale());

		newspr->SetMaterial(spr->GetMaterial());
		newspr->CameraOriented = spr->CameraOriented;
		newspr->clampU1 = spr->clampU1;
		newspr->clampU2 = spr->clampU2;
		newspr->clampV1 = spr->clampV1;
		newspr->clampV2 = spr->clampV2;
		newspr->halfH   = spr->halfH;
		newspr->halfW   = spr->halfW;
		newspr->rotationZ = spr->rotationZ;

		int i;
		for(i=0; i<4; i++)
		{
			newspr->UV1[i] = spr->UV1[i];
			newspr->UV2[i] = spr->UV2[i];
			newspr->vertColor1[i] = spr->vertColor1[i];
			newspr->vertColor2[i] = spr->vertColor2[i];
		}

		newspr->name	 = spr->name;
		newspr->rangeMAX = spr->rangeMAX;
		newspr->rangeMIN = spr->rangeMIN;
	}
	//*********** PCL ***********//
	else if (curNode->type == PCL_TYPE_ID)
	{
		ZEmitter	*pcl = (ZEmitter*) curNode;
		ZEmitter	*newPcl = new ZEmitter((int)scene, pcl->mask, pcl->life, pcl->volume);
		if(!newPcl)				{	MMset(m,0,NIL);		return 0;	}
		newPcl->InsertAsChildOf(scene->World);

		newPcl->name	 = pcl->name;
		newPcl->rangeMAX = pcl->rangeMAX;
		newPcl->rangeMIN = pcl->rangeMIN;

		h3d = createH3D(m, (int)newPcl, MTOP(MMfetch(m,MTOP(s3d),1)));
		
		ZPRS	*newPRS;
		ZPRS	*prs = pcl->GetPRS();
		newPRS = newPcl->GetPRS();
		newPRS->coeffM3D = prs->coeffM3D;
		newPRS->SetPos( prs->GetPos() );
		newPRS->SetAng( prs->GetAng() );
		newPRS->SetScale(prs->GetScale());

		newPcl->pFather = pcl->pFather;
		newPcl->state	= pcl->state&PCL_ENABLE;

		std::vector<ZEffect*>::iterator	eit = pcl->effectlist.begin();	
		for(;eit!=pcl->effectlist.end();eit++)
			newPcl->effectlist.push_back(*eit);
		if(newPcl->effectlist.size())	newPcl->hasEffects = true;

		std::vector<T_PCL_LIST>::iterator	pit = pcl->particlelist.begin();	
		for(;pit!=pcl->particlelist.end();pit++)
		{
			T_PCL_LIST t;
			t.list.resize(0);
			t.nbpart	= 0;
			t.parttype	= pit->parttype;
			newPcl->particlelist.push_back(t);
		}
	}
	//*********** MSH ***********//
	else if (curNode->type == MSH_TYPE_ID)
	{
		ZMesh	*msh = (ZMesh*) curNode;
		
		ZMesh	*curMsh = new ZMesh((int)scene, msh->NbVerts, msh->NbFaces);
		if(curMsh==NULL)		{	MMset(m,0,NIL);		return 0;	}
		scene->MshList.Add(curMsh);

		curMsh->name			  = msh->name;
		curMsh->dependency		  = msh->dependency;
		curMsh->displayListCreate = msh->displayListCreate;
		
		h3d = createH3D(m, (int)curMsh, MTOP(MMfetch(m,MTOP(s3d),1)));

		ZFace	*curFace, *face;
		int i;
		for(i=0; i<msh->Faces.size(); i++)
		{
			curFace = &(curMsh->Faces[i]);
			face	= &(msh->Faces[i]);
			
			curFace->initFace();
			curFace->SetMaterial(face->GetMaterial());
			
			curFace->SetVertsRef(face->VertRef[0], face->VertRef[1], face->VertRef[2]);
			curFace->dependency = face->dependency;
			
			curFace->UV1[0] = face->UV1[0];
			curFace->UV1[1] = face->UV1[1];
			curFace->UV1[2] = face->UV1[2];
			curFace->UV2[0] = face->UV2[0];
			curFace->UV2[1] = face->UV2[1];
			curFace->UV2[2] = face->UV2[2];

			curFace->clampU1 = face->clampU1;
			curFace->clampV1 = face->clampV1;
			curFace->clampU2 = face->clampU2;
			curFace->clampV2 = face->clampV2;
			
			curFace->index	= face->index;
		}

		ZVert	*curVert, *vert;
		for(i=0; i<msh->Verts.size(); i++)
		{
			curVert = &(curMsh->Verts[i]);
			vert	= &(msh->Verts[i]);

			curVert->color1 = vert->color1;
			curVert->color2 = vert->color2;
			curVert->Normal = vert->Normal;
			curVert->SetCoord(vert->x, vert->y, vert->z);
		}

		curMsh->hasTopoChanged = true;
		curMsh->hasViewChanged = true;

		scene->meshModified		= true;
	}

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

	scene->updateGraphList = true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



void GetFirstRecentName(ZNode *baseNode, ZNode **result, string testName)
{
	ZNode	*curNode = baseNode->son;
	
	while(curNode!=NULL)
	{
		//Test the Node
		if ((curNode->name == testName) && ( ((*result)==NULL) || (curNode->version>(*result)->version)  ) ) 		*result = curNode;

		//If the search is recursive
		GetFirstRecentName(curNode, result, testName);

		curNode = curNode->next;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObj
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S] H3d
int ZM3getObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObj ");
#endif

	int name = MMpull(m);
    int s3d  = MMget(m,0);
    
    if((name==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZNode	*curNode;
	curNode = NULL;
	GetFirstRecentName(scene->World, &curNode, string(MMstartstr(m,MTOP(name))) );

	if(curNode==NULL)				{	MMset(m,0,NIL);		return 0;	}

	int	h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)curNode);

	if(h3d!=NIL)	h3d = PTOM(h3d);
	MMset(m,0,h3d);
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3objName
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] S
int ZM3objName(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3objName ");
#endif

    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMpull(m);

	if(h3d==NIL)					return Mpushstrbloc(m, NULL);
    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL)					return Mpushstrbloc(m, NULL);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return Mpushstrbloc(m, (char*)node->name.c_str());
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getFather
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3getFather(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getFather ");
#endif
    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)				{	MMset(m,0,NIL);		return 0;	}

    node = node->father;

	if((node->type>MAX_NODE_SCENE)||(node==NULL))		{	MMset(m,0,NIL);		return 0;	}

	h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)node);

	if(h3d!=NIL)	h3d = PTOM(h3d);
	MMset(m,0,h3d);
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getFirstSon
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3getFirstSon(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getFirstSon ");
#endif
    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}

	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

    node = node->son;

	if(node==NULL)		{	MMset(m,0,NIL);		return 0;	}

	h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)node);

	if(h3d!=NIL)	h3d = PTOM(h3d);
	MMset(m,0,h3d);
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getBrother														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3getBrother(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getBrother ");
#endif
    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

    if(node->father==scene->World)	{	MMset(m,0,NIL);		return 0;	}

	node = node->next;

	if(node==NULL)		{	MMset(m,0,NIL);		return 0;	}

	h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)node);

	if(h3d!=NIL)	h3d = PTOM(h3d);
	MMset(m,0,h3d);
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3bigFather
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] H3d
int ZM3bigFather(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3bigFather ");
#endif
    int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*nodeSon;
	while((node!=NULL)&&(node!=scene->World))	{	nodeSon = node;		node = node->father;	}

	h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)nodeSon);

	if(h3d!=NIL)	h3d = PTOM(h3d);
	MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3isFather
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d H3d] I

///////// ATTENTION !!! FONCTION QUI CHIE LA MORT !!! RENVOIT "true" si pere==fils !!!!!! //////////
int ZM3isFather(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3isFather ");
#endif

    int pere = MMpull(m);
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    
	if(pere==NIL)					{	MMset(m,0,ITOM(0));	return 0;	}

	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}
	ZNode	*papa = (ZNode*) MMfetch(m,MTOP(pere),0);
	if(papa==NULL||papa->type==MSH_TYPE_ID)					{	MMset(m,0,ITOM(0));		return 0;	}

    int	result = 0;
	while((node!=NULL)&&(node!=scene->World)&&(!result))	{	if(papa==node)	result = 1;		node = node->father;	}

	if(result==1)		MMset(m,0,ITOM(1));
	else				MMset(m,0,ITOM(0));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3unLink
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3unLink(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3unlink ");
#endif

    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

	if(node->father!=scene->World)		node->InsertAsChildOf(scene->World);

	scene->updateGraphList = true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	MMset(m,0,0);
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3link														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d H3d] I
int ZM3link(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3link ");
#endif

    int pere = MMpull(m);
    int h3d	 = MMpull(m);
    int s3d	 = MMget(m,0);
    
	if((s3d==NIL)||(h3d==NIL))		return 0;
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)		{	MMset(m,0,NIL);		return 0;	}

	if(pere == NIL)		{	MMset(m,0,NIL);		return 0;	}

	ZNode	*nodePERE = (ZNode*) MMfetch(m,MTOP(pere),0);
	if(nodePERE==NULL||nodePERE->type==MSH_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}
	if(nodePERE->type == MSH_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}

	ZNode	*nodeFILS = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(nodeFILS==NULL||nodeFILS->type==MSH_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}
	if(nodeFILS->type == MSH_TYPE_ID)	{	MMset(m,0,NIL);		return 0;	}


	// test de validit du pere par rapport au fils : on ne doit pas "boucler"
	bool	impossible = false;
	ZNode	*curNode = nodePERE;
	while(curNode && !(impossible|=(curNode==nodeFILS)) )			curNode = curNode->father;
	if(impossible)		{	MMset(m,0,NIL);		return 0;	}
	
	// Effectue le link
	nodeFILS->InsertAsChildOf(nodePERE);
	
	scene->updateGraphList = true;
	
    MMset(m, 0, 0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3renameObj
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d S] I
int ZM3renameObj(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3renameObj ");
#endif
    int name = MMpull(m);
    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(name==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL/*||node->type==MSH_TYPE_ID*/)					{	MMset(m,0,NIL);		return 0;	}

	node->SetName((char*)MMstartstr(m,MTOP(name)));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	MMset(m,0,0);
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listOfBigFathers
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d] [H3d r1]
int ZM3listOfBigFathers(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listOfBigFather ");
#endif
	// Version MBdeftab non bugge

	int		h3d;
	int		j, k, n, tmp_res;

	n=0;


	int s3d = MMpull(m);
    if(s3d==NIL)			return MMpush(m,NIL);
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)			return MMpush(m,NIL);

	ZNode	*node = scene->World->son;
	if(node==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMpush(m, s3d);

	while(node!=NULL)
	{
		h3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(MMget(m,0)),1)), (int)node);
		if (MMpush(m,PTOM(h3d)))		return MERRMEM;
		n++;

		INVERT(m,0,1);
		
		node = node->next;
	}
	
	MMpull(m);
	
	if(MMpush(m,NIL))		return MERRMEM;
	for(j=0;j<n;j++)
	{
    	if (MMpush(m,2*2)) return MERRMEM;
		if (k=MBdeftab(m)) return k;
	}
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}






//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getObjType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d H3d] I
int ZM3getObjType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getObjType ");
#endif

    int h3d  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if(node==NULL||node->type==MSH_TYPE_ID)					{	MMset(m,0,NIL);		return 0;	}

    if(node->type==LGH_TYPE_ID)
	{
		if(((ZLight*)node)->oldStyle == true)		MMset(m,0,ITOM(node->type));
		else										MMset(m,0,ITOM(50));
		return 0;
	}

	if(node->type==SND_TYPE_ID)
	{
	  //$LB
	  /*
		if(((ZSound*)node)->pWSound->pHListener )	MMset(m,0,ITOM(55));
		else*/										MMset(m,0,ITOM(60));
		return 0;
	}
	
	MMset(m,0,ITOM(node->type));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}
