//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///		   ANCIENNES FONCTIONS										    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



	
	
	
int createSceneWITHOUTregister(mmachine m)		// pour le m3initialize
{
    int		i;
	
	// Cration de la scene 3D
	ZScene		*scene = NULL;
	scene = new ZScene(false);
	if(scene==NULL)				return MERRMEM;
	scene->InitWorld();
	
	scene->accelerated = false;

	int s3d = MMmalloc(m, 4, TYPETAB);
	if(s3d==NIL)				return MERRMEM;
	for(int iii=0; iii<4; iii++)	MMstore(m, s3d, iii, NIL);

	MMstore(m, s3d, 0, (int)scene);
	MMpush(m,PTOM(s3d));


	// Cration de la hash_table des H3D
	int hashH3D = MMmalloc(m, HASH_SIZE, TYPETAB);
	if(hashH3D==NIL)			return MERRMEM;
	for(i=0; i<HASH_SIZE; i++)		MMstore(m, hashH3D, i, NIL);

	s3d = MTOP(MMpull(m));
	MMstore(m, s3d, 1, PTOM(hashH3D));
	MMpush(m,PTOM(s3d));


	// Cration de la hash_table des MATERIAUX
	int hashMAT = MMmalloc(m, HASH_SIZE, TYPETAB);
	if(hashMAT==NIL)			return MERRMEM;
	for(i=0; i<HASH_SIZE; i++)		MMstore(m, hashMAT, i, NIL);

	s3d = MTOP(MMpull(m));
	MMstore(m, s3d, 2, PTOM(hashMAT));
	MMpush(m,PTOM(s3d));


	// Cration de la hash_table des TEXTURES
	int hashTEX = MMmalloc(m, HASH_SIZE, TYPETAB);
	if(hashTEX==NIL)			return MERRMEM;
	for(i=0; i<HASH_SIZE; i++)		MMstore(m, hashTEX, i, NIL);

	s3d = MTOP(MMpull(m));
	MMstore(m, s3d, 3, PTOM(hashTEX));


	// Pose le rsultat sur la pile avant l'appel de 'ObjCreate'
	if(MMpush(m, PTOM(s3d)))	return MERRMEM;

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3initialize
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [I I I I I I] S3d
int ZM3initialize(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3initialize ");
#endif

	MMpull(m);
    MMpull(m);
    MMpull(m);
    MMpull(m);
    MMpull(m);
    MMpull(m);

	#ifdef	_INFO_SCREEN_
		if(userACCEL && !mainInfoWND)	CreateWinInfoSCREEN(600, 1000);
	#endif

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return createSceneWITHOUTregister(m);			// cre une session et pose le pointeur scol sur la pile
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3desalloc
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] I
int ZM3desalloc(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3desalloc ");
#endif

	int s3d	 = MMget(m,0);
	if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}

	ZooDestroySession(m, 0, s3d);

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}





///////////////////////////////////////////////////////////////////////////////////////
///		Macro GLOBAL_RENDER_FILL_SOFT												///
///////////////////////////////////////////////////////////////////////////////////////
#define GLOBAL_RENDER_FILL_SOFT(flag_of_wired)															\
	int		fond, y, x, h3d, surf, s3d;																	\
	ZNode	*node, *father;																				\
																										\
	fond = MMpull(m);																					\
	y	 = MMpull(m);																					\
	x	 = MMpull(m);																					\
	h3d	 = MMpull(m);																					\
	surf = MMpull(m);																					\
	s3d  = MMget(m,0);																					\
																										\
	if((surf==NIL)||(s3d==NIL)||(h3d==NIL)|| scolGLX->fullscreenMode)		{   MMset(m,0,NIL);		return 0;	}	\
																										\
	ZScene	*scene;																						\
	scene = (ZScene*) MMfetch(m,MTOP(s3d),0);															\
	if(scene==NULL)								{   MMset(m,0,NIL);		return 0;	}					\
																										\
	/*/////////////////////////////////////////////////////////////////									\
	///		Session en mode HARD -> ne fait rien					///									\
	/////////////////////////////////////////////////////////////////*/									\
	if(scene->accelerated)																				\
	{																									\
		MMset(m,0,NIL);																					\
		return 0;																						\
	}																									\
	/*/////////////////////////////////////////////////////////////////									\
	///		Session en mode SOFT -> affiche le mode soft			///									\
	/////////////////////////////////////////////////////////////////*/									\
	else																								\
	{																									\
		RenderBuffer	buffer;																			\
		if(fillRenderBuffer(m, &buffer, surf))			{   MMset(m,0,NIL);		return 0;	}			\
																										\
		/* Couleur de Fond */																			\
		fond = MTOI(fond);																				\
		float	r = 0;																					\
		float	g = 0;																					\
		float	b = 0;																					\
																										\
		if(fond!=NIL)																					\
		{																								\
			r = ((fond)&255)	 / CONST_COLOR;															\
			g = ((fond>>8)&255)	 / CONST_COLOR;															\
			b = ((fond>>16)&255) / CONST_COLOR;															\
		}																								\
																										\
		/* Recupration de la camera */																	\
		node = (ZNode*) MMfetch(m,MTOP(h3d),0);															\
		if((node==NULL)||(node->type!=CAM_TYPE_ID))		{   MMset(m,0,NIL);		return 0;	}			\
		scene->SetActiveCam((ZCamera*)node);															\
																										\
		father = getBigFather(node);																	\
																										\
		/* Prpare la camera par prcaution et aussi pour le calcul des subMatrices */					\
		ZMatrix		matx = ComputeWorldMatrix(node);													\
		((ZCamera*)node)->worldMat = matx;																\
		((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));							\
																										\
		/* Rendu de la scene */																			\
		if(fond==NIL)		scene->DisplaySOFT(&buffer, r, g, b, father, flag_of_wired, false, false);	\
		else				scene->DisplaySOFT(&buffer, r, g, b, father, flag_of_wired, false, true);	\
	}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3scanline
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjBitmap H3d I I I] H3d
int ZM3scanline(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3scanline ");
#endif

	// Macro de rendu GLOBAL
//	GLOBAL_RENDER_FILL_SOFT(false)


////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////

	int		fond, y, x, h3d, surf, s3d;																	
	ZNode	*node, *father;																				
																										
	fond = MMpull(m);																					
	y	 = MMpull(m);																					
	x	 = MMpull(m);																					
	h3d	 = MMpull(m);																					
	surf = MMpull(m);																					
	s3d  = MMget(m,0);																					
																										
	if((surf==NIL)||(s3d==NIL)||(h3d==NIL)|| scolGLX->fullscreenMode)		{   MMset(m,0,NIL);		return 0;	}	
																										
	ZScene	*scene;																						
	scene = (ZScene*) MMfetch(m,MTOP(s3d),0);															
	if(scene==NULL)								{   MMset(m,0,NIL);		return 0;	}					



	///////////////////////////////////////////////////////////////////									
	///		Session en mode HARD -> ne fait rien					///									
	///////////////////////////////////////////////////////////////////
	if(scene->accelerated)																				
	{																									
		MMset(m,0,NIL);																					
		return 0;																						
	}																									
	///////////////////////////////////////////////////////////////////									
	///		Session en mode SOFT -> affiche le mode soft			///									
	///////////////////////////////////////////////////////////////////									
	else																								
	 {																								       

	  //$LBPtrObjVoid		O;
        PtrObjBitmap	B;

		int				i;
        guint32			*Image;


        //$LB O = (PtrObjVoid)	MMstart(m, MTOP(surf) );
        //$LB B = (PtrObjBitmap)	MMstart(m, MTOP(O->Buffer) );
	B = (PtrObjBitmap) objdd_get_buffer (m, MTOP(surf));
		
	if(!B)			return -1;

        Image = (guint32*) OBJBITMAP_GET_MEM(B);



        i = (OBJBITMAP_GET_BPL(B) * OBJBITMAP_GET_H(B)) >> 2;

	while(i)	Image[--i] = 0;


		////////////////		
		
		RenderBuffer	buffer;																			
		if(fillRenderBuffer(m, &buffer, surf))			{   MMset(m,0,NIL);		return 0;	}			
																										
		// Couleur de Fond
		fond = MTOI(fond);																				
		float	r = 0;																					
		float	g = 0;																					
		float	b = 0;																					
																										
		if(fond!=NIL)																					
		{																								
			b = ((fond)&255)	 / CONST_COLOR;															
			g = ((fond>>8)&255)	 / CONST_COLOR;															
			r = ((fond>>16)&255) / CONST_COLOR;															
		}																								
			 																							
		// Recupration de la camera
		node = (ZNode*) MMfetch(m,MTOP(h3d),0);															
		if((node==NULL)||(node->type!=CAM_TYPE_ID))		{   MMset(m,0,NIL);		return 0;	}			
		scene->SetActiveCam((ZCamera*)node);															
																										
		father = getBigFather(node);																	
																										
		// Prpare la camera par prcaution et aussi pour le calcul des subMatrices
		ZMatrix		matx = ComputeWorldMatrix(node);													
		((ZCamera*)node)->worldMat = matx;																
		((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));							

		// Rendu de la scene 						
		if(fond==NIL)		scene->DisplaySOFT(&buffer, r, g, b, father, false, false, false);	
		else				scene->DisplaySOFT(&buffer, r, g, b, father, false, false, true);	
	
	}


////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////


	CLEAN_UNUSED_DATAS

	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	float	dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), NULL, NULL, NULL, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			if(result!=NIL)		result = PTOM(result);
		}
	}

	MMset(m,0,result);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3scanlineM													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjBitmap H3d I I I] [H3d HMat3d]
int ZM3scanlineM(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3scanlineM ");
#endif

	// Macro de rendu GLOBAL
	GLOBAL_RENDER_FILL_SOFT(false)

	CLEAN_UNUSED_DATAS

	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), NULL, NULL, NULL, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m, 0, mater);
	MMpush(m, result);
	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m) );
	MMstore(m, tuple, 1, MMget(m,0) );

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3scanlineInfo
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjBitmap H3d I I] [H3d HMat3d I I I]
int ZM3scanlineInfo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3scanlineInfo ");
#endif

	int y	 = MMpull(m);
	int x	 = MMpull(m);
	int h3d	 = MMpull(m);
	MMpull(m);						// on ne se sert pas de l'ObjBitmap
	int s3d	 = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(x==NIL)||(y==NIL))		{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{   MMset(m,0,NIL);		return 0;	}

	// Recupration de la camera
	ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=CAM_TYPE_ID))		{   MMset(m,0,NIL);		return 0;	}
	scene->SetActiveCam((ZCamera*)node);

	// Prpare la camera par prcaution..
	ZMatrix		matx = ComputeWorldMatrix(node);
	((ZCamera*)node)->worldMat = matx;
	((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));
	((ZCamera*)node)->ComputeMatrix();

	// Prpare la scne qui peut avoir chang
	ZNodeGraph	*father = (ZNodeGraph*) getBigFather(node);

	scene->World->createNodeLists(father);

	scene->World->ComputeMatrices(node, father, IdentityMatrix(), 1.0f, true);
	scene->World->TransformVertices();

	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	u = 0, v = 0, z = 0, dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), &u, &v, &z, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m,0,mater);
	MMpush(m,result);

	int tuple = MMmalloc(m, 5, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m));
	MMstore(m, tuple, 1, MMget(m,0));
	if(mater!=NIL)
	{
		MMstore(m, tuple, 2, ITOM(AROUNDINT(u*CONST_TEX_COORD)));
		MMstore(m, tuple, 3, ITOM(AROUNDINT(v*CONST_TEX_COORD)));
		MMstore(m, tuple, 4, ITOM(AROUNDINT(-z*100.0f)));
	}
	else
	{
		MMstore(m, tuple, 2, NIL);
		MMstore(m, tuple, 3, NIL);
		MMstore(m, tuple, 4, NIL);
	}

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureTotalSize
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun [S3d] I
int ZM3textureTotalSize(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureTotalSize ");
#endif

    int s3d = MMget(m,0);

    if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	ZTexture	*tex;
	
	int		size=0;

	for(int i=0; i<scene->TexList.Size(); i++)
    {
		tex = scene->TexList[i];
		size += tex->Width*tex->Height*4;
    }

	MMset(m,0,ITOM(size));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3videoInfos														
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [] [S S S S]
int ZM3videoInfos(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ZM3videoInfos ");
#endif

	ZDetector	detect;
	
	Mpushstrbloc(m, (char*)detect.CheckOpenGLvendor());
	Mpushstrbloc(m, (char*)detect.CheckOpenGLrenderer());
	Mpushstrbloc(m, (char*)detect.CheckOpenGLdriver());
	Mpushstrbloc(m, (char*)detect.CheckOpenGLextensions());

    if(MMpush(m,4*2))			return MERRMEM;
	if(int k=MBdeftab(m))		return k;


#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3TestSurfaceZbuf
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun[ObjSurface] I
int ZMX3TestSurfaceZbuf(mmachine m)
{
	if(MMget(m,0)==NIL)		return 0;
	
	MMset(m,0,ITOM(1));
	
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZisPentium
//////////////////////////////////////////////////////////////////////////////////////////////
///	fun[] I
int ZisPentium(mmachine m)
{

  //$LB TODO TO DO
 /*
	if(testP4())	{	MMpush(m,ITOM(4));	return 0;	}
	if(testP3())	{	MMpush(m,ITOM(3));	return 0;	}
*/

	MMpush(m,0);
	return 0;
}

