//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///			 GESTION DE SESSION ET DE SURFACE							    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////
///		createScene
//////////////////////////////////////////////////////////////////////////////////////////////
// Cre une session et dpose le handler sur la pile (dpile le channel laiss en paramtre)
int createScene(mmachine m, bool accel)
{
    int		i;


      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("createScene"); 
      #endif

	
	// Cration de la scene 3D
	ZScene		*scene = NULL;
	scene = new ZScene(accel);
	if(scene==NULL)				return MERRMEM;
	scene->InitWorld();


	int s3d = MMmalloc(m, 4, TYPETAB);
	if(s3d==NIL)				return MERRMEM;
	for(i=0; i<4; i++)			MMstore(m, s3d, i, NIL);

	MMstore(m, s3d, 0, (int)scene);
	MMpush(m,PTOM(s3d));


	// Cration de la hash_table des H3D
	int hashH3D = MMmalloc(m, HASH_SIZE, TYPETAB);
	if(hashH3D==NIL)			return MERRMEM;
	for(i=0; i<HASH_SIZE; i++)	MMstore(m, hashH3D, i, NIL);

	s3d = MTOP(MMpull(m));
	MMstore(m, s3d, 1, PTOM(hashH3D));
	MMpush(m,PTOM(s3d));


	// Cration de la hash_table des MATERIAUX
	int hashMAT = MMmalloc(m, HASH_SIZE, TYPETAB);
	if(hashMAT==NIL)			return MERRMEM;
	for(i=0; i<HASH_SIZE; i++)	MMstore(m, hashMAT, i, NIL);

	s3d = MTOP(MMpull(m));
	MMstore(m, s3d, 2, PTOM(hashMAT));
	MMpush(m,PTOM(s3d));


	// Cration de la hash_table des TEXTURES
	int hashTEX = MMmalloc(m, HASH_SIZE, TYPETAB);
	if(hashTEX==NIL)			return MERRMEM;
	for(i=0; i<HASH_SIZE; i++)	MMstore(m, hashTEX, i, NIL);

	s3d = MTOP(MMpull(m));
	MMstore(m, s3d, 3, PTOM(hashTEX));


	// Pose le rsultat sur la pile avant l'appel de 'ObjCreate'
	if(MMpush(m, PTOM(s3d)))	return MERRMEM;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("createScene ok"); 
      #endif


	return OBJcreate(m, typeSession, num3d++, -1, -1);
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3create														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [Chn I I I I I] S3d		--> specifique pour le rendu SOFT
int ZM3create(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3create ");
#endif
	
	int		k, p;

	MMpull(m);
    MMpull(m);
    MMpull(m);
    MMpull(m);
    MMpull(m);


	#ifdef	_INFO_SCREEN_
		if(userACCEL && !mainInfoWND)	CreateWinInfoSCREEN(600, 1000);
	#endif

	if(k = createScene(m, false))	return k;			// cre une session et pose le pointeur scol sur la pile
	p = MMget(m,0);
	if(p==NIL)				return 0;


#ifdef	_SCOL_DEBUG_
	MMechostr(0," ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3create														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [Chn I I I I I] S3d
int ZMX3create(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3create ");
#endif

	int		k, p;

	MMpull(m);
    MMpull(m);
    MMpull(m);
    MMpull(m);
    MMpull(m);


	#ifdef	_INFO_SCREEN_
		if(userACCEL && !mainInfoWND)	CreateWinInfoSCREEN(600, 1000);
	#endif

	if(k = createScene(m, scolGLX->userACCEL))	return k;			// cre une session et pose le pointeur scol sur la pile
	p = MMget(m,0);
	if(p==NIL)				return 0;


	// ------->  C'est l !!!! qu'on place le FLAG pour le mode soft ou le mode HARD !!!!!!!  <-----

	//	ZScene	*s;
	//	s=(session3d)MMstart(m,p>>1);
	//	s->mx3=mx3value; //1 : Hardware s->mx3=0; //0 : software

#ifdef	_SCOL_DEBUG_
	MMechostr(0," ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3createSession														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [Chn] S3d
int ZMX3createSession(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3createSession ");
#endif

	int		k, p;


	#ifdef	_INFO_SCREEN_
		if(userACCEL && !mainInfoWND)	CreateWinInfoSCREEN(600, 1000);
	#endif

	if(k = createScene(m, scolGLX->userACCEL))	return k;			// cre une session et pose le pointeur scol sur la pile
	p = MMget(m,0);
	if(p==NIL)				return 0;

#ifdef	_SCOL_DEBUG_
	MMechostr(0," ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZooDestroySession														
//////////////////////////////////////////////////////////////////////////////////////////////
// fonction d'appel lors de la destruction interne d'une surface (dclare dans le ObjRegister)
int ZooDestroySession(mmachine m, int q, int s3d)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("ZooDestroySession"); 
      #endif

	MMechostr(0,"session destroyed !!\n");

	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);

	// Efface la scene
	MMstore(m, MTOP(s3d), 0, (int)NULL);
	delete scene;

	// Efface les Hash_tab
	int	hashTab = MMfetch(m,MTOP(s3d),1);
	CleanHash(m, MTOP(hashTab));
	MMstore(m, MTOP(s3d), 1, NIL);

	hashTab = MMfetch(m,MTOP(s3d),2);
	CleanHash(m, MTOP(hashTab));
	MMstore(m, MTOP(s3d), 2, NIL);

	hashTab = MMfetch(m,MTOP(s3d),3);
	CleanHash(m, MTOP(hashTab));
	MMstore(m, MTOP(s3d), 3, NIL);

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("ZooDestroySession ok"); 
      #endif


	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3destroy
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] I
int ZM3destroy(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3destroy ");
#endif

    int s3d	 = MMget(m,0);
    if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
	OBJdelTM(m, typeSession, s3d);

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3freeMemory
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] I
int ZM3freeMemory(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3freeMemory ");
#endif

    int s3d	 = MMget(m,0);

    if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m, MTOP(s3d), 0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0,ITOM(4096*4096));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3reset
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] I
int ZM3reset(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3reset ");
#endif

    int s3d	 = MMget(m,0);

	if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m, MTOP(s3d), 0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	scene->Reset();

	// Efface les Hash_tab
	int	hashTab = MMfetch(m,MTOP(s3d),1);
	CleanHash(m, MTOP(hashTab));
//	MMstore(m, MTOP(s3d), 1, NIL);

	hashTab = MMfetch(m,MTOP(s3d),2);
	CleanHash(m, MTOP(hashTab));
//	MMstore(m, MTOP(s3d), 2, NIL);

	hashTab = MMfetch(m,MTOP(s3d),3);
	CleanHash(m, MTOP(hashTab));
//	MMstore(m, MTOP(s3d), 3, NIL);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3create ");
#endif
    
	MMset(m,0,0);
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		SetGL2D														
//////////////////////////////////////////////////////////////////////////////////////////////
//$LB : removed HDC
bool SetGL2D(mmachine m, int surf, HWND *phwnd=NULL, HGLRC *prc=NULL)
{
	HWND	hwnd;
	HGLRC	rc;
	//$LB RECT	rect;
	int hwndW, hwndH;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("SetGL2D"); 
      #endif


	rc =	(HGLRC)	MMfetch(m,surf,2);
	hwnd =	(HWND)	MMfetch(m,surf,3);

	if (!rc || !hwnd)	return false;

	if(wglGetCurrentContext()!=rc)
	{
		wglMakeCurrent(hwnd,rc);
	}

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	//$LB
	/*
	GetClientRect(hwnd,&rect);
	gluOrtho2D(0,(float)rect.right,(float)rect.bottom,0);
	*/
	gdk_window_get_size (hwnd, &hwndW, &hwndH);
	gluOrtho2D(0, (float)hwndW, (float)hwndH, 0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glDisable(GL_TEXTURE_2D);
	glDisable(GL_FOG);
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);

	if (phwnd)		*phwnd	= hwnd;
	if (prc)		*prc	= rc;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("SetGL2D ok"); 
      #endif


	return true;
}












//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//$LB
/*
int ChoosePixelFormatEx(HDC hdc,int *p_bpp,int *p_depth,int *p_dbl,int *p_acc)
{ 
	int wbpp;
	if(p_bpp==NULL)			wbpp = -1; 
	else					wbpp = *p_bpp;

	int wdepth; 
	if(p_depth==NULL)		wdepth = 16; 
	else					wdepth = *p_depth;

	int wdbl; 
	if(p_dbl==NULL)			wdbl = -1; 
	else					wdbl = *p_dbl;

	int wacc; 
	if(p_acc==NULL)			wacc = 1; 
	else					wacc = *p_acc;

	PIXELFORMATDESCRIPTOR pfd; 
	ZeroMemory(&pfd, sizeof(pfd)); 
	pfd.nSize		= sizeof(pfd); 
	pfd.nVersion	= 1;

	int num = DescribePixelFormat(hdc, 1, sizeof(pfd), &pfd);
	if(num==0)		return 0;

	unsigned int maxqual  = 0; 
	int			 maxindex = 0;

	int max_bpp, max_depth, max_dbl, max_acc;

	for(int i=1; i<=num; i++)
	{
		ZeroMemory(&pfd, sizeof(pfd)); 
		pfd.nSize		= sizeof(pfd); 
		pfd.nVersion	= 1;

		DescribePixelFormat(hdc, i, sizeof(pfd), &pfd);
		int bpp		= pfd.cColorBits;
		int depth	= pfd.cDepthBits;

		// Mode palett
		bool pal	= (pfd.iPixelType==PFD_TYPE_COLORINDEX);
		// Modes accelers
		bool mcd	= ( (pfd.dwFlags & PFD_GENERIC_FORMAT) &&  (pfd.dwFlags & PFD_GENERIC_ACCELERATED));
		bool soft	= ( (pfd.dwFlags & PFD_GENERIC_FORMAT) && !(pfd.dwFlags & PFD_GENERIC_ACCELERATED));
		bool icd	= (!(pfd.dwFlags & PFD_GENERIC_FORMAT) && !(pfd.dwFlags & PFD_GENERIC_ACCELERATED));
		// Modes de trac
		bool opengl = (0 != (pfd.dwFlags & PFD_SUPPORT_OPENGL));
		bool window = (0 != (pfd.dwFlags & PFD_DRAW_TO_WINDOW));
		bool bitmap = (0 != (pfd.dwFlags & PFD_DRAW_TO_BITMAP));
		bool dbuff	= (0 != (pfd.dwFlags & PFD_DOUBLEBUFFER));

		unsigned int	q=0;

		if(opengl && window)											q = q + 0x8000;
		if(wdepth==-1 || (wdepth>0 && depth>0))							q = q + 0x4000;
		if(wdbl==-1 || (wdbl==0 && !dbuff) || (wdbl==1 && dbuff))		q = q + 0x2000;

		if(wacc==-1 || (wacc==0 && soft) || (wacc==1 && (mcd||icd)))	q = q + 0x1000;
		if(mcd || icd)													q = q + 0x0040; 
		if(icd)															q = q + 0x0002;

		if(wbpp==-1 || (wbpp==bpp))										q = q + 0x0800;
		if(bpp>16)														q = q + 0x0020; 
		if(bpp==16)														q = q + 0x0008;
		
		if(wdepth==-1 || (wdepth==depth))								q = q + 0x0400;
		if(depth>16)													q = q + 0x0010; 
		if(depth==16)													q = q + 0x0004;
		
		if(!pal)														q = q + 0x0080;
		if(bitmap)														q = q + 0x0001;

		if(q>maxqual)
		{
			maxqual		= q; 
			maxindex	= i;
			max_bpp		= bpp;
			max_depth	= depth;
			max_dbl		= dbuff?1:0;
			max_acc		= soft?0:1;
		}
	}

	if(maxindex==0)		return maxindex;

	if(p_bpp   != NULL)			*p_bpp	 = max_bpp;
	if(p_depth != NULL)			*p_depth = max_depth;
	if(p_dbl   != NULL)			*p_dbl	 = max_dbl;
	if(p_acc   != NULL)			*p_acc	 = max_acc;

	return maxindex;
}
*/












//////////////////////////////////////////////////////////////////////////////////////////////
///		CreateMainContext														
//////////////////////////////////////////////////////////////////////////////////////////////
//$LB  : removed HDC and PIXELFORMATDESCRIPTOR
HGLRC CreateMainContext()
{
GdkWindowAttr ha;
GdkWindow* hwnd;
 

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("CreateMainContext"); 
      #endif


  //$LB 
  //HWND	hwnd = CreateWindow("scolGL", "scolGL", WS_CHILD, 0, 0, 1, 1, HScol, NULL, NULL, 0);
  // 
  ha.title = "scolGL";
  ha.event_mask = 0;
  ha.x = 0; ha.y = 0;
  ha.width = 1; ha.height = 1;
  ha.wclass = GDK_INPUT_OUTPUT;
  ha.visual = scolGLX->GetGdkVisual();
  ha.window_type = GDK_WINDOW_CHILD; 
  hwnd = gdk_window_new (HScol, &ha, GDK_WA_TITLE|GDK_WA_X|GDK_WA_Y|GDK_WA_VISUAL);
  //

   


	///////////////////////////////////////////////////
	///		Test de meilleure qualit de rendu		///
	///////////////////////////////////////////////////


	// Assignation des rsultats globaux
        //$LB : mainBPP, mainDEPTH, mainDBLBUF are set in the scolGLX class constructor
        /*
	mainBPP		= bpp;
	mainDEPTH	= depth;
	mainDBLBUF	= dbl;
	*/


	scolGLX->mainhwnd = hwnd;

	scolGLX->mainglrc = wglCreateContext(None);

	if (wglGetCurrentContext() != scolGLX->mainglrc)		
	  wglMakeCurrent(scolGLX->mainhwnd, scolGLX->mainglrc);



	// Driver type
	//$LB
	/*
	if(0 != (pfd.dwFlags & PFD_GENERIC_FORMAT))
	{
		MMechostr(0,"**** Generic Software                                          ****\n" );
		return NULL;
	}
	else
	{
		if(0 != (pfd.dwFlags & PFD_GENERIC_ACCELERATED))
			MMechostr(0,"**** MCD ACCELERATED                                           ****\n" );
		else
			MMechostr(0,"**** ICD ACCELERATED                                           ****\n" );
	}

	MMechostr(0,"**** Color  : %d                                               ****\n",bpp);
	MMechostr(0,"**** Depth  : %d                                               ****\n",depth);
	if(dbl)		MMechostr(0,"**** Buffer : double                                           ****\n");
	else		MMechostr(0,"**** Buffer : simple                                           ****\n");
	*/

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("CreateMainContext ok"); 
      #endif


	return scolGLX->mainglrc;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		InitOpenGL														
//////////////////////////////////////////////////////////////////////////////////////////////
//$LB removed HDC and PIXELFORMAT
int InitOpenGL(mmachine m,int w,int h, HWND *resWnd)
{
	int		objSurf;
	HGLRC	hglrc;

	//$LB
	GdkWindowAttr ha;
        GdkWindow*	hwnd;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("InitOpenGL"); 
      #endif


	//$LB
	/*
	*resWnd = hwnd = CreateWindow("scolGL", "scolGL", WS_CHILD, 0, 0, w, h, HScol, NULL, NULL, 0);
	ShowWindow(hwnd, SW_SHOWNORMAL);
	UpdateWindow(hwnd);
	*/
	//
	ha.title = "scolGL";
        ha.event_mask = GDK_EXPOSURE_MASK | GDK_STRUCTURE_MASK;
	ha.x = 0;  ha.y = 0;
	ha.width = w;  ha.height = h;
        ha.wclass = GDK_INPUT_OUTPUT;
	ha.visual = scolGLX->GetGdkVisual();
	ha.window_type = GDK_WINDOW_CHILD;
	ha.override_redirect = TRUE;

	*resWnd = hwnd = gdk_window_new (HScol, &ha, GDK_WA_TITLE|GDK_WA_X|GDK_WA_Y|GDK_WA_VISUAL|GDK_WA_NOREDIR);
	gdk_window_show (hwnd);
	//

   
	hglrc	= wglCreateContext(scolGLX->mainglrc);
	
	if(wglGetCurrentContext()!=hglrc)
	{
		wglMakeCurrent(hwnd, hglrc);
	}

	//$LB not used in GLX (realized by wglCreateContext<=>glXCreateContext) : wglShareLists(mainglrc, hglrc);

	glViewport(0,0,w,h);												// Reset The Current Viewport

	objSurf = MMmalloc(m,4,TYPEBUF);
	if(!objSurf)		return MERRMEM;
	MMstore(m,objSurf,0,MYWND_WINDOWED);
	//$LB MMstore(m,objSurf,1,(int)hdc);
	MMstore (m, objSurf, 1, NULL);
	MMstore(m,objSurf,2,(int)hglrc);
	MMstore(m,objSurf,3,(int)hwnd);

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("InitOpenGL ok"); 
      #endif


	return objSurf;
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		InitOpenGLfullScreen														
//////////////////////////////////////////////////////////////////////////////////////////////
//$LB 
int InitOpenGLfullScreen (mmachine m,int w,int h)
{

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("InitOpenGLfullScreen"); 
      #endif


        //$LB 
        /*
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	*/

  //$LB
  /*
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)w;			// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)h;			// Set Bottom Value To Requested Height
	*/

	//$LB
	/*
	DEVMODE dmScreenSettings;									// Device Mode
	memset(&dmScreenSettings,0,sizeof(dmScreenSettings));		// Makes Sure Memory's Cleared
	dmScreenSettings.dmSize=sizeof(dmScreenSettings);			// Size Of The Devmode Structure
	dmScreenSettings.dmPelsWidth	= w;						// Selected Screen Width
	dmScreenSettings.dmPelsHeight	= h;						// Selected Screen Height
	dmScreenSettings.dmBitsPerPel	= mainBPP;			//32; // Selected Bits Per Pixel  <--------------------- modifier le BPP par passage de paramtre !!
	dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

	// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
	if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
	{
		// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
		if(MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card.","SCOL Engine",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
		{
			fullscreenMode--;
			return NIL;											// Return FALSE
		}
		else
		{
			// Pop Up A Message Box Letting User Know The Program Is Closing.
			MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
			return NIL;											// Return FALSE
		}
	}
	*/
	GdkWindowAttr ha;
        HWND	hwnd;
	HGLRC	hglrc = wglCreateContext(scolGLX->mainglrc);								// Are We Able To Get A Rendering Context?

	// switch to fullscreen mode
        scolGLX->SetBestMode(w,h);

        if (!(XF86VidModeSwitchToMode (scolX->dpy, scolX->screen, scolGLX->GetBestMode())))
	  MMechostr(MSKFOO, "\nInitOpenGLfullScreen : XF86VidModeSwitchToMode Error!\n");
        if (!(XF86VidModeSetViewPort(scolX->dpy, scolX->screen, 0, 0)))
	  MMechostr(MSKFOO, "\nInitOpenFLfullScreen : XF86VidModeSetViewPort Error!\n");


	//$LB
	/*
	dwExStyle	= WS_EX_APPWINDOW | WS_EX_TOPMOST;										// Window Extended Style
	dwStyle		= WS_POPUP;												// Windows Style

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);			// Adjust Window To True Requested Size

	// Create The Window
	HWND	hwnd = CreateWindowEx(	dwExStyle,							// Extended Style For The Window
									"GenericClass",						// Class Name
									"GenericClass",						// Window Title
									dwStyle |							// Defined Window Style
									WS_CLIPSIBLINGS |					// Required Window Style
									WS_CLIPCHILDREN,					// Required Window Style
									0, 0,								// Window Position
									WindowRect.right-WindowRect.left,	// Calculate Window Width
									WindowRect.bottom-WindowRect.top,	// Calculate Window Height
									HScol,								// No Parent Window
									NULL,								// No Menu
									NULL,								// Instance
									NULL );								// Dont Pass Anything To WM_CREATE

	HDC		hdc = GetDC(hwnd);											// Did We Get A Device Context?
	*/


 
	GtkWidget *frame;
   

	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n000\n");

	if (!(frame = gtk_window_new (GTK_WINDOW_TOPLEVEL)))
	{
	  MMechostr(MSKDEBUG, "\nInitOpenGLfullscreen : could'nt create the window!\n");
	  return MERRMEM;
	}

	ha.title = "scolGL";
        ha.event_mask = GDK_EXPOSURE_MASK | GDK_STRUCTURE_MASK;
	ha.x = 0;  ha.y = 0;
	ha.width = w;  ha.height = h;
        ha.wclass = GDK_INPUT_OUTPUT;
	ha.visual = scolGLX->GetGdkVisual();
	ha.window_type = GDK_WINDOW_CHILD;
	ha.override_redirect = TRUE;

	hwnd = gdk_window_new (HScol, &ha, GDK_WA_X|GDK_WA_Y|GDK_WA_VISUAL|GDK_WA_NOREDIR);



	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n001\n");

	gdk_window_show (hwnd);
	//

	//gtk_widget_show (frame);

	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n002\n");

	frame->window = hwnd;
      

	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n003\n");

	//hwnd = frame->window;

	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n004\n");



	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n005\n");	

	if(wglGetCurrentContext()!=hglrc)
	{

	  //$LBDEBUG
	  MMechostr(MSKDEBUG, "\n006\n");	

		wglMakeCurrent(hwnd, hglrc);
	}

	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n007\n");



	glViewport(0,0,w,h);												// Reset The Current Viewport



	int objSurf = MMmalloc(m,4,TYPEBUF);
	if(!objSurf)		return MERRMEM;
	MMstore(m,objSurf,0,MYWND_FULLSCREEN);
	//$LB MMstore(m,objSurf,1,(int)hdc);
	MMstore(m,objSurf,1,(int)NULL);
	MMstore(m,objSurf,2,(int)hglrc);

	//MMstore(m,objSurf,3,(int)hwnd);
	//$LB : store the GtkWidget, instead of storing the gdkWindow, 'til we reach the _CRfullscreenSurface function...
	MMstore (m, objSurf, 3, (int)frame);

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("InitOpenGLfullScreen ok"); 
      #endif


	return objSurf;
}











#define		TYP_ENGINE_HARDWARE		0
#define		TYP_ENGINE_SOFTWARE		1


//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZGETengineState
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[] I
int _ZGETengineState(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"GETengineState ");
#endif

	if(scolGLX->userACCEL)		MMpush(m, ITOM(TYP_ENGINE_HARDWARE));
	else				MMpush(m, ITOM(TYP_ENGINE_SOFTWARE));
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		RERPUL														
//////////////////////////////////////////////////////////////////////////////////////////////
#define RETPUL(x,y) {	for (int i=0;i<x-1;i++) MMpull(m);		MMset(m,0,y);	return 0;	}








//$LB
/*
typedef struct BitmapInfo2
{
	BITMAPINFO	Bit;
	RGBQUAD		Quad[256];
} BitmapInfo2;


typedef struct LPalette2
{
    WORD			Version ;
    WORD			ColorNum ;
    PALETTEENTRY	Colors[256];
} LPalette;


HBITMAP NewObjBitmap(PtrObjBitmap B, PtrPalette P)
{
	DIBSECTION	Info;
    BitmapInfo2 Bi;
    int			tf, i;

	Bi.Bit.bmiHeader.biSize	  = sizeof( BITMAPINFOHEADER );
	Bi.Bit.bmiHeader.biWidth  = B->TailleW;

    #ifdef USE_DRAWDIB
         Bi.Bit.bmiHeader.biHeight = B->TailleH;
    #else
         Bi.Bit.bmiHeader.biHeight = -B->TailleH;
    #endif

    Bi.Bit.bmiHeader.biPlanes		 = 1;
    Bi.Bit.bmiHeader.biBitCount		 = 16;
    Bi.Bit.bmiHeader.biCompression	 = BI_RGB;
    Bi.Bit.bmiHeader.biSizeImage	 = 0;
    Bi.Bit.bmiHeader.biXPelsPerMeter = 0;
    Bi.Bit.bmiHeader.biYPelsPerMeter = 0;
	Bi.Bit.bmiHeader.biClrUsed = 0;
	tf = DIB_RGB_COLORS;
    Bi.Bit.bmiHeader.biClrImportant	 = Bi.Bit.bmiHeader.biClrUsed;

    B->HBitmap = CreateDIBSection(NULL, (BITMAPINFO*) &Bi, tf, (void**) &B->Bitmap, NULL, 0);

    if(B->HBitmap==NULL)		return NULL;		// BITMAP ERROR WIN32

    i = GetObject(B->HBitmap, sizeof(DIBSECTION), &Info);
	if(!i)		MMechostr(1, "GETOBJECT ERROR Num %d", GetLastError());

	B->Bitmap	 = (short*) Info.dsBm.bmBits;
	B->Bitmap[0] = 0;
    B->BPP = Info.dsBm.bmBitsPixel;
    B->BPL = Info.dsBm.bmWidthBytes;
    if(B->BPL%4 != 0)		B->BPL += 4 - (B->BPL % 4);

    if(Info.dsBmih.biHeight > 0)		B->Flags = BUFFER_FLAG_DOWN; 
	else								B->Flags = 0;

	return B->HBitmap;
}    
*/



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZCRsurface														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[Chn I I] ObjSurface
int _ZCRsurface(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"CRsurface ");
#endif

	if(scolGLX->userACCEL)
	{
		int		h = MTOI( MMpull(m) );
		int		w = MTOI( MMget(m,0) );

		// Si le mode fullscreen n'est pas activ, on cre la surface
		if(scolGLX->fullscreenMode == 0)
		{
			scolGLX->windowedMode++;
			
			GdkWindow*	hwnd;
			int		res = InitOpenGL(m, w, h, &hwnd);

			if(res<0)     RETPUL(2, NIL);

			MMset(m, 0, PTOM(res) );							// empile les donnes sur la surface, avant le ObjCreate

#ifdef	_SCOL_DEBUG_
			MMechostr(0,"ok\n");
#endif
			// Creation de la surface
			return OBJcreate(m, typeSurface, (int)hwnd, -1, -1);				// !!! ObjCreate dpile les donnes jusqu' l'obtention du channel !!!
		}
		// Si le mode fullscreen EST activ, on ne fait rien..
		else
		{
			MMpull(m);
			MMset(m,0,NIL);
#ifdef	_SCOL_DEBUG_
			MMechostr(0,"ok\n");
#endif
			return 0;
		}
	}
	else
	{
	  scolGLX->windowedMode++;
	  int k =  _CRbitmap (m);
#ifdef	_SCOL_DEBUG_
			MMechostr(0,"ok\n");
#endif
			return k;
	  
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZCRfullscreenSurface
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[Chn I I] ObjSurface
int _ZCRfullscreenSurface(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"CRfullscreenSurface ");
#endif
	GtkWidget* frame;
	int		h = MTOI( MMpull(m) );
	int		w = MTOI( MMget(m,0) );


	// Si aucune fentre d'aucune sorte n'a encore t cre, on cre le FullScreen
	if( (scolGLX->windowedMode == 0) && (scolGLX->fullscreenMode==0) && scolGLX->userACCEL)
	{
		scolGLX->fullscreenMode++;

		///////////////////////////////////
		/// CREATION de l'ObjSurface	///
		///////////////////////////////////

		int		res = InitOpenGLfullScreen(m, w, h);

		//$LB : get the GtkWidget created by InitOpenGLfullscreen, and store the gdkwindow instead...
		frame = (GtkWidget*)MMfetch (m, res, 3);
		MMstore (m, res, 3, (int)frame->window);


		if(res<0)     RETPUL(2, NIL);

		MMset(m, 0, PTOM(res) );							// empile les donnes sur la surface, avant le ObjCreate


		// on insere un second canal afin de ne pas perdre cette donne aprs l'OBJcreate
		// --> ETAT DE LA PILE : Chn ObjSurfPtrData
		int		tmp_res, i;
		if((tmp_res=MMpush(m,NIL))<0)		return MERRMEM;
		for(i=0;i<2;i++)		MMset(m,i,MMget(m,i+1));

		// --> ETAT DE LA PILE : Chn Chn ObjSurfPtrData
		OBJcreate(m, typeSurface, 0, -1, -1);		// !!! ObjCreate dpile les donnes jusqu' l'obtention du channel !!!

		// --> ETAT DE LA PILE : Chn ObjSurface
		INVERT(m,0,1);

		// --> ETAT DE LA PILE : ObjSurface Chn


		///////////////////////////////////
		/// CREATION de l'ObjWin		///
		///////////////////////////////////
		ScolWindow win;
		HWND hwnd;


		if (!(win.frame = frame) ||
		    (!(win.child = gtk_fixed_new ())) )
		{
		  MMechostr(MSKFOO, "\n_CRfullscreenSurface : window creation failed!\n");
		  return MERRMEM;
		}

		gtk_widget_add_events (win.child, GDK_BUTTON_RELEASE_MASK|GDK_KEY_RELEASE_MASK);
		gtk_widget_set_usize (win.frame, w, h);
		win.expose_area = (GdkRectangle*) malloc (sizeof(GdkRectangle));

		win.w = w;
		win.h = h;
		win.x = 0;
		win.y = 0;
		win.oldw = w;
		win.oldh = h;
		win.oldx = 0;
		win.oldy = 0;

		win.expose_area->x = 0;
		win.expose_area->y = 0;
		win.expose_area->width = w;
		win.expose_area->height = h;

		hwnd = win.frame->window;

		gtk_object_set_user_data (GTK_OBJECT(win.child), (gpointer)hwnd);

		gtk_signal_connect (GTK_OBJECT(win.child), "destroy", GTK_SIGNAL_FUNC(ObjWinKill), (gpointer)hwnd);
		//gtk_signal_connect (GTK_OBJECT(win.frame), "configure-event", GTK_SIGNAL_FUNC(ObjWinMove), (gpointer)hwnd);
		gtk_signal_connect (GTK_OBJECT(win.frame), "delete-event", GTK_SIGNAL_FUNC(ObjWinDelete), (gpointer)hwnd);
   
		//win.cb_resize_signal_id = gtk_signal_connect (GTK_OBJECT(win.child), "size-allocate", GTK_SIGNAL_FUNC(ObjWinResize), (gpointer)hwnd);

		win.cb_expose_signal_id = gtk_signal_connect (GTK_OBJECT(win.child), "expose-event",	GTK_SIGNAL_FUNC(window_rfl_expose),  (gpointer)hwnd);
		win.cb_draw_signal_id = gtk_signal_connect (GTK_OBJECT(win.child),"draw", GTK_SIGNAL_FUNC(window_rfl_draw), (gpointer)hwnd);

		win.scol_paint_cb = FALSE;
	
		scol_object_create (m, &win, sizeof(ScolWindow), ObjWindowType, (int)hwnd, WN_MENU|WN_MINBOX);



		// --> ETAT DE LA PILE : ObjSurface ObjWin
	    MMpull(m);
		// --> ETAT DE LA PILE : ObjSurface
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	// sinon, on ne fait rien..
	else
	{
		MMpull(m);
		MMset(m,0,NIL);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_GETwindowFromFullscreenSurface
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface] ObjWin
int _ZGETwindowFromFullscreenSurface (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"GETwindowFromFullscreenSurface ");
#endif

	int surf = MMget(m,0);
	if(surf==NIL)		{	MMset(m,0,NIL);		return 0;	}

	int	 mode = MMfetch(m, MTOP(surf), 0);
	GdkWindow* hwnd = (GdkWindow*) MMfetch(m, MTOP(surf), 3);


	//$LBDEBUG
	MMechostr(MSKDEBUG, "\n_GETwinFromFullscreenSurface %d\n", hwnd);

	if(mode==MYWND_WINDOWED || scolGLX->userACCEL==false)
	{
		MMset(m,0,NIL);
	}
	else
	{
	  //$LB TODO TO DO ? : window handler...

		int objwin = MMfetch(m, OBJfindTH(m, ObjWindowType, (int)hwnd), OFFOBJMAG);
		MMset(m,0,objwin);
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_GETsurfaceState
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[] I
int _ZGETsurfaceState(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"GETsurfaceState ");
#endif

	if(scolGLX->fullscreenMode)			MMpush(m, 0);
	else if(scolGLX->windowedMode)		MMpush(m, 2);
	else						MMpush(m, 4);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZDSsurface														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface] I
int _ZDSsurface (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"DSsurface ");
#endif

	if(scolGLX->userACCEL)
	{
		int surf = MMget(m,0);
		if(surf==NIL)		{	MMset(m,0,NIL);		return 0;	}

		OBJdelTM(m,typeSurface,surf);
			
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		MMset(m,0,0);
		return 0;
	}
	else
	{

		int				s;
		//$LB PtrObjVoid		O;
		//$LB PtrObjBitmap	M;

		s = MMget(m, 0);
		if(s==NIL) 
		{
			MMset(m, 0, 0);
			return 0;
		}

		//$LB
		/*
		O = (PtrObjVoid)	MMstart(m, (s>>1)) ;
		M = (PtrObjBitmap)	MMstart(m, (O->Buffer>>1) ) ;  
		
		OBJdelTH(m, ObjBitmapType, (int)M->HBitmap);
		*/
		int handle = (int)MMfetch (m, MMfetch(m, s>>1, OFFOBJMAG)>>1, OBJDD_HANDLE)>>1;
		
		OBJdelTH(m, ObjBitmapType, handle);

		scolGLX->windowedMode--;
     
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		MMset(m,0,0) ;
		return 0 ;
	 
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZooDestroySurface														
//////////////////////////////////////////////////////////////////////////////////////////////
// fonction d'appel lors de la destruction interne d'une surface (dclare dans le ObjCreate)
int ZooDestroySurface(mmachine m, int q, int p)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ZooDestroySurface ");
#endif

	//$LB HDC		hdc;
	HGLRC	rc;
	GdkWindow*	hwnd;

	p >>= 1;

	int mode = MMfetch(m, p, 0);
	//$LB hdc		 = (HDC)	MMfetch(m, p, 1);
	rc		 = (HGLRC)	MMfetch(m, p, 2);
	hwnd	 = (GdkWindow*)	MMfetch(m, p, 3);

	if(!rc && /*$LB !hdc &&*/ !hwnd)		return 0;

	MMechostr(1, "\n------ Starting destroy of surface..\n" );

	if(mode == MYWND_WINDOWED)
	{

		scolGLX->windowedMode--;


		if(rc)
		{





			if(wglMakeCurrentNULL()==FALSE)		MMechostr(1, "------ Can't set the current rendering context to NULL ! ------\n" );



	 

			//$LB if(wglDeleteContext(rc)==FALSE)				MMechostr(1, "------ Can't delete rendering context ! ------\n" );
			wglDeleteContext(rc);

	 


		}


	


		//$LB
		/*
		if(hdc)
		{
			if(ReleaseDC(hwnd, hdc)==0)					MMechostr(1, "------ Can't release device context ! ------\n" );
		}
		*/

		//$LB
		/*
		if(SetParent(hwnd, HScol)==NULL)				MMechostr(1, "------ Can't set the window parent ! ------\n" );
		if(DestroyWindow(hwnd)==0)						MMechostr(1, "------ Can't destroy the window ! ------\n" );
		*/
		SetParent(hwnd, HScol);






		DestroyWindow(hwnd);





	}
	else
	{
		scolGLX->fullscreenMode = 0;


		//$LB ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		XF86VidModeSwitchToMode(scolX->dpy, scolX->screen, scolGLX->GetDeskModePtr()); 	// If So Switch Back To The Desktop
                XF86VidModeSetViewPort(scolX->dpy, scolX->screen, 0, 0);
		
		if(rc)
		{
			if(wglMakeCurrentNULL()==FALSE)		MMechostr(1, "------ Can't set the current rendering context to NULL ! ------\n" );
			//$LBif(wglDeleteContext(rc)==FALSE)				MMechostr(1, "------ Can't delete rendering context ! ------\n" );
			wglDeleteContext(rc);
		}

		//$LB
		/*
		if(hdc)
		{
			if(ReleaseDC(hwnd, hdc)==0)					MMechostr(1, "------ Can't release device context ! ------\n" );
		}
		*/
		
		//$LB if(SetParent(hwnd, HScol)==NULL)				MMechostr(1, "------ Can't set the window parent ! ------\n" );
		SetParent(hwnd, HScol);
		
		// Destruction de l'ObjWin
		//$LB TODO TO DO : window handler...
		OBJdelTH(m, ObjWindowType, (int)hwnd);
	}






	if(wglMakeCurrent(scolGLX->mainhwnd, scolGLX->mainglrc)==FALSE)		MMechostr(1, "------ Can't set the current rendering context to MAINcontext ! ------\n" );






	MMechostr(1, "------ .. surface destroyed\n\n" );

	MMstore(m, p, 1, NIL);
	MMstore(m, p, 2, NIL);
	MMstore(m, p, 3, NIL);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZFILLsurface														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface I] ObjSurface
int _ZFILLsurface (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"FILLsurface ");
#endif

	if(scolGLX->userACCEL)
	{
	  //$LB 
	  //HDC		dc;
	  GdkWindow* hwnd;

		HGLRC	rc;
		
		

		int color	= MTOI( MMpull(m) );
		int surf	= MTOP( MMget(m,0) );
		
		if(surf==NIL)		return 0;

		//$LB 
		//dc = (HDC)	 MMfetch(m,surf,1);
		hwnd = (GdkWindow*) MMfetch(m, surf, 3); 

		rc = (HGLRC) MMfetch(m,surf,2);
		
		
		
		if(!rc /* $LB || !dc*/)		return 0;

		if(wglGetCurrentContext()!=rc)
		{
			wglMakeCurrent(hwnd, rc);
		}

		glDrawBuffer(GL_BACK);

		float r= (float)((color)    &255) / CONST_COLOR;
		float g= (float)((color>>8) &255) / CONST_COLOR;
		float b= (float)((color>>16)&255) / CONST_COLOR;

		glClearColor(r, g, b, 0);
		glClear(GL_COLOR_BUFFER_BIT);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{

	  int k = _FILLbitmap(m);


#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
        return k;

	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZGetsurfaceSize
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface] [I I]
int _ZGETsurfaceSize (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"GETsurfaceSize ");
#endif

	if(scolGLX->userACCEL)
	{
		HWND	hwnd;
		//$LB RECT	rect;
		int w,h;

		int surf = MTOP(MMpull(m));
		if(surf==NIL)		return MMpush(m,NIL);


		//$LB
		//SetGL2D(m, surf, NULL, &hwnd)
		SetGL2D(m, surf, &hwnd, NULL);
		//$LB GetClientRect(hwnd, &rect);
		gdk_window_get_size(hwnd, &w, &h);

		//$LB
		/*
		if(MMpush(m, ITOM(rect.right)))			return MERRMEM;
		if(MMpush(m, ITOM(rect.bottom)))		return MERRMEM;
		*/
		if(MMpush(m, ITOM(h)))			return MERRMEM;
		if(MMpush(m, ITOM(w)))		return MERRMEM;

		if(MMpush(m, 2*2))					return MERRMEM;
  
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return MBdeftab(m);
	}
	else
	{

	  //$LB PtrObjVoid O ;
		PtrObjBitmap B ;
		int s , h , w ; 

		s = MMpull ( m ) ;     
		if ( s == NIL )
		{
			MMechostr ( 1 , "GetBitmapWSize : Bitmap object is NIL\n" ) ;
			w = -1 ; 
			h = -1 ;
		} 
		else
		{
		  //$LB O = ( PtrObjVoid ) MMstart(m,(s>>1) ) ;    
		  //$LB B = ( PtrObjBitmap ) MMstart(m, (O->Buffer>>1) ) ;
		  B = (PtrObjBitmap) objdd_get_buffer (m,MTOP(s));
		  w = OBJBITMAP_GET_W(B) << 1 ;
		  h = OBJBITMAP_GET_H(B) << 1 ;
		}

		if ( MMpush(m,w )) return MERRMEM ;
		if ( MMpush(m,h )) return MERRMEM ;
		if ( MMpush(m,4 )) return MERRMEM ;
		s = MBdeftab ( m ) ;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return s ;
	
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZBLTsurface
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [ObjWin I I ObjSurface I I I I] ObjWin
int _ZBLTsurface (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"BLTsurface ");
#endif

	if(scolGLX->userACCEL)
	{
		int		surf, ox, oy, x, y, w, h, win;
		HWND	hwnd, parent;
		//$LB HDC		hdc;
		HGLRC	hglrc;

		//$LB PtrObjVoid		OB;
		PtrObjWindow	W;

		h	 = MTOI( MMpull(m) );
		w	 = MTOI( MMpull(m) );
		oy	 = MTOI( MMpull(m) );
		ox	 = MTOI( MMpull(m) );
		surf = MTOP( MMpull(m) );
		y	 = MTOI( MMpull(m) );
		x	 = MTOI( MMpull(m) );
		win	 = MTOP( MMget(m,0) );

		if(win==NIL || surf==NIL)		{	MMset(m,0,NIL);		return 0;	}

		int	 mode = MMfetch(m, surf, 0);
		if(mode == MYWND_FULLSCREEN)	{	MMset(m,0,NIL);		return 0;	}

		// Rcupration de la wnd OpenGL
		//$LB hdc		= (HDC)		MMfetch(m, surf, 1);
		hglrc	= (HGLRC)	MMfetch(m, surf, 2);
		hwnd	= (HWND)	MMfetch(m, surf, 3);

		// Rcupration de la wnd SCOL
		//$LB 
		/*
		OB		= (PtrObjVoid)		MMstart(m, win);
		W		= (PtrObjWindow)	MMstart(m, OB->Buffer>>1);
		parent	= (HWND)			W->WHandler;
		*/
		//
		W = (PtrObjWindow) objdd_get_buffer (m, win);
		parent	= (HWND) OBJWIN_GET_WIN(W);
		//

		// Modifications des paramtres
		if(GetParent(hwnd)!=parent)
		{
			SetParent(hwnd, parent);
			//$LB ShowWindow(hwnd, SW_SHOWNORMAL);
			gdk_window_show (hwnd);
		}
		MoveWindow(hwnd, x, y, w, h, true);

		if(wglGetCurrentContext()!=hglrc)
		{
			wglMakeCurrent(hwnd,hglrc);
		}

		SwapBuffers(hwnd);

		//$LB TODO TO DO
		// changement de curseur - rcupration du curseur de la wnd SCOL et attribution  la wnd d'OpenGL
		/*
		POINT	curseurPos;
		GetCursorPos(&curseurPos);
		if( hwnd == WindowFromPoint(curseurPos) )
		{
			if(W->Cursor != (HCURSOR)GetClassLong(hwnd, GCL_HCURSOR) )
			{
				if(W->Cursor==0)		SetClassLong(hwnd, GCL_HCURSOR, (long)LoadCursor(NULL,IDC_ARROW) ) ;
				else					SetClassLong(hwnd, GCL_HCURSOR, (long)W->Cursor ) ;
			}
		}
		*/

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{

		int				surf, ox, oy, x, y, w, h, win;
		//$LB PtrObjVoid		OS, OD;
		PtrObjBitmap	B;
		PtrObjWindow	W;
		

		h	 = MTOI( MMpull(m) );
		w	 = MTOI( MMpull(m) );
		oy	 = MTOI( MMpull(m) );
		ox	 = MTOI( MMpull(m) );
		surf = MMpull(m);
		y	 = MTOI( MMpull(m) );
		x	 = MTOI( MMpull(m) );
		win	 = MMpull(m);

		if( surf==NIL || win==NIL )		return MMpush(m,win);

		//$LB
		/*
		OS = (PtrObjVoid)	MMstart(m, MTOP(surf));
		OD = (PtrObjVoid)	MMstart(m, MTOP(win));
		B  = (PtrObjBitmap) MMstart(m, MTOP(OS->Buffer));
		W  = (PtrObjWindow) MMstart(m, MTOP(OD->Buffer));
		*/
		B = (PtrObjBitmap) objdd_get_buffer (m, MTOP(surf));
		W = (PtrObjWindow) objdd_get_buffer (m, MTOP(win));
		
		
	        gdk_draw_image (W->child->window, W->child->style->black_gc, OBJBITMAP_GET_IMAGE(B), ox, oy, x, y, w, h);

		

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return MMpush(m,win);
		

	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZBLTsurfaceFullScreen														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [ObjSurface] ObjWin
int _ZBLTsurfaceFullScreen (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"BLTsurfaceFullscreen ");
#endif
	int		surf;
	HWND	hwnd;
	//$LB HDC		hdc;
	HGLRC	hglrc;

	surf = MTOP( MMget(m,0) );

	if(surf==NIL)			{	MMset(m,0,NIL);		return 0;	}


	int	 mode = MMfetch(m, surf, 0);
	if(mode == MYWND_WINDOWED)
	{
		MMset(m,0,NIL);
		return 0;
	}

	// Rcupration de la wnd OpenGL
	//$LB hdc		= (HDC)		MMfetch(m, surf, 1);
	hglrc	= (HGLRC)	MMfetch(m, surf, 2);
	hwnd	= (HWND)	MMfetch(m, surf, 3);

	//$LB
	if(hwnd!=NULL)		SwapBuffers(hwnd);

	//$LB TODO TO DO window handler
	int objwin = MMfetch(m, OBJfindTH(m, ObjWindowType, (int)hwnd), OFFOBJMAG);
	MMset(m,0,objwin);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}





//////////////////////////////////////
//////////////////////////////////////
////
////		MANISSE World....
////
//////////////////////////////////////
//////////////////////////////////////
//$LB 
/*
void GetBitmapPalette ( PtrObjBitmap B , PtrPalette P )
{
    RGBQUAD Pal [ 256 ] ;
    HDC dc ;
    int i ;
    HBITMAP OldBitmap ;

    dc = CreateCompatibleDC ( NULL ) ;
    OldBitmap = (HBITMAP) SelectObject ( dc , B->HBitmap ) ;
    i = GetDIBColorTable ( dc , 0 , 256 , Pal ) ;
    SelectObject ( dc , OldBitmap ) ;
    DeleteDC ( dc ) ;

    for ( i = 0 ; i < 256 ; i ++ )
    {
        GET_RED(P,i) = Pal[i].rgbRed ;
        GET_GREEN(P,i) = Pal[i].rgbGreen ;
        GET_BLUE(P,i) = Pal[i].rgbBlue ;
    
    }
}
*/




/*
int ClipBlit ( int dtaillew , int dtailleh , int staillew , int stailleh ,
                int *dposx , int *dposy , int *sposx , int *sposy , int *taillew , int *tailleh ) 
{       

  // step 1 verification de dposx 
    if ( *dposx < 0 )
    {
        *sposx -= *dposx ;
        *taillew += *dposx ;
        *dposx = 0 ;
    } else if ( *dposx >= dtaillew ) return 0 ;
   

    // step 2 verification de dposy 
    if ( *dposy < 0 )
    {
        *sposy -= *dposy ;
        *tailleh += *dposy ;
        *dposy = 0 ;
    } else if ( *dposy >= dtailleh ) return 0 ;

    // step 3 verification de sposx 
    if ( *sposx < 0 )
    {
        *taillew += *sposx ;
        *dposx -= *sposx;
        *sposx = 0 ;
       
    } else if ( *sposx >= staillew ) return 0 ;

    // step 4 verification de sposy 
    if ( *sposy < 0 )
    {
        *tailleh  += *sposy ;
        *dposy -= *sposy;
        *sposy = 0 ;
    } else if ( *sposy >= stailleh ) return 0 ;

    // step 4 verification de taillew 
    if ( *taillew < 0 ) return 0 ;
    if ( *taillew + *sposx >= staillew )
    {   
         *taillew -=  ( *taillew + *sposx ) - staillew ;     
         if ( * taillew < 0 ) return 0 ;
    }
    if ( *taillew + *dposx >= dtaillew )
    {
        *taillew -= ( *taillew + *dposx ) - dtaillew ;
        if ( * taillew  < 0 ) return 0 ;
    }

    // step 5 verification de tailleh 
    if ( *tailleh < 0 ) return 0 ;
    if ( *tailleh + *sposy >= stailleh )
    {
        *tailleh -= ( *tailleh + *sposy ) - stailleh ;
        if ( *tailleh < 0 ) return 0 ;
    }
    if ( *tailleh + *dposy >= dtailleh ) 
    {
        *tailleh -= ( *tailleh + *dposy ) -dtailleh ;
        if ( *tailleh < 0 ) return 0 ;
    }

    return 1 ;    
}
*/


//$LB
/*
int GRCopyBitmap ( mmachine m )
{
    int s , s2 , res , couleur , taillew , tailleh , sposx , sposy , dposx , dposy ;
    PtrObjVoid OS , OD ;       
    PtrObjBitmap BD,BS ;        
    int i , dcx , dcy , scx , scy ;
    register unsigned char * BufS , * BufD ;       
    register j ;
    struct Palette Pal ;       

    couleur = MMpull(m) >> 1 ;        
    tailleh = MMpull(m) >> 1 ;
    taillew = MMpull(m)>> 1 ;
    sposy = MMpull(m) >> 1 ;
    sposx = MMpull(m) >> 1 ;
    s2 = MMpull(m) ;
    dposy = MMpull(m) >> 1;
    dposx = MMpull(m) >> 1 ;
    s = MMpull(m) ;
    if ( s2 == NIL )
    {
        MMechostr ( 1 , "PaintBuffer : Buffer object is NIL\n" ) ;
        return MMpush(m,s) ;
    }
    OS = ( PtrObjVoid ) MMstart(m, (s2>>1) ) ;        
    if ( s == NIL )
    {
        MMechostr ( 1 , "PaintBuffer : Window object is NIL\n" ) ;
        return MMpush(m,s) ;
    }
    OD = ( PtrObjVoid ) MMstart(m, (s>>1) ) ;
    
    BS = ( PtrObjBitmap ) MMstart(m, (OS->Buffer>>1) ) ;
    BD = ( PtrObjBitmap ) MMstart(m, (OD->Buffer>>1) ) ;

	if (BS->Bitmap==NULL)
	{
		if (OS->Tab==NIL) MMechostr(MSKDEBUG,"bitmap is _CRbitmap\n");
	      else  MMechostr(MSKDEBUG,"bitmap is _LDbitmap : %s\n",MMstartstr(m,OS->Tab>>1));

		MMechostr(MSKTRACE,"COPYbitmap : Source Bitmap already destroyed %x\n",BS->HBitmap);
		return MMpush(m,NIL);
	}
	if (BD->Bitmap==NULL)
	{
		MMechostr(MSKTRACE,"COPYbitmap : Dest Bitmap already destroyed %x\n",BD->HBitmap);
		return MMpush(m,NIL);
	}

	// calcule le rectangle final = proc de clipping 
    if ( ClipBlit ( BD->TailleW , BD->TailleH , BS->TailleW , BS->TailleH ,
            &dposx , &dposy , &sposx , &sposy , &taillew , &tailleh ) )
    {      
     
        if (( BD->BPP == 8 ) && ( BS->BPP == 8 ))
        {
            BufS = ( unsigned char * ) BS->Bitmap ;
            BufD = ( unsigned char * ) BD->Bitmap ;

            dcy = dposy * BD->BPL + dposx ;
            scy = sposy * BS->BPL + sposx ;
            if ( couleur == NIL )  for ( j = 0 ; j < tailleh ; j ++ )
            {                     
               
                CopyMemory(BufD + dcy , BufS + scy , taillew ) ;
                dcy += BD->BPL ; scy += BS->BPL ;
            } else
            for ( j = 0 ; j < tailleh ; j ++ )
            {                     
                dcx = dcy  ;
                scx = scy ;
                for ( i = 0 ; i < taillew ; i ++ )
                {             
                    if ( BufS [scx ] != couleur ) BufD [ dcx ] = BufS [ scx ] ;
                    dcx ++ ;
                    scx ++ ;
                }
                dcy += BD->BPL ;
                scy += BS->BPL ;
            }
        } else if (( BD->BPP == 16 ) && ( BS->BPP == 8 ))
        {
            BufS = ( unsigned char * ) BS->Bitmap ;
            dcy = dposy * ( BD->BPL >> 1 ) + dposx ;
            scy = sposy * BS->BPL + sposx ;
            GetBitmapPalette ( BS , & Pal ) ;
            
            for ( j = 0 ; j < tailleh ; j ++ )
            {
                dcx = dcy ;
                scx = scy ;
                for ( i = 0 ; i < taillew ; i ++)
                {
                    if ( BufS [ scx ] != couleur )
                    BD->Bitmap [ dcx ] =  ( GET_BLUE(&Pal,BufS [ scx ])>>3)  + 
                        ( (GET_GREEN ( &Pal,BufS[ scx ]) >>3)<< 5 )    + 
                        ( (GET_RED ( &Pal , BufS [ scx ]) >>3) << 10 ) ;
                    dcx ++ ;
                    scx ++ ;
                }
                dcy += BD->BPL>>1 ;
                scy += BS->BPL ;
            }
        } else if (( BD->BPP == 16 ) && ( BS->BPP == 16 ))
        {
            dcy = dposy * ( BD->BPL >> 1 ) + dposx ;
            scy = sposy * ( BS->BPL >> 1 ) + sposx ;                           
            if ( couleur == NIL ) 
            {            
                BufS = (( unsigned char * ) BS->Bitmap ) + ( scy << 1 ) ;
                BufD = (( unsigned char * ) BD->Bitmap ) + ( dcy << 1 ) ;
                taillew <<= 1 ;
                for ( j = 0 ; j < tailleh ; j ++ )
                {                 
                    memcpy( BufD,BufS,taillew) ;                   
                    BufD += BD->BPL ;
                    BufS += BS->BPL ;
                }
            }
            else 
            {
                couleur = Color24To16(couleur); 
                for ( j = 0 ; j < tailleh ; j ++ )
                {
                    dcx = dcy ;
                    scx = scy ;
                    for ( i = 0 ; i < taillew ; i ++ , dcx ++ , scx ++ )
                    if ( BS->Bitmap [ scx ] != couleur ) BD->Bitmap [ dcx ] = BS->Bitmap [ scx ] ;                               
                    dcy += BD->BPL >> 1 ;
                    scy += BS->BPL >> 1 ;
                }
            }
        }
    }
                               
    res = MMpush(m,s) ;

    return res ;
}
*/





//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZBitmap2Surface														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface I I ObjBitmap I I I I I] ObjSurface
int _ZBitmap2Surface (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"Bitmap2Surface ");
#endif

	if(scolGLX->userACCEL)
	{
		unsigned char	*buffer;
		unsigned char	r,g,b;

		int		c, couleur, coulBase;
		//$LB RECT	rect;
		HWND	hwnd;
		int hwndW, hwndH;
		int		x, y, bw, offset, yoffset, Y;
		int		sh, sw, sy, sx, bitmap, dy, dx, surf;

		coulBase = couleur = MMpull(m)>>1;
		//$LB
		if (couleur != NIL)
		  coulBase = couleur = UTILS_BGR_2_RGB(couleur);

	       
		sh = MMpull(m)>>1;
		sw = MMpull(m)>>1;
		sy = MMpull(m)>>1;
		sx = MMpull(m)>>1;
		bitmap = MMpull(m)>>1;
		dy = MMpull(m)>>1;
		dx = MMpull(m)>>1;
		surf = MMget(m,0)>>1;

		if(surf==NIL || bitmap==NIL || sx==NIL || sy==NIL || dx==NIL || dy==NIL || sh==NIL || sw==NIL)	return 0;

		//$LB
		/*
		PtrObjVoid		OB = (PtrObjVoid)	MMstart(m, bitmap);
		PtrObjBitmap	B  = (PtrObjBitmap)	MMstart(m, OB->Buffer>>1);
		*/
		PtrObjBitmap B = (PtrObjBitmap) objdd_get_buffer (m, bitmap);

		//$LB
		/*
		SetGL2D(m, surf, NULL, &hwnd);
		GetClientRect(hwnd, &rect);
		*/
		SetGL2D(m, surf, &hwnd, NULL);
		gdk_window_get_size (hwnd, &hwndW, &hwndH);

		//$LB
		/*
		if(dx>rect.right)		return 0;
		if(dy>rect.bottom-1)	return 0;
		*/
		if (dx > hwndW) return 0;
		if (dy > hwndH-1) return 0;

		if(dx<0)				{	sx+=dx; dx=0; }
		if(dy<0)				{	sy+=dy; dy=0; }

		//$LB
		/*
		if(dx+sw>rect.right)		sw = rect.right-dx;
		if(dy+sh>rect.bottom-1)		sh = rect.bottom-1-dy;
		*/
		if (dx+sw > hwndW) sw = hwndW - dx;
		if (dy+sh > hwndH-1) sh = hwndH-1 - dy;

		//$LB if(B->BPP!=16)			return 0;

		if(sx<0)				{	sw+=sx; sx=0; }
		if(sy<0)				{	sh+=sy; sy=0; }
		//$LB
		/*
		if(sx+sw>B->TailleW)		sw = B->TailleW-sx;
		if(sy+sh>B->TailleH)		sh = B->TailleH-sy;
		*/
		if (sx+sw > OBJBITMAP_GET_W(B)) sw = OBJBITMAP_GET_W(B) - sx;
		if (sy+sh > OBJBITMAP_GET_H(B)) sw = OBJBITMAP_GET_H(B) - sy;

		if(sw<=0)				return 0;
		if(sh<=0)				return 0;

		buffer = (unsigned char*) malloc(sizeof(char)*sw*sh*4);
		if(!buffer)				return 0;

		//$LB bw = B->BPL/2;
		bw = OBJBITMAP_GET_BPL(B) >>2;
		offset = sx + sy*bw;

		//$LB
		/*
		r = (couleur>>3) &31;
		g = (couleur>>11)&31;
		b = (couleur>>19)&31;
		couleur = b+(g<<5)+(r<<10);
		*/
		r = (couleur>>16) && 0xFF;
		g = (couleur>>8) && 0xFF;
		b = (couleur) && 0xFF;

		yoffset=0;
		for(y=0; y<sh; y++)
		{
		  //$LB TODO TO DO ? * 4?
			Y = (sh-y-1)*sw*4;
			for(x=0; x<sw; x++)
			{
			  //$LB c = ((unsigned short*)B->Bitmap)[offset + x + yoffset];
			  c = (int)((guint32*)OBJBITMAP_GET_MEM(B))[offset + x + yoffset];

			        //$LB
			        /*
				r =  (c&31)<<3;
				g = ((c>>5)&31)<<3;
				b = ((c>>10)&31)<<3;
				*/
			        b = c & 0xFF;
			        g = (c>>8) & 0xFF;
			        r = (c>>16) & 0xFF;

				//$LB TODO TO DO ? RGBA ?
				buffer[Y+0] = r;
				buffer[Y+1] = g;
				buffer[Y+2] = b;

				if(couleur==c)		buffer[Y+3] = 0;
				else				buffer[Y+3] = 255;
				Y+=4;
			}
			yoffset+=bw;
		}

		glPixelStorei(GL_PACK_LSB_FIRST,	GL_FALSE);
		glPixelStorei(GL_UNPACK_LSB_FIRST,	GL_FALSE);
		glRasterPos2i(dx, dy+sh);

		if(coulBase!=NIL)
		{
			glEnable(GL_ALPHA_TEST);
			glDisable(GL_BLEND);
			glAlphaFunc(GL_EQUAL,1);
		}
		glDrawPixels(sw, sh, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
		if(coulBase!=NIL)		glDisable(GL_ALPHA_TEST);

		free(buffer);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{
	 
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return _CPbitmap16(m);
	
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZSurface2Bitmap														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjBitmap I I ObjSurface I I I I I] ObjBitmap
int _ZSurface2Bitmap (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"Surface2Bitmap ");
#endif

	if(scolGLX->userACCEL)
	{
		unsigned char	*buffer;
		unsigned char	r, g, b;

		int 	couleur = MMpull(m)>>1;
		//$LB RECT	rect;
		HWND	hwnd;
		//$LB
		int hwndW, hwndH;
		int		x, y, c, bw, offset, yoffset, Y;
		int		sh = MMpull(m)>>1,
				sw = MMpull(m)>>1,
				sy = MMpull(m)>>1,
				sx = MMpull(m)>>1,
				surf = MMpull(m)>>1,
				dy = MMpull(m)>>1,
				dx = MMpull(m)>>1,
				bitmap = MMget(m,0)>>1;

		if(surf==NIL || bitmap==NIL || sx==NIL || sy==NIL || dx==NIL || dy==NIL || sh==NIL || sw==NIL)	    return 0;

		//$LB
		if (couleur != NIL) couleur = UTILS_BGR_2_RGB(couleur);


		//$LB
		/*
		PtrObjVoid		OB = (PtrObjVoid)   MMstart(m, bitmap);
		PtrObjBitmap	B  = (PtrObjBitmap) MMstart(m, OB->Buffer>>1);
		*/
		PtrObjBitmap B = (PtrObjBitmap) objdd_get_buffer (m, bitmap);




		//$LB
		/*
		if(dx>B->TailleW)		return 0;
		if(dy>B->TailleH)		return 0;
		*/
		if (dx > OBJBITMAP_GET_W(B)) return 0;
		if (dy > OBJBITMAP_GET_H(B)) return 0;

		if(dx<0)			{	sx+=dx; dx=0; }
		if(dy<0)			{	sy+=dy; dy=0; }

		//$LB if(B->BPP!=16)			return 0;

		//$LB
		/*
		if(dx+sw>B->TailleW)	sw = B->TailleW-dx;
		if(dy+sh>B->TailleH)	sh = B->TailleH-dy;
		*/
		if (dx+sw > OBJBITMAP_GET_W(B))  sw = OBJBITMAP_GET_W(B) - dx;
		if (dy+sh > OBJBITMAP_GET_H(B)) sh = OBJBITMAP_GET_H(B) - dy;

		//$LB
		/*
		SetGL2D(m, surf, NULL, &hwnd);
		GetClientRect(hwnd, &rect);
		*/
		SetGL2D(m, surf, &hwnd, NULL);
		gdk_window_get_size (hwnd, &hwndW, &hwndH);

		if(sx<0)			{	sw+=sx; sx=0; }
		if(sy<0)			{	sh+=sy; sy=0; }

		//$LB
		/*
		if(sx+sw>rect.right)	sw = rect.right-sx;
		if(sy+sh>rect.bottom-1)	sh = rect.bottom-1-sy;
		*/
		if (sx+sw > hwndW) sw = hwndW - sx;
		if (sy+sh > hwndH-1) sh = hwndH-1 - sy;

		if(sw<=0)				return 0;
		if(sh<=0)				return 0;

		buffer = (unsigned char*) malloc(sizeof(char)*sw*sh*3);
		if(!buffer)				return 0;

		glPixelStorei(GL_PACK_LSB_FIRST,	GL_FALSE);
		glPixelStorei(GL_UNPACK_LSB_FIRST,	GL_FALSE);
		glReadPixels(sx, sy, sw, sh, GL_RGB, GL_UNSIGNED_BYTE, buffer);

		//$LB bw = B->BPL/2;
		bw = OBJBITMAP_GET_BPL(B) >>2;
		offset = sx + sy*bw;

		if(couleur!=NIL)		// couleur de transparence
		{
		        //$LB
		        /*
			r = (couleur>>3)&31;
			g = (couleur>>11)&31;
			b = (couleur>>19)&31;
			*/
		        r = (couleur>>16) & 0xFF;
			g = (couleur>>8) & 0xFF;
			b = (couleur) & 0xFF;

			//$LB ???? couleur = b+(g<<5)+(r<<10);
			offset = dx + dy*bw;

			yoffset = 0;
			for(y=0; y<sh; y++)
			{
			  //$LB TODO TO DO ? * 3??
				Y = (sh-y-1)*sw*3;
				for(x=0; x<sw; x++)
				{
				  //$LB TODO TO DO ? RGBA ?
				        /*
					b = buffer[Y+0];
					g = buffer[Y+1];
					r = buffer[Y+2];
					*/
				        r = buffer[Y+0];
				        g = buffer[Y+1];
				        b = buffer[Y+2];

					//$LB c = (r>>3) + ((g>>3)<<5) + ((b>>3)<<10);
					c = r<<16 | g<<8 | b;

					//$LB if(couleur!=c)        ((unsigned short*)B->Bitmap)[offset + x + yoffset] = c;
					if (couleur != c) ((guint32*)OBJBITMAP_GET_MEM(B)) [offset + x + yoffset] = c;

					Y+=3;
				}
				yoffset+=bw;
			}
		}
		else					// pas de transparence : copie intgrale
		{
			offset = dx + dy*bw;
			yoffset = 0;
			for(y=0; y<sh; y++)
			{
				Y = (sh-y-1)*sw*3;
				for(x=0; x<sw; x++)
				{
				        //$LB
				        /*
					b = buffer[Y+0];
					g = buffer[Y+1];
					r = buffer[Y+2];
					c = (r>>3) + ((g>>3)<<5) + ((b>>3)<<10);
					((unsigned short*)B->Bitmap)[offset + x + yoffset] = c;
					*/
				        r = buffer[Y+0];
				        g = buffer[Y+1];
				        b = buffer[Y+2];
				        c = r<<16 | g<<8 | b;
				        ((guint32*)OBJBITMAP_GET_MEM(B)) [offset + x + yoffset] = c;

					Y+=3;
				}
				yoffset+=bw;
			}
		}

		free(buffer);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{
	  
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return _CPbitmap16(m);

	
	 
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_ZSurface2Surface														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface I I ObjSurface I I I I I] ObjSurface
int _ZSurface2Surface (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"surface2surface ");
#endif
	if(scolGLX->userACCEL)
	{
		unsigned char	*buffer;
		
		int		couleur = MMpull(m)>>1;
		//$LB RECT	rectS, rectD; 
		HWND	hwndS, hwndD;
		int hwndSW, hwndSH, hwndDW, hwndDH;
		
		int		i, c;
		int		sh = MMpull(m)>>1,
				sw = MMpull(m)>>1,
				sy = MMpull(m)>>1,
				sx = MMpull(m)>>1,
				surfS = MMpull(m)>>1,
				dy = MMpull(m)>>1,
				dx = MMpull(m)>>1,
				surfD = MMget(m,0)>>1;

		if(surfS==NIL || surfD==NIL || sx==NIL || sy==NIL || dx==NIL || dy==NIL || sh==NIL || sw==NIL)    return 0;

		//$LB
		if (couleur != NIL) UTILS_BGR_2_RGB(couleur);

		//$LB
		/*
		SetGL2D(m, surfD, NULL, &hwndD);
		SetGL2D(m, surfS, NULL, &hwndS);
		*/
		SetGL2D (m, surfD, &hwndD, NULL);
		SetGL2D (m, surfS, &hwndS, NULL);

		//$LB
		/*
		GetClientRect(hwndS, &rectS);
		GetClientRect(hwndD, &rectD);
		*/
		gdk_window_get_size(hwndS, &hwndSW, &hwndSH);
		gdk_window_get_size(hwndD, &hwndDW, &hwndDH);


		//$LB
		/*
		if(dx>rectD.right)			return 0;
		if(dy>rectD.bottom)			return 0;
		*/
		if(dx > hwndDW)			return 0;
		if(dy > hwndDH)			return 0;

		if(dx<0)				{	sx+=dx; dx=0;	}
		if(dy<0)				{	sy+=dy; dy=0;	}

		//$LB
		/*
		if(dx+sw>rectD.right)		sw = rectD.right-dx;
		if(dy+sh>rectD.bottom)		sh = rectD.bottom-dy;
		*/
		if(dx+sw > hwndDW)		sw = hwndDW-dx;
		if(dy+sh > hwndDH)		sh = hwndDH-dy;

		if(sx<0)				{	sw+=sx; sx=0;	}
		if(sy<0)				{	sh+=sy; sy=0;	}

		//$LB
		/*
		if(sx+sw>rectS.right)		sw = rectS.right-sx;
		if(sy+sh>rectS.bottom)		sh = rectS.bottom-sy;
		*/
		if(sx+sw > hwndSW)		sw = hwndSW-sx;
		if(sy+sh > hwndSH)		sh = hwndSH-sy;

		if(sw<=0)					return 0;
		if(sh<=0)					return 0;

		
		//$LB SetGL2D(m, surfS, NULL, &hwndS);
		SetGL2D(m, surfS, &hwndS, NULL);

		glPixelStorei(GL_PACK_LSB_FIRST,	GL_FALSE);
		glPixelStorei(GL_UNPACK_LSB_FIRST,	GL_FALSE);

		if(couleur==NIL)
		{
			buffer = (unsigned char*) malloc(sizeof(char)*sw*sh*4);
			if(!buffer)		return 0;

			//$LB glReadPixels(sx, rectS.bottom-sh-sy, sw, sh, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
			glReadPixels(sx, hwndSH-sh-sy, sw, sh, GL_RGBA, GL_UNSIGNED_BYTE, buffer);

			//$LB SetGL2D(m, surfD, NULL, &hwndD);
			SetGL2D (m, surfD, &hwndD, NULL);

			glRasterPos2i(dx, dy+sh);
			glDrawPixels(sw, sh, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
		}
		else
		{
		        //$LB
		        /*
			int rr = (couleur>>3)&31;
			int gg = (couleur>>11)&31;
			int bb = (couleur>>19)&31;
			couleur = bb+(gg<<5)+(rr<<10);
			*/

			buffer = (unsigned char*) malloc(sizeof(char)*sw*sh*4);
			if(!buffer)		return 0;

			//$LB glReadPixels(sx, rectS.bottom-sh-sy, sw, sh, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
			glReadPixels(sx, hwndSH-sh-sy, sw, sh, GL_RGBA, GL_UNSIGNED_BYTE, buffer);

			glEnable(GL_ALPHA_TEST);
			glAlphaFunc(GL_EQUAL,0);
			for(i=0; i<sw*sh; i++)
			{
			        //$LB TODO TO DO ?
			        //$LB c = (buffer[i*4]>>3) + ((buffer[i*4+1]>>3)<<5) + ((buffer[i*4+2]>>3)<<10);
			        c = (buffer[i*4]<<16) | ((buffer[i*4+1])<<8) | ((buffer[i*4+2]));
				if (c==couleur)		buffer[i*4+3]=255;
				else				buffer[i*4+3]=0;
			}

			//$LB SetGL2D(m, surfD, NULL, &hwndD);
			SetGL2D(m, surfD, &hwndD, NULL);

			glRasterPos2i(dx, dy+sh);
			glDrawPixels(sw, sh, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
			glDisable(GL_ALPHA_TEST);
		}

		free(buffer);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{
	  
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return _CPbitmap16(m);
			

	}
}











int		valDST=0;
int		valSRC=0;



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZTest
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [I] I
int ZTest(mmachine m)
{
	int	val = MMget(m,0);


	if(val)
	{
		valSRC++;
		if(valSRC>10)	valSRC=0;
	}
	else
	{
		valDST++;
		if(valDST>10)	valDST=0;
	}


	return 0;
}
















//////////////////////////////////////////////////////////////////////////////////////////////
///		_SDRAWrectangle														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [ObjSurface I I I I I I I I I] ObjSurface
int ZSDRAWrectangle (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"_SDRAWrectangle ");
#endif

	if(scolGLX->userACCEL)
	{
		float	r, g, b;
		int		x, y, w, h, mc, tc, cc, mf, cf, surf;

		cf = MTOI(MMpull(m));
		mf = MTOI(MMpull(m));
		cc = MTOI(MMpull(m));
		tc = MTOI(MMpull(m));
		mc = MTOI(MMpull(m));
		h  = MTOI(MMpull(m));
		w  = MTOI(MMpull(m));
		y  = MTOI(MMpull(m));
		x  = MTOI(MMpull(m));

		surf = MTOP(MMget(m,0));
		if(surf==NIL)	return 0;

		//$LB ????????????? SetGL2D(m,surf);
		SetGL2D (m, surf, NULL, NULL);
		
		if(mc)
		{
	//		glDisable(GL_CULL_FACE);

		        b = ((cf>>16)&255)	/ CONST_COLOR;  
			g = ((cf>>8)&255)	/ CONST_COLOR;  
			r = ((cf)&255)		/ CONST_COLOR;  
		

			glShadeModel(GL_FLAT);
			glBegin(GL_QUADS);
				glColor4f(r,g,b,1.0f);
				glVertex2f(x+w,y);
				glVertex2f(x+w,y+h); 	
				glVertex2f(x,y+h); 
				glVertex2f(x,y); 
			glEnd();

	//		glEnable(GL_CULL_FACE);
		}

		if(mf)
		{
			b = ((cf>>16)&255)	/ CONST_COLOR;  
			g = ((cf>>8)&255)	/ CONST_COLOR;  
			r = ((cf)&255)		/ CONST_COLOR;  

			glColor4f(r,g,b,1.0);
			glLineWidth(tc);
			
			glBegin(GL_LINE_LOOP);
				glVertex2f(x,y);  
				glVertex2f(x+w,y);  
				glVertex2f(x+w,y+h);  
				glVertex2f(x,y+h);
			glEnd();
			
			glLineWidth(1);
		}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{

	  int k = _DRAWrectangle(m);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
        return k;

	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		_SDRAWline														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface I I I I I I I] ObjSurface
int ZSDRAWline (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"_SDRAWline ");
#endif

	if(scolGLX->userACCEL)
	{
		float	r,g,b;
		int	x,y,xx,yy,mc,tc,cc,surf;

		cc = MMpull(m)>>1;
		tc = MMpull(m)>>1;
		mc = MMpull(m)>>1;
		yy = MMpull(m)>>1;
		xx = MMpull(m)>>1;
		y  = MMpull(m)>>1;
		x  = MMpull(m)>>1;

		surf = MMget(m,0)>>1;
		if(surf==NIL)		return 0;

		//$LB ????????? SetGL2D(m,surf);
		SetGL2D(m, surf, NULL, NULL);

		if (mc)
		{
			b = ((cc>>16)&255)	/ CONST_COLOR;  
			g = ((cc>>8)&255)	/ CONST_COLOR;  
			r = ((cc)&255)		/ CONST_COLOR;  

			glColor4f(r,g,b,1.0);
			glLineWidth(tc);

			glBegin(GL_LINES);
				glVertex2f(x,y);  
				glVertex2f(xx,yy);
			glEnd();

			glLineWidth(1);
		}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{
	  int k = _DRAWline (m);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return k;
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		_SDRAWcircle														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface I I I I I I I I] ObjSurface
int ZSDRAWcircle (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"_SDRAWcircle ");
#endif

	if(scolGLX->userACCEL)
	{
		int		x,y,ray,mc,tc,cc,mf,cf,surf,i;
		float	r,g,b,angle;

		cf	= MMpull(m)>>1,
		mf	= MMpull(m)>>1,
		cc	= MMpull(m)>>1,
		tc	= MMpull(m)>>1,
		mc	= MMpull(m)>>1,
		ray	= MMpull(m)>>1,
		y	= MMpull(m)>>1,
		x	= MMpull(m)>>1,
		
		surf = MMget(m,0)>>1;
		if(surf==NIL)		return 0;
  
		//$LB ????????? SetGL2D(m,surf);
		SetGL2D(m, surf, NULL, NULL);

		if (mf)
		{
			glDisable(GL_CULL_FACE);
			
			b = ((cf>>16)&255)	/ CONST_COLOR;  
			g = ((cf>>8)&255)	/ CONST_COLOR;  
			r = ((cf)&255)		/ CONST_COLOR;  

			glColor3f(r,g,b);

			glBegin(GL_TRIANGLE_FAN);
				
				for (i=0;i<ray*2;i++)
				{
					angle=(3.1415926535/((float)ray*2.0f)) * (float)i;
					glVertex2f(x+sin(angle)*ray, y+cos(angle)*ray); 
				}

			glEnd();

			glEnable(GL_CULL_FACE);
		}

		if (mc)
		{
			b = ((cf>>16)&255)	/ CONST_COLOR;  
			g = ((cf>>8)&255)	/ CONST_COLOR;  
			r = ((cf)&255)		/ CONST_COLOR;  

			glColor3f(r,g,b);
			glLineWidth(tc);
			
			glBegin(GL_LINE_LOOP);
				for (i=0;i<ray/2;i++)
				{
					angle=(4*3.1415926535/(float)ray)*(float)i;
					glVertex2f(x+sin(angle)*ray,y+cos(angle)*ray);
				}
			glEnd();
		}
		glLineWidth(1);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{
	
	  int k = _DRAWcircle (m);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return k;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		Structure GLFont														
//////////////////////////////////////////////////////////////////////////////////////////////
typedef struct GLFont
{
	int list;
	int height;
	int ascend;
} GLFont;





//////////////////////////////////////////////////////////////////////////////////////////////
///		_SDRAWtext														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface ObjFont I I I I S] ObjSurface
int ZSDRAWtext (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"_SDRAWtext ");
#endif

	if(scolGLX->userACCEL)
	{
		glDisable(GL_CULL_FACE);

		//$LB PtrObjVoid	OB;
		PtrObjFont	F;
		int			font, surf, x, y, flag, col, pstr,listbase;
		char		buf[1025];											// texte  afficher

		//$LB HDC			dc;
		HWND		hwnd;
		HGLRC		rc;

		float		r,g,b;
		GLFont		*glfont=NULL;

		buf[1024] = 0;

		pstr =	MMpull(m)>>1;
		col	 =	MMpull(m)>>1;
		flag =	MMpull(m)>>1;
		y	 =	MMpull(m)>>1;
		x	 =	MMpull(m)>>1;
		font =	MMpull(m)>>1;
		surf =	MMget(m,0)>>1;

		if(surf==NIL || font==NIL || x==NIL || y==NIL || col==NIL || pstr==NIL)			return 0;

		strncpy(buf, MMstartstr(m,pstr), 1024);					// recup le txt

		//$LB SetGL2D(m, surf, &dc, &hwnd, &rc);						// passe en mode 2D
		SetGL2D(m, surf, &hwnd, &rc);						// passe en mode 2D

		//$LB
		/*
		OB = ( PtrObjVoid ) MMstart(m, font);
		F  = ( PtrObjFont ) MMstart(m, OB->Buffer>>1);
		*/
		F = (PtrObjFont) objdd_get_buffer (m, font);

		//$LB if (OB->Tab == NIL)
		if (F->glfont == NULL)
		{
			// ---------------------> supprimer le OB->tab, car il contient un pointeur SCOL qui ne sera jamais
			//						  rinitialis !!!!!!!!!!!
			int			f;
			//$LB HGDIOBJ		oldobj;
			//$LB TEXTMETRIC	textmetric;
			XFontStruct* xfontStruct;

			//$LB
			F->glfont = (GLFont*) malloc(sizeof(GLFont));
			if(!F->glfont)		return 0;
			glfont = (GLFont*) F->glfont;

			MMpush(m, PTOM(font));

			f = MMmalloc(m,2,TYPEBUF);
			if(f<0)			return f;
			font = MTOP(MMpull(m));

			//$LB
			/*
			OB   = ( PtrObjVoid ) MMstart(m, font);
			F    = ( PtrObjFont ) MMstart(m, MTOP(OB->Buffer));
			OB->Tab = PTOM(f);
			MMstore(m,f,0,0);
			MMstore(m,f,1,(int)glfont);
			*/

			//$LB oldobj = SelectObject(dc, F->WHandler);
			glfont->list = glGenLists(255);

			//$LB
		        F = (PtrObjFont) objdd_get_buffer (m, font);



			//$LB wglUseFontBitmaps(dc, 0, 255, glfont->list);
			xfontStruct = (XFontStruct*) GDK_FONT_XFONT(F->font);
			glXUseXFont (xfontStruct->fid, 0, 255, glfont->list);

			//$LB
			/*
			GetTextMetrics(dc, &textmetric);
			glfont->height = textmetric.tmHeight;
			glfont->ascend = textmetric.tmAscent;
			SelectObject(dc, oldobj);
			*/
			glfont->height = xfontStruct->ascent + xfontStruct->descent;
			glfont->ascend = xfontStruct->ascent;

		}

		//$LB glfont = (GLFont*) MMfetch(m, MTOP(OB->Tab), 1);
		glfont = (GLFont*)F->glfont;
		if(!glfont)		return 0;

		glGetIntegerv(GL_LIST_BASE, &listbase);

		r = ((col)&255)		/ CONST_COLOR;  
		g = ((col>>8)&255)  / CONST_COLOR;  
		b = ((col>>16)&255) / CONST_COLOR;  
		glColor3f(r,g,b);

		glRasterPos2i(x, y+glfont->ascend);

		glListBase(glfont->list);
		glCallLists(strlen(buf),GL_UNSIGNED_BYTE,buf);
		glListBase(listbase);

		glEnable(GL_CULL_FACE);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{
	  int k = _DRAWtext (m);
		
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return k;
	}
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		_SDRAWpoly														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun[ObjSurface I tab[I I] I I I I I] ObjSurface
int ZSDRAWpoly (mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"_SDRAWpoly ");
#endif

	if(scolGLX->userACCEL)
	{
		float	r,g,b;
		int		*ptab;
		
		int		cf	 = MMpull(m)>>1,
				mf	 = MMpull(m)>>1,
				cc	 = MMpull(m)>>1,
				tc	 = MMpull(m)>>1,
				mc	 = MMpull(m)>>1,
				pt	 = MMpull(m)>>1,
				np	 = MMpull(m)>>1,
				surf = MMget(m,0)>>1;

		if(np<3)			return 0;
		if(pt==NIL)			return 0;
		
		ptab = (int*)MMstart(m,pt);
  
		if(surf==NIL)		return 0;
		SetGL2D(m, surf, NULL, NULL);

		if (mf)
		{
			glDisable(GL_CULL_FACE);

			//$LB
			/*
			r=((cf>>10)&31)/32.0f;  
			g=((cf>>5)&31)/32.0f;  
			b=((cf)&31)/32.0f;  
			*/
			r = ((cf) & 0xFF) / 255.0f;
			g = ((cf>>8) & 0xFF) / 255.0f;
			b = ((cf>>16) & 0xFF) / 255.0f;

			glColor3f(r,g,b);
			
			glBegin (GL_TRIANGLE_FAN);
				for(int n=0;n<np;n+=2)		  glVertex2i(*(ptab+n),*(ptab+n+1));
				glVertex2i(*(ptab),*(ptab+1));
			glEnd();
		
			glEnable(GL_CULL_FACE);
		}

		if (mc)
		{
		        //$LB
		        /*
			r=((cc>>10)&31)/32.0f;  
			g=((cc>>5)&31)/32.0f;  
			b=((cc)&31)/32.0f;  
			*/
		        r = ((cc) & 0xFF) / 255.0f;
			g = ((cc>>8) & 0xFF) / 255.0f;
			b = ((cc>>16) & 0xFF) / 255.0f;

			glLineWidth(tc);
			glColor3f(r,g,b);
			
			glBegin (GL_LINE_LOOP);
				for(int n=0;n<np;n+=2)		  glVertex2i(*(ptab+n),*(ptab+n+1));
			glEnd();
			
			glLineWidth(1);
		}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
		return 0;
	}
	else
	{
	  int k = _DRAWpoly16 (m);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return k;
	}
}
