//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///			    GESTION DES SPRITES									    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createSprite
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d I I HMat3d I]
int ZM3createSprite(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createSprite ");
#endif

	int flg	 = MMpull(m);
	int mat	 = MMpull(m);
	int H	 = MMpull(m);
	int W	 = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(H==NIL)||(W==NIL)||(mat==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)													{	MMset(m,0,NIL);		return 0;	}

	// Creation du sprite
	ZSprite		*curSpr;
	curSpr = new ZSprite((int)scene);
	if(curSpr == NULL)												{	MMset(m,0,NIL);		return 0;	}
	curSpr->InsertAsChildOf(scene->World);
	curSpr->SetName("");

	// Attribution des composantes du sprite
	curSpr->halfW = ((float)MTOI(W)) / 200.0f;
	curSpr->halfH = ((float)MTOI(H)) / 200.0f;
	curSpr->SetMaterial(mater);

	if(flg==0)	curSpr->CameraOriented = false;
	else		curSpr->CameraOriented = true;

	// Declaration en SCOL
	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)curSpr, hash_tab);

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createSpriteF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d F F HMat3d I]
int ZM3createSpriteF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createSpriteF ");
#endif
	int flg	 = MMpull(m);
	int mat	 = MMpull(m);
	int H	 = MMpull(m);
	int W	 = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(H==NIL)||(W==NIL)||(mat==NIL))					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)													{	MMset(m,0,NIL);		return 0;	}

	// Creation du sprite
	ZSprite		*curSpr;
	curSpr = new ZSprite((int)scene);
	if(curSpr == NULL)												{	MMset(m,0,NIL);		return 0;	}
	curSpr->InsertAsChildOf(scene->World);
	curSpr->SetName("");

	// Attribution des composantes du sprite
	curSpr->halfW = MTOF(W) / 200.0f;
	curSpr->halfH = MTOF(H) / 200.0f;
	curSpr->SetMaterial(mater);

	if(flg==0)	curSpr->CameraOriented = false;
	else		curSpr->CameraOriented = true;

	// Declaration en SCOL
	int hash_tab = MTOP( MMfetch(m,MTOP(s3d),1) );
	int	h3d = createH3D(m, (int)curSpr, hash_tab);

	scene->updateGraphList = true;

	// Pose le rsultat sur la pile
	if(h3d!=NIL)	h3d = PTOM(h3d);
    MMset(m,0,h3d);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
    return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setSprite
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I I HMat3d I] I
int ZM3setSprite(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setSprite ");
#endif

	int flg	= MMpull(m);
	int mat	= MMpull(m);
	int H   = MMpull(m);
	int W   = MMpull(m);
	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(H==NIL)||(W==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)													{	MMset(m,0,NIL);		return 0;	}


	// Attribution des composantes du sprite
	sprite->halfW = ((float)MTOI(W)) / 200.0f;
	sprite->halfH = ((float)MTOI(H)) / 200.0f;
	sprite->SetMaterial(mater);

	if(flg==0)	sprite->CameraOriented = false;
	else		sprite->CameraOriented = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setSpriteF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d F F HMat3d I] I
int ZM3setSpriteF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setSpriteF ");
#endif
	int flg	= MMpull(m);
	int mat	= MMpull(m);
	int H   = MMpull(m);
	int W   = MMpull(m);
	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(H==NIL)||(W==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)													{	MMset(m,0,NIL);		return 0;	}


	// Attribution des composantes du sprite
	sprite->halfW = MTOF(W) / 200.0f;
	sprite->halfH = MTOF(H) / 200.0f;
	sprite->SetMaterial(mater);

	if(flg==0)	sprite->CameraOriented = false;
	else		sprite->CameraOriented = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getSprite
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I HMat3d I]
int ZM3getSprite(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getSprite ");
#endif
	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))										{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

	MMpull(m);

	int k;

	// Pose des composants sur la pile
	if(MMpush(m, ITOM(AROUNDINT(200.0f*sprite->halfW))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(200.0f*sprite->halfH))))			return MERRMEM;

	int	mat3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)sprite->GetMaterial());
	if(mat3d!=NIL)		mat3d = PTOM(mat3d);
	if(MMpush(m, mat3d))											return MERRMEM;

	if(sprite->CameraOriented)		{	if(MMpush(m, 0))		return MERRMEM;	}
	else							{	if(MMpush(m, 2))		return MERRMEM;	}

	// Creation du tuple rsultat
	if(MMpush(m, 4*2))												return MERRMEM;
	if(k=MBdeftab(m))												return k;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getSpriteF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [F F HMat3d I]
int ZM3getSpriteF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getSpriteF ");
#endif

	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))										{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

	MMpull(m);

	int k;

	// Pose des composants sur la pile
	if(MMpush(m, FTOM(200.0f*sprite->halfW)))			return MERRMEM;
	if(MMpush(m, FTOM(200.0f*sprite->halfH)))			return MERRMEM;

	int	mat3d = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)sprite->GetMaterial());
	if(mat3d!=NIL)		mat3d = PTOM(mat3d);
	if(MMpush(m, mat3d))								return MERRMEM;

	if(sprite->CameraOriented)		{	if(MMpush(m, 0))		return MERRMEM;	}
	else							{	if(MMpush(m, 2))		return MERRMEM;	}
	
	// Creation du tuple rsultat
	if(MMpush(m, 4*2))					return MERRMEM;
	if(k=MBdeftab(m))					return k;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setSpriteTexCoord
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [[I I] r1] [[I I] r1]] I
int ZM3setSpriteTexCoord(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setSpriteTexCoord ");
#endif

	int tex2  = MTOP(MMpull(m));
	int tex1  = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))								{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;
	

	ZVector3	texCoord[4];
	int			coordPTR;

	if(tex1!=NIL)
	{
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[0].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		tex1 = MTOP(MMfetch(m,tex1,1));
		if(tex1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[1].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		tex1 = MTOP(MMfetch(m,tex1,1));
		if(tex1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[2].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		tex1 = MTOP(MMfetch(m,tex1,1));
		if(tex1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[3].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		sprite->UV1[0] = texCoord[0];
		sprite->UV1[1] = texCoord[1];
		sprite->UV1[2] = texCoord[2];
		sprite->UV1[3] = texCoord[3];

		if( sprite->UV1[0].u<0.0f || sprite->UV1[1].u<0.0f || sprite->UV1[2].u<0.0f || sprite->UV1[3].u<0.0f ||
			sprite->UV1[0].u>1.0f || sprite->UV1[1].u>1.0f || sprite->UV1[2].u>1.0f || sprite->UV1[3].u>1.0f )	sprite->clampU1 = false;
		else																									sprite->clampU1 = true;

		if( sprite->UV1[0].v<0.0f || sprite->UV1[1].v<0.0f || sprite->UV1[2].v<0.0f || sprite->UV1[3].v<0.0f || 
			sprite->UV1[0].v>1.0f || sprite->UV1[1].v>1.0f || sprite->UV1[2].v>1.0f || sprite->UV1[3].v>1.0f )	sprite->clampV1 = false;
		else																									sprite->clampV1 = true;
	}

	if(tex2!=NIL)
	{
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[0].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		tex2 = MTOP(MMfetch(m,tex2,1));
		if(tex2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[1].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		tex2 = MTOP(MMfetch(m,tex2,1));
		if(tex2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[2].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		tex2 = MTOP(MMfetch(m,tex2,1));
		if(tex2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[3].SetCoord( ((float)MTOI(MMfetch(m,coordPTR,0))) / CONST_TEX_COORD, ((float)MTOI(MMfetch(m,coordPTR,1))) / CONST_TEX_COORD, 1.0f);

		sprite->UV2[0] = texCoord[0];	
		sprite->UV2[1] = texCoord[1];	
		sprite->UV2[2] = texCoord[2];	
		sprite->UV2[3] = texCoord[3];	

		if( sprite->UV2[0].u<0.0f || sprite->UV2[1].u<0.0f || sprite->UV2[2].u<0.0f || sprite->UV2[3].u<0.0f ||
			sprite->UV2[0].u>1.0f || sprite->UV2[1].u>1.0f || sprite->UV2[2].u>1.0f || sprite->UV2[3].u>1.0f )	sprite->clampU2 = false;
		else																									sprite->clampU2 = true;

		if( sprite->UV2[0].v<0.0f || sprite->UV2[1].v<0.0f || sprite->UV2[2].v<0.0f || sprite->UV2[3].v<0.0f || 
			sprite->UV2[0].v>1.0f || sprite->UV2[1].v>1.0f || sprite->UV2[2].v>1.0f || sprite->UV2[3].v>1.0f )	sprite->clampV2 = false;
		else																									sprite->clampV2 = true;
	}

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setSpriteTexCoordF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [[F F] r1] [[F F] r1]] I
int ZM3setSpriteTexCoordF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setSpriteTexCoordF ");
#endif

	int tex2  = MTOP(MMpull(m));
	int tex1  = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))								{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;
	

	ZVector3	texCoord[4];
	int			coordPTR;

	if(tex1!=NIL)
	{
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[0].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		tex1 = MTOP(MMfetch(m,tex1,1));
		if(tex1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[1].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		tex1 = MTOP(MMfetch(m,tex1,1));
		if(tex1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[2].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		tex1 = MTOP(MMfetch(m,tex1,1));
		if(tex1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex1,0));
		texCoord[3].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		sprite->UV1[0] = texCoord[0];	
		sprite->UV1[1] = texCoord[1];	
		sprite->UV1[2] = texCoord[2];	
		sprite->UV1[3] = texCoord[3];	

		if( sprite->UV1[0].u<0.0f || sprite->UV1[1].u<0.0f || sprite->UV1[2].u<0.0f || sprite->UV1[3].u<0.0f ||
			sprite->UV1[0].u>1.0f || sprite->UV1[1].u>1.0f || sprite->UV1[2].u>1.0f || sprite->UV1[3].u>1.0f )	sprite->clampU1 = false;
		else																									sprite->clampU1 = true;

		if( sprite->UV1[0].v<0.0f || sprite->UV1[1].v<0.0f || sprite->UV1[2].v<0.0f || sprite->UV1[3].v<0.0f || 
			sprite->UV1[0].v>1.0f || sprite->UV1[1].v>1.0f || sprite->UV1[2].v>1.0f || sprite->UV1[3].v>1.0f )	sprite->clampV1 = false;
		else																									sprite->clampV1 = true;
	}

	if(tex2!=NIL)
	{
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[0].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		tex2 = MTOP(MMfetch(m,tex2,1));
		if(tex2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[1].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		tex2 = MTOP(MMfetch(m,tex2,1));
		if(tex2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[2].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		tex2 = MTOP(MMfetch(m,tex2,1));
		if(tex2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		coordPTR = MTOP(MMfetch(m,tex2,0));
		texCoord[3].SetCoord( MTOF(MMfetch(m,coordPTR,0)), MTOF(MMfetch(m,coordPTR,1)), 1.0f);

		sprite->UV2[0] = texCoord[0];	
		sprite->UV2[1] = texCoord[1];	
		sprite->UV2[2] = texCoord[2];	
		sprite->UV2[3] = texCoord[3];	

		if( sprite->UV2[0].u<0.0f || sprite->UV2[1].u<0.0f || sprite->UV2[2].u<0.0f || sprite->UV2[3].u<0.0f ||
			sprite->UV2[0].u>1.0f || sprite->UV2[1].u>1.0f || sprite->UV2[2].u>1.0f || sprite->UV2[3].u>1.0f )	sprite->clampU2 = false;
		else																									sprite->clampU2 = true;

		if( sprite->UV2[0].v<0.0f || sprite->UV2[1].v<0.0f || sprite->UV2[2].v<0.0f || sprite->UV2[3].v<0.0f || 
			sprite->UV2[0].v>1.0f || sprite->UV2[1].v>1.0f || sprite->UV2[2].v>1.0f || sprite->UV2[3].v>1.0f )	sprite->clampV2 = false;
		else																									sprite->clampV2 = true;
	}

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getSpriteTexCoord
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[I I] r1] [[I I] r1]]
int ZM3getSpriteTexCoord(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getSpriteTexCoord ");
#endif

	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))								{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;
	
	MMpull(m);

	int		j, k;

	// creation de la liste des TexCoord1
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[0].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[0].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;
	
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[1].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[1].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;

	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[2].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[2].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;

	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[3].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV1[3].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;

	if(MMpush(m, NIL))															return MERRMEM;

	for(j=0; j<4; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}


	// creation de la liste des TexCoord2
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[0].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[0].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;
	
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[1].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[1].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;

	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[2].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[2].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;

	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[3].u))))			return MERRMEM;
	if(MMpush(m, ITOM(AROUNDINT(CONST_TEX_COORD*sprite->UV2[3].v))))			return MERRMEM;
	if(MMpush(m, 2*2))															return MERRMEM;
	if(k=MBdeftab(m))															return k;

	if(MMpush(m, NIL))															return MERRMEM;

	for(j=0; j<4; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}


	// Creation de la liste finale
    if(MMpush(m,2*2))		return MERRMEM;
	if(k=MBdeftab(m))		return k;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getSpriteTexCoordF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[F F] r1] [[F F] r1]]
int ZM3getSpriteTexCoordF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getSpriteTexCoordF ");
#endif

	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))								{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

	MMpull(m);

	int		j, k;

	// creation de la liste des TexCoord1
	if(MMpush(m, FTOM(sprite->UV1[0].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV1[0].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;
	
	if(MMpush(m, FTOM(sprite->UV1[1].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV1[1].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;

	if(MMpush(m, FTOM(sprite->UV1[2].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV1[2].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;

	if(MMpush(m, FTOM(sprite->UV1[3].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV1[3].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;

	if(MMpush(m, NIL))								return MERRMEM;

	for(j=0; j<4; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}


	// creation de la liste des TexCoord2
	if(MMpush(m, FTOM(sprite->UV2[0].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV2[0].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;
	
	if(MMpush(m, FTOM(sprite->UV2[1].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV2[1].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;

	if(MMpush(m, FTOM(sprite->UV2[2].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV2[2].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;

	if(MMpush(m, FTOM(sprite->UV2[3].u)))			return MERRMEM;
	if(MMpush(m, FTOM(sprite->UV2[3].v)))			return MERRMEM;
	if(MMpush(m, 2*2))								return MERRMEM;
	if(k=MBdeftab(m))								return k;

	if(MMpush(m, NIL))								return MERRMEM;

	for(j=0; j<4; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}


	// Creation de la liste finale
    if(MMpush(m,2*2))		return MERRMEM;
	if(k=MBdeftab(m))		return k;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setSpriteVrtColors
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I r1] [I r1]] I
int ZM3setSpriteVrtColors(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setSpriteVrtColors ");
#endif

	int col2  = MTOP(MMpull(m));
	int col1  = MTOP(MMpull(m));
	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))								{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;
	

	ZVector3	colors[4];
	int			col;

	if(col1!=NIL)
	{
		col = MTOI(MMfetch(m,col1,0));
		colors[0].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		col1 = MTOP(MMfetch(m,col1,1));
		if(col1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		col = MTOI(MMfetch(m,col1,0));
		colors[1].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		col1 = MTOP(MMfetch(m,col1,1));
		if(col1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		col = MTOI(MMfetch(m,col1,0));
		colors[2].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		col1 = MTOP(MMfetch(m,col1,1));
		if(col1==NIL)			{	MMset(m,0,NIL);		return 0;	}
		col = MTOI(MMfetch(m,col1,0));
		colors[3].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		sprite->vertColor1[0] = colors[0];	
		sprite->vertColor1[1] = colors[1];	
		sprite->vertColor1[2] = colors[2];	
		sprite->vertColor1[3] = colors[3];	
	}

	if(col2!=NIL)
	{
		col = MTOI(MMfetch(m,col2,0));
		colors[0].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		col2 = MTOP(MMfetch(m,col2,1));
		if(col2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		col = MTOI(MMfetch(m,col2,0));
		colors[1].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		col2 = MTOP(MMfetch(m,col2,1));
		if(col2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		col = MTOI(MMfetch(m,col2,0));
		colors[2].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		col2 = MTOP(MMfetch(m,col2,1));
		if(col2==NIL)			{	MMset(m,0,NIL);		return 0;	}
		col = MTOI(MMfetch(m,col2,0));
		colors[3].SetCoord( ((float)((col&0x00ff0000)>>16)) / CONST_COLOR,
							((float)((col&0x0000ff00)>>8) ) / CONST_COLOR,
							((float) (col&0x000000ff)	  ) / CONST_COLOR  );

		sprite->vertColor2[0] = colors[0];	
		sprite->vertColor2[1] = colors[1];	
		sprite->vertColor2[2] = colors[2];	
		sprite->vertColor2[3] = colors[3];	
	}

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getSpriteVrtColors
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [[I r1] [I r1]]
int ZM3getSpriteVrtColors(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getSpriteVrtColors ");
#endif

	int h3d   = MMpull(m);
    int s3d   = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL))								{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))				{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;
	
	MMpull(m);

	int		j, k, coul;


	// creation de la liste des vertColor1
	coul = AROUNDINT(sprite->vertColor1[0].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor1[0].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor1[0].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;

	coul = AROUNDINT(sprite->vertColor1[1].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor1[1].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor1[1].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;
	
	coul = AROUNDINT(sprite->vertColor1[2].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor1[2].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor1[2].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;
	
	coul = AROUNDINT(sprite->vertColor1[3].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor1[3].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor1[3].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;

	if(MMpush(m, NIL))															return MERRMEM;

	for(j=0; j<4; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}


	// creation de la liste des vertColor2
	coul = AROUNDINT(sprite->vertColor2[0].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor2[0].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor2[0].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;

	coul = AROUNDINT(sprite->vertColor2[1].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor2[1].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor2[1].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;
	
	coul = AROUNDINT(sprite->vertColor2[2].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor2[2].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor2[2].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;
	
	coul = AROUNDINT(sprite->vertColor2[3].z*CONST_COLOR) + (AROUNDINT(sprite->vertColor2[3].y*CONST_COLOR)<<8) + (AROUNDINT(sprite->vertColor2[3].x*CONST_COLOR)<<16);
	if(MMpush(m,ITOM(coul)))		return MERRMEM;

	if(MMpush(m, NIL))															return MERRMEM;

	for(j=0; j<4; j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}


	// Creation de la liste finale
    if(MMpush(m,2*2))		return MERRMEM;
	if(k=MBdeftab(m))		return k;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setSpriteAngle
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I] I
int ZM3setSpriteAngle(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setSpriteAngle ");
#endif

	int rot = MMpull(m);
	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(rot==NIL))							{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

	// Attribution de la rotation
	sprite->rotationZ = ((float)MTOI(rot)) * 360.0f/CONST_ANGLE;

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setSpriteAngleF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d F] I
int ZM3setSpriteAngleF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setSpriteAngleF ");
#endif

	int rot = MMpull(m);
	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL)||(rot==NIL))							{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

	// Attribution de la rotation
	sprite->rotationZ = MTOF(rot) * 180.0f/MY_PI;

	MMset(m,0,0);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getSpriteAngle
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int ZM3getSpriteAngle(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getSpriteAngle ");
#endif

	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))										{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

	MMset(m,0,ITOM(AROUNDINT(sprite->rotationZ * CONST_ANGLE / 360.0f)));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getSpriteAngleF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] F
int ZM3getSpriteAngleF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getSpriteAngleF ");
#endif

	int h3d = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(h3d==NIL))										{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)													{	MMset(m,0,NIL);		return 0;	}

    ZNode	*node = (ZNode*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=SPR_TYPE_ID))						{	MMset(m,0,NIL);		return 0;	}
    ZSprite	*sprite = (ZSprite*)node;

	MMset(m,0, FTOM(sprite->rotationZ * MY_PI/180.0f) );

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;	
}
