

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///		     GESTION DES TEXTURES									    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureSetGeneralDefaultType 
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d I] I
int ZM3textureSetGeneralDefaultType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureSetGeneralDefaultType ");
#endif

	int flag = MMpull(m);
    int s3d  = MMget(m,0);

    if((flag==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*)MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	flag = MTOI(flag);

	// TEX_MIPMAP = TF_BILINEAR
	if(flag&TF_BILINEAR)	scene->generalTextureFilter = TF_BILINEAR;
	else					scene->generalTextureFilter = TF_LINEAR;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	
	MMset(m,0,0);
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureSetType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d I] I
int ZM3textureSetType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureSetType ");
#endif


	int flag = MMpull(m);
	int tex  = MMpull(m);
    int s3d  = MMget(m,0);

    if((tex==NIL)||(flag==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*)MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	flag = MTOI(flag);

	// TEX_MIPMAP == TF_BILINEAR
	if(flag&TF_BILINEAR)	textu->SetTextureFilter(TF_BILINEAR);
	else					textu->SetTextureFilter(TF_LINEAR);

	textu->modified = true;
	scene->textureModified = true;

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	
	MMset(m,0,0);
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureGetType
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d] I
int ZM3textureGetType(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureSetType ");
#endif

	int tex  = MMpull(m);
    int s3d  = MMget(m,0);

    if((tex==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*)MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int flag;

	// TEX_MIPMAP == TF_BILINEAR
	if(textu->filter==TF_BILINEAR)		flag = TF_BILINEAR;
	else								flag = 0;


#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	MMset(m,0,ITOM(flag));
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3listALLTextures
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d] [HTx3d r1]
int ZM3listALLTextures(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3listALLTextures ");
#endif
	int s3d = MMget(m,0);

    if(s3d==NIL)					{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int	n=0;
	int tx, tmp_res;
    
	int i;
	for(i=0; i<scene->TexList.Size(); i++)
    {
		int s3d = MMget(m,0);
		int hash = MTOP(MMfetch(m,MTOP(s3d),3));

		tx = NodeTOHandle(m, hash, (int)scene->TexList[i]);
		if(tx!=NIL)
		{
			tx = PTOM(tx);
			if(MMpush(m,tx))			return MERRMEM;
			INVERT(m,0,1);
			n++;
		}
    }

	if(n==0)		{	MMset(m,0,NIL);		return n;	}
	MMpull(m);
	if(MMpush(m,NIL))		return MERRMEM;

	int k,j;
	for(j=0;j<n;j++)
	{
    	if(MMpush(m,2*2))		return MERRMEM;
		if(k=MBdeftab(m))		return k;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getTexture
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S] HTX3d
int ZM3getTexture(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getTexture ");
#endif
	int name = MMpull(m);
    int s3d  = MMget(m,0);

    if((name==NIL)||(s3d==NIL))		{	MMset(m,0,NIL);		return 0;	}

    ZScene	*scene = (ZScene*)MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

	string	nom = string(MMstartstr(m,MTOP(name)));

	int i;
	for(i=0; i<scene->TexList.Size() && scene->TexList[i]->name!=nom; i++);

	if(i>=scene->TexList.Size())		{	MMset(m,0,NIL);		return 0;	}

	int	tex = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),3)), (int)scene->TexList[i]);
	if(tex!=NIL)		tex = PTOM(tex);
	MMset(m,0,tex);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureName
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d] S
int ZM3textureName(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureName ");
#endif
    int tex = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(tex==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMpull(m);

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return Mpushstrbloc(m, (char*)textu->name.c_str());
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3renameTexture
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d S] I
int ZM3renameTexture(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3renameTexture ");
#endif
    int name = MMpull(m);
    int tex  = MMpull(m);
    int s3d  = MMget(m,0);

    if((s3d==NIL)||(tex==NIL)||(name==NIL))			{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	textu->SetName((char*)MMstartstr(m,MTOP(name)));
	textu->SetFileName((char*)MMstartstr(m,MTOP(name)));
	textu->renamed = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3textureCount
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d] I
int ZM3textureCount(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3textureCount ");
#endif
	int tex = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(tex==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	MMset(m,0,ITOM(textu->nbRef));
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3copyMaterialTexture
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HMat3d] HTx3d
int ZM3copyMaterialTexture(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3copyMaterialTexture ");
#endif

	int mat = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(mat==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZMaterial	*mater = (ZMaterial*) MMfetch(m,MTOP(mat),0);
	if(mater==NULL)					{	MMset(m,0,NIL);		return 0;	}

	// Rcupration de la texture du matriau
	ZTexture	*tex = mater->GetTexture1();
	if(tex==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int newTex = NIL;

	if(tex->nbRef != 1)
	{
		// Cration de la nouvelle texture
		ZTexture	*curTex = new ZTexture(scene->accelerated);
		if(!curTex)					{	MMset(m,0,NIL);		return 0;	}
		scene->TexList.Add(curTex);

		curTex->SetTextureFilter(tex->filter);

		// Copie des donnes de texture
		curTex->SetFileName(tex->filename);
		curTex->SetName(tex->name);

		curTex->renamed		= true;
		curTex->modified	= true;

		scene->textureModified = true;

		curTex->SetRate(tex->GetRate());
		curTex->value = tex->value;

		curTex->A = tex->A;		curTex->S = tex->S;
		curTex->C = tex->C;		curTex->X = tex->X;
		curTex->R = tex->R;		curTex->Y = tex->Y;

		curTex->filter  = tex->filter;
		curTex->SetTranspR(tex->GetTranspR());
		curTex->SetTranspG(tex->GetTranspG());
		curTex->SetTranspB(tex->GetTranspB());

		curTex->Height = tex->Height;
		curTex->Width  = tex->Width;

		curTex->activated = false;

		if(tex->ID_created==true && tex->activated && tex->accelerated)
		{
			tex->PutGLparams();
			curTex->ImageModif	= (unsigned char *) malloc(tex->Width * tex->Height * 4);
			glGetTexImage(GL_TEXTURE_2D, 0, GL_RGBA, GL_UNSIGNED_BYTE, curTex->ImageModif);
			curTex->SetupTexture();
			curTex->activated = true;
		}

/*		curTex->SetFileName(tex->filename);
		curTex->SetName(tex->name);

		curTex->renamed = true;
		curTex->modified = true;

		scene->textureModified		= true;

		curTex->SetRate(tex->GetRate());
		curTex->value = tex->value;

		curTex->A = tex->A;		curTex->S = tex->S;
		curTex->C = tex->C;		curTex->X = tex->X;
		curTex->R = tex->R;		curTex->Y = tex->Y;

		curTex->filter  = tex->filter;
		curTex->SetTranspR(tex->GetTranspR());
		curTex->SetTranspG(tex->GetTranspG());
		curTex->SetTranspB(tex->GetTranspB());

		curTex->Height = tex->Height;
		curTex->Width  = tex->Width;

		curTex->activated = tex->activated;

		if(tex->Image != NULL)
		{
			curTex->Image		= (unsigned char *) malloc(tex->Width * tex->Height * 4);
			memcpy(curTex->Image, tex->Image, tex->Height*tex->Width*4);
		}

		if(tex->ImageModif != NULL)
		{
			curTex->ImageModif	= (unsigned char *) malloc(tex->Width * tex->Height * 4);
			memcpy(curTex->ImageModif, tex->ImageModif, tex->Height*tex->Width*4);
		}

		curTex->SetupTexture();
*/

		// Attribution au matriau
		mater->SetTexture1(curTex);
		mater->modified = true;

		scene->materialModified = true;

		// Dclaration dans la hashtable
		int hash_tab = MTOP( MMfetch(m,MTOP(s3d),3) );
		newTex = createHmatHtx(m, (int)curTex, hash_tab);
	}
	else
	{
		newTex = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),3)), (int)tex);
	}

	if(newTex!=NIL)		newTex = PTOM(newTex);

	MMset(m,0,newTex);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3isTextureFilled
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d] I
int ZM3isTextureFilled(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3isTextureFilled ");
#endif

	int tex = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(tex==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	
	if(/*(textu->ImageModif==NULL)||*/(textu->activated==false)||(textu->renamed==true))	{	MMset(m,0,0);			return 0;	}
	else																				{	MMset(m,0,ITOM(1));		return 0;	}
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3fillTexture
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d] I
int ZM3fillTexture(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3fillTexture ");
#endif

	int tex = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(tex==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}


	// charge la bitmap
	free(textu->Image);		textu->Image = NULL;

	textu->A = textu->C = textu->X = textu->Y = textu->R = textu->S = false;

	int		debName = 0;
	char	*namefile = (char*)textu->name.c_str();
	if(namefile[0]=='%')			debName = M3DloadFilter(namefile, textu);

	bool	test = true;
	char	name[SIZESIGN];


	// $LB if(SPfindfile((packdir)SCgetExtra("FirstPack"), &(namefile[debName]), NULL, name)==-1)		test=false;
	if(SPfindfile((packdir)Firstpack, &(namefile[debName]), NULL, name)==-1)		test=false;


	// load du fichier
	if(test)	
	{
		if(textu->LoadTexture(name)==false)
		{
			test = false;
			textu->activated = false;
			textu->modified  = true;
			free(textu->Image);			textu->Image = NULL;	
			free(textu->ImageModif);	textu->ImageModif = NULL;
			MMset(m,0,NIL);
		
			scene->textureModified		= true;
			
			return 0;
		}
	}

	// cration de la bitmap finale
	if(test)
	{
		free(textu->ImageModif);		textu->ImageModif = NULL;
		textu->CreateModifiedImg();
		textu->SetupTexture();
		textu->modified  = true;
		textu->activated = true;

		scene->textureModified		= true;
	}


	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;	
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3freeTexture
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d] I
int ZM3freeTexture(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3freeTexture ");
#endif

	int tex = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(tex==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	if(textu->Image!=NULL)				free(textu->Image);
	if(textu->ImageModif!=NULL)			free(textu->ImageModif);

	textu->Image = textu->ImageModif = NULL;

	if(scene->accelerated)
	{
		if(textu->ID_created)
		{
			glDeleteTextures(1, &(textu->texID));
			textu->ID_created = false;
		}
	}
	else
	{
		free(textu->bitmap16);
		textu->bitmap16 = NULL;
	}

	textu->activated = false;
	textu->modified  = true;

	scene->textureModified = true;

	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3getTransparencyColor
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d] I
int ZM3getTransparencyColor(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3getTransparencyColor ");
#endif

	int tex = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(tex==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	int couleurTransp = ((textu->GetTranspB())<<16) + ((textu->GetTranspG())<<8) + (textu->GetTranspR());

	MMset(m,0, ITOM(couleurTransp));		// !!!!!!!!!!!! la couleur est au format BGR !!!!!!!!!!!
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3setTransparencyColor
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d HTx3d I] I
int ZM3setTransparencyColor(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3setTransparencyColor ");
#endif
	int col	= MMpull(m);
	int tex = MMpull(m);
    int s3d = MMget(m,0);

    if((s3d==NIL)||(tex==NIL)||(col==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}

    ZTexture	*textu = (ZTexture*) MMfetch(m,MTOP(tex),0);
	if(textu==NULL)					{	MMset(m,0,NIL);		return 0;	}

	col = MTOI(col);

	int		debName = 0;
	char	*namefile = (char*)textu->name.c_str();
	if(namefile[0]=='%')			debName = M3DloadFilter(namefile, textu);

	///////--------> EST-CE BIEN RAISONNABLE ???? <---------- /////
	textu->A = true;
	///////////////////////////////////////////////////////////////

	textu->SetTranspR( (col&0x00ff0000)>>16 );
	textu->SetTranspG( (col&0x0000ff00)>>8  );
	textu->SetTranspB( (col&0x000000ff)     );

	if(textu->GetRate()==0)		textu->SetRate(5);
/*
	bool	test = true;
	char	name[SIZESIGN];
	if(SPfindfile((packdir)SCgetExtra("FirstPack"), &(namefile[debName]), NULL, name)==-1)		test=false;


	if(test)
	{
		if(textu->LoadTexture(name)==false)
		{
			test = false;		
			textu->activated = false;
			textu->modified  = true;
			free(textu->Image);			textu->Image = NULL;	
			free(textu->ImageModif);	textu->ImageModif = NULL;
			MMset(m,0,NIL);

			scene->textureModified		= true;
			
			return 0;
		}
	}

	if(test)
	{
		if(textu->ImageModif!=NULL)		{	free(textu->ImageModif);		textu->ImageModif = NULL;		}
		textu->CreateModifiedImg_WithoutLoading_A();
		textu->SetupTexture();
		textu->modified = true;
		textu->activated = true;

		scene->textureModified		= true;
	}
*/
	if(textu->activated==true)
	{
		if(textu->accelerated)
		{
			textu->PutGLparams();
			unsigned char	*bitmap = (unsigned char*) malloc(textu->Width * textu->Height * 4);
			glGetTexImage(GL_TEXTURE_2D, 0, GL_RGBA, GL_UNSIGNED_BYTE, bitmap);

			if(textu->Image!=NULL)			{	free(textu->Image);				textu->Image = NULL;			}
			if(textu->ImageModif!=NULL)		{	free(textu->ImageModif);		textu->ImageModif = NULL;		}

			int pipo;
			for(pipo=0; pipo<textu->Width*textu->Height; pipo++)		bitmap[pipo*4+3] = 255;

			textu->Image = bitmap;

			textu->CreateModifiedImg_WithoutLoading_A();
			textu->SetupTexture();
			textu->modified = true;
			scene->textureModified = true;
		}
		else
		{
			unsigned char	*bitmap = (unsigned char*) malloc(textu->Width * textu->Height * 4);
			short			*bitm	= (short*)textu->bitmap16;
			short			color;
			int i;
			for(i=0; i<textu->Width * textu->Height; i++)
			{
				color = bitm[i];

				bitmap[i*4+0] = ((color>>10)&31)<<3;	
				bitmap[i*4+1] = ((color>>5)&31)<<3;	
				bitmap[i*4+2] = (color&31)<<3;		
				bitmap[i*4+3] = 255;
			}

			textu->Image = bitmap;

			textu->CreateModifiedImg_WithoutLoading_A();
			textu->SetupTexture();
			textu->modified = true;
			scene->textureModified = true;
		}
	}


	MMset(m,0,0);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3createTexture
//////////////////////////////////////////////////////////////////////////////////////////////
/// fun [S3d S] HTx3d
int ZM3createTexture(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3createTexture ");
#endif
	int nam  = MMpull(m);
	int s3d  = MMget(m,0);

    if((s3d==NIL)||(nam==NIL))		{	MMset(m,0,NIL);		return 0;	}
    ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{	MMset(m,0,NIL);		return 0;	}


	// Creation de la nouvelle texture
	string	nom = string(MMstartstr(m,MTOP(nam)));

	ZTexture*	curTex = new ZTexture(scene->accelerated);
	if(!curTex)						{	MMset(m,0,NIL);		return 0;	}
	scene->TexList.Add(curTex);

	curTex->SetName(nom);
	curTex->SetFileName(nom);
	curTex->renamed = false;		// becoz we load the bitmap in the following lines



	// Chargement de la bitmap
	curTex->SetTextureFilter(scene->generalTextureFilter);

	int		debName  = 0;
	char	*ptrName = (char *) nom.c_str();
	if(nom[0]=='%')			debName = M3DloadFilter(ptrName, curTex);


	bool	test = true;
	char	name[SIZESIGN];

	//$LB if(SPfindfile((packdir)SCgetExtra("FirstPack"), (char*)(ptrName+debName), NULL, name)==-1)		{	scene->TexList.DeleteLastEntry();	delete curTex;		MMset(m,0,NIL);		return 0;	}

	if(SPfindfile((packdir)Firstpack, (char*)(ptrName+debName), NULL, name)==-1)		{	scene->TexList.DeleteLastEntry();	delete curTex;		MMset(m,0,NIL);		return 0;	}

	if(curTex->LoadTexture(name)==false)
	{
		free(curTex->Image);			curTex->Image = NULL;	
		free(curTex->ImageModif);		curTex->ImageModif = NULL;
		scene->TexList.DeleteLastEntry();
		delete curTex;
		MMset(m,0,NIL);
		return 0;
	}

	// Prpare la texture
	curTex->CreateModifiedImg();
	curTex->SetupTexture();
	curTex->modified = true;

	scene->textureModified		= true;

	int hash_tab = MTOP( MMfetch(m,MTOP(MMget(m,0)),3) );
	int tex = createHmatHtx(m, (int)curTex, hash_tab);

	// Pose le rsultat sur la pile
	MMset(m, 0, PTOM(tex));
	
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}

