

#include	"scol/zooscol.h"
#include "x11/common_x11.h"
#include <linux/stddef.h>
#include "kernel/3d/register.h"


extern unsigned long * colortable;
extern mmachine mm;
int LoadEngine(mmachine m);

///////////////////////////////////////////////
///		FUNCTIONS for Engine declaring		///
///////////////////////////////////////////////
//int		MX3registerDevice (char *name,char *id);


///////////////////////////////////////////////
///		FUNCTIONS for Sound Loading			///
///////////////////////////////////////////////
int		SCOLloadSound(mmachine m);				// Declaration in Sound.cpp
int		SCOLfreeSound();					// Declaration in Sound.cpp


///////////////////////////////////////////////
///		FUNCTION for Particle Loading		///
///////////////////////////////////////////////
int		SCOLloadParticle(mmachine m);			// Declaration in Particle4.cpp


///////////////////////////////////////////////
///		FUNCTION for Callback3D Loading		///
///////////////////////////////////////////////
int		SCOLloadCB3D(mmachine m);				// Declaration in Particle4.cpp


///////////////////////////////////////////////
///		FUNCTION for BOX loading			///
///////////////////////////////////////////////
int		SCOLloadBOX(mmachine m);							// Declaration in Particle4.cpp






///////////////////////////////////////////////////////////////
///		Starting point of the DLL							///
///////////////////////////////////////////////////////////////
//$LB extern "C" __declspec (dllexport) int SCOLloadZooGL(mmachine m)
extern "C" int SCOLloadZooGL(mmachine m)
{
	int		k = 0;
	char	*hwid = NULL;

      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("SCOLloadZooGL"); 
      #endif


	for(int ii=0; ii<255; ii++)		monClavier[ii] = false;

	//$LB ww = w;
	mm = m;

	

	//$LB ww->Buffer2texture = ZBuffer2texture;

	MMechostr(MSKDEBUG,"SCOLloadZooGL trying loading OpenGL DLL ...\n");

	//$LB MX3registerDevice = (int(*)(char *clearname,char *id))SCgetExtra("MX3registerDevice");

	//$LB
	SCOLGLXload();

	LoadEngine(m);

	scolGLX->userACCEL	= false;


	//$LB
	if ((scolGLX->InitGLX()) && ((scolGLX->mainglrc = CreateMainContext())))
	{


		MX3registerDevice("OpenGL", "OpenGL");
		// UserACCEL : temporairement mis  true,  cause du fichier 'vgh'
		scolGLX->userACCEL = true;
	}




	//$LB hwid = (char*) SCgetExtra("3dhardware");
	hwid = (char*)hardware3d;




	// Passe dans le mode slectionn par le user
	if(hwid!=NULL)
	{


		// mode SOFT
		if(!strcmp(hwid,"Scol Software 3D Engine"))
		{
			scolGLX->userACCEL = false;
			MMechostr(MSKDEBUG,"... DLL loaded in SOFTWARE mode\n");
			SCOLloadSound(m);
			SCOLloadParticle(m);
			SCOLloadCB3D(m);
			SCOLloadBOX(m);
		}
		// mode OpenGL
		else if(!strcmp(hwid,"OpenGL") && scolGLX->userACCEL)
		{
			scolGLX->userACCEL = true;
			MMechostr(MSKDEBUG,"... DLL loaded in HARDWARE mode\n");
			SCOLloadSound(m);
			SCOLloadParticle(m);
			SCOLloadCB3D(m);
			SCOLloadBOX(m);
		}
		// ID non vide et non reconnu : on passe en SOFT
		else if(strlen(hwid) != 0)
		{
			scolGLX->userACCEL = false;
			MMechostr(MSKDEBUG,"... Mode unknown\n");
			SCOLloadSound(m);
			SCOLloadParticle(m);
			SCOLloadCB3D(m);
			SCOLloadBOX(m);
		}
		// Pas d'ID du tout (c'est le dernier cas)
		else
		{
			if(scolGLX->userACCEL)		MMechostr(MSKDEBUG,"... Automatic ACCELERATED mode\n");
			else				MMechostr(MSKDEBUG,"... Automatic SOFTWARE mode\n");
			SCOLloadSound(m);
			SCOLloadParticle(m);
			SCOLloadCB3D(m);
			SCOLloadBOX(m);
		}
	}
	else
	{
		if(scolGLX->userACCEL)		MMechostr(MSKDEBUG,"... Automatic ACCELERATED mode\n");
		else				MMechostr(MSKDEBUG,"... Automatic SOFTWARE mode\n");
		SCOLloadSound(m);
		SCOLloadParticle(m);
		SCOLloadCB3D(m);
		SCOLloadBOX(m);
	}


	return k;
}





///////////////////////////////////////////////////////////////
///		Ending point of the DLL								///
///////////////////////////////////////////////////////////////
//$LB extern "C" __declspec (dllexport) int SCOLfreeZooGL()
extern "C" int SCOLfreeZooGL()
{
      #ifdef LIB3D_X11_DEBUG 
      SCOL_X11_DEBUG("SCOLfreeZooGL"); 
      #endif

	MMechostr(MSKDEBUG,"Release OpenGL DLL\n");

	if(colortable)		free(colortable);


#ifdef _INFO_SCREEN_

	if(scolGLX->userACCEL)
	{
		if(mainInfoRC)
		{
			if(wglMakeCurrentNULL()==FALSE)		MMechostr(1, "------ Can't set the current rendering context to NULL ! ------\n" );
	                if(wglDeleteContext(mainInfoRC)==FALSE)		MMechostr(1, "------ Can't delete the MAIN rendering context ! ------\n" );
		}

		if(mainInfoDC)
		{
			if(ReleaseDC(mainInfoWND, mainInfoDC)==0)	MMechostr(1, "------ Can't release the MAIN device context ! ------\n" );;
		}

		if(mainInfoWND)
		{
			if(DestroyWindow(mainInfoWND)==0)			MMechostr(1, "------ Can't destroy the MAIN window ! ------\n" );;
		}

		//$LB
		/*
		if(!UnregisterClass("InfoGL", hInstance))
		{
			MMechostr(1,"----> Could Not Unregister InfoSCREEN Class !\n");
		}
		*/
	}

#endif


	MMechostr(1, "\n------ CLOSING ZOOGL DLL..\n" );

	if(scolGLX->mainglrc)
	{
		if(wglMakeCurrentNULL()==FALSE)		MMechostr(1, "------ Can't set the current rendering context to NULL ! ------\n" );
		
		//$LB
		/*
		if(wglDeleteContext(scolGLX->mainglrc)==FALSE)		MMechostr(1, "------ Can't delete the MAIN rendering context ! ------\n" );
		else										MMechostr(1, "--> mainglrc released : OK\n" );
		*/
		wglDeleteContext(scolGLX->mainglrc);

	}

	//$LB
	/*
	if(mainhdc) 
	{
		if(ReleaseDC(mainhwnd, mainhdc)==0)			MMechostr(1, "------ Can't release the MAIN device context ! ------\n" );
		else										MMechostr(1, "--> mainhdc released : OK\n" );
	}
	*/

	if(scolGLX->mainhwnd)
	{
	        //$LB
	        /*
		if(DestroyWindow(scolGLX->mainhwnd)==0)				MMechostr(1, "------ Can't destroy the MAIN window ! ------\n" );
		else										MMechostr(1, "--> mainhwnd released : OK\n" );
		*/
	  DestroyWindow(scolGLX->mainhwnd);
	}

	scolGLX->mainglrc  = NULL;
	//$LB mainhdc   = NULL;
	scolGLX->mainhwnd  = NULL;

	//$LB
	/*
	if(!UnregisterClass("scolGL", hInstance))
	{
		MMechostr(1, "----> Could Not Unregister Class !\n");
		hInstance=NULL;         // Set hInstance To NULL
	}
	else
		MMechostr(1, "--> class scolGL unregistred : OK\n" );
	*/

	MMechostr(1, "------ ..ZOOGL DLL CLOSED\n\n" );


	SCOLfreeSound();
	SCOLGLXfree();

	return 0;
}


/*
extern "C" __declspec (dllexport) BOOL WINAPI DllMain(HANDLE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{
	_asm{int 3};
	return TRUE;
}
*/

